

indexing
	description: "Generates unique id's for objects"
	names: "id"
	representation: "integer"
	access: "fixed"
	size: "fixed"
	contents: "INTEGER"
	patterns: "singleton"



class 

	OBJECT_IDENTIFIER
	
inherit
	
	SINGLETON
		redefine
			default_create
		end

creation
	default_create

feature -- Initialization

	default_create is
			-- 
		do

		end

feature -- Access
	
	last_id: INTEGER
	
feature -- Measurement
feature -- Comparison
feature -- Status report
feature -- Status setting
feature -- Cursor movement
feature -- Element change
	
	next_id is
			-- Update `last_id' with a new id
		do
			last_id := last_id + 1
		ensure
			updated: last_id = old last_id + 1
		end
	
feature -- Removal
feature -- Resizing
feature -- Transformation
feature -- Conversion
feature -- Duplication
feature -- Basic operations
feature -- Miscellaneous
feature -- Obsolete
feature -- Inapplicable
feature {NONE} -- Implementation
	
invariant
	
	last_id_positive: last_id >= 0
	
end -- OBJECT_IDENTIFIER

