

indexing
	description: "Provides facilities for converting between numeric types"
	names: "numeric", "conversion"
	representation: "none"
	access: "none"
	size: "none"
	contents: "none"
	patterns: "none"



class 

	NUMERIC_CONVERSION

feature -- Integer_8 conversion

	integer_8_to_integer_8 (val: INTEGER_8): INTEGER_8 is
			-- Return `val'.
		do
			Result := val
		end
	
	integer_8_to_integer_16 (val: INTEGER_8): INTEGER_16 is
			-- Convert `val' into an INTEGER_16 value.
		do
			Result := val.to_integer_16
		end
	
	integer_8_to_integer, integer_8_to_integer_32 (val: INTEGER_8): INTEGER is
			-- Convert `val' into an INTEGER_32 value.
		do
			Result := val.to_integer
		end
	
	integer_8_to_integer_64 (val: INTEGER_8): INTEGER_64 is
			-- Convert `val' into an INTEGER_64 value.
		do
			Result := val.to_integer_64
		end


	integer_8_to_real_32 (val: INTEGER_8): REAL is
			-- Convert `val' into a REAL_32
		do
			Result := val.to_real
		end
	
	integer_8_to_real_64 (val: INTEGER_8): DOUBLE is
			-- Convert `val' into a REAL_64
		do
			Result := val.to_double
		end














	
feature -- Integer_16 conversion

	integer_16_to_integer_8 (val: INTEGER_16): INTEGER_8 is
			-- Return `val'.
		do
			Result := val.to_integer_8
		end
	
	integer_16_to_integer_16 (val: INTEGER_16): INTEGER_16 is
			-- Convert `val' into an INTEGER_16 value.
		do
			Result := val
		end
	
	integer_16_to_integer, integer_16_to_integer_32 (val: INTEGER_16): INTEGER is
			-- Convert `val' into an INTEGER_32 value.
		do
			Result := val.to_integer
		end
	
	integer_16_to_integer_64 (val: INTEGER_16): INTEGER_64 is
			-- Convert `val' into an INTEGER_64 value.
		do
			Result := val.to_integer_64
		end


	integer_16_to_real_32 (val: INTEGER_16): REAL is
			-- Convert `val' into a REAL_32
		do
			Result := val.to_real
		end
	
	integer_16_to_real_64 (val: INTEGER_16): DOUBLE is
			-- Convert `val' into a REAL_64
		do
			Result := val.to_double
		end














	
feature -- Integer_32 conversion

	integer_to_integer_8 (val: INTEGER): INTEGER_8 is
			-- Return `val'.
		do
			Result := val.to_integer_8
		end
	
	integer_to_integer_16 (val: INTEGER): INTEGER_16 is
			-- Convert `val' into an INTEGER_16 value.
		do
			Result := val.to_integer_16
		end
	
	integer_to_integer, integer_to_integer_32 (val: INTEGER): INTEGER is
			-- Convert `val' into an INTEGER value.
		do
			Result := val
		end
	
	integer_to_integer_64 (val: INTEGER): INTEGER_64 is
			-- Convert `val' into an INTEGER_64 value.
		do
			Result := val.to_integer_64
		end


	integer_to_real_32 (val: INTEGER): REAL is
			-- Convert `val' into a REAL_32
		do
			Result := val.to_real
		end
	
	integer_to_real_64 (val: INTEGER): DOUBLE is
			-- Convert `val' into a REAL_64
		do
			Result := val.to_double
		end














	
feature -- Integer_64 conversion

	integer_64_to_integer_8 (val: INTEGER_64): INTEGER_8 is
			-- Return `val'.
		do
			Result := val.to_integer_8
		end
	
	integer_64_to_integer_16 (val: INTEGER_64): INTEGER_16 is
			-- Convert `val' into an INTEGER_16 value.
		do
			Result := val.to_integer_16
		end
	
	integer_64_to_integer, integer_64_to_integer_32 (val: INTEGER_64): INTEGER is
			-- Convert `val' into an INTEGER_32 value.
		do
			Result := val.to_integer
		end
	
	integer_64_to_integer_64 (val: INTEGER_64): INTEGER_64 is
			-- Convert `val' into an INTEGER_64 value.
		do
			Result := val
		end


	integer_64_to_real_32 (val: INTEGER_64): REAL is
			-- Convert `val' into a REAL_32
		do
			Result := val.to_real
		end
	
	integer_64_to_real_64 (val: INTEGER_64): DOUBLE is
			-- Convert `val' into a REAL_64
		do
			Result := val.to_double
		end














	
feature -- Real_32 conversion


	real_32_truncated_to_integer, real_32_truncated_to_integer_32 (val: REAL): INTEGER is
			-- Convert `val' into an INTEGER_32 value.
		do
			Result := val.truncated_to_integer
		end
	
	real_32_truncated_to_integer_64 (val: REAL): INTEGER_64 is
			-- Convert `val' into an INTEGER_64 value.
		do
			Result := val.truncated_to_integer_64
		end

	real_32_rounded_to_integer, real_32_rounded_to_integer_32 (val: REAL): INTEGER is
			-- Convert `val' into an INTEGER_32 value.
		do
			Result := (val + 0.5).truncated_to_integer
		end
	
	real_32_rounded_to_integer_64 (val: REAL): INTEGER_64 is
			-- Convert `val' into an INTEGER_64 value.
		do
			Result := (val + 0.5).truncated_to_integer_64
		end

	real_32_truncated_to_real_32, real_32_to_real_32 (val: REAL): REAL is
			-- Convert `val' into a REAL_32
		do
			Result := val
		end
	
	real_32_to_real_64 (val: REAL): DOUBLE is
			-- Convert `val' into a REAL_64
		do
			Result := val.to_double
		end






































	
feature -- Real_64 conversion


	real_64_truncated_to_integer, real_64_truncated_to_integer_32 (val: DOUBLE): INTEGER is
			-- Convert `val' into an INTEGER_32 value.
		do
			Result := val.truncated_to_integer
		end
	
	real_64_truncated_to_integer_64 (val: DOUBLE): INTEGER_64 is
			-- Convert `val' into an INTEGER_64 value.
		do
			Result := val.truncated_to_integer_64
		end

	real_64_rounded_to_integer, real_64_rounded_to_integer_32 (val: DOUBLE): INTEGER is
			-- Convert `val' into an INTEGER_32 value.
		do
			Result := (val + 0.5).truncated_to_integer
		end
	
	real_64_rounded_to_integer_64 (val: DOUBLE): INTEGER_64 is
			-- Convert `val' into an INTEGER_64 value.
		do
			Result := (val + 0.5).truncated_to_integer_64
		end

	real_64_truncated_to_real_32, real_64_to_real_32 (val: DOUBLE): REAL is
			-- Convert `val' into a REAL_32
		do
			Result := val.truncated_to_real
		end
	
	real_64_to_real_64 (val: DOUBLE): DOUBLE is
			-- Convert `val' into a REAL_64
		do
			Result := val
		end






































	
end -- NUMERIC_CONVERSION

