

indexing
	description: "Tags used by TIFF images"
	patterns: "none"
	date: "$Date: 2006-12-06 13:14:08 -0500 (Wed, 06 Dec 2006) $"
	revision: "$Revision: 271 $"
	status: "unreviewed"




class 

	TIFF_CONSTANTS

feature -- Initialization
feature -- Access - Tag data type information.
	
	tiff_notype: INTEGER is	
			--	placeholder 
		external
			"C macro use <tiff.h>"
		alias
			"TIFF_NOTYPE"
		end
	
	tiff_byte: INTEGER is	
			--	8-bit unsigned integer 
		external
			"C macro use <tiff.h>"
		alias
			"TIFF_BYTE"
		end
	
	tiff_ascii: INTEGER is	
			--	8-bit bytes w/ last byte null 
		external
			"C macro use <tiff.h>"
		alias
			"TIFF_ASCII"
		end
	
	tiff_short: INTEGER is	
			--	16-bit unsigned integer 
		external
			"C macro use <tiff.h>"
		alias
			"TIFF_SHORT"
		end
	
	tiff_long: INTEGER is	
			--	32-bit unsigned integer 
		external
			"C macro use <tiff.h>"
		alias
			"TIFF_LONG"
		end
	
	tiff_rational: INTEGER is	
			--	64-bit unsigned fraction 
		external
			"C macro use <tiff.h>"
		alias
			"TIFF_RATIONAL"
		end
	
	tiff_sbyte: INTEGER is	
			--	8-bit signed integer 
		external
			"C macro use <tiff.h>"
		alias
			"TIFF_SBYTE"
		end
	
	tiff_undefined: INTEGER is	
			--	8-bit untyped data 
		external
			"C macro use <tiff.h>"
		alias
			"TIFF_UNDEFINED"
		end
	
	tiff_sshort: INTEGER is	
			--	16-bit signed integer 
		external
			"C macro use <tiff.h>"
		alias
			"TIFF_SSHORT"
		end
	
	tiff_slong: INTEGER is	
			--	32-bit signed integer 
		external
			"C macro use <tiff.h>"
		alias
			"TIFF_SLONG"
		end
	
	tiff_srational: INTEGER is	
			--	64-bit signed fraction 
		external
			"C macro use <tiff.h>"
		alias
			"TIFF_SRATIONAL"
		end
	
	tiff_float: INTEGER is	
			--	32-bit IEEE floating point 
		external
			"C macro use <tiff.h>"
		alias
			"TIFF_FLOAT"
		end
	
	tiff_double: INTEGER is	
			--	64-bit IEEE floating point 
		external
			"C macro use <tiff.h>"
		alias
			"TIFF_DOUBLE"
		end	
	
feature -- Access
	
	tiff_version: INTEGER is	
			-- 42
		external
			"C macro use <tiff.h>"
		alias
			"TIFF_VERSION"
		end
	
	tiff_bigendian: INTEGER is		
			-- 0x4d4d
		external
			"C macro use <tiff.h>"
		alias
			"TIFF_BIGENDIAN"
		end
	
	tiff_littleendian: INTEGER is	
			-- 0x4949
		external
			"C macro use <tiff.h>"
		alias
			"TIFF_LITTLEENDIAN"
		end
	
	tifftag_subfiletype: INTEGER is		
			-- 254	/* subfile data descriptor */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_SUBFILETYPE"
		end
	
	filetype_reducedimage: INTEGER is	
			-- 0x1	/* reduced resolution version */
		external
			"C macro use <tiff.h>"
		alias
			"FILETYPE_REDUCEDIMAGE"
		end
	
	filetype_page: INTEGER is		
			-- 0x2	/* one page of many */
		external
			"C macro use <tiff.h>"
		alias
			"FILETYPE_PAGE"
		end
	
	filetype_mask: INTEGER is		
			-- 0x4	/* transparency mask */
		external
			"C macro use <tiff.h>"
		alias
			"FILETYPE_MASK"
		end
	
	tifftag_osubfiletype: INTEGER is		
			-- 255	/* +kind of data in subfile */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_OSUBFILETYPE"
		end
	
	ofiletype_image: INTEGER is		
			-- 1	/* full resolution image data */
		external
			"C macro use <tiff.h>"
		alias
			"OFILETYPE_IMAGE"
		end
	
	ofiletype_reducedimage: INTEGER is	
			-- 2	/* reduced size image data */
		external
			"C macro use <tiff.h>"
		alias
			"OFILETYPE_REDUCEDIMAGE"
		end
	
	ofiletype_page: INTEGER is		
			-- 3	/* one page of many */
		external
			"C macro use <tiff.h>"
		alias
			"OFILETYPE_PAGE"
		end
	
	tifftag_imagewidth: INTEGER is		
			-- 256	/* image width in pixels */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_IMAGEWIDTH"
		end
	
	tifftag_imagelength: INTEGER is		
			-- 257	/* image height in pixels */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_IMAGELENGTH"
		end
	
	tifftag_bitspersample: INTEGER is		
			-- 258	/* bits per channel (sample) */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_BITSPERSAMPLE"
		end
	
	tifftag_compression: INTEGER is		
			-- 259	/* data compression technique */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_COMPRESSION"
		end
	
	compression_none: INTEGER is		
			-- 1	/* dump mode */
		external
			"C macro use <tiff.h>"
		alias
			"COMPRESSION_NONE"
		end
	
	compression_ccittrle: INTEGER is	
			-- 2	/* CCITT modified Huffman RLE */
		external
			"C macro use <tiff.h>"
		alias
			"COMPRESSION_CCITTRLE"
		end
	
	compression_ccittfax3: INTEGER is	
			-- 3	/* CCITT Group 3 fax encoding */
		external
			"C macro use <tiff.h>"
		alias
			"COMPRESSION_CCITTFAX3"
		end
	
	compression_ccitt_t4: INTEGER is		
			-- 3	   /* CCITT T.4 (TIFF 6 name) */
		external
			"C macro use <tiff.h>"
		alias
			"COMPRESSION_CCITT_T4"
		end
	
	compression_ccittfax4: INTEGER is	
			-- 4	/* CCITT Group 4 fax encoding */
		external
			"C macro use <tiff.h>"
		alias
			"COMPRESSION_CCITTFAX4"
		end
	
	compression_ccitt_t6: INTEGER is		
			-- 4	   /* CCITT T.6 (TIFF 6 name) */
		external
			"C macro use <tiff.h>"
		alias
			"COMPRESSION_CCITT_T6"
		end
	
	compression_lzw: INTEGER is		
			-- 5	   /* Lempel-Ziv  & Welch */
		external
			"C macro use <tiff.h>"
		alias
			"COMPRESSION_LZW"
		end
	
	compression_ojpeg: INTEGER is		
			-- 6	/* !6.0 JPEG */
		external
			"C macro use <tiff.h>"
		alias
			"COMPRESSION_OJPEG"
		end
	
	compression_jpeg: INTEGER is		
			-- 7	/* %JPEG DCT compression */
		external
			"C macro use <tiff.h>"
		alias
			"COMPRESSION_JPEG"
		end
	
	compression_next: INTEGER is		
			-- 32766	/* NeXT 2-bit RLE */
		external
			"C macro use <tiff.h>"
		alias
			"COMPRESSION_NEXT"
		end
	
	compression_ccittrlew: INTEGER is	
			-- 32771	/* #1 w/ word alignment */
		external
			"C macro use <tiff.h>"
		alias
			"COMPRESSION_CCITTRLEW"
		end
	
	compression_packbits: INTEGER is	
			-- 32773	/* Macintosh RLE */
		external
			"C macro use <tiff.h>"
		alias
			"COMPRESSION_PACKBITS"
		end
	
	compression_thunderscan: INTEGER is	
			-- 32809	/* ThunderScan RLE */
		external
			"C macro use <tiff.h>"
		alias
			"COMPRESSION_THUNDERSCAN"
		end
	
	compression_it8ctpad: INTEGER is	
			-- 32895   /* IT8 CT w/padding */
		external
			"C macro use <tiff.h>"
		alias
			"COMPRESSION_IT8CTPAD"
		end
	
	compression_it8lw: INTEGER is		
			-- 32896   /* IT8 Linework RLE */
		external
			"C macro use <tiff.h>"
		alias
			"COMPRESSION_IT8LW"
		end
	
	compression_it8mp: INTEGER is		
			-- 32897   /* IT8 Monochrome picture */
		external
			"C macro use <tiff.h>"
		alias
			"COMPRESSION_IT8MP"
		end
	
	compression_it8bl: INTEGER is		
			-- 32898   /* IT8 Binary line art */
		external
			"C macro use <tiff.h>"
		alias
			"COMPRESSION_IT8BL"
		end
	
	compression_pixarfilm: INTEGER is	
			-- 32908   /* Pixar companded 10bit LZW */
		external
			"C macro use <tiff.h>"
		alias
			"COMPRESSION_PIXARFILM"
		end
	
	compression_pixarlog: INTEGER is	
			-- 32909   /* Pixar companded 11bit ZIP */
		external
			"C macro use <tiff.h>"
		alias
			"COMPRESSION_PIXARLOG"
		end
	
	compression_deflate: INTEGER is		
			-- 32946	/* Deflate compression */
		external
			"C macro use <tiff.h>"
		alias
			"COMPRESSION_DEFLATE"
		end
	
	compression_adobe_deflate: INTEGER is	
			-- 8	   /* Deflate compression, as recognized by Adobe */
		external
			"C macro use <tiff.h>"
		alias
			"COMPRESSION_ADOBE_DEFLATE"
		end
	
	compression_dcs: INTEGER is				
			-- 32947   /* Kodak DCS encoding */
		external
			"C macro use <tiff.h>"
		alias
			"COMPRESSION_DCS"
		end
	
	compression_jbig: INTEGER is		
			-- 34661	/* ISO JBIG */
		external
			"C macro use <tiff.h>"
		alias
			"COMPRESSION_JBIG"
		end
	
	compression_sgilog: INTEGER is		
			-- 34676	/* SGI Log Luminance RLE */
		external
			"C macro use <tiff.h>"
		alias
			"COMPRESSION_SGILOG"
		end
	
	compression_sgilog24: INTEGER is	
			-- 34677	/* SGI Log 24-bit packed */
		external
			"C macro use <tiff.h>"
		alias
			"COMPRESSION_SGILOG24"
		end
	
	tifftag_photometric: INTEGER is		
			-- 262	/* photometric interpretation */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_PHOTOMETRIC"
		end
	
	photometric_miniswhite: INTEGER is	
			-- 0	/* min value is white */
		external
			"C macro use <tiff.h>"
		alias
			"PHOTOMETRIC_MINISWHITE"
		end
	
	photometric_minisblack: INTEGER is	
			-- 1	/* min value is black */
		external
			"C macro use <tiff.h>"
		alias
			"PHOTOMETRIC_MINISBLACK"
		end
	
	photometric_rgb: INTEGER is		
			-- 2	/* RGB color model */
		external
			"C macro use <tiff.h>"
		alias
			"PHOTOMETRIC_RGB"
		end
	
	photometric_palette: INTEGER is		
			-- 3	/* color map indexed */
		external
			"C macro use <tiff.h>"
		alias
			"PHOTOMETRIC_PALETTE"
		end
	
	photometric_mask: INTEGER is		
			-- 4	/* $holdout mask */
		external
			"C macro use <tiff.h>"
		alias
			"PHOTOMETRIC_MASK"
		end
	
	photometric_separated: INTEGER is	
			-- 5	/* !color separations */
		external
			"C macro use <tiff.h>"
		alias
			"PHOTOMETRIC_SEPARATED"
		end
	
	photometric_ycbcr: INTEGER is		
			-- 6	/* !CCIR 601 */
		external
			"C macro use <tiff.h>"
		alias
			"PHOTOMETRIC_YCBCR"
		end
	
	photometric_cielab: INTEGER is		
			-- 8	/* !1976 CIE L*a*b* */
		external
			"C macro use <tiff.h>"
		alias
			"PHOTOMETRIC_CIELAB"
		end
	
	photometric_itulab: INTEGER is		
			-- 10	/* ITU L*a*b* */
		external
			"C macro use <tiff.h>"
		alias
			"PHOTOMETRIC_ITULAB"
		end
	
	photometric_logl: INTEGER is		
			-- 32844	/* CIE Log2(L) */
		external
			"C macro use <tiff.h>"
		alias
			"PHOTOMETRIC_LOGL"
		end
	
	photometric_logluv: INTEGER is		
			-- 32845	/* CIE Log2(L) (u',v') */
		external
			"C macro use <tiff.h>"
		alias
			"PHOTOMETRIC_LOGLUV"
		end
	
	tifftag_threshholding: INTEGER is		
			-- 263	/* +thresholding used on data */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_THRESHHOLDING"
		end
	
	threshhold_bilevel: INTEGER is		
			-- 1	/* b&w art scan */
		external
			"C macro use <tiff.h>"
		alias
			"THRESHHOLD_BILEVEL"
		end
	
	threshhold_halftone: INTEGER is		
			-- 2	/* or dithered scan */
		external
			"C macro use <tiff.h>"
		alias
			"THRESHHOLD_HALFTONE"
		end
	
	threshhold_errordiffuse: INTEGER is	
			-- 3	/* usually floyd-steinberg */
		external
			"C macro use <tiff.h>"
		alias
			"THRESHHOLD_ERRORDIFFUSE"
		end
	
	tifftag_cellwidth: INTEGER is		
			-- 264	/* +dithering matrix width */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_CELLWIDTH"
		end
	
	tifftag_celllength: INTEGER is		
			-- 265	/* +dithering matrix height */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_CELLLENGTH"
		end
	
	tifftag_fillorder: INTEGER is		
			-- 266	/* data order within a byte */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_FILLORDER"
		end
	
	fillorder_msb2lsb: INTEGER is		
			-- 1	/* most significant -> least */
		external
			"C macro use <tiff.h>"
		alias
			"FILLORDER_MSB2LSB"
		end
	
	fillorder_lsb2msb: INTEGER is		
			-- 2	/* least significant -> most */
		external
			"C macro use <tiff.h>"
		alias
			"FILLORDER_LSB2MSB"
		end
	
	tifftag_documentname: INTEGER is		
			-- 269	/* name of doc. image is from */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_DOCUMENTNAME"
		end
	
	tifftag_imagedescription: INTEGER is	
			-- 270	/* info about image */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_IMAGEDESCRIPTION"
		end
	
	tifftag_make: INTEGER is			
			-- 271	/* scanner manufacturer name */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_MAKE"
		end
	
	tifftag_model: INTEGER is			
			-- 272	/* scanner model name/number */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_MODEL"
		end
	
	tifftag_stripoffsets: INTEGER is		
			-- 273	/* offsets to data strips */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_STRIPOFFSETS"
		end
	
	tifftag_orientation: INTEGER is		
			-- 274	/* +image orientation */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_ORIENTATION"
		end
	
	orientation_topleft: INTEGER is		
			-- 1	/* row 0 top, col 0 lhs */
		external
			"C macro use <tiff.h>"
		alias
			"ORIENTATION_TOPLEFT"
		end
	
	orientation_topright: INTEGER is	
			-- 2	/* row 0 top, col 0 rhs */
		external
			"C macro use <tiff.h>"
		alias
			"ORIENTATION_TOPRIGHT"
		end
	
	orientation_botright: INTEGER is	
			-- 3	/* row 0 bottom, col 0 rhs */
		external
			"C macro use <tiff.h>"
		alias
			"ORIENTATION_BOTRIGHT"
		end
	
	orientation_botleft: INTEGER is		
			-- 4	/* row 0 bottom, col 0 lhs */
		external
			"C macro use <tiff.h>"
		alias
			"ORIENTATION_BOTLEFT"
		end
	
	orientation_lefttop: INTEGER is		
			-- 5	/* row 0 lhs, col 0 top */
		external
			"C macro use <tiff.h>"
		alias
			"ORIENTATION_LEFTTOP"
		end
	
	orientation_righttop: INTEGER is	
			-- 6	/* row 0 rhs, col 0 top */
		external
			"C macro use <tiff.h>"
		alias
			"ORIENTATION_RIGHTTOP"
		end
	
	orientation_rightbot: INTEGER is	
			-- 7	/* row 0 rhs, col 0 bottom */
		external
			"C macro use <tiff.h>"
		alias
			"ORIENTATION_RIGHTBOT"
		end
	
	orientation_leftbot: INTEGER is		
			-- 8	/* row 0 lhs, col 0 bottom */
		external
			"C macro use <tiff.h>"
		alias
			"ORIENTATION_LEFTBOT"
		end
	
	tifftag_samplesperpixel: INTEGER is		
			-- 277	/* samples per pixel */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_SAMPLESPERPIXEL"
		end
	
	tifftag_rowsperstrip: INTEGER is		
			-- 278	/* rows per strip of data */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_ROWSPERSTRIP"
		end
	
	tifftag_stripbytecounts: INTEGER is		
			-- 279	/* bytes counts for strips */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_STRIPBYTECOUNTS"
		end
	
	tifftag_minsamplevalue: INTEGER is		
			-- 280	/* +minimum sample value */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_MINSAMPLEVALUE"
		end
	
	tifftag_maxsamplevalue: INTEGER is		
			-- 281	/* +maximum sample value */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_MAXSAMPLEVALUE"
		end
	
	tifftag_xresolution: INTEGER is		
			-- 282	/* pixels/resolution in x */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_XRESOLUTION"
		end
	
	tifftag_yresolution: INTEGER is		
			-- 283	/* pixels/resolution in y */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_YRESOLUTION"
		end
	
	tifftag_planarconfig: INTEGER is		
			-- 284	/* storage organization */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_PLANARCONFIG"
		end
	
	planarconfig_contig: INTEGER is		
			-- 1	/* single image plane */
		external
			"C macro use <tiff.h>"
		alias
			"PLANARCONFIG_CONTIG"
		end
	
	planarconfig_separate: INTEGER is	
			-- 2	/* separate planes of data */
		external
			"C macro use <tiff.h>"
		alias
			"PLANARCONFIG_SEPARATE"
		end
	
	tifftag_pagename: INTEGER is		
			-- 285	/* page name image is from */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_PAGENAME"
		end
	
	tifftag_xposition: INTEGER is		
			-- 286	/* x page offset of image lhs */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_XPOSITION"
		end
	
	tifftag_yposition: INTEGER is		
			-- 287	/* y page offset of image lhs */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_YPOSITION"
		end
	
	tifftag_freeoffsets: INTEGER is		
			-- 288	/* +byte offset to free block */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_FREEOFFSETS"
		end
	
	tifftag_freebytecounts: INTEGER is		
			-- 289	/* +sizes of free blocks */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_FREEBYTECOUNTS"
		end
	
	tifftag_grayresponseunit: INTEGER is	
			-- 290	/* $gray scale curve accuracy */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_GRAYRESPONSEUNIT"
		end
	
	grayresponseunit_10s: INTEGER is	
			-- 1	/* tenths of a unit */
		external
			"C macro use <tiff.h>"
		alias
			"GRAYRESPONSEUNIT_10S"
		end
	
	grayresponseunit_100s: INTEGER is	
			-- 2	/* hundredths of a unit */
		external
			"C macro use <tiff.h>"
		alias
			"GRAYRESPONSEUNIT_100S"
		end
	
	grayresponseunit_1000s: INTEGER is	
			-- 3	/* thousandths of a unit */
		external
			"C macro use <tiff.h>"
		alias
			"GRAYRESPONSEUNIT_1000S"
		end
	
	grayresponseunit_10000s: INTEGER is	
			-- 4	/* ten-thousandths of a unit */
		external
			"C macro use <tiff.h>"
		alias
			"GRAYRESPONSEUNIT_10000S"
		end
	
	grayresponseunit_100000s: INTEGER is	
			-- 5	/* hundred-thousandths */
		external
			"C macro use <tiff.h>"
		alias
			"GRAYRESPONSEUNIT_100000S"
		end
	
	tifftag_grayresponsecurve: INTEGER is	
			-- 291	/* $gray scale response curve */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_GRAYRESPONSECURVE"
		end
	
	tifftag_group3options: INTEGER is		
			-- 292	/* 32 flag bits */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_GROUP3OPTIONS"
		end
	
	tifftag_t4options: INTEGER is		
			-- 292	/* TIFF 6.0 proper name alias */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_T4OPTIONS"
		end
	
	group3opt_2dencoding: INTEGER is	
			-- 0x1	/* 2-dimensional coding */
		external
			"C macro use <tiff.h>"
		alias
			"GROUP3OPT_2DENCODING"
		end
	
	group3opt_uncompressed: INTEGER is	
			-- 0x2	/* data not compressed */
		external
			"C macro use <tiff.h>"
		alias
			"GROUP3OPT_UNCOMPRESSED"
		end
	
	group3opt_fillbits: INTEGER is		
			-- 0x4	/* fill to byte boundary */
		external
			"C macro use <tiff.h>"
		alias
			"GROUP3OPT_FILLBITS"
		end
	
	tifftag_group4options: INTEGER is		
			-- 293	/* 32 flag bits */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_GROUP4OPTIONS"
		end
	
	tifftag_t6options: INTEGER is				
			-- 293	   /* TIFF 6.0 proper name */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_T6OPTIONS"
		end
	
	group4opt_uncompressed: INTEGER is	
			-- 0x2	/* data not compressed */
		external
			"C macro use <tiff.h>"
		alias
			"GROUP4OPT_UNCOMPRESSED"
		end
	
	tifftag_resolutionunit: INTEGER is		
			-- 296	/* units of resolutions */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_RESOLUTIONUNIT"
		end
	
	resunit_none: INTEGER is		
			-- 1	/* no meaningful units */
		external
			"C macro use <tiff.h>"
		alias
			"RESUNIT_NONE"
		end
	
	resunit_inch: INTEGER is		
			-- 2	/* english */
		external
			"C macro use <tiff.h>"
		alias
			"RESUNIT_INCH"
		end
	
	resunit_centimeter: INTEGER is		
			-- 3	/* metric */
		external
			"C macro use <tiff.h>"
		alias
			"RESUNIT_CENTIMETER"
		end
	
	tifftag_pagenumber: INTEGER is		
			-- 297	/* page numbers of multi-page */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_PAGENUMBER"
		end
	
	tifftag_colorresponseunit: INTEGER is	
			-- 300	/* $color curve accuracy */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_COLORRESPONSEUNIT"
		end
	
	colorresponseunit_10s: INTEGER is	
			-- 1	/* tenths of a unit */
		external
			"C macro use <tiff.h>"
		alias
			"COLORRESPONSEUNIT_10S"
		end
	
	colorresponseunit_100s: INTEGER is	
			-- 2	/* hundredths of a unit */
		external
			"C macro use <tiff.h>"
		alias
			"COLORRESPONSEUNIT_100S"
		end
	
	colorresponseunit_1000s: INTEGER is	
			-- 3	/* thousandths of a unit */
		external
			"C macro use <tiff.h>"
		alias
			"COLORRESPONSEUNIT_1000S"
		end
	
	colorresponseunit_10000s: INTEGER is	
			-- 4	/* ten-thousandths of a unit */
		external
			"C macro use <tiff.h>"
		alias
			"COLORRESPONSEUNIT_10000S"
		end
	
	colorresponseunit_100000s: INTEGER is	
			-- 5	/* hundred-thousandths */
		external
			"C macro use <tiff.h>"
		alias
			"COLORRESPONSEUNIT_100000S"
		end
	
	tifftag_transferfunction: INTEGER is	
			-- 301	/* !colorimetry info */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_TRANSFERFUNCTION"
		end
	
	tifftag_software: INTEGER is		
			-- 305	/* name & release */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_SOFTWARE"
		end
	
	tifftag_datetime: INTEGER is		
			-- 306	/* creation date and time */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_DATETIME"
		end
	
	tifftag_artist: INTEGER is			
			-- 315	/* creator of image */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_ARTIST"
		end
	
	tifftag_hostcomputer: INTEGER is		
			-- 316	/* machine where created */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_HOSTCOMPUTER"
		end
	
	tifftag_predictor: INTEGER is		
			-- 317	/* prediction scheme w/ LZW */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_PREDICTOR"
		end
	
	tifftag_whitepoint: INTEGER is		
			-- 318	/* image white point */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_WHITEPOINT"
		end
	
	tifftag_primarychromaticities: INTEGER is	
			-- 319	/* !primary chromaticities */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_PRIMARYCHROMATICITIES"
		end
	
	tifftag_colormap: INTEGER is		
			-- 320	/* RGB map for pallette image */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_COLORMAP"
		end
	
	tifftag_halftonehints: INTEGER is		
			-- 321	/* !highlight+shadow info */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_HALFTONEHINTS"
		end
	
	tifftag_tilewidth: INTEGER is		
			-- 322	/* !rows/data tile */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_TILEWIDTH"
		end
	
	tifftag_tilelength: INTEGER is		
			-- 323	/* !cols/data tile */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_TILELENGTH"
		end
	
	tifftag_tileoffsets: INTEGER is		
			-- 324	/* !offsets to data tiles */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_TILEOFFSETS"
		end
	
	tifftag_tilebytecounts: INTEGER is		
			-- 325	/* !byte counts for tiles */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_TILEBYTECOUNTS"
		end
	
	tifftag_badfaxlines: INTEGER is		
			-- 326	/* lines w/ wrong pixel count */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_BADFAXLINES"
		end
	
	tifftag_cleanfaxdata: INTEGER is		
			-- 327	/* regenerated line info */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_CLEANFAXDATA"
		end
	
	cleanfaxdata_clean: INTEGER is		
			-- 0	/* no errors detected */
		external
			"C macro use <tiff.h>"
		alias
			"CLEANFAXDATA_CLEAN"
		end
	
	cleanfaxdata_regenerated: INTEGER is	
			-- 1	/* receiver regenerated lines */
		external
			"C macro use <tiff.h>"
		alias
			"CLEANFAXDATA_REGENERATED"
		end
	
	cleanfaxdata_unclean: INTEGER is	
			-- 2	/* uncorrected errors exist */
		external
			"C macro use <tiff.h>"
		alias
			"CLEANFAXDATA_UNCLEAN"
		end
	
	tifftag_consecutivebadfaxlines: INTEGER is	
			-- 328	/* max consecutive bad lines */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_CONSECUTIVEBADFAXLINES"
		end
	
	tifftag_subifd: INTEGER is			
			-- 330	/* subimage descriptors */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_SUBIFD"
		end
	
	tifftag_inkset: INTEGER is			
			-- 332	/* !inks in separated image */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_INKSET"
		end
	
	inkset_cmyk: INTEGER is			
			-- 1	/* !cyan-magenta-yellow-black */
		external
			"C macro use <tiff.h>"
		alias
			"INKSET_CMYK"
		end
	
	tifftag_inknames: INTEGER is		
			-- 333	/* !ascii names of inks */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_INKNAMES"
		end
	
	tifftag_numberofinks: INTEGER is		
			-- 334	/* !number of inks */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_NUMBEROFINKS"
		end
	
	tifftag_dotrange: INTEGER is		
			-- 336	/* !0% and 100% dot codes */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_DOTRANGE"
		end
	
	tifftag_targetprinter: INTEGER is		
			-- 337	/* !separation target */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_TARGETPRINTER"
		end
	
	tifftag_extrasamples: INTEGER is		
			-- 338	/* !info about extra samples */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_EXTRASAMPLES"
		end
	
	extrasample_unspecified: INTEGER is	
			-- 0	/* !unspecified data */
		external
			"C macro use <tiff.h>"
		alias
			"EXTRASAMPLE_UNSPECIFIED"
		end
	
	extrasample_assocalpha: INTEGER is	
			-- 1	/* !associated alpha data */
		external
			"C macro use <tiff.h>"
		alias
			"EXTRASAMPLE_ASSOCALPHA"
		end
	
	extrasample_unassalpha: INTEGER is	
			-- 2	/* !unassociated alpha data */
		external
			"C macro use <tiff.h>"
		alias
			"EXTRASAMPLE_UNASSALPHA"
		end
	
	tifftag_sampleformat: INTEGER is		
			-- 339	/* !data sample format */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_SAMPLEFORMAT"
		end
	
	sampleformat_uint: INTEGER is		
			-- 1	/* !unsigned integer data */
		external
			"C macro use <tiff.h>"
		alias
			"SAMPLEFORMAT_UINT"
		end
	
	sampleformat_int: INTEGER is		
			-- 2	/* !signed integer data */
		external
			"C macro use <tiff.h>"
		alias
			"SAMPLEFORMAT_INT"
		end
	
	sampleformat_ieeefp: INTEGER is		
			-- 3	/* !IEEE floating point data */
		external
			"C macro use <tiff.h>"
		alias
			"SAMPLEFORMAT_IEEEFP"
		end
	
	sampleformat_void: INTEGER is		
			-- 4	/* !untyped data */
		external
			"C macro use <tiff.h>"
		alias
			"SAMPLEFORMAT_VOID"
		end
	
	sampleformat_complexint: INTEGER is	
			-- 5	/* !complex signed int */
		external
			"C macro use <tiff.h>"
		alias
			"SAMPLEFORMAT_COMPLEXINT"
		end
	
	sampleformat_complexieeefp: INTEGER is	
			-- 6	/* !complex ieee floating */
		external
			"C macro use <tiff.h>"
		alias
			"SAMPLEFORMAT_COMPLEXIEEEFP"
		end
	
	tifftag_sminsamplevalue: INTEGER is		
			-- 340	/* !variable MinSampleValue */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_SMINSAMPLEVALUE"
		end
	
	tifftag_smaxsamplevalue: INTEGER is		
			-- 341	/* !variable MaxSampleValue */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_SMAXSAMPLEVALUE"
		end
	
	tifftag_jpegtables: INTEGER is		
			-- 347	/* %JPEG table stream */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_JPEGTABLES"
		end
	
	tifftag_jpegproc: INTEGER is		
			-- 512	/* !JPEG processing algorithm */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_JPEGPROC"
		end
	
	jpegproc_baseline: INTEGER is		
			-- 1	/* !baseline sequential */
		external
			"C macro use <tiff.h>"
		alias
			"JPEGPROC_BASELINE"
		end
	
	jpegproc_lossless: INTEGER is		
			-- 14	/* !Huffman coded lossless */
		external
			"C macro use <tiff.h>"
		alias
			"JPEGPROC_LOSSLESS"
		end
	
	tifftag_jpegifoffset: INTEGER is		
			-- 513	/* !pointer to SOI marker */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_JPEGIFOFFSET"
		end
	
	tifftag_jpegifbytecount: INTEGER is		
			-- 514	/* !JFIF stream length */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_JPEGIFBYTECOUNT"
		end
	
	tifftag_jpegrestartinterval: INTEGER is	
			-- 515	/* !restart interval length */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_JPEGRESTARTINTERVAL"
		end
	
	tifftag_jpeglosslesspredictors: INTEGER is	
			-- 517	/* !lossless proc predictor */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_JPEGLOSSLESSPREDICTORS"
		end
	
	tifftag_jpegpointtransform: INTEGER is	
			-- 518	/* !lossless point transform */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_JPEGPOINTTRANSFORM"
		end
	
	tifftag_jpegqtables: INTEGER is		
			-- 519	/* !Q matrice offsets */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_JPEGQTABLES"
		end
	
	tifftag_jpegdctables: INTEGER is		
			-- 520	/* !DCT table offsets */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_JPEGDCTABLES"
		end
	
	tifftag_jpegactables: INTEGER is		
			-- 521	/* !AC coefficient offsets */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_JPEGACTABLES"
		end
	
	tifftag_ycbcrcoefficients: INTEGER is	
			-- 529	/* !RGB -> YCbCr transform */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_YCBCRCOEFFICIENTS"
		end
	
	tifftag_ycbcrsubsampling: INTEGER is	
			-- 530	/* !YCbCr subsampling factors */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_YCBCRSUBSAMPLING"
		end
	
	tifftag_ycbcrpositioning: INTEGER is	
			-- 531	/* !subsample positioning */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_YCBCRPOSITIONING"
		end
	
	ycbcrposition_centered: INTEGER is	
			-- 1	/* !as in PostScript Level 2 */
		external
			"C macro use <tiff.h>"
		alias
			"YCBCRPOSITION_CENTERED"
		end
	
	ycbcrposition_cosited: INTEGER is	
			-- 2	/* !as in CCIR 601-1 */
		external
			"C macro use <tiff.h>"
		alias
			"YCBCRPOSITION_COSITED"
		end
	
	tifftag_referenceblackwhite: INTEGER is	
			-- 532	/* !colorimetry info */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_REFERENCEBLACKWHITE"
		end
	
	tifftag_refpts: INTEGER is			
			-- 32953	/* image reference points */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_REFPTS"
		end
	
	tifftag_regiontackpoint: INTEGER is		
			-- 32954	/* region-xform tack point */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_REGIONTACKPOINT"
		end
	
	tifftag_regionwarpcorners: INTEGER is	
			-- 32955	/* warp quadrilateral */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_REGIONWARPCORNERS"
		end
	
	tifftag_regionaffine: INTEGER is		
			-- 32956	/* affine transformation mat */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_REGIONAFFINE"
		end
	
	tifftag_matteing: INTEGER is		
			-- 32995	/* $use ExtraSamples */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_MATTEING"
		end
	
	tifftag_datatype: INTEGER is		
			-- 32996	/* $use SampleFormat */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_DATATYPE"
		end
	
	tifftag_imagedepth: INTEGER is		
			-- 32997	/* z depth of image */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_IMAGEDEPTH"
		end
	
	tifftag_tiledepth: INTEGER is		
			-- 32998	/* z depth/data tile */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_TILEDEPTH"
		end
	
	tifftag_pixar_imagefullwidth: INTEGER is	
			-- 33300   /* full image size in x */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_PIXAR_IMAGEFULLWIDTH"
		end
	
	tifftag_pixar_imagefulllength: INTEGER is	
			-- 33301   /* full image size in y */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_PIXAR_IMAGEFULLLENGTH"
		end
	
	tifftag_pixar_textureformat: INTEGER is	
			-- 33302	/* texture map format */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_PIXAR_TEXTUREFORMAT"
		end
	
	tifftag_pixar_wrapmodes: INTEGER is		
			-- 33303	/* s & t wrap modes */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_PIXAR_WRAPMODES"
		end
	
	tifftag_pixar_fovcot: INTEGER is		
			-- 33304	/* cotan(fov) for env. maps */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_PIXAR_FOVCOT"
		end
	
	tifftag_pixar_matrix_worldtoscreen: INTEGER is 
			-- 33305
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_PIXAR_MATRIX_WORLDTOSCREEN"
		end
	
	tifftag_pixar_matrix_worldtocamera: INTEGER is 
			-- 33306
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_PIXAR_MATRIX_WORLDTOCAMERA"
		end
	
	tifftag_writerserialnumber: INTEGER is		
			-- 33405   /* device serial number */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_WRITERSERIALNUMBER"
		end
	
	tifftag_copyright: INTEGER is		
			-- 33432	/* copyright string */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_COPYRIGHT"
		end
	
	tifftag_richtiffiptc: INTEGER is	
			-- 33723
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_RICHTIFFIPTC"
		end
	
	tifftag_it8site: INTEGER is			
			-- 34016	/* site name */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_IT8SITE"
		end
	
	tifftag_it8colorsequence: INTEGER is	
			-- 34017	/* color seq. [RGB,CMYK,etc] */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_IT8COLORSEQUENCE"
		end
	
	tifftag_it8header: INTEGER is		
			-- 34018	/* DDES Header */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_IT8HEADER"
		end
	
	tifftag_it8rasterpadding: INTEGER is	
			-- 34019	/* raster scanline padding */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_IT8RASTERPADDING"
		end
	
	tifftag_it8bitsperrunlength: INTEGER is	
			-- 34020	/* # of bits in short run */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_IT8BITSPERRUNLENGTH"
		end
	
	tifftag_it8bitsperextendedrunlength: INTEGER is 
			-- 34021/* # of bits in long run */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_IT8BITSPEREXTENDEDRUNLENGTH"
		end
	
	tifftag_it8colortable: INTEGER is		
			-- 34022	/* LW colortable */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_IT8COLORTABLE"
		end
	
	tifftag_it8imagecolorindicator: INTEGER is	
			-- 34023	/* BP/BL image color switch */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_IT8IMAGECOLORINDICATOR"
		end
	
	tifftag_it8bkgcolorindicator: INTEGER is	
			-- 34024	/* BP/BL bg color switch */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_IT8BKGCOLORINDICATOR"
		end
	
	tifftag_it8imagecolorvalue: INTEGER is	
			-- 34025	/* BP/BL image color value */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_IT8IMAGECOLORVALUE"
		end
	
	tifftag_it8bkgcolorvalue: INTEGER is	
			-- 34026	/* BP/BL bg color value */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_IT8BKGCOLORVALUE"
		end
	
	tifftag_it8pixelintensityrange: INTEGER is	
			-- 34027	/* MP pixel intensity value */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_IT8PIXELINTENSITYRANGE"
		end
	
	tifftag_it8transparencyindicator: INTEGER is 
			-- 34028	/* HC transparency switch */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_IT8TRANSPARENCYINDICATOR"
		end
	
	tifftag_it8colorcharacterization: INTEGER is 
			-- 34029	/* color character. table */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_IT8COLORCHARACTERIZATION"
		end
	
	tifftag_framecount: INTEGER is				
			-- 34232   /* Sequence Frame Count */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_FRAMECOUNT"
		end
	
	tifftag_iccprofile: INTEGER is		
			-- 34675	/* ICC profile data */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_ICCPROFILE"
		end
	
	tifftag_photoshop: INTEGER is				
			-- 34377 
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_PHOTOSHOP"
		end
	
	tifftag_jbigoptions: INTEGER is		
			-- 34750	/* JBIG options */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_JBIGOPTIONS"
		end
	
	tifftag_faxrecvparams: INTEGER is		
			-- 34908	/* encoded Class 2 ses. parms */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_FAXRECVPARAMS"
		end
	
	tifftag_faxsubaddress: INTEGER is		
			-- 34909	/* received SubAddr string */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_FAXSUBADDRESS"
		end
	
	tifftag_faxrecvtime: INTEGER is		
			-- 34910	/* receive time (secs) */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_FAXRECVTIME"
		end
	
	tifftag_stonits: INTEGER is			
			-- 37439	/* Sample value to Nits */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_STONITS"
		end
	
	tifftag_fedex_edr: INTEGER is		
			-- 34929	/* unknown use */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_FEDEX_EDR"
		end
	
	tifftag_dcshueshiftvalues: INTEGER is		
			-- 65535   /* hue shift correction data */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_DCSHUESHIFTVALUES"
		end
	
	tifftag_faxmode: INTEGER is			
			-- 65536	/* Group 3/4 format control */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_FAXMODE"
		end
	
	faxmode_classic: INTEGER is	
			-- 0x0000		/* default, include RTC */
		external
			"C macro use <tiff.h>"
		alias
			"FAXMODE_CLASSIC"
		end
	
	faxmode_nortc: INTEGER is	
			-- 0x0001		/* no RTC at end of data */
		external
			"C macro use <tiff.h>"
		alias
			"FAXMODE_NORTC"
		end
	
	faxmode_noeol: INTEGER is	
			-- 0x0002		/* no EOL code at end of row */
		external
			"C macro use <tiff.h>"
		alias
			"FAXMODE_NOEOL"
		end
	
	faxmode_bytealign: INTEGER is	
			-- 0x0004		/* byte align row */
		external
			"C macro use <tiff.h>"
		alias
			"FAXMODE_BYTEALIGN"
		end
	
	faxmode_wordalign: INTEGER is	
			-- 0x0008		/* word align row */
		external
			"C macro use <tiff.h>"
		alias
			"FAXMODE_WORDALIGN"
		end
	
	faxmode_classf: INTEGER is	
			-- FAXMODE_NORTC	/* TIFF Class F */
		external
			"C macro use <tiff.h>"
		alias
			"FAXMODE_CLASSF"
		end
	
	tifftag_jpegquality: INTEGER is		
			-- 65537	/* Compression quality level */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_JPEGQUALITY"
		end
	
	tifftag_jpegcolormode: INTEGER is		
			-- 65538	/* Auto RGB<=>YCbCr convert? */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_JPEGCOLORMODE"
		end
	
	jpegcolormode_raw: INTEGER is	
			-- 0x0000		/* no conversion (default) */
		external
			"C macro use <tiff.h>"
		alias
			"JPEGCOLORMODE_RAW"
		end
	
	jpegcolormode_rgb: INTEGER is	
			-- 0x0001		/* do auto conversion */
		external
			"C macro use <tiff.h>"
		alias
			"JPEGCOLORMODE_RGB"
		end
	
	tifftag_jpegtablesmode: INTEGER is		
			-- 65539	/* What to put in JPEGTables */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_JPEGTABLESMODE"
		end
	
	jpegtablesmode_quant: INTEGER is 
			-- 0x0001		/* include quantization tbls */
		external
			"C macro use <tiff.h>"
		alias
			"JPEGTABLESMODE_QUANT"
		end
	
	jpegtablesmode_huff: INTEGER is	
			-- 0x0002		/* include Huffman tbls */
		external
			"C macro use <tiff.h>"
		alias
			"JPEGTABLESMODE_HUFF"
		end
	
	tifftag_faxfillfunc: INTEGER is		
			-- 65540	/* G3/G4 fill function */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_FAXFILLFUNC"
		end
	
	tifftag_pixarlogdatafmt: INTEGER is		
			-- 65549	/* PixarLogCodec I/O data sz */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_PIXARLOGDATAFMT"
		end
	
	pixarlogdatafmt_8bit: INTEGER is	
			-- 0	/* regular u_char samples */
		external
			"C macro use <tiff.h>"
		alias
			"PIXARLOGDATAFMT_8BIT"
		end
	
	pixarlogdatafmt_8bitabgr: INTEGER is	
			-- 1	/* ABGR-order u_chars */
		external
			"C macro use <tiff.h>"
		alias
			"PIXARLOGDATAFMT_8BITABGR"
		end
	
	pixarlogdatafmt_11bitlog: INTEGER is	
			-- 2	/* 11-bit log-encoded (raw) */
		external
			"C macro use <tiff.h>"
		alias
			"PIXARLOGDATAFMT_11BITLOG"
		end
	
	pixarlogdatafmt_12bitpicio: INTEGER is	
			-- 3	/* as per PICIO (1.0==2048) */
		external
			"C macro use <tiff.h>"
		alias
			"PIXARLOGDATAFMT_12BITPICIO"
		end
	
	pixarlogdatafmt_16bit: INTEGER is	
			-- 4	/* signed short samples */
		external
			"C macro use <tiff.h>"
		alias
			"PIXARLOGDATAFMT_16BIT"
		end
	
	pixarlogdatafmt_float: INTEGER is	
			-- 5	/* IEEE float samples */
		external
			"C macro use <tiff.h>"
		alias
			"PIXARLOGDATAFMT_FLOAT"
		end
	
	tifftag_dcsimagertype: INTEGER is			
			-- 65550   /* imager model & filter */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_DCSIMAGERTYPE"
		end
	
	dcsimagermodel_m3: INTEGER is			
			-- 0	   /* M3 chip (1280 x 1024) */
		external
			"C macro use <tiff.h>"
		alias
			"DCSIMAGERMODEL_M3"
		end
	
	dcsimagermodel_m5: INTEGER is			
			-- 1	   /* M5 chip (1536 x 1024) */
		external
			"C macro use <tiff.h>"
		alias
			"DCSIMAGERMODEL_M5"
		end
	
	dcsimagermodel_m6: INTEGER is			
			-- 2	   /* M6 chip (3072 x 2048) */
		external
			"C macro use <tiff.h>"
		alias
			"DCSIMAGERMODEL_M6"
		end
	
	dcsimagerfilter_ir: INTEGER is			
			-- 0	   /* infrared filter */
		external
			"C macro use <tiff.h>"
		alias
			"DCSIMAGERFILTER_IR"
		end
	
	dcsimagerfilter_mono: INTEGER is		
			-- 1	   /* monochrome filter */
		external
			"C macro use <tiff.h>"
		alias
			"DCSIMAGERFILTER_MONO"
		end
	
	dcsimagerfilter_cfa: INTEGER is			
			-- 2	   /* color filter array */
		external
			"C macro use <tiff.h>"
		alias
			"DCSIMAGERFILTER_CFA"
		end
	
	dcsimagerfilter_other: INTEGER is		
			-- 3	   /* other filter */
		external
			"C macro use <tiff.h>"
		alias
			"DCSIMAGERFILTER_OTHER"
		end
	
	tifftag_dcsinterpmode: INTEGER is			
			-- 65551   /* interpolation mode */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_DCSINTERPMODE"
		end
	
	dcsinterpmode_normal: INTEGER is		
			-- 0x0	   /* whole image, default */
		external
			"C macro use <tiff.h>"
		alias
			"DCSINTERPMODE_NORMAL"
		end
	
	dcsinterpmode_preview: INTEGER is		
			-- 0x1	   /* preview of image (384x256) */
		external
			"C macro use <tiff.h>"
		alias
			"DCSINTERPMODE_PREVIEW"
		end
	
	tifftag_dcsbalancearray: INTEGER is			
			-- 65552   /* color balance values */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_DCSBALANCEARRAY"
		end
	
	tifftag_dcscorrectmatrix: INTEGER is		
			-- 65553   /* color correction values */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_DCSCORRECTMATRIX"
		end
	
	tifftag_dcsgamma: INTEGER is				
			-- 65554   /* gamma value */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_DCSGAMMA"
		end
	
	tifftag_dcstoeshoulderpts: INTEGER is		
			-- 65555   /* toe & shoulder points */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_DCSTOESHOULDERPTS"
		end
	
	tifftag_dcscalibrationfd: INTEGER is		
			-- 65556   /* calibration file desc */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_DCSCALIBRATIONFD"
		end
	
	tifftag_zipquality: INTEGER is		
			-- 65557	/* compression quality level */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_ZIPQUALITY"
		end
	
	tifftag_pixarlogquality: INTEGER is		
			-- 65558	/* PixarLog uses same scale */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_PIXARLOGQUALITY"
		end
	
	tifftag_dcscliprectangle: INTEGER is	
			-- 65559	/* area of image to acquire */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_DCSCLIPRECTANGLE"
		end
	
	tifftag_sgilogdatafmt: INTEGER is		
			-- 65560	/* SGILog user data format */
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_SGILOGDATAFMT"
		end
	
	sgilogdatafmt_float: INTEGER is		
			-- 0	/* IEEE float samples */
		external
			"C macro use <tiff.h>"
		alias
			"SGILOGDATAFMT_FLOAT"
		end
	
	sgilogdatafmt_16bit: INTEGER is		
			-- 1	/* 16-bit samples */
		external
			"C macro use <tiff.h>"
		alias
			"SGILOGDATAFMT_16BIT"
		end
	
	sgilogdatafmt_raw: INTEGER is		
			-- 2	/* uninterpreted data */
		external
			"C macro use <tiff.h>"
		alias
			"SGILOGDATAFMT_RAW"
		end
	
	sgilogdatafmt_8bit: INTEGER is		
			-- 3	/* 8-bit RGB monitor values */
		external
			"C macro use <tiff.h>"
		alias
			"SGILOGDATAFMT_8BIT"
		end
	
	tifftag_sgilogencode: INTEGER is		
			-- 65561 /* SGILog data encoding control*/
		external
			"C macro use <tiff.h>"
		alias
			"TIFFTAG_SGILOGENCODE"
		end
	
	sgilogencode_nodither: INTEGER is	
			-- 0	 /* do not dither encoded values*/
		external
			"C macro use <tiff.h>"
		alias
			"SGILOGENCODE_NODITHER"
		end
	
	sgilogencode_randither: INTEGER is	
			-- 1	 /* randomly dither encd values */
		external
			"C macro use <tiff.h>"
		alias
			"SGILOGENCODE_RANDITHER"
		end
	
		
feature -- Measurement
feature -- Comparison
feature -- Status report
feature -- Status setting
feature -- Cursor movement
feature -- Element change
feature -- Removal
feature -- Resizing
feature -- Transformation
feature -- Conversion
feature -- Duplication
feature -- Basic operations
feature -- Miscellaneous
feature -- Obsolete
feature -- Inapplicable
feature {NONE} -- Implementation

end -- TIFF_CONSTANTS

