

indexing
	description: "Arrayed list of integers"
	names: "list", "integer"
	representation: "array", "list"
	access: "sequential", "indexed"
	size: "resizable"
	contents: "INTEGER"
	patterns: "none"
	date: "$Date: 2007-03-29 13:43:21 -0400 (Thu, 29 Mar 2007) $"
	revision: "$Revision: 286 $"
	author: "Mark A. Bolstad"
	status: "unreviewed"


class 

	INTEGER_64_ARRAYED_LIST

inherit

	LARGE_ARRAYED_LIST [INTEGER_64]

	PLATFORM
		undefine
			default_create, is_equal, copy, out
		end
	
creation
	default_create, make, make_equal, make_default,
	make_from_linear, make_from_array

feature {INTEGER_64_ARRAYED_LIST} -- Implementation

	internal_item (i: INTEGER_64): INTEGER_64 is
			-- Retrive the item from storage, translating to the 
			-- appropriate byte position
		do
			Result := storage.read_integer_64 ((i - 1) * item_size)
		end
	
	internal_put (val: INTEGER_64; i: INTEGER_64) is
			-- Put the item into storage, translating to the 
			-- appropriate byte position
		do
			storage.put_integer_64 (val, (i - 1) * item_size)
		end

	item_size: INTEGER is
			-- What is the size of an individual item being stored? 
			-- This is meaningless for compund objects.
		do
			Result := integer64_bits // 8
		end
	
	size_of_object: INTEGER is
			-- What is the size (in bytes) of the object being stored?
		do
			Result := item_size
		end	
	
	create_default_item is
			-- Create a default version of the generic parameter
		do
			create default_item
		end
	
end -- INTEGER_64_ARRAYED_LIST

