

indexing
	description: "Arrayed list of reals"
	names: "list", "real"
	representation: "array", "list"
	access: "sequential", "indexed"
	size: "resizable"
	contents: "REAL"
	patterns: "none"
	date: "$Date: 2006-06-23 10:34:45 -0400 (Fri, 23 Jun 2006) $"
	revision: "$Revision: 226 $"
	author: "Mark A. Bolstad"
	status: "unreviewed"








class 

	REAL_ARRAYED_LIST

inherit


	LARGE_ARRAYED_LIST [REAL]





	PLATFORM
		undefine
			default_create, is_equal, copy, out
		end
	
creation
	default_create, make, make_equal, make_default,
	make_from_linear, make_from_array

feature {REAL_ARRAYED_LIST} -- Implementation


	internal_item (i: INTEGER_64): REAL is




			-- Retrive the item from storage, translating to the 
			-- appropriate byte position
		do
			Result := storage.read_real ((i - 1) * item_size)
		end
	

	internal_put (val: REAL; i: INTEGER_64) is




			-- Put the item into storage, translating to the 
			-- appropriate byte position
		do
			storage.put_real (val, (i - 1) * item_size)
		end

	item_size: INTEGER is
			-- What is the size of an individual item being stored? 
			-- This is meaningless for compund objects.
		do

			Result := Real_bits // 8




		end
	
	size_of_object: INTEGER is
			-- What is the size (in bytes) of the object being stored?
		do
			Result := item_size
		end	
	
	create_default_item is
			-- Create a default version of the generic parameter
		do
			create default_item
		end
	
end -- REAL_ARRAYED_LIST

