
indexing
	description: "Mathematical vectors of reals."
	names: "vector"
	representation: "array"
	access: "fixed"
	size: "fixed"
	contents: "DOUBLE"
	patterns: "none"

deferred class

	VECTOR

inherit

	LINEAR_TUPLE

feature -- Basic operations

	infix "+" (other: like Current): like Current is
			-- Sum with `other'.
		require else
			other_non_void: other /= Void
			same_dimension: count = other.count
		deferred
		ensure then
			non_void_result: Result /= Void
			first_item_is_sum:
				Result.item (1) = filter_nan (item (1) + other.item (1))
			last_item_is_sum:
				Result.item (count) =
					filter_nan (item (count) + other.item (count))
			--- Ditto for items in-between.
		end

	infix "-" (other: like Current): like Current is
			-- Difference with `other'.
		require else
			other_non_void: other /= Void
			same_dimension: count = other.count
		deferred
		ensure then
			non_void_result: Result /= Void
			first_item_is_difference:
				Result.item (1) = filter_nan (item (1) - other.item (1))
			last_item_is_difference:
				Result.item (count) =
					filter_nan (item (count) - other.item (count))
			--- Ditto for items in-between.
		end

	cross, infix "*" (other: like Current): like Current is
			-- Cross Product by `other'.
		require
			other_non_void: other /= Void
			same_dimension: count = other.count
			all_finite: all_finite and other.all_finite
		do
				check
					never_called: false
				end
		ensure then
			non_void_result: Result /= Void
		end

feature {NONE} -- Implementation

	Opening_out_delimiter: CHARACTER is '<'
			-- First character of result of `out'.

	Closing_out_delimiter: CHARACTER is '>'
			-- Second character of result of `out'.

end -- deferred class VECTOR

