indexing

	description: "2D cartesian vectors."
	names: "2d", "cartesian", "vector", "line", "ray"
	representation: "expanded", "DOUBLE"
	access: "fixed"
	size: "fixed"
	contents: "DOUBLE"

class

	VECTOR2

inherit

	VECTOR
		rename
			make as make_with_elements
		undefine
			default_create, two_norm, magnitude, to_real,
			magnitude_squared, unit, prefix "+"
		end

	LINEAR_TUPLE_2D
	
creation
	make, default_create, make_from_array, make_from_c
	
feature -- Basic operations

	infix "+" (other: like Current): like Current is
			-- Sum with `other'.
		local
			result_x, result_y: DOUBLE
		do
			if x /= -other.x then
				result_x := x + other.x
			end

			if y /= -other.y then
				result_y := y + other.y
			end

			create Result.make (result_x, result_y)
		ensure then
			Result_not_void: Result /= Void
			result_x_is_x_sum: Result.x = filter_nan (x + other.x)
			result_y_is_y_sum: Result.y = filter_nan (y + other.y)
		end

	infix "-" (other: like Current): like Current is
			-- Difference with `other'.
		local
			result_x, result_y: DOUBLE
		do
			if x /= other.x then
				result_x := x - other.x
			end

			if y /= other.y then
				result_y := y - other.y
			end

			create Result.make (result_x, result_y)
		ensure then
			Result_not_void: Result /= Void
			result_x_is_x_difference: Result.x = filter_nan (x - other.x)
			result_y_is_y_difference: Result.y = filter_nan (y - other.y)
		end

end -- class VECTOR2
