indexing

	description: "Geometric objects that can be intersected with a ray."
	contents: "DOUBLE"
	date: "$Date: 2006-12-06 13:14:08 -0500 (Wed, 06 Dec 2006) $"
	revision: "$Revision: 271 $"
	status: "reviewed", "tested"

deferred class

	INTERSECTABLE
	
inherit
	
	ANY
		redefine
			default_create
		end
	
feature -- Initialization
	
	default_create is
			-- Initialization
		do
			intersection_count := 0
			intersection_hit := 0
		end
	
feature -- Status report
	
	intersection_count: INTEGER
			-- The number of times has `intersect' been called
	
	intersection_hit: INTEGER
			-- The number of times has `intersect' succeeded
	
	intersected: BOOLEAN
			-- Did last 'intersect' yield one or more points of intersection?
	
feature -- Basic operations
	
	reset_intersection_count is
			-- Reset the count
		do
			intersection_count := 0
			intersection_hit := 0
		end
	
	intersect (ray: RAY) is
			-- Intersect with `ray'.
			-- If `ray' does not intersect then `intersected' will be False
			-- else `intersected' will be True and `intersection' will yield
			-- the ordered parametric coordinates along `ray' of each
			-- successive point of intersection.
		do
			intersection_count := intersection_count + 1
		end

end -- deferred class INTERSECTABLE

