

indexing
	description: "The entities in a bucket"
	names: "bucket", "entity"
	representation: "PAIR"
	access: "membership"
	size: "fixed"
	contents: "DOUBLE", "SCENE_DRAWABLE"
	patterns: "none"
	status: "unreviewed"




class 

	BUCKET_ENTITY

inherit

	PAIR [DOUBLE, SCENE_DRAWABLE]
		rename
			first as depth,
			second as drawable
		export
			{NONE} put_first, replace_first, put_second, replace_second
		redefine
			is_equal
		end

	COMPARABLE
		undefine
			is_equal
		end

creation
	make

feature -- Comparison

	infix "<" (other: like Current): BOOLEAN is
			-- Is `Current' less than `other'? 
		do
			Result := depth < other.depth
		end
	
	is_equal (other: like Current): BOOLEAN is
			-- Do `Current' and other have equal-valued items?
		do
			Result := depth.is_equal (other.depth)
		end

end -- BUCKET_ENTITY

