

indexing
	description: "The items in the bucket table"
	patterns: "none"
	status: "unreviewed"
	date: "$Date: 2006-09-04 15:55:08 -0400 (Mon, 04 Sep 2006) $"
	revision: "$Revision: 264 $"



class 

	BUCKET_TABLE_ITEM

inherit

	TRIPLE [BOOLEAN, SORTABLE_ARRAYED_LIST [BUCKET_ENTITY],
					   DS_ARRAYED_LIST [MICROPOLYGON]]
		rename
			first as processed,
			second as entity_list,
			third as mp_list,
			replace_third as replace_mp_list
		redefine
			replace_mp_list
		end

creation
	make

feature -- Status Report

	no_duplicate_micropolygons: BOOLEAN is
			-- Are there any duplicate micropolygons?
		do
			Result := true
			if mp_list /= Void then
				from
					mp_list.start
				until
					mp_list.after or not Result
				loop
					Result := mp_list.occurrences (mp_list.item_for_iteration) = 1
					mp_list.forth
				end
			end
		end

	entity_count: INTEGER is
			-- The number of entities
		do
			if entity_list /= Void then
				Result := entity_list.count
			end
		ensure
			Result_not_negative: Result >= 0
		end

	mp_count: INTEGER is
			-- The number of micropolygons
		do
			if mp_list /= Void then
				Result := mp_list.count
			end
		ensure
			Result_not_negative: Result >= 0
		end

feature -- Element change

	replace_mp_list (new_list: DS_ARRAYED_LIST [MICROPOLYGON]) is
			-- Replace the micropolygon list.
		do
			Precursor {TRIPLE} (new_list)
		ensure then
			no_duplicate_micropolygons: no_duplicate_micropolygons
		end

invariant

	no_duplicate_micropolygons: mp_list /= Void implies no_duplicate_micropolygons
	
end -- BUCKET_TABLE_ITEM

