

indexing
	description: "Abstract class for applying actions to nodes in the SL AST"
	names: "action"
	contents: "generic"
	patterns: "strategy"


deferred class 

	SL_ACTION

inherit
	
	OBJECT_IDENTIFIER
		undefine
			is_equal, copy, default_create
		end
	
	ANY
		redefine
			default_create
		end

feature -- Initialization
	
	default_create is
			-- Initialize the action
		do
			terminate_action := false
		end

feature -- Measurement
feature -- Comparison
feature -- Status report
	
	terminate_action: BOOLEAN
			-- Should the traversal stop this action

	reverse_order: BOOLEAN
			-- Does this action need the traversal to run in reverse 
			-- order?
	
feature -- Status setting
	
	push (node: PARSE_NODE) is
			-- Increase depth in tree
		deferred
		end 

	pop (node: PARSE_NODE) is
			-- Increase depth in tree
		deferred
		end 

	set_reverse_order (backwards: BOOLEAN) is
			-- Set `reverse_order' to `backwards'
		do
			reverse_order := backwards
		ensure
			reverse_order_set: reverse_order = backwards
		end
	
feature -- Cursor movement
feature -- Element change
feature -- Removal
feature -- Resizing
feature -- Transformation
feature -- Conversion
feature -- Duplication
feature -- Basic operations
	
	pre_action (node: PARSE_NODE) is
			-- Apply this action before the traversal of children of `node'
		require 
			node_not_void: node /= Void
		do
		end 

	traversal_action (node: PARSE_NODE) is
			-- Apply this action during the traversal of children of `node'
		require 
			node_not_void: node /= Void
		do
		end 

	post_action (node: PARSE_NODE) is
			-- Apply this action after the traversal of children of `node'
		require 
			node_not_void: node /= Void
		do
		end 

	finalize is
			-- Do any necessary finalization
		do
		end
	
feature -- Miscellaneous
feature -- Obsolete
feature -- Inapplicable
feature {NONE} -- Implementation
	
invariant
	
end -- SL_ACTION

