

indexing
	description: "A Generic Node for DAG output"
	names: "Node", "DAG"
	representation: "fixed"
	access: "Fixed"
	size: "fixed"
	contents: "SL_VARAIBLE"
	patterns: "none"
	date: "$Date: 2006-06-23 10:34:45 -0400 (Fri, 23 Jun 2006) $"
	author: "Mark A. Bolstad"
	status: "unreviewed"




class 

	DAG_NODE

inherit

	VARIABLE_PARSE_NODE
		redefine
			set_parent, glsl_pre_action
		end

creation
	default_create

feature -- Initialization
feature -- Access

	definition: PARSE_NODE
			-- Where is `variable' used

feature -- Measurement
feature -- Comparison
feature -- Status report
feature -- Status setting
feature -- Cursor movement
feature -- Element change
	
	set_definition (node: PARSE_NODE) is
			-- Set `definition' to `node'
		require 
			node_not_void: node /= Void
		do
			definition := node
		ensure 
			definition_set: definition = node
		end 
	
	set_parent (node: PARSE_NODE) is
			-- Set `parent'.first to `node'
		do
			parent.force_last (node)
		end 
	
	set_variable (new_variable: SL_VARIABLE) is
			-- Set `variable' to `new_variable'
		require 
			new_variable_not_void: new_variable /= Void
		do
			variable := new_variable
		ensure 
			variable_set: variable = new_variable
		end 
	
feature -- Removal
feature -- Resizing
feature -- Transformation
feature -- Conversion
feature -- Duplication
feature -- Basic operations
	
	glsl_pre_action (action: GLSL_OUTPUT) is
			-- Export the information corresponding to this node to a 
			-- GLSL shader
		do
			if not action.variable_defined (variable.name) then
				action.defining_variable (variable.name)
					
				if variable.is_parameter then
					action.fragment_shader.append_string (glsl_storage_class)
					action.fragment_shader.append_string (" ")
					action.fragment_shader.append_string (glsl_variable_type)
					action.fragment_shader.append_string (" ")
					action.fragment_shader.append_string (variable.name)
					action.fragment_shader.append_string (";%N")
				elseif variable.is_builtin then
				else -- Variable is user-defined
					action.user_variables.append_string ("%T")
					action.user_variables.append_string (glsl_variable_type)
					action.user_variables.append_string (" ")
					action.user_variables.append_string (variable.name)
					action.user_variables.append_string (";%N")
				end
			end
		end 

feature -- Miscellaneous
feature -- Obsolete
feature -- Inapplicable
feature {NONE} -- Implementation

end -- DAG_NODE

