

indexing
	description: "Storage information for the dot record structure"
	names: "INTEGER", "STRING"
	representation: "fixed"
	access: "fixed"
	size: "fixed"
	contents: "INTEGER", "STRING"
	patterns: "none"
	date: "$Date: 2006-06-23 10:34:45 -0400 (Fri, 23 Jun 2006) $"
	author: "Mark A. Bolstad"
	status: "unreviewed"




class 

	DOT_RECORD_INFO

inherit

	HASHABLE

creation
	make

feature -- Initialization

	make (new_id: INTEGER; new_identifier: STRING; new_format_string: STRING) is
			-- Initialize the structure
		do
			id := new_id
			identifier := new_identifier
			format_string := new_format_string
		end

feature -- Access

	id: INTEGER
			-- An identifier
	
	identifier: STRING
			-- An identifier
	
	format_string: STRING
			-- The dot record format
	
	hash_code: INTEGER is
			-- Hash code value
		do
			Result := id
		end

feature -- Measurement
feature -- Comparison
feature -- Status report
feature -- Status setting
feature -- Cursor movement
feature -- Element change
feature -- Removal
feature -- Resizing
feature -- Transformation
feature -- Conversion
feature -- Duplication
feature -- Basic operations
feature -- Miscellaneous
feature -- Obsolete
feature -- Inapplicable
feature {NONE} -- Implementation

invariant

	id_is_positive: id > 0
	format_string_not_void: format_string /= Void
	identifier_not_void: identifier /= Void
	format_string_not_void: format_string.count > 0
	identifier_not_void: identifier.count > 0
	
end -- DOT_RECORD_INFO

