
indexing
	description: "A node in the parse tree representing assignments"
	patterns: "none"
	date: "$Date: 2006-12-06 13:14:08 -0500 (Wed, 06 Dec 2006) $"
	revision: "$Revision: 271 $"
	status: "unreviewed"




class 

	ASSIGN_PARSE_NODE
	
inherit
	
	VARIABLE_PARSE_NODE
		redefine
			stack_output, correct_child_count, dag_output, glsl_pre_action,
			glsl_post_action
		end

creation
	default_create, make

feature -- Initialization
feature -- Access
feature -- Measurement
feature -- Comparison
feature -- Status report
feature -- Status setting
feature -- Cursor movement
feature -- Element change
feature -- Removal
feature -- Resizing
feature -- Transformation
feature -- Conversion
feature -- Duplication
feature -- Basic operations

	stack_output (action: STACK_ACTION) is
			-- Output this node to the VM
		do
			if can_be_duplicated then
				action.shader_file.put_string ("%Tdup")
				action.shader_file.put_string ("%N")
			end

			action.shader_file.put_string ("%Tpop ")

			if has_translated_variable (variable) then
				action.shader_file.put_string (translated_variable (variable).name)
				action.shader_file.put_string ("%N")
			else
				action.shader_file.put_string (variable.name)
				action.shader_file.put_string ("%N")				
			end				
		end 

	dag_output (action: DAG_ACTION) is
			-- Start the definition of this node in the DAG
		do
			action.start_definition (Current)
		end 

	glsl_pre_action (action: GLSL_OUTPUT) is
			-- Export the information corresponding to this node to a 
			-- GLSL shader
		do
			action.fragment_shader.append_string (action.indentation_string)
			action.fragment_shader.append_string (translated_glsl_name (action))
			action.fragment_shader.append_string (" = ")
		end 

	glsl_post_action (action: GLSL_OUTPUT) is
			-- Export the information corresponding to this node to a 
			-- GLSL shader
		do
			action.fragment_shader.append_string (";%N")
		end 

feature -- Miscellaneous
feature -- Obsolete
feature -- Inapplicable
feature {NONE} -- Implementation

	correct_child_count: BOOLEAN is
			-- Does this node have the correct number of children
		do
			Result := children.count <= 1
		end
	
end -- ASSIGN_PARSE_NODE

