

indexing
	description: "A node in the parse tree representing conditionals"
	patterns: "none"
	date: "$Date: 2006-12-06 13:14:08 -0500 (Wed, 06 Dec 2006) $"
	revision: "$Revision: 271 $"
	status: "unreviewed"




class 

	CONDITIONAL_PARSE_NODE
	
inherit
	
	PARSE_NODE
		redefine
			glsl_pre_action, glsl_traverse_action, glsl_post_action
		end

creation
	default_create

feature -- Initialization
feature -- Access
feature -- Measurement
feature -- Comparison
feature -- Status report
feature -- Status setting
feature -- Cursor movement
feature -- Element change
feature -- Removal
feature -- Resizing
feature -- Transformation
feature -- Conversion
feature -- Duplication
feature -- Basic operations

	check_type: BOOLEAN is
			-- 
		do
			-- Fix to traverse children
			Result := true
		end 

	glsl_pre_action (action: GLSL_OUTPUT) is
			-- Export the information corresponding to this node to a 
			-- GLSL shader
		do
			action.fragment_shader.append_string (action.indentation_string)
			action.fragment_shader.append_string ("if ( ")
		end 

	glsl_traverse_action (action: GLSL_OUTPUT) is
			-- Export the information corresponding to this node to a 
			-- GLSL shader
		do
			if current_index = 1 then
				action.fragment_shader.append_string (" )%N")
				action.fragment_shader.append_string (action.indentation_string)
				action.fragment_shader.append_string ("{%N")
				action.indent
			elseif current_index < children.count then
				action.dedent
				action.fragment_shader.append_string (action.indentation_string)
				action.fragment_shader.append_string ("}%N")
				action.fragment_shader.append_string (action.indentation_string)
				action.fragment_shader.append_string ("else%N")
				action.fragment_shader.append_string (action.indentation_string)
				action.fragment_shader.append_string ("{%N")
				action.indent
			end
		end 

	glsl_post_action (action: GLSL_OUTPUT) is
			-- Export the information corresponding to this node to a 
			-- GLSL shader
		do
			action.dedent
			action.fragment_shader.append_string (action.indentation_string)
			action.fragment_shader.append_string ("}%N")
		end 

feature -- Miscellaneous
feature -- Obsolete
feature -- Inapplicable
feature {NONE} -- Implementation

end -- CONDITIONAL_PARSE_NODE

