

indexing
	description: "A node in the parse tree representing a declaration"
	patterns: "none"
	date: "$Date: 2006-12-06 13:14:08 -0500 (Wed, 06 Dec 2006) $"
	revision: "$Revision: 271 $"
	status: "unreviewed"




class 

	DECLARATION_PARSE_NODE
	
inherit
	
	PARSE_NODE
		redefine
			default_create, type
		end
	
	SL_TYPES
		undefine
			default_create
		end

creation
	default_create, make, make_with_type

feature -- Initialization
	
	default_create is
			-- Default Initialization
		do
			Precursor {PARSE_NODE}
			
			type := void_type
		end
	
	make (new_name: STRING) is
			-- Create a new declaration
		require 
			new_name_not_void: new_name /= Void
			new_name_not_empty: new_name.count > 0
		do
			default_create
			name := new_name.twin
		end
	
	make_with_type (new_name: STRING; new_type: INTEGER) is
			-- Create a new declaration
		require 
			new_name_not_void: new_name /= Void
			new_name_not_empty: new_name.count > 0
			valid_type: new_type >= float_type and new_type <= h_point_type
		do
			make (new_name)
			type := new_type
		end
	
feature -- Access
	
	name: STRING
			-- What is the declaration called?
	
feature -- Measurement
feature -- Comparison
feature -- Status report
	
	type: INTEGER
			-- The type of the cast
	
feature -- Status setting
feature -- Cursor movement
feature -- Element change
	
	set_name (new_name: STRING) is
			-- Set `name' to `new_name'
		require 
			new_name_not_void: new_name /= Void
			new_name_not_empty: new_name.count > 0
		do
			name := new_name.twin
		ensure 
			name_set: name.is_equal (new_name)
		end 
	
	set_type (new_type: INTEGER) is
			-- Set `type' to `new_type'
		require 
			valid_type: new_type >= float_type and new_type <= h_point_type
		do
			type := new_type
		ensure 
			type_set: type = new_type
		end 

feature -- Removal
feature -- Resizing
feature -- Transformation
feature -- Conversion
feature -- Duplication
feature -- Basic operations
feature -- Miscellaneous
feature -- Obsolete
feature -- Inapplicable
feature {NONE} -- Implementation
	
invariant
	
	type_valid: type >= float_type and type <= h_point_type
	
end -- DECLARATION_PARSE_NODE

