

indexing
	description: "A node in the parse tree representing floats"
	patterns: "none"
	date: "$Date: 2006-12-06 13:14:08 -0500 (Wed, 06 Dec 2006) $"
	revision: "$Revision: 271 $"
	status: "unreviewed"




class 

	FLOAT_CONSTANT_PARSE_NODE
	
inherit
	
	PARSE_NODE
		redefine
			type, stack_output, dot_label_string, glsl_pre_action
		end

creation
	default_create, make

feature -- Initialization
	
	make (new_value: REAL) is
			-- Create a new parse node with `new_value'
		do
			default_create
			value := new_value
			type := float_type
		end
	
feature -- Access
	
	value: REAL
			-- The value
	
feature -- Measurement
feature -- Comparison
feature -- Status report
	
	type: INTEGER
			-- What is the type of this parse node?
	
feature -- Status setting
feature -- Cursor movement
feature -- Element change
	
	set_value (new_value: REAL) is
			-- Set `value' to `new_value'
		do
			value := new_value
		ensure
			value_set: value = new_value
		end 

feature -- Removal
feature -- Resizing
feature -- Transformation
feature -- Conversion
feature -- Duplication
feature -- Basic operations

	stack_output (action: STACK_ACTION) is
			-- Output this node to the VM
		do
			action.shader_file.put_string ("%Tpushif ")
			action.shader_file.put_string (value.out)

			action.shader_file.put_string ("%N")
		end 

	glsl_pre_action (action: GLSL_OUTPUT) is
			-- Export the information corresponding to this node to a 
			-- GLSL shader
		do
			action.fragment_shader.append_string ("float( ")
			action.fragment_shader.append_string (value.out)
			action.fragment_shader.append_string (" )")
		end 

feature -- Miscellaneous
feature -- Obsolete
feature -- Inapplicable
feature {NONE} -- Implementation

	dot_label_string: STRING is
			-- The string to use as a label in the digraph
		do
			Result := dot_preamble
			Result.append_string (" | value\n")
			Result.append_string (value.out)
			Result.append_string (" } }")
			Result.append_character ('"')
		end
	
invariant
	has_no_children: children.count = 0
	
end -- FLOAT_CONSTANT_PARSE_NODE

