

indexing
	description: "A node in the parse tree representing logical operatations"
	patterns: "none"
	date: "$Date: 2006-12-06 13:14:08 -0500 (Wed, 06 Dec 2006) $"
	revision: "$Revision: 271 $"
	status: "unreviewed"




class 

	LOGICAL_OPERATION_PARSE_NODE
	
inherit
	
	PARSE_NODE
		redefine
			glsl_pre_action, glsl_traverse_action
		end

	SL_TYPES
		undefine
			default_create
		end

creation
	default_create, make

feature -- Initialization

	make (new_operator: INTEGER) is
			-- Create a new node representing `new_operator'
		require 
			in_range: new_operator >= and_operator and
					  new_operator <= negation_operator
		do
			default_create
			
			operator := new_operator
		ensure 
			operator_set: operator = new_operator
		end 

feature -- Access

	operator: INTEGER
			-- The logical operation
	
feature -- Measurement
feature -- Comparison
feature -- Status report
feature -- Status setting
feature -- Cursor movement
feature -- Element change
feature -- Removal
feature -- Resizing
feature -- Transformation
feature -- Conversion
feature -- Duplication
feature -- Basic operations
	
	glsl_pre_action (action: GLSL_OUTPUT) is
			-- Export the information corresponding to this node to a 
			-- GLSL shader
		do
			if operator = negation_operator then
				action.fragment_shader.append_string (" ! ")
			end
		end 

	glsl_traverse_action (action: GLSL_OUTPUT) is
			-- Export the information corresponding to this node to a 
			-- GLSL shader
		do
			if current_index < children.count then
				inspect operator
				when and_operator then
					action.fragment_shader.append_string (" && ")
				when or_operator then
					action.fragment_shader.append_string (" || ")
				end
			end
		end 

feature -- Miscellaneous
feature -- Obsolete
feature -- Inapplicable
feature {NONE} -- Implementation

invariant
	in_range: operator >= and_operator and operator <= negation_operator
	
end -- LOGICAL_OPERATION_PARSE_NODE

