

indexing
	description: "Hold information about SL functions, both built-in and user-defined"
	patterns: "none"
	date: "$Date: 2006-12-06 13:14:08 -0500 (Wed, 06 Dec 2006) $"
	revision: "$Revision: 271 $"
	status: "unreviewed"




class 

	SL_FUNCTIONS
	
inherit
	
	DS_HASH_TABLE [DS_ARRAYED_LIST [SL_FUNCTION], STRING]
		export
			{NONE} make
		redefine
			default_create
		end
	
	SL_TYPES
		undefine
			default_create, copy, is_equal
		end
	
creation
	default_create

feature -- Initialization

	default_create is
			-- 
		do
			make (400)
			initialize
		end

feature -- Access
feature -- Measurement
feature -- Comparison
feature -- Status report
feature -- Status setting
feature -- Cursor movement
feature -- Element change
feature -- Removal
feature -- Resizing
feature -- Transformation
feature -- Conversion
feature -- Duplication
feature -- Basic operations
feature -- Miscellaneous
feature -- Obsolete
feature -- Inapplicable
feature {NONE} -- Implementation
	
	initialize is
			-- Initialize the hash table
		local
			functor: SL_FUNCTION
			listor: DS_ARRAYED_LIST [SL_FUNCTION]
		do
			create listor.make (6)
			create functor.make (color_type, "Deriv", "cDeriv", "cf" )
			listor.force_last (functor)
			create functor.make (float_type, "Deriv", "fDeriv", "ff" )
			listor.force_last (functor)
			create functor.make (h_point_type, "Deriv", "hDeriv", "hf" )
			listor.force_last (functor)
			create functor.make (normal_type, "Deriv", "nDeriv", "nf" )
			listor.force_last (functor)
			create functor.make (point_type, "Deriv", "pDeriv", "pf" )
			listor.force_last (functor)
			create functor.make (vector_type, "Deriv", "vDeriv", "vf" )
			listor.force_last (functor)
			put (listor, "Deriv")
			
			create listor.make (6)
			create functor.make (color_type, "Du", "cDu", "c")
			listor.force_last (functor)
			create functor.make (float_type, "Du", "fDu", "f")
			listor.force_last (functor)
			create functor.make (h_point_type, "Du", "hDu", "h")
			listor.force_last (functor)
			create functor.make (normal_type, "Du", "nDu", "n")
			listor.force_last (functor)
			create functor.make (point_type, "Du", "pDu", "p")
			listor.force_last (functor)
			create functor.make (vector_type, "Du", "vDu", "v")
			listor.force_last (functor)
			put (listor, "Du")
			
			create listor.make (6)
			create functor.make (color_type, "Dv", "cDv", "c")
			listor.force_last (functor)
			create functor.make (float_type, "Dv", "fDv", "f")
			listor.force_last (functor)
			create functor.make (h_point_type, "Dv", "hDv", "h")
			listor.force_last (functor)
			create functor.make (normal_type, "Dv", "nDv", "n")
			listor.force_last (functor)
			create functor.make (point_type, "Dv", "pDv", "p")
			listor.force_last (functor)
			create functor.make (vector_type, "Dv", "vDv", "v")
			listor.force_last (functor)
			put (listor, "Dv")
			
			create listor.make (6)
			create functor.make (float_type, "abs", "abs", "f" )
			listor.force_last (functor)
			put (listor, "abs")
			
			create listor.make (6)
			create functor.make (float_type, "acos", "acos", "f" )
			listor.force_last (functor)
			put (listor, "acos")
			
			create listor.make (6)
			create functor.make (color_type, "ambient", "ambient", "" )
			listor.force_last (functor)
			put (listor, "ambient")
			
			create listor.make (6)
			create functor.make (float_type, "area", "area", "h")
			listor.force_last (functor)
			create functor.make (float_type, "area", "area", "p")
			listor.force_last (functor)
			put (listor, "area")
			
			create listor.make (6)
			create functor.make (float_type, "asin", "asin", "f" )
			listor.force_last (functor)
			put (listor, "asin")
			
			create listor.make (6)
			create functor.make (float_type, "atan", "atan", "f" )
			listor.force_last (functor)
			create functor.make (float_type, "atan", "atan2", "ff" )
			listor.force_last (functor)
			put (listor, "atan")
			
			create listor.make (6)
			create functor.make (point_type, "bump", "bump1", "sfppp*" )
			listor.force_last (functor)
			create functor.make (point_type, "bump", "bump2", "sfpppff*" )
			listor.force_last (functor)
			create functor.make (point_type, "bump", "bump3", "sfpppffffffff*" )
			listor.force_last (functor)
			put (listor, "bump")
			
			create listor.make (6)
			create functor.make (point_type, "calculatenormal", "calculatenormal", "h")
			listor.force_last (functor)
			create functor.make (point_type, "calculatenormal", "calculatenormal", "p")
			listor.force_last (functor)
			put (listor, "calculatenormal")
			
			create listor.make (6)
			create functor.make (float_type, "ceil", "ceil", "f" )
			listor.force_last (functor)
			put (listor, "ceil")
			
			create listor.make (6)
			create functor.make (color_type, "cellnoise", "ccellnoise1", "f" )
			listor.force_last (functor)
			create functor.make (color_type, "cellnoise", "ccellnoise2", "ff" )
			listor.force_last (functor)
			create functor.make (color_type, "cellnoise", "ccellnoise3", "p" )
			listor.force_last (functor)
			create functor.make (color_type, "cellnoise", "ccellnoise4", "pf" )
			listor.force_last (functor)
			create functor.make (float_type, "cellnoise", "fcellnoise1", "f" )
			listor.force_last (functor)
			create functor.make (float_type, "cellnoise", "fcellnoise2", "ff" )
			listor.force_last (functor)
			create functor.make (float_type, "cellnoise", "fcellnoise3", "p" )
			listor.force_last (functor)
			create functor.make (float_type, "cellnoise", "fcellnoise4", "pf" )
			listor.force_last (functor)
			create functor.make (point_type, "cellnoise", "pcellnoise1", "f" )
			listor.force_last (functor)
			create functor.make (point_type, "cellnoise", "pcellnoise2", "ff" )
			listor.force_last (functor)
			create functor.make (point_type, "cellnoise", "pcellnoise3", "p" )
			listor.force_last (functor)
			create functor.make (point_type, "cellnoise", "pcellnoise4", "pf" )
			listor.force_last (functor)
			put (listor, "cellnoise")
			
			create listor.make (6)
			create functor.make (color_type, "clamp", "cclamp", "ccc" )
			listor.force_last (functor)
			create functor.make (float_type, "clamp", "clamp", "fff" )
			listor.force_last (functor)
			create functor.make (normal_type, "clamp", "nclamp", "nnn" )
			listor.force_last (functor)
			create functor.make (point_type, "clamp", "pclamp", "ppp" )
			listor.force_last (functor)
			create functor.make (vector_type, "clamp", "vclamp", "vvv" )
			listor.force_last (functor)
			put (listor, "clamp")
			
			create listor.make (6)
			create functor.make (float_type, "comp", "comp", "cf" )
			listor.force_last (functor)
			create functor.make (float_type, "comp", "mcomp", "mff" )
			listor.force_last (functor)
			put (listor, "comp")
			
			create listor.make (6)
			create functor.make (string_type, "concat", "concat", "ss*" )
			listor.force_last (functor)
			put (listor, "concat")
			
			create listor.make (6)
			create functor.make (float_type, "cos", "cos", "f" )
			listor.force_last (functor)
			put (listor, "cos")
			
			create listor.make (6)
			create functor.make (color_type, "ctransform", "ctransform", "sc" )
			listor.force_last (functor)
			create functor.make (color_type, "ctransform", "ctransform2", "ssc" )
			listor.force_last (functor)
			put (listor, "ctransform")
			
			create listor.make (6)
			create functor.make (float_type, "degrees", "degrees", "f" )
			listor.force_last (functor)
			put (listor, "degrees")
			
			create listor.make (6)
			create functor.make (float_type, "depth", "depth", "p" )
			listor.force_last (functor)
			put (listor, "depth")
			
			create listor.make (6)
			create functor.make (float_type, "determinant", "determinant", "m" )
			listor.force_last (functor)
			put (listor, "determinant")
			
			create listor.make (6)
			create functor.make (color_type, "diffuse", "diffuse", "p" )
			listor.force_last (functor)
			put (listor, "diffuse")
			
			create listor.make (6)
			create functor.make (float_type, "distance", "distance", "pp" )
			listor.force_last (functor)
			put (listor, "distance")
			
			create listor.make (6)
			create functor.make (color_type, "environment", "cenvironment2", "sfp*")
			listor.force_last (functor)
			create functor.make (color_type, "environment", "cenvironment3", "sfpppp*" )
			listor.force_last (functor)
			create functor.make (float_type, "environment", "fenvironment2", "sfp*")
			listor.force_last (functor)
			create functor.make (float_type, "environment", "fenvironment3", "sfpppp*" )
			listor.force_last (functor)
			put (listor, "environment")
			
			create listor.make (6)
			create functor.make (float_type, "exp", "exp", "f" )
			listor.force_last (functor)
			put (listor, "exp")
			
			create listor.make (6)
			create functor.make (point_type, "faceforward", "faceforward", "pp" )
			listor.force_last (functor)
			put (listor, "faceforward")
			
			create listor.make (6)
			create functor.make (float_type, "filterstep", "filterstep", "ff*" )
			listor.force_last (functor)
			create functor.make (float_type, "filterstep", "filterstep2", "fff*" )
			listor.force_last (functor)
			put (listor, "filterstep")
			
			create listor.make (6)
			create functor.make (float_type, "floor", "floor", "f" )
			listor.force_last (functor)
			put (listor, "floor")
			
			create listor.make (6)
			create functor.make (string_type, "format", "format", "s*" )
			listor.force_last (functor)
			put (listor, "format")
			
			create listor.make (6)
			create functor.make (void_type, "fresnel", "fresnel", "ppfff" )
			listor.force_last (functor)
			create functor.make (void_type, "fresnel", "fresnel2", "ppfffpp" )
			listor.force_last (functor)
			put (listor, "fresnel")
			
			create listor.make (6)
			create functor.make (float_type, "inversesqrt", "inversesqrt", "f" )
			listor.force_last (functor)
			put (listor, "inversesqrt")
			
			create listor.make (6)
			create functor.make (float_type, "length", "length", "p" )
			listor.force_last (functor)
			put (listor, "length")
			
			create listor.make (6)
			create functor.make (float_type, "log", "log", "f" )
			listor.force_last (functor)
			create functor.make (float_type, "log", "log2", "ff" )
			listor.force_last (functor)
			put (listor, "log")
			
			create listor.make (6)
			create functor.make (float_type, "match", "match", "ss" )
			listor.force_last (functor)
			put (listor, "match")
			
			create listor.make (6)
			create functor.make (color_type, "max", "cmax", "cc*" )
			listor.force_last (functor)
			create functor.make (float_type, "max", "max", "ff*" )
			listor.force_last (functor)
			create functor.make (normal_type, "max", "nmax", "nn*" )
			listor.force_last (functor)
			create functor.make (point_type, "max", "pmax", "pp*" )
			listor.force_last (functor)
			create functor.make (vector_type, "max", "vmax", "vv*" )
			listor.force_last (functor)
			put (listor, "max")
			
			create listor.make (6)
			create functor.make (color_type, "min", "cmin", "cc*" )
			listor.force_last (functor)
			create functor.make (float_type, "min", "min", "ff*" )
			listor.force_last (functor)
			create functor.make (normal_type, "min", "nmin", "nn*" )
			listor.force_last (functor)
			create functor.make (point_type, "min", "pmin", "pp*" )
			listor.force_last (functor)
			create functor.make (vector_type, "min", "vmin", "vv*" )
			listor.force_last (functor)
			put (listor, "min")
			
			create listor.make (6)
			create functor.make (color_type, "mix", "cmix", "ccf" )
			listor.force_last (functor)
			create functor.make (float_type, "mix", "fmix", "fff" )
			listor.force_last (functor)
			create functor.make (normal_type, "mix", "nmix", "nnf" )
			listor.force_last (functor)
			create functor.make (point_type, "mix", "pmix", "ppf" )
			listor.force_last (functor)
			create functor.make (vector_type, "mix", "vmix", "vvf" )
			listor.force_last (functor)
			put (listor, "mix")
			
			create listor.make (6)
			create functor.make (float_type, "mod", "mod", "ff" )
			listor.force_last (functor)
			put (listor, "mod")
			
			create listor.make (6)
			create functor.make (matrix_type, "mtransform", "mtransform", "sm" )
			listor.force_last (functor)
			create functor.make (matrix_type, "mtransform", "mtransform2", "ssm" )
			listor.force_last (functor)
			put (listor, "mtransform")
			
			create listor.make (6)
			create functor.make (color_type, "noise", "cnoise1", "f" )
			listor.force_last (functor)
			create functor.make (color_type, "noise", "cnoise2", "ff" )
			listor.force_last (functor)
			create functor.make (color_type, "noise", "cnoise3", "p" )
			listor.force_last (functor)
			create functor.make (color_type, "noise", "cnoise4", "pf" )
			listor.force_last (functor)
			create functor.make (float_type, "noise", "noise1", "f" )
			listor.force_last (functor)
			create functor.make (float_type, "noise", "noise2", "ff" )
			listor.force_last (functor)
			create functor.make (float_type, "noise", "noise3", "p" )
			listor.force_last (functor)
			create functor.make (float_type, "noise", "noise4", "pf" )
			listor.force_last (functor)
			create functor.make (point_type, "noise", "pnoise1", "f" )
			listor.force_last (functor)
			create functor.make (point_type, "noise", "pnoise2", "ff" )
			listor.force_last (functor)
			create functor.make (point_type, "noise", "pnoise3", "p" )
			listor.force_last (functor)
			create functor.make (point_type, "noise", "pnoise4", "pf" )
			listor.force_last (functor)
			put (listor, "noise")
			
			create listor.make (6)
			create functor.make (point_type, "normalize", "normalize", "p" )
			listor.force_last (functor)
			put (listor, "normalize")
			
			create listor.make (6)
			create functor.make (normal_type, "ntransform", "ntransform", "sn" )
			listor.force_last (functor)
			create functor.make (normal_type, "ntransform", "ntransform2", "ssn" )
			listor.force_last (functor)
			create functor.make (normal_type, "ntransform", "ntransformm", "mn" )
			listor.force_last (functor)
			put (listor, "ntransform")
			
			create listor.make (6)
			create functor.make (color_type, "operator*", "mulcc", "cc" )
			listor.force_last (functor)
			create functor.make (color_type, "operator*", "mulfc", "fc" )
			listor.force_last (functor)
			create functor.make (float_type, "operator*", "mulff", "ff" )
			listor.force_last (functor)
			create functor.make (matrix_type, "operator*", "mulmm", "mm" )
			listor.force_last (functor)
			create functor.make (normal_type, "operator*", "mulfp", "fn" )
			listor.force_last (functor)
			create functor.make (normal_type, "operator*", "mulpp", "nn" )
			listor.force_last (functor)
			create functor.make (point_type, "operator*", "mulfp", "fp" )
			listor.force_last (functor)
			create functor.make (point_type, "operator*", "mulpp", "pp" )
			listor.force_last (functor)
			create functor.make (vector_type, "operator*", "mulfp", "fv" )
			listor.force_last (functor)
			create functor.make (vector_type, "operator*", "mulpp", "vv" )
			listor.force_last (functor)
			put (listor, "operator*")
			
			create listor.make (6)
			create functor.make (color_type, "operator+", "addcc", "cc" )
			listor.force_last (functor)
			create functor.make (color_type, "operator+", "addfc", "fc" )
			listor.force_last (functor)
			create functor.make (float_type, "operator+", "addff", "ff" )
			listor.force_last (functor)
			create functor.make (normal_type, "operator+", "addfp", "fn" )
			listor.force_last (functor)
			create functor.make (normal_type, "operator+", "addpp", "nn" )
			listor.force_last (functor)
			create functor.make (point_type, "operator+", "addfp", "fp" )
			listor.force_last (functor)
			create functor.make (point_type, "operator+", "addpp", "pp" )
			listor.force_last (functor)
			create functor.make (vector_type, "operator+", "addfp", "fv" )
			listor.force_last (functor)
			create functor.make (vector_type, "operator+", "addpp", "vv" )
			listor.force_last (functor)
			put (listor, "operator+")
			
			create listor.make (6)
			create functor.make (color_type, "operator-", "negc", "c" )
			listor.force_last (functor)
			create functor.make (color_type, "operator-", "subcc", "cc" )
			listor.force_last (functor)
			create functor.make (color_type, "operator-", "subfc", "fc" )
			listor.force_last (functor)
			create functor.make (float_type, "operator-", "negf", "f" )
			listor.force_last (functor)
			create functor.make (float_type, "operator-", "subff", "ff" )
			listor.force_last (functor)
			create functor.make (normal_type, "operator-", "negp", "n" )
			listor.force_last (functor)
			create functor.make (normal_type, "operator-", "subfp", "fn" )
			listor.force_last (functor)
			create functor.make (normal_type, "operator-", "subpp", "nn" )
			listor.force_last (functor)
			create functor.make (point_type, "operator-", "negp", "p" )
			listor.force_last (functor)
			create functor.make (point_type, "operator-", "subfp", "fp" )
			listor.force_last (functor)
			create functor.make (point_type, "operator-", "subpp", "pp" )
			listor.force_last (functor)
			create functor.make (vector_type, "operator-", "negp", "v" )
			listor.force_last (functor)
			create functor.make (vector_type, "operator-", "subfp", "fv" )
			listor.force_last (functor)
			create functor.make (vector_type, "operator-", "subpp", "vv" )
			listor.force_last (functor)
			put (listor, "operator-")
			
			create listor.make (6)
			create functor.make (float_type, "operator.", "dotpp", "nn" )
			listor.force_last (functor)
			create functor.make (float_type, "operator.", "dotpp", "pp" )
			listor.force_last (functor)
			create functor.make (float_type, "operator.", "dotpp", "vv" )
			listor.force_last (functor)
			put (listor, "operator.")
			
			create listor.make (6)
			create functor.make (color_type, "operator/", "divcc", "cc" )
			listor.force_last (functor)
			create functor.make (color_type, "operator/", "divfc", "fc" )
			listor.force_last (functor)
			create functor.make (float_type, "operator/", "divff", "ff" )
			listor.force_last (functor)
			create functor.make (matrix_type, "operator/", "divmm", "mm" )
			listor.force_last (functor)
			create functor.make (normal_type, "operator/", "divfp", "fn" )
			listor.force_last (functor)
			create functor.make (normal_type, "operator/", "divpp", "nn" )
			listor.force_last (functor)
			create functor.make (point_type, "operator/", "divfp", "fp" )
			listor.force_last (functor)
			create functor.make (point_type, "operator/", "divpp", "pp" )
			listor.force_last (functor)
			create functor.make (vector_type, "operator/", "divfp", "fv" )
			listor.force_last (functor)
			create functor.make (vector_type, "operator/", "divpp", "vv" )
			listor.force_last (functor)
			put (listor, "operator/")
			
			create listor.make (6)
			create functor.make (normal_type, "operator^", "crspp", "nn" )
			listor.force_last (functor)
			create functor.make (point_type, "operator^", "crspp", "pp" )
			listor.force_last (functor)
			create functor.make (vector_type, "operator^", "crspp", "vv" )
			listor.force_last (functor)
			put (listor, "operator^")
			
			create listor.make (6)
			create functor.make (color_type, "phong", "phong", "ppf" )
			listor.force_last (functor)
			put (listor, "phong")
			
			create listor.make (6)
			create functor.make (color_type, "pnoise", "cpnoise1", "ff" )
			listor.force_last (functor)
			create functor.make (color_type, "pnoise", "cpnoise2", "ffff" )
			listor.force_last (functor)
			create functor.make (color_type, "pnoise", "cpnoise3", "pp" )
			listor.force_last (functor)
			create functor.make (color_type, "pnoise", "cpnoise4", "pfpf" )
			listor.force_last (functor)
			create functor.make (float_type, "pnoise", "fpnoise1", "ff" )
			listor.force_last (functor)
			create functor.make (float_type, "pnoise", "fpnoise2", "ffff" )
			listor.force_last (functor)
			create functor.make (float_type, "pnoise", "fpnoise3", "pp" )
			listor.force_last (functor)
			create functor.make (float_type, "pnoise", "fpnoise4", "pfpf" )
			listor.force_last (functor)
			create functor.make (point_type, "pnoise", "ppnoise1", "ff" )
			listor.force_last (functor)
			create functor.make (point_type, "pnoise", "ppnoise2", "ffff" )
			listor.force_last (functor)
			create functor.make (point_type, "pnoise", "ppnoise3", "pp" )
			listor.force_last (functor)
			create functor.make (point_type, "pnoise", "ppnoise4", "pfpf" )
			listor.force_last (functor)
			put (listor, "pnoise")
			
			create listor.make (6)
			create functor.make (float_type, "pow", "pow", "ff" )
			listor.force_last (functor)
			put (listor, "pow")
			
			create listor.make (6)
			create functor.make (void_type, "printf", "printf", "s*" )
			listor.force_last (functor)
			put (listor, "printf")
			
			create listor.make (6)
			create functor.make (float_type, "ptlined", "ptlined", "ppp" )
			listor.force_last (functor)
			put (listor, "ptlined")
			
			create listor.make (6)
			create functor.make (float_type, "radians", "radians", "f" )
			listor.force_last (functor)
			put (listor, "radians")
			
			create listor.make (6)
			create functor.make (color_type, "random", "crandom", "" )
			listor.force_last (functor)
			create functor.make (float_type, "random", "frandom", "" )
			listor.force_last (functor)
			create functor.make (point_type, "random", "prandom", "" )
			listor.force_last (functor)
			put (listor, "random")
			
			create listor.make (6)
			create functor.make (point_type, "reflect", "reflect", "pp" )
			listor.force_last (functor)
			put (listor, "reflect")
			
			create listor.make (6)
			create functor.make (point_type, "refract", "refract", "ppf" )
			listor.force_last (functor)
			put (listor, "refract")
			
			create listor.make (6)
			create functor.make (matrix_type, "rotate", "mrotate", "mfv" )
			listor.force_last (functor)
			create functor.make (point_type, "rotate", "rotate", "pfpp" )
			listor.force_last (functor)
			put (listor, "rotate")
			
			create listor.make (6)
			create functor.make (float_type, "round", "round", "f" )
			listor.force_last (functor)
			put (listor, "round")
			
			create listor.make (6)
			create functor.make (matrix_type, "scale", "mscale", "mp" )
			listor.force_last (functor)
			put (listor, "scale")
			
			create listor.make (6)
			create functor.make (void_type, "setcomp", "setcomp", "Cff" )
			listor.force_last (functor)
			create functor.make (void_type, "setcomp", "setcomp", "cff" )
			listor.force_last (functor)
			create functor.make (void_type, "setcomp", "setmcomp", "mfff" )
			listor.force_last (functor)
			put (listor, "setcomp")
			
			create listor.make (6)
			create functor.make (void_type, "setxcomp", "setxcomp", "Nf" )
			listor.force_last (functor)
			create functor.make (void_type, "setxcomp", "setxcomp", "Pf" )
			listor.force_last (functor)
			create functor.make (void_type, "setxcomp", "setxcomp", "Vf" )
			listor.force_last (functor)
			put (listor, "setxcomp")
			
			create listor.make (6)
			create functor.make (void_type, "setycomp", "setycomp", "Nf" )
			listor.force_last (functor)
			create functor.make (void_type, "setycomp", "setycomp", "Pf" )
			listor.force_last (functor)
			create functor.make (void_type, "setycomp", "setycomp", "Vf" )
			listor.force_last (functor)
			put (listor, "setycomp")
			
			create listor.make (6)
			create functor.make (void_type, "setzcomp", "setzcomp", "Nf" )
			listor.force_last (functor)
			create functor.make (void_type, "setzcomp", "setzcomp", "Pf" )
			listor.force_last (functor)
			create functor.make (void_type, "setzcomp", "setzcomp", "Vf" )
			listor.force_last (functor)
			put (listor, "setzcomp")
			
			create listor.make (6)
			create functor.make (string_type, "shadername", "shadername", "" )
			listor.force_last (functor)
			create functor.make (string_type, "shadername", "shadername2", "s" )
			listor.force_last (functor)
			put (listor, "shadername")
			
			create listor.make (6)
			create functor.make (float_type, "shadow", "shadow", "sfp*" )
			listor.force_last (functor)
			create functor.make (float_type, "shadow", "shadow2", "sfpppp*" )
			listor.force_last (functor)
			put (listor, "shadow")
			
			create listor.make (6)
			create functor.make (float_type, "sign", "sign", "f" )
			listor.force_last (functor)
			put (listor, "sign")
			
			create listor.make (6)
			create functor.make (float_type, "sin", "sin", "f" )
			listor.force_last (functor)
			put (listor, "sin")
			
			create listor.make (6)
			create functor.make (float_type, "smoothstep", "smoothstep", "fff" )
			listor.force_last (functor)
			put (listor, "smoothstep")
			
			create listor.make (6)
			create functor.make (color_type, "specular", "specular", "ppf" )
			listor.force_last (functor)
			put (listor, "specular")
			
			create listor.make (6)
			create functor.make (color_type, "specularbrdf", "specularbrdf", "vnvf" )
			listor.force_last (functor)
			put (listor, "specularbrdf")
			
			create listor.make (6)
			create functor.make (color_type, "spline", "cspline", "fcccc*" )
			listor.force_last (functor)
			create functor.make (color_type, "spline", "csplinea", "f[c]" )
			listor.force_last (functor)
			create functor.make (color_type, "spline", "scspline", "sfcccc*" )
			listor.force_last (functor)
			create functor.make (color_type, "spline", "scsplinea", "sf[c]" )
			listor.force_last (functor)
			create functor.make (float_type, "spline", "fspline", "fffff*" )
			listor.force_last (functor)
			create functor.make (float_type, "spline", "fsplinea", "f[f]" )
			listor.force_last (functor)
			create functor.make (float_type, "spline", "sfspline", "sfffff*" )
			listor.force_last (functor)
			create functor.make (float_type, "spline", "sfsplinea", "sf[f]" )
			listor.force_last (functor)
			create functor.make (point_type, "spline", "pspline", "fpppp*" )
			listor.force_last (functor)
			create functor.make (point_type, "spline", "psplinea", "f[p]" )
			listor.force_last (functor)
			create functor.make (point_type, "spline", "spspline", "sfpppp*" )
			listor.force_last (functor)
			create functor.make (point_type, "spline", "spsplinea", "sf[p]" )
			listor.force_last (functor)
			create functor.make (point_type, "spline", "svspline", "sfvvvv*" )
			listor.force_last (functor)
			create functor.make (point_type, "spline", "svsplinea", "sf[v]" )
			listor.force_last (functor)
			create functor.make (point_type, "spline", "vspline", "fvvvv*" )
			listor.force_last (functor)
			create functor.make (point_type, "spline", "vsplinea", "f[v]" )
			listor.force_last (functor)
			put (listor, "spline")
			
			create listor.make (6)
			create functor.make (float_type, "sqrt", "sqrt", "f" )
			listor.force_last (functor)
			put (listor, "sqrt")
			
			create listor.make (6)
			create functor.make (float_type, "step", "step", "ff" )
			listor.force_last (functor)
			put (listor, "step")
			
			create listor.make (6)
			create functor.make (float_type, "tan", "tan", "f" )
			listor.force_last (functor)
			put (listor, "tan")
			
			create listor.make (6)
			create functor.make (color_type, "texture", "ctexture1", "sf*")
			listor.force_last (functor)
			create functor.make (color_type, "texture", "ctexture2", "sfff*")
			listor.force_last (functor)
			create functor.make (color_type, "texture", "ctexture3", "sfffffffff*" )
			listor.force_last (functor)
			create functor.make (float_type, "texture", "ftexture1", "sf*")
			listor.force_last (functor)
			create functor.make (float_type, "texture", "ftexture2", "sfff*")
			listor.force_last (functor)
			create functor.make (float_type, "texture", "ftexture3", "sfffffffff*" )
			listor.force_last (functor)
			put (listor, "texture")
			
			create listor.make (6)
			create functor.make (color_type, "trace", "trace", "pp" )
			listor.force_last (functor)
			put (listor, "trace")
			
			create listor.make (6)
			create functor.make (point_type, "transform", "transform", "sp" )
			listor.force_last (functor)
			create functor.make (point_type, "transform", "transform2", "ssp" )
			listor.force_last (functor)
			create functor.make (point_type, "transform", "transformm", "mp" )
			listor.force_last (functor)
			put (listor, "transform")
			
			create listor.make (6)
			create functor.make (matrix_type, "translate", "mtranslate", "mv" )
			listor.force_last (functor)
			put (listor, "translate")
			
			create listor.make (6)
			create functor.make (vector_type, "vtransform", "vtransform", "sv" )
			listor.force_last (functor)
			create functor.make (vector_type, "vtransform", "vtransform2", "ssv" )
			listor.force_last (functor)
			create functor.make (vector_type, "vtransform", "vtransformm", "mv" )
			listor.force_last (functor)
			put (listor, "vtransform")
			
			create listor.make (6)
			create functor.make (float_type, "xcomp", "xcomp", "h" )
			listor.force_last (functor)
			create functor.make (float_type, "xcomp", "xcomp", "n" )
			listor.force_last (functor)
			create functor.make (float_type, "xcomp", "xcomp", "p" )
			listor.force_last (functor)
			create functor.make (float_type, "xcomp", "xcomp", "v" )
			listor.force_last (functor)
			put (listor, "xcomp")
			
			create listor.make (6)
			create functor.make (float_type, "ycomp", "ycomp", "h" )
			listor.force_last (functor)
			create functor.make (float_type, "ycomp", "ycomp", "n" )
			listor.force_last (functor)
			create functor.make (float_type, "ycomp", "ycomp", "p" )
			listor.force_last (functor)
			create functor.make (float_type, "ycomp", "ycomp", "v" )
			listor.force_last (functor)
			put (listor, "ycomp")
			
			create listor.make (6)
			create functor.make (float_type, "zcomp", "zcomp", "h" )
			listor.force_last (functor)
			create functor.make (float_type, "zcomp", "zcomp", "n" )
			listor.force_last (functor)
			create functor.make (float_type, "zcomp", "zcomp", "p" )
			listor.force_last (functor)
			create functor.make (float_type, "zcomp", "zcomp", "v" )
			listor.force_last (functor)
			put (listor, "zcomp")
		end 
end -- SL_FUNCTIONS

