indexing

	description: "Parser token codes"
	generator: "geyacc version 3.4"

class SL_TOKENS

inherit

	YY_PARSER_TOKENS

feature -- Last values

	last_any_value: ANY
	last_string_value: STRING
	last_real_value: REAL

feature -- Access

	token_name (a_token: INTEGER): STRING is
			-- Name of token `a_token'
		do
			inspect a_token
			when 0 then
				Result := "EOF token"
			when -1 then
				Result := "Error token"
			when IDENTIFIER then
				Result := "IDENTIFIER"
			when SYMBOL then
				Result := "SYMBOL"
			when TYPE_FLOAT then
				Result := "TYPE_FLOAT"
			when TYPE_POINT then
				Result := "TYPE_POINT"
			when TYPE_STRING then
				Result := "TYPE_STRING"
			when TYPE_COLOR then
				Result := "TYPE_COLOR"
			when TYPE_NORMAL then
				Result := "TYPE_NORMAL"
			when TYPE_VECTOR then
				Result := "TYPE_VECTOR"
			when TYPE_VOID then
				Result := "TYPE_VOID"
			when TYPE_MATRIX then
				Result := "TYPE_MATRIX"
			when TYPE_UNIFORM then
				Result := "TYPE_UNIFORM"
			when TYPE_VARYING then
				Result := "TYPE_VARYING"
			when SHADER_TYPE_SURFACE then
				Result := "SHADER_TYPE_SURFACE"
			when SHADER_TYPE_VOLUME then
				Result := "SHADER_TYPE_VOLUME"
			when SHADER_TYPE_IMAGER then
				Result := "SHADER_TYPE_IMAGER"
			when SHADER_TYPE_TRANSFORMATION then
				Result := "SHADER_TYPE_TRANSFORMATION"
			when SHADER_TYPE_DISPLACEMENT then
				Result := "SHADER_TYPE_DISPLACEMENT"
			when SHADER_TYPE_LIGHT then
				Result := "SHADER_TYPE_LIGHT"
			when SHADER_TYPE_ATMOSPHERE then
				Result := "SHADER_TYPE_ATMOSPHERE"
			when SHADER_ATTRIBUTE then
				Result := "SHADER_ATTRIBUTE"
			when SHADER_OPTION then
				Result := "SHADER_OPTION"
			when SHADER_RENDERERINFO then
				Result := "SHADER_RENDERERINFO"
			when SHADER_INCIDENT then
				Result := "SHADER_INCIDENT"
			when SHADER_OPPOSITE then
				Result := "SHADER_OPPOSITE"
			when SHADER_LIGHTSOURCE then
				Result := "SHADER_LIGHTSOURCE"
			when EXTERN then
				Result := "EXTERN"
			when SHADER_TEXTUREINFO then
				Result := "SHADER_TEXTUREINFO"
			when PAREN_LEFT then
				Result := "PAREN_LEFT"
			when PAREN_RIGHT then
				Result := "PAREN_RIGHT"
			when BRACE_LEFT then
				Result := "BRACE_LEFT"
			when BRACE_RIGHT then
				Result := "BRACE_RIGHT"
			when COMMA then
				Result := "COMMA"
			when SEMI_COLON then
				Result := "SEMI_COLON"
			when BRACKET_LEFT then
				Result := "BRACKET_LEFT"
			when BRACKET_RIGHT then
				Result := "BRACKET_RIGHT"
			when EQUAL_SIGN then
				Result := "EQUAL_SIGN"
			when MULT_OP then
				Result := "MULT_OP"
			when ADD_OP then
				Result := "ADD_OP"
			when IF_STMT then
				Result := "IF_STMT"
			when ELSE_STMT then
				Result := "ELSE_STMT"
			when WHILE_STMT then
				Result := "WHILE_STMT"
			when FOR_STMT then
				Result := "FOR_STMT"
			when CONTINUE_STMT then
				Result := "CONTINUE_STMT"
			when BREAK_STMT then
				Result := "BREAK_STMT"
			when RETURN_STMT then
				Result := "RETURN_STMT"
			when ILLUMINATE then
				Result := "ILLUMINATE"
			when ILLUMINANCE then
				Result := "ILLUMINANCE"
			when SOLAR then
				Result := "SOLAR"
			when TEXTUREMAP then
				Result := "TEXTUREMAP"
			when ENVIRONMENT then
				Result := "ENVIRONMENT"
			when BUMP then
				Result := "BUMP"
			when SHADOW then
				Result := "SHADOW"
			when SETXCOMP then
				Result := "SETXCOMP"
			when SETYCOMP then
				Result := "SETYCOMP"
			when SETZCOMP then
				Result := "SETZCOMP"
			when SETCOMP then
				Result := "SETCOMP"
			when ADD_ASSIGN then
				Result := "ADD_ASSIGN"
			when SUB_ASSIGN then
				Result := "SUB_ASSIGN"
			when MUL_ASSIGN then
				Result := "MUL_ASSIGN"
			when DIV_ASSIGN then
				Result := "DIV_ASSIGN"
			when TERIARY_OP then
				Result := "TERIARY_OP"
			when COLON then
				Result := "COLON"
			when OR_OP then
				Result := "OR_OP"
			when AND_OP then
				Result := "AND_OP"
			when GT_OP then
				Result := "GT_OP"
			when GE_OP then
				Result := "GE_OP"
			when LT_OP then
				Result := "LT_OP"
			when LE_OP then
				Result := "LE_OP"
			when EQ_OP then
				Result := "EQ_OP"
			when NE_OP then
				Result := "NE_OP"
			when SUB_OP then
				Result := "SUB_OP"
			when CROSS_OP then
				Result := "CROSS_OP"
			when DIV_OP then
				Result := "DIV_OP"
			when DOT_OP then
				Result := "DOT_OP"
			when UNARY_MINUS then
				Result := "UNARY_MINUS"
			when NEGATION then
				Result := "NEGATION"
			when FLOAT_CONSTANT then
				Result := "FLOAT_CONSTANT"
			when STRING_LITERAL then
				Result := "STRING_LITERAL"
			else
				Result := yy_character_token_name (a_token)
			end
		end

feature -- Token codes

	IDENTIFIER: INTEGER is 258
	SYMBOL: INTEGER is 259
	TYPE_FLOAT: INTEGER is 260
	TYPE_POINT: INTEGER is 261
	TYPE_STRING: INTEGER is 262
	TYPE_COLOR: INTEGER is 263
	TYPE_NORMAL: INTEGER is 264
	TYPE_VECTOR: INTEGER is 265
	TYPE_VOID: INTEGER is 266
	TYPE_MATRIX: INTEGER is 267
	TYPE_UNIFORM: INTEGER is 268
	TYPE_VARYING: INTEGER is 269
	SHADER_TYPE_SURFACE: INTEGER is 270
	SHADER_TYPE_VOLUME: INTEGER is 271
	SHADER_TYPE_IMAGER: INTEGER is 272
	SHADER_TYPE_TRANSFORMATION: INTEGER is 273
	SHADER_TYPE_DISPLACEMENT: INTEGER is 274
	SHADER_TYPE_LIGHT: INTEGER is 275
	SHADER_TYPE_ATMOSPHERE: INTEGER is 276
	SHADER_ATTRIBUTE: INTEGER is 277
	SHADER_OPTION: INTEGER is 278
	SHADER_RENDERERINFO: INTEGER is 279
	SHADER_INCIDENT: INTEGER is 280
	SHADER_OPPOSITE: INTEGER is 281
	SHADER_LIGHTSOURCE: INTEGER is 282
	EXTERN: INTEGER is 283
	SHADER_TEXTUREINFO: INTEGER is 284
	PAREN_LEFT: INTEGER is 285
	PAREN_RIGHT: INTEGER is 286
	BRACE_LEFT: INTEGER is 287
	BRACE_RIGHT: INTEGER is 288
	COMMA: INTEGER is 289
	SEMI_COLON: INTEGER is 290
	BRACKET_LEFT: INTEGER is 291
	BRACKET_RIGHT: INTEGER is 292
	EQUAL_SIGN: INTEGER is 293
	MULT_OP: INTEGER is 294
	ADD_OP: INTEGER is 295
	IF_STMT: INTEGER is 296
	ELSE_STMT: INTEGER is 297
	WHILE_STMT: INTEGER is 298
	FOR_STMT: INTEGER is 299
	CONTINUE_STMT: INTEGER is 300
	BREAK_STMT: INTEGER is 301
	RETURN_STMT: INTEGER is 302
	ILLUMINATE: INTEGER is 303
	ILLUMINANCE: INTEGER is 304
	SOLAR: INTEGER is 305
	TEXTUREMAP: INTEGER is 306
	ENVIRONMENT: INTEGER is 307
	BUMP: INTEGER is 308
	SHADOW: INTEGER is 309
	SETXCOMP: INTEGER is 310
	SETYCOMP: INTEGER is 311
	SETZCOMP: INTEGER is 312
	SETCOMP: INTEGER is 313
	ADD_ASSIGN: INTEGER is 314
	SUB_ASSIGN: INTEGER is 315
	MUL_ASSIGN: INTEGER is 316
	DIV_ASSIGN: INTEGER is 317
	TERIARY_OP: INTEGER is 318
	COLON: INTEGER is 319
	OR_OP: INTEGER is 320
	AND_OP: INTEGER is 321
	GT_OP: INTEGER is 322
	GE_OP: INTEGER is 323
	LT_OP: INTEGER is 324
	LE_OP: INTEGER is 325
	EQ_OP: INTEGER is 326
	NE_OP: INTEGER is 327
	SUB_OP: INTEGER is 328
	CROSS_OP: INTEGER is 329
	DIV_OP: INTEGER is 330
	DOT_OP: INTEGER is 331
	UNARY_MINUS: INTEGER is 332
	NEGATION: INTEGER is 333
	FLOAT_CONSTANT: INTEGER is 334
	STRING_LITERAL: INTEGER is 335

end
