

indexing
	description: "Hold information about SL variables, both built-in and user-defined"
	patterns: "none"
	date: "$Date: 2006-12-06 13:14:08 -0500 (Wed, 06 Dec 2006) $"
	revision: "$Revision: 271 $"
	status: "unreviewed"




class 

	SL_VARIABLES

inherit
	
	DS_HASH_TABLE [SL_VARIABLE, STRING]
		export
			{NONE} make
		redefine
			default_create
		end

	SL_TYPES
		undefine
			default_create, copy, is_equal
		end
	
creation
	default_create

feature -- Initialization

	default_create is
			-- 
		do
			make (400)
			initialize
		end

feature -- Access
feature -- Measurement
feature -- Comparison
feature -- Status report
feature -- Status setting
feature -- Cursor movement
feature -- Element change
feature -- Removal
feature -- Resizing
feature -- Transformation
feature -- Conversion
feature -- Duplication
feature -- Basic operations
feature -- Miscellaneous
feature -- Obsolete
feature -- Inapplicable
feature {NONE} -- Implementation

	
	initialize is
			-- Initialize the hash table
		local
			variable: SL_VARIABLE
		do
			create variable.make_with_storage (color_type, varying, "Cs" )
			variable.set_builtin_status (true)
			put (variable, "Cs")
			
			create variable.make_with_storage (color_type, varying, "Os" )
			variable.set_builtin_status (true)
			put (variable, "Os")
			
			create variable.make_with_storage (point_type, varying, "Ng" )
			variable.set_builtin_status (true)
			put (variable, "Ng")
			
			create variable.make_with_storage (float_type, uniform, "du" )
			variable.set_builtin_status (true)
			put (variable, "du")
			
			create variable.make_with_storage (float_type, uniform, "dv" )
			variable.set_builtin_status (true)
			put (variable, "dv")
			
			create variable.make_with_storage (point_type, varying, "L" )
			variable.set_builtin_status (true)
			put (variable, "L")
			
			create variable.make_with_storage (color_type, varying, "Cl" )
			variable.set_builtin_status (true)
			put (variable, "Cl")
			
			create variable.make_with_storage (color_type, varying, "Ol" )
			variable.set_builtin_status (true)
			put (variable, "Ol")
			
			create variable.make_with_storage (point_type, varying, "P" )
			variable.set_builtin_status (true)
			put (variable, "P")
			
			create variable.make_with_storage (point_type, varying, "dPdu" )
			variable.set_builtin_status (true)
			put (variable, "dPdu")
			
			create variable.make_with_storage (point_type, varying, "dPdv" )
			variable.set_builtin_status (true)
			put (variable, "dPdv")
			
			create variable.make_with_storage (point_type, varying, "N" )
			variable.set_builtin_status (true)
			put (variable, "N")
			
			create variable.make_with_storage (float_type, varying, "u" )
			variable.set_builtin_status (true)
			put (variable, "u")
			
			create variable.make_with_storage (float_type, varying, "v" )
			variable.set_builtin_status (true)
			put (variable, "v")
			
			create variable.make_with_storage (float_type, varying, "s" )
			variable.set_builtin_status (true)
			put (variable, "s")
			
			create variable.make_with_storage (float_type, varying, "t" )
			variable.set_builtin_status (true)
			put (variable, "t")
			
			create variable.make_with_storage (point_type, varying, "I" )
			variable.set_builtin_status (true)
			put (variable, "I")
			
			create variable.make_with_storage (color_type, varying, "Ci" )
			variable.set_builtin_status (true)
			put (variable, "Ci")
			
			create variable.make_with_storage (color_type, varying, "Oi" )
			variable.set_builtin_status (true)
			put (variable, "Oi")
			
			create variable.make_with_storage (point_type, varying, "Ps" )
			variable.set_builtin_status (true)
			put (variable, "Ps")
			
			create variable.make_with_storage (point_type, uniform, "E" )
			variable.set_builtin_status (true)
			put (variable, "E")
			
			create variable.make_with_storage (float_type, uniform, "ncomps" )
			variable.set_builtin_status (true)
			put (variable, "ncomps")
			
			create variable.make_with_storage (float_type, uniform, "time" )
			variable.set_builtin_status (true)
			put (variable, "time")
			
			create variable.make_with_storage (float_type, uniform, "alpha" )
			variable.set_builtin_status (true)
			put (variable, "alpha")
		end
	
end -- SL_VARIABLES

