

indexing
	description: "A node in the parse tree representing string literals"
	patterns: "none"
	date: "$Date: 2006-12-06 13:14:08 -0500 (Wed, 06 Dec 2006) $"
	revision: "$Revision: 271 $"
	status: "unreviewed"




class 

	STRING_CONSTANT_PARSE_NODE
	
inherit
	
	PARSE_NODE
		redefine
			type, stack_output
		end

creation
	default_create, make

feature -- Initialization
	
	make (new_value: STRING) is
			-- Create a new parse node with `new_value'
		do
			default_create
			value := new_value.twin
			type := string_type
		end
	
feature -- Access
	
	value: STRING
			-- The value
	
feature -- Measurement
feature -- Comparison
feature -- Status report
	
	type: INTEGER
			-- What is the type of this parse node?
	
feature -- Status setting
feature -- Cursor movement
feature -- Element change
	
	set_value (new_value: STRING) is
			-- Set `value' to `new_value'
		do
			value := new_value.twin
		ensure
			value_set: value.is_equal (new_value)
		end 

feature -- Removal
feature -- Resizing
feature -- Transformation
feature -- Conversion
feature -- Duplication
feature -- Basic operations

	stack_output (action: STACK_ACTION) is
			-- Output this node to the VM
		do
			action.shader_file.put_string ("%Tpushis ")
			action.shader_file.put_string (value)

			action.shader_file.put_string ("%N")
		end 

feature -- Miscellaneous
feature -- Obsolete
feature -- Inapplicable
feature {NONE} -- Implementation

end -- STRING_CONSTANT_PARSE_NODE

