

indexing
	description: "A node in the parse tree representing teriary constructs"
	patterns: "none"
	date: "$Date: 2006-12-06 13:14:08 -0500 (Wed, 06 Dec 2006) $"
	revision: "$Revision: 271 $"
	status: "unreviewed"




class 

	TERIARY_CONSTRUCT_PARSE_NODE
	
inherit
	
	PARSE_NODE
		redefine
			type, resolve_type
		end

creation
	default_create

feature -- Initialization
feature -- Access
feature -- Measurement
feature -- Comparison
feature -- Status report
	
	type: INTEGER is
			-- What is the type of this parse node?
		do
			Result := children.item (2).type
		end

feature -- Status setting
feature -- Cursor movement
feature -- Element change
feature -- Removal
feature -- Resizing
feature -- Transformation
feature -- Conversion
feature -- Duplication
feature -- Basic operations

	resolve_type (return_type: INTEGER) is
			-- Force type coercion as necessary to 
			-- ensure correct operation
		local
			cast_node: CAST_PARSE_NODE
		do
			if return_type = nil_type or else coercible (type, encoded_type (return_type)) then
				from
					children.start
					type_error := false
				until
					children.after
				loop
					if children.is_first then
						children.item_for_iteration.resolve_type (float_type)
					else
						children.item_for_iteration.resolve_type (type)
					end
					
					type_error := type_error or children.item_for_iteration.has_valid_type
					if not type_error and then
					   not (type = nil_type or else mutable (type, children.item_for_iteration.type)) then
					   -- Create a CAST_PARSE_NODE to cast `children.item_for_iteration.type' to `type'
					   create cast_node.make (type)
					   cast_node.add_last (children.item_for_iteration)
					   children.replace_at (cast_node)
					   cast_node.set_parent (Current)
					end
					
					children.forth
				end
			else
				error_string.append ("Unable to cast a ")
				error_string.append (type_to_string (type))
				error_string.append (" to a ")
				error_string.append (type_to_string (return_type))
				error_string.append ("%N%T")
				error_string.append ("Line	")
				error_string.append (line_number.out)
				error_string.append (": ")
				error_string.append (file_name)
				error_string.append ("%N%N")

				type_error := true
			end
		end 

feature -- Miscellaneous
feature -- Obsolete
feature -- Inapplicable
feature {NONE} -- Implementation

end -- TERIARY_CONSTRUCT_PARSE_NODE

