

indexing
	description: "Type and space information for variables"
	patterns: "none"
	date: "$Date: 2006-12-06 13:14:08 -0500 (Wed, 06 Dec 2006) $"
	revision: "$Revision: 271 $"
	status: "unreviewed"




class 

	TYPE_AND_SPACE
	
inherit
	
	SL_TYPES

creation
	make, make_with_storage

feature -- Initialization

	make (new_type: INTEGER; new_space: STRING ) is
			-- Create a type and space definition
			-- Space may be Void to indicate default space
		require
			new_type_in_range: new_type >= float_type and new_type <= h_point_type
		do
			type := new_type
			space := new_space
			storage_class := uniform
			storage_set := false
		end

	make_with_storage (new_type: INTEGER; new_space: STRING; new_storage: INTEGER ) is
			-- Create a type and space definition
			-- Space may be Void to indicate default space
		require
			new_type_in_range: new_type >= float_type and new_type <= h_point_type
			new_storage_in_range: new_storage >= uniform and new_storage <= varying
		do
			make (new_type, new_space)
			storage_class := new_storage
			storage_set := true
		end

feature -- Access
	
	type: INTEGER
			-- The return type of the variable
	
	space: STRING
			-- The SL name of the variable
	
	storage_class: INTEGER
			-- The storage class of the variable

	storage_set: BOOLEAN
			-- Has the `storage_class' been explicitly set?
	
feature -- Measurement
feature -- Comparison
feature -- Status report
feature -- Status setting
feature -- Cursor movement
feature -- Element change
feature -- Removal
feature -- Resizing
feature -- Transformation
feature -- Conversion
feature -- Duplication
feature -- Basic operations
feature -- Miscellaneous
feature -- Obsolete
feature -- Inapplicable
feature {NONE} -- Implementation

invariant
	type_in_range: type >= float_type and type <= h_point_type
	storage_class_in_range: storage_class >= uniform and storage_class <= varying
	
end -- TYPE_AND_SPACE

