

indexing
	description: "Abstract class for light integration"
	patterns: "none"
	date: "$Date: 2006-12-06 13:14:08 -0500 (Wed, 06 Dec 2006) $"
	revision: "$Revision: 271 $"
	status: "unreviewed"




deferred class 

	INTEGRATOR

inherit
	
	ANY
		redefine
			default_create
		end

feature -- Initialization
	
	default_create is
			-- Initialize
		do
			shadow_rays_generated := 0
			shadow_rays_blocked := 0
		end
	
	make (new_scene: SCENE_ACCELERATOR [SCENE_DRAWABLE]; 
		  new_transform: TRANSFORM) is
			-- Initialize the integrator with `new_scene'
		require
			new_scene_not_void: new_scene /= Void
			new_transform_not_void: new_transform /= Void
		do
			default_create
			
			set_scene (new_scene)
			viewing_transform := new_transform
		end
	
feature -- Access
	
	scene: SCENE_ACCELERATOR [SCENE_DRAWABLE]
			-- The root node of the scene graph
	
	viewing_transform: TRANSFORM
			-- The viewing transform
	
	shadow_rays_generated: INTEGER
	shadow_rays_blocked: INTEGER
	
feature -- Measurement
feature -- Comparison
feature -- Status report
feature -- Status setting
feature -- Cursor movement
feature -- Element change
	
	set_scene (new_scene: SCENE_ACCELERATOR [SCENE_DRAWABLE]) is
			-- Set `scene' to `new_scene'
		require 
			new_scene_not_void: new_scene /= Void
		do
			scene := new_scene
		ensure 
			scene_set: scene = new_scene
		end 

feature -- Removal
feature -- Resizing
feature -- Transformation
feature -- Conversion
feature -- Duplication
feature -- Basic operations
	
	integrate (ray: RAY; info: INTERSECTION_DATA): RGBA_COLOR is
			-- `integrate' the COLOR along `ray'
		require 
			ray_not_void: ray /= Void
			info_not_void: info /= Void
			scene_not_void: scene /= Void
		deferred
		ensure 
			color_not_void: Result /= Void
		end 

feature -- Miscellaneous
feature -- Obsolete
feature -- Inapplicable
feature {NONE} -- Implementation
	
invariant
	
	shadow_rays_generated_positive: shadow_rays_generated >= 0
	shadow_rays_blocked_positive: shadow_rays_blocked >= 0
	blocked_less_than_generated: shadow_rays_blocked <= shadow_rays_generated

end -- INTEGRATOR

