indexing
	description: "Scanners for RenderMan RIB parsers"
	patterns: "none"
	date: "$Date: 2006-12-06 13:14:08 -0500 (Wed, 06 Dec 2006) $"
	revision: "$Revision: 271 $"
	status: "unreviewed"
 
class 
	
	RIB_SCANNER

inherit

	YY_COMPRESSED_SCANNER_SKELETON
				rename
						make as make_compressed_scanner_skeleton,
						reset as reset_compressed_scanner_skeleton
				end

	RIB_TOKENS
		export {NONE} all end

		KL_IMPORTED_INTEGER_ROUTINES
		KL_IMPORTED_STRING_ROUTINES
		KL_SHARED_PLATFORM
		KL_SHARED_EXCEPTIONS
		KL_SHARED_ARGUMENTS

creation

		make

feature -- Status report

	valid_start_condition (sc: INTEGER): BOOLEAN is
			-- Is `sc' a valid start condition?
		do
			Result := (sc = INITIAL)
		end

feature {NONE} -- Implementation

	yy_build_tables is
			-- Build scanner tables.
		do
			yy_nxt := yy_nxt_template
			yy_chk := yy_chk_template
			yy_base := yy_base_template
			yy_def := yy_def_template
			yy_ec := yy_ec_template
			yy_meta := yy_meta_template
			yy_accept := yy_accept_template
		end

	yy_execute_action (yy_act: INTEGER) is
			-- Execute semantic action.
		do
if yy_act <= 54 then
if yy_act <= 27 then
if yy_act <= 14 then
if yy_act <= 7 then
if yy_act <= 4 then
if yy_act <= 2 then
if yy_act = 1 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 47 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 47")
end
-- Ignore separators
else
yy_set_line (0)
--|#line 48 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 48")
end

eif_lineno := eif_lineno + text_count

	if eif_lineno \\ line_count_multiple	= 0 then
		  io.put_integer (eif_lineno)
		  io.put_string ("%N")
	end
						   
end
else
if yy_act = 3 then
	yy_column := yy_column + 1
--|#line 57 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 57")
end
last_token := BRACKET_LEFT
else
	yy_column := yy_column + 1
--|#line 58 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 58")
end
last_token := BRACKET_RIGHT
end
end
else
if yy_act <= 6 then
if yy_act = 5 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 60 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 60")
end

			last_token := RIB_DIRECTIVE
			last_string_value := text
			  
else
	yy_line := yy_line + 1
	yy_column := 1
--|#line 67 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 67")
end


eif_lineno := eif_lineno + 1

	if eif_lineno \\ line_count_multiple	= 0 then
		  io.put_integer (eif_lineno)
		  io.put_string ("%N")
	end
						   
end
else
	yy_column := yy_column + 7
--|#line 78 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 78")
end
last_token := RIB_VERSION
end
end
else
if yy_act <= 11 then
if yy_act <= 9 then
if yy_act = 8 then
	yy_column := yy_column + 7
--|#line 79 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 79")
end
last_token := RIB_DECLARE
else
	yy_column := yy_column + 11
--|#line 80 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 80")
end
last_token := RIB_READARCHIVE
end
else
if yy_act = 10 then
	yy_column := yy_column + 6
--|#line 81 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 81")
end
last_token := RIB_FORMAT
else
	yy_column := yy_column + 16
--|#line 82 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 82")
end
last_token := RIB_FRAMEASPECTRATIO
end
end
else
if yy_act <= 13 then
if yy_act = 12 then
	yy_column := yy_column + 12
--|#line 83 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 83")
end
last_token := RIB_SCREENWINDOW
else
	yy_column := yy_column + 10
--|#line 84 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 84")
end
last_token := RIB_CROPWINDOW
end
else
	yy_column := yy_column + 10
--|#line 85 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 85")
end
last_token := RIB_PROJECTION
end
end
end
else
if yy_act <= 21 then
if yy_act <= 18 then
if yy_act <= 16 then
if yy_act = 15 then
	yy_column := yy_column + 8
--|#line 86 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 86")
end
last_token := RIB_CLIPPING
else
	yy_column := yy_column + 12
--|#line 87 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 87")
end
last_token := RIB_DEPTHOFFIELD
end
else
if yy_act = 17 then
	yy_column := yy_column + 7
--|#line 88 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 88")
end
last_token := RIB_SHUTTER
else
	yy_column := yy_column + 13
--|#line 89 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 89")
end
last_token := RIB_PIXELVARIANCE
end
end
else
if yy_act <= 20 then
if yy_act = 19 then
	yy_column := yy_column + 12
--|#line 90 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 90")
end
last_token := RIB_PIXELSAMPLES
else
	yy_column := yy_column + 11
--|#line 91 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 91")
end
last_token := RIB_PIXELFILTER
end
else
	yy_column := yy_column + 8
--|#line 92 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 92")
end
last_token := RIB_EXPOSURE
end
end
else
if yy_act <= 24 then
if yy_act <= 23 then
if yy_act = 22 then
	yy_column := yy_column + 6
--|#line 93 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 93")
end
last_token := RIB_IMAGER
else
	yy_column := yy_column + 8
--|#line 94 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 94")
end
last_token := RIB_QUANTIZE
end
else
	yy_column := yy_column + 7
--|#line 95 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 95")
end
last_token := RIB_DISPLAY
end
else
if yy_act <= 26 then
if yy_act = 25 then
	yy_column := yy_column + 5
--|#line 96 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 96")
end
last_token := RIB_HIDER
else
	yy_column := yy_column + 12
--|#line 97 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 97")
end
last_token := RIB_COLORSAMPLES
end
else
	yy_column := yy_column + 14
--|#line 98 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 98")
end
last_token := RIB_RELATIVEDETAIL
end
end
end
end
else
if yy_act <= 41 then
if yy_act <= 34 then
if yy_act <= 31 then
if yy_act <= 29 then
if yy_act = 28 then
	yy_column := yy_column + 6
--|#line 99 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 99")
end
last_token := RIB_OPTION
else
	yy_column := yy_column + 9
--|#line 100 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 100")
end
last_token := RIB_ATTRIBUTE
end
else
if yy_act = 30 then
	yy_column := yy_column + 5
--|#line 101 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 101")
end
last_token := RIB_COLOR
else
	yy_column := yy_column + 7
--|#line 102 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 102")
end
last_token := RIB_OPACITY
end
end
else
if yy_act <= 33 then
if yy_act = 32 then
	yy_column := yy_column + 7
--|#line 103 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 103")
end
last_token := RIB_SURFACE
else
	yy_column := yy_column + 10
--|#line 104 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 104")
end
last_token := RIB_ATMOSPHERE
end
else
	yy_column := yy_column + 8
--|#line 105 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 105")
end
last_token := RIB_INTERIOR
end
end
else
if yy_act <= 38 then
if yy_act <= 36 then
if yy_act = 35 then
	yy_column := yy_column + 8
--|#line 106 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 106")
end
last_token := RIB_EXTERIOR
else
	yy_column := yy_column + 10
--|#line 107 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 107")
end
last_token := RIB_ILLUMINATE
end
else
if yy_act = 37 then
	yy_column := yy_column + 12
--|#line 108 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 108")
end
last_token := RIB_DISPLACEMENT
else
	yy_column := yy_column + 18
--|#line 109 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 109")
end
last_token := RIB_TEXTURECOORDINATES
end
end
else
if yy_act <= 40 then
if yy_act = 39 then
	yy_column := yy_column + 11
--|#line 110 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 110")
end
last_token := RIB_SHADINGRATE
else
	yy_column := yy_column + 20
--|#line 111 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 111")
end
last_token := RIB_SHADINGINTERPOLATION
end
else
	yy_column := yy_column + 5
--|#line 112 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 112")
end
last_token := RIB_MATTE
end
end
end
else
if yy_act <= 48 then
if yy_act <= 45 then
if yy_act <= 43 then
if yy_act = 42 then
	yy_column := yy_column + 5
--|#line 113 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 113")
end
last_token := RIB_BOUND
else
	yy_column := yy_column + 6
--|#line 114 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 114")
end
last_token := RIB_DETAIL
end
else
if yy_act = 44 then
	yy_column := yy_column + 11
--|#line 115 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 115")
end
last_token := RIB_DETAILRANGE
else
	yy_column := yy_column + 22
--|#line 116 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 116")
end
last_token := RIB_GEOMETRICAPPROXIMATION
end
end
else
if yy_act <= 47 then
if yy_act = 46 then
	yy_column := yy_column + 11
--|#line 117 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 117")
end
last_token := RIB_ORIENTATION
else
	yy_column := yy_column + 18
--|#line 118 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 118")
end
last_token := RIB_REVERSEORIENTATION
end
else
	yy_column := yy_column + 5
--|#line 119 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 119")
end
last_token := RIB_SIDES
end
end
else
if yy_act <= 51 then
if yy_act <= 50 then
if yy_act = 49 then
	yy_column := yy_column + 5
--|#line 120 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 120")
end
last_token := RIB_BASIS
else
	yy_column := yy_column + 9
--|#line 121 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 121")
end
last_token := RIB_TRIMCURVE
end
else
	yy_column := yy_column + 11
--|#line 122 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 122")
end
last_token := RIB_LIGHTSOURCE
end
else
if yy_act <= 53 then
if yy_act = 52 then
	yy_column := yy_column + 15
--|#line 123 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 123")
end
last_token := RIB_AREALIGHTSOURCE
else
	yy_column := yy_column + 8
--|#line 124 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 124")
end
last_token := RIB_IDENTITY
end
else
	yy_column := yy_column + 17
--|#line 125 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 125")
end
last_token := RIB_COORDSYSTRANSFORM
end
end
end
end
end
else
if yy_act <= 81 then
if yy_act <= 68 then
if yy_act <= 61 then
if yy_act <= 58 then
if yy_act <= 56 then
if yy_act = 55 then
	yy_column := yy_column + 15
--|#line 126 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 126")
end
last_token := RIB_CONCATTRANSFORM
else
	yy_column := yy_column + 9
--|#line 127 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 127")
end
last_token := RIB_TRANSFORM
end
else
if yy_act = 57 then
	yy_column := yy_column + 9
--|#line 128 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 128")
end
last_token := RIB_TRANSLATE
else
	yy_column := yy_column + 6
--|#line 129 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 129")
end
last_token := RIB_ROTATE
end
end
else
if yy_act <= 60 then
if yy_act = 59 then
	yy_column := yy_column + 5
--|#line 130 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 130")
end
last_token := RIB_SCALE
else
	yy_column := yy_column + 4
--|#line 131 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 131")
end
last_token := RIB_SKEW
end
else
	yy_column := yy_column + 11
--|#line 132 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 132")
end
last_token := RIB_DEFORMATION
end
end
else
if yy_act <= 65 then
if yy_act <= 63 then
if yy_act = 62 then
	yy_column := yy_column + 16
--|#line 133 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 133")
end
last_token := RIB_COORDINATESYSTEM
else
	yy_column := yy_column + 11
--|#line 134 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 134")
end
last_token := RIB_MAKETEXTURE
end
else
if yy_act = 64 then
	yy_column := yy_column + 8
--|#line 135 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 135")
end
last_token := RIB_MAKEBUMP
else
	yy_column := yy_column + 22
--|#line 136 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 136")
end
last_token := RIB_MAKELATLONGENVIRONMENT
end
end
else
if yy_act <= 67 then
if yy_act = 66 then
	yy_column := yy_column + 23
--|#line 137 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 137")
end
last_token := RIB_MAKECUBEFACEENVIRONMENT
else
	yy_column := yy_column + 10
--|#line 138 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 138")
end
last_token := RIB_MAKESHADOW
end
else
	yy_column := yy_column + 7
--|#line 139 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 139")
end
last_token := RIB_POLYGON
end
end
end
else
if yy_act <= 75 then
if yy_act <= 72 then
if yy_act <= 70 then
if yy_act = 69 then
	yy_column := yy_column + 14
--|#line 140 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 140")
end
last_token := RIB_GENERALPOLYGON
else
	yy_column := yy_column + 13
--|#line 141 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 141")
end
last_token := RIB_POINTSPOLYGON
end
else
if yy_act = 71 then
	yy_column := yy_column + 20
--|#line 142 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 142")
end
last_token := RIB_POINTSGENERALPOLYGON
else
	yy_column := yy_column + 5
--|#line 143 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 143")
end
last_token := RIB_PATCH
end
end
else
if yy_act <= 74 then
if yy_act = 73 then
	yy_column := yy_column + 9
--|#line 144 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 144")
end
last_token := RIB_PATCHMESH
else
	yy_column := yy_column + 7
--|#line 145 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 145")
end
last_token := RIB_NUPATCH
end
else
	yy_column := yy_column + 6
--|#line 146 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 146")
end
last_token := RIB_SPHERE
end
end
else
if yy_act <= 78 then
if yy_act <= 77 then
if yy_act = 76 then
	yy_column := yy_column + 4
--|#line 147 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 147")
end
last_token := RIB_CONE
else
	yy_column := yy_column + 8
--|#line 148 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 148")
end
last_token := RIB_CYLINDER
end
else
	yy_column := yy_column + 11
--|#line 149 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 149")
end
last_token := RIB_HYPERBOLOID
end
else
if yy_act <= 80 then
if yy_act = 79 then
	yy_column := yy_column + 10
--|#line 150 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 150")
end
last_token := RIB_PARABOLOID
else
	yy_column := yy_column + 4
--|#line 151 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 151")
end
last_token := RIB_DISK
end
else
	yy_column := yy_column + 5
--|#line 152 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 152")
end
last_token := RIB_TORUS
end
end
end
end
else
if yy_act <= 94 then
if yy_act <= 88 then
if yy_act <= 85 then
if yy_act <= 83 then
if yy_act = 82 then
	yy_column := yy_column + 8
--|#line 153 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 153")
end
last_token := RIB_GEOMETRY
else
	yy_column := yy_column + 14
--|#line 154 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 154")
end
last_token := RIB_OBJECTINSTANCE
end
else
if yy_act = 84 then
	yy_column := yy_column + 6
--|#line 155 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 155")
end
last_token := RIB_POINTS
else
	yy_column := yy_column + 6
--|#line 156 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 156")
end
last_token := RIB_CURVES
end
end
else
if yy_act <= 87 then
if yy_act = 86 then
	yy_column := yy_column + 15
--|#line 157 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 157")
end
last_token := RIB_SUBDIVISIONMESH
else
	yy_column := yy_column + 14
--|#line 158 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 158")
end
last_token := RIB_ATTRIBUTEBEGIN
end
else
	yy_column := yy_column + 12
--|#line 159 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 159")
end
last_token := RIB_ATTRIBUTEEND
end
end
else
if yy_act <= 91 then
if yy_act <= 90 then
if yy_act = 89 then
	yy_column := yy_column + 14
--|#line 160 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 160")
end
last_token := RIB_TRANSFORMBEGIN
else
	yy_column := yy_column + 12
--|#line 161 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 161")
end
last_token := RIB_TRANSFORMEND
end
else
	yy_column := yy_column + 11
--|#line 162 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 162")
end
last_token := RIB_OBJECTBEGIN
end
else
if yy_act <= 93 then
if yy_act = 92 then
	yy_column := yy_column + 9
--|#line 163 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 163")
end
last_token := RIB_OBJECTEND
else
	yy_column := yy_column + 11
--|#line 164 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 164")
end
last_token := RIB_MOTIONBEGIN
end
else
	yy_column := yy_column + 9
--|#line 165 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 165")
end
last_token := RIB_MOTIONEND
end
end
end
else
if yy_act <= 101 then
if yy_act <= 98 then
if yy_act <= 96 then
if yy_act = 95 then
	yy_column := yy_column + 10
--|#line 166 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 166")
end
last_token := RIB_SOLIDBEGIN
else
	yy_column := yy_column + 8
--|#line 167 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 167")
end
last_token := RIB_SOLIDEND
end
else
if yy_act = 97 then
	yy_column := yy_column + 10
--|#line 168 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 168")
end
last_token := RIB_WORLDBEGIN
else
	yy_column := yy_column + 8
--|#line 169 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 169")
end
last_token := RIB_WORLDEND
end
end
else
if yy_act <= 100 then
if yy_act = 99 then
	yy_column := yy_column + 10
--|#line 170 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 170")
end
last_token := RIB_FRAMEBEGIN
else
	yy_column := yy_column + 8
--|#line 171 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 171")
end
last_token := RIB_FRAMEEND
end
else
yy_set_line_column
--|#line 174 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 174")
end

			last_token := RIB_STRING
			last_string_value := text
		  
end
end
else
if yy_act <= 104 then
if yy_act <= 103 then
if yy_act = 102 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 180 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 180")
end

				last_token := RIB_INTEGER
			last_integer_value := text.to_integer
			   
else
	yy_end := yy_end - 1
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 186 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 186")
end

						   last_token := RIB_REAL
						   last_double_value := text.to_double
											 
end
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 187 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 187")
end

						   last_token := RIB_REAL
						   last_double_value := text.to_double
											 
end
else
if yy_act <= 106 then
if yy_act = 105 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 188 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 188")
end

						   last_token := RIB_REAL
						   last_double_value := text.to_double
											 
else
	yy_column := yy_column + 1
--|#line 195 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 195")
end

						
end
else
yy_set_line_column
--|#line 0 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 0")
end
last_token := yyError_token
fatal_error ("scanner jammed")
end
end
end
end
end
end
		end

	yy_execute_eof_action (yy_sc: INTEGER) is
			-- Execute EOF semantic action.
		do
			inspect yy_sc
when 0 then
--|#line 0 "rib_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'rib_scanner.l' at line 0")
end
terminate
			else
				terminate
			end
		end

feature {NONE} -- Table templates

	yy_nxt_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
				0,	  4,	5,	  6,	7,	  8,	9,	 10,   11,	 12,
			   13,	 14,   15,	 16,   17,	 18,   19,	 20,	4,	 21,
			   22,	 23,   24,	 25,   26,	 27,   28,	 29,	4,	 30,
			   31,	 32,	4,	  4,	4,	  4,	4,	  4,	4,	  4,
				4,	  4,	4,	  4,	4,	  4,	4,	  4,	4,	  4,
				4,	  4,   33,	  4,	4,	  4,	4,	 39,   48,	 40,
			   41,	 42,   44,	 42,   46,	 55,   47,	 68,   45,	 56,
			   50,	 61,   49,	 51,   58,	 52,   59,	130,   53,	 63,
			   71,	 69,   54,	 79,   74,	131,   62,	 64,   65,	 66,
			  654,	 45,   75,	 80,   72,	 73,   81,	 98,   76,	 99,

			   77,	 82,   83,	655,   84,	 88,   44,	 42,   85,	 86,
			  135,	 43,   45,	 87,  149,	 89,   94,	 90,   38,	 38,
			   39,	 38,   38,	 38,   38,	 38,   96,	101,  136,	112,
			  150,	 97,  113,	102,  106,	 45,  107,	108,  117,	 94,
			  151,	118,  114,	121,  122,	115,  145,	 38,   38,	138,
			  141,	139,  157,	142,   97,	161,  166,	146,  167,	152,
			   96,	656,   98,	162,   99,	168,  147,	158,  165,	165,
			   39,	165,  165,	165,  165,	165,  176,	186,  177,	236,
			  312,	237,  187,	268,  269,	325,  326,	389,  168,	327,
			  349,	657,  270,	363,  313,	369,  364,	165,  165,	271,

			  272,	370,  350,	372,  351,	421,  373,	408,  390,	411,
			  409,	463,  412,	422,  494,	557,  413,	599,  558,	658,
			  600,	659,  495,	660,  661,	662,  464,	663,  664,	665,
			  666,	667,  668,	669,  670,	671,  672,	673,  674,	675,
			  676,	677,  678,	679,  680,	681,  682,	683,  684,	685,
			  686,	687,  688,	689,  690,	691,  692,	693,  694,	695,
			  696,	697,  698,	699,  700,	701,  702,	703,  704,	705,
			  706,	707,  708,	709,  710,	711,  712,	713,  714,	715,
			  716,	717,  718,	719,  720,	721,  722,	723,  724,	725,
			  726,	727,  728,	729,  730,	731,  732,	733,  734,	735,

			  736,	737,  738,	739,  740,	741,  742,	743,  744,	745,
			  746,	747,  748,	749,  750,	751,  752,	753,  754,	755,
			  756,	757,  758,	759,   36,	 36,   38,	 38,   93,	 93,
			   95,	165,  165,	653,  652,	651,  650,	649,  648,	647,
			  646,	645,  644,	643,  642,	641,  640,	639,  638,	637,
			  636,	635,  634,	633,  632,	631,  630,	629,  628,	627,
			  626,	625,  624,	623,  622,	621,  620,	619,  618,	617,
			  616,	615,  614,	613,  612,	611,  610,	609,  608,	607,
			  606,	605,  604,	603,  602,	601,  598,	597,  596,	595,
			  594,	593,  592,	591,  590,	589,  588,	587,  586,	585,

			  584,	583,  582,	581,  580,	579,  578,	577,  576,	575,
			  574,	573,  572,	571,  570,	569,  568,	567,  566,	565,
			  564,	563,  562,	561,  560,	559,  556,	555,  554,	553,
			  552,	551,  550,	549,  548,	547,  546,	545,  544,	543,
			  542,	541,  540,	539,  538,	537,  536,	535,  534,	533,
			  532,	531,  530,	529,  528,	527,  526,	525,  524,	523,
			  522,	521,  520,	519,  518,	517,  516,	515,  514,	513,
			  512,	511,  510,	509,  508,	507,  506,	505,  504,	503,
			  502,	501,  500,	499,  498,	497,  496,	493,  492,	491,
			  490,	489,  488,	487,  486,	485,  484,	483,  482,	481,

			  480,	479,  478,	477,  476,	475,  474,	473,  472,	471,
			  470,	469,  468,	467,  466,	465,  462,	461,  460,	459,
			  458,	457,  456,	455,  454,	453,  452,	451,  450,	449,
			  448,	447,  446,	445,  444,	443,  442,	441,  440,	439,
			  438,	437,  436,	435,  434,	433,  432,	431,  430,	429,
			  428,	427,  426,	425,  424,	423,  420,	419,  418,	417,
			  416,	415,  414,	410,  407,	406,  405,	404,  403,	402,
			  401,	400,  399,	398,  397,	396,  395,	394,  393,	392,
			  391,	388,  387,	386,  385,	384,  383,	382,  381,	380,
			  379,	378,  377,	376,  375,	374,  371,	368,  367,	366,

			  365,	362,  361,	360,  359,	358,  357,	356,  355,	354,
			  353,	352,  348,	347,  346,	345,  344,	343,  342,	341,
			  340,	339,  338,	337,  336,	335,  334,	333,  332,	331,
			  330,	329,  328,	324,  323,	322,  321,	320,  319,	318,
			  317,	316,  315,	314,  311,	310,  309,	308,  307,	306,
			  237,	237,  305,	304,  303,	302,  301,	300,  299,	298,
			  297,	296,  295,	294,  293,	292,  291,	290,  289,	288,
			  287,	286,  285,	284,  283,	282,  281,	280,  279,	278,
			  277,	276,  275,	274,  273,	267,  266,	265,  264,	263,
			  262,	261,  260,	259,  258,	257,  256,	255,  254,	253,

			  252,	251,  250,	249,  248,	247,  246,	245,  244,	243,
			  242,	241,  240,	239,  238,	167,  167,	 39,  235,	234,
			  233,	232,  231,	230,  229,	228,  227,	226,  225,	224,
			  223,	222,  221,	220,  219,	218,  217,	216,  215,	214,
			  213,	212,  211,	210,  209,	208,  207,	206,  205,	204,
			  203,	202,  201,	200,  199,	198,  197,	196,  195,	194,
			  193,	192,  191,	190,  189,	188,  185,	184,  183,	182,
			  181,	180,  179,	178,  175,	174,  173,	172,  171,	170,
			  169,	 99,   99,	164,  163,	160,  159,	156,  155,	154,
			  153,	148,  144,	143,  140,	137,  134,	133,  132,	129,

			  128,	127,  126,	125,  124,	123,  120,	119,  116,	111,
			  110,	109,  105,	104,  103,	100,   43,	 39,   37,	 35,
			   34,	 92,   91,	 78,   70,	 67,   60,	 57,   43,	 37,
			   35,	 34,  760,	  3,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760, yy_Dummy>>)
		end

	yy_chk_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
				0,	  1,	1,	  1,	1,	  1,	1,	  1,	1,	  1,
				1,	  1,	1,	  1,	1,	  1,	1,	  1,	1,	  1,
				1,	  1,	1,	  1,	1,	  1,	1,	  1,	1,	  1,
				1,	  1,	1,	  1,	1,	  1,	1,	  1,	1,	  1,
				1,	  1,	1,	  1,	1,	  1,	1,	  1,	1,	  1,
				1,	  1,	1,	  1,	1,	  1,	1,	  8,   13,	  8,
				9,	  9,   11,	 11,   12,	 15,   12,	 22,   11,	 15,
			   14,	 19,   13,	 14,   17,	 14,   17,	 68,   14,	 20,
			   24,	 22,   14,	 27,   25,	 68,   19,	 20,   20,	 20,
			  623,	 11,   25,	 27,   24,	 24,   28,	 45,   25,	 45,

			   25,	 28,   28,	626,   28,	 29,   42,	 42,   28,	 28,
			   72,	 43,   42,	 28,   81,	 29,   43,	 29,   40,	 40,
			   40,	 40,   40,	 40,   40,	 40,   44,	 47,   72,	 55,
			   81,	 44,   55,	 47,   51,	 42,   51,	 51,   57,	 43,
			   82,	 57,   55,	 60,   60,	 55,   79,	 40,   40,	 74,
			   76,	 74,   87,	 76,   44,	 90,   94,	 79,   94,	 82,
			   96,	627,   97,	 90,   97,	 96,   79,	 87,   93,	 93,
			   93,	 93,   93,	 93,   93,	 93,  107,	116,  107,	168,
			  246,	168,  116,	201,  201,	258,  258,	321,   96,	258,
			  282,	628,  201,	296,  246,	302,  296,	 93,   93,	201,

			  201,	302,  282,	304,  282,	352,  304,	341,  321,	343,
			  341,	397,  343,	352,  430,	507,  343,	551,  507,	629,
			  551,	631,  430,	632,  633,	634,  397,	636,  637,	638,
			  639,	640,  641,	644,  645,	646,  649,	650,  651,	652,
			  653,	654,  656,	657,  658,	659,  660,	662,  663,	664,
			  665,	667,  668,	669,  670,	671,  672,	673,  674,	675,
			  676,	677,  679,	681,  682,	683,  684,	685,  686,	687,
			  689,	690,  691,	692,  694,	695,  696,	698,  700,	701,
			  702,	703,  707,	708,  709,	710,  711,	712,  713,	714,
			  715,	717,  718,	721,  722,	723,  724,	725,  726,	727,

			  729,	730,  731,	732,  733,	734,  735,	736,  737,	738,
			  739,	741,  743,	744,  745,	746,  747,	748,  749,	750,
			  753,	754,  755,	757,  761,	761,  762,	762,  763,	763,
			  764,	765,  765,	619,  618,	615,  614,	613,  612,	610,
			  608,	607,  606,	605,  604,	603,  602,	600,  599,	598,
			  597,	595,  594,	593,  592,	591,  590,	588,  587,	586,
			  585,	584,  582,	581,  580,	579,  578,	576,  575,	574,
			  572,	571,  570,	568,  567,	566,  565,	564,  562,	561,
			  560,	559,  558,	557,  555,	554,  550,	549,  548,	547,
			  546,	545,  544,	543,  542,	541,  540,	539,  538,	537,

			  536,	534,  533,	532,  530,	528,  527,	526,  525,	524,
			  523,	522,  521,	520,  519,	518,  517,	516,  515,	514,
			  513,	512,  511,	510,  509,	508,  506,	505,  503,	502,
			  501,	500,  499,	498,  496,	495,  494,	493,  492,	491,
			  490,	488,  487,	486,  485,	484,  483,	482,  481,	480,
			  479,	478,  477,	476,  475,	474,  473,	472,  471,	469,
			  467,	465,  463,	462,  460,	459,  456,	455,  454,	453,
			  451,	450,  449,	448,  447,	445,  444,	443,  441,	440,
			  439,	438,  437,	436,  434,	433,  432,	429,  428,	427,
			  426,	425,  424,	422,  421,	420,  419,	418,  417,	416,

			  415,	413,  412,	411,  409,	408,  407,	406,  405,	404,
			  403,	402,  401,	400,  399,	398,  396,	395,  394,	393,
			  392,	391,  389,	388,  387,	386,  384,	383,  382,	381,
			  380,	379,  378,	377,  376,	375,  374,	373,  372,	371,
			  370,	369,  368,	367,  366,	364,  363,	362,  361,	360,
			  358,	357,  356,	355,  354,	353,  351,	350,  349,	348,
			  347,	346,  344,	342,  340,	339,  338,	337,  336,	335,
			  334,	332,  331,	330,  329,	328,  327,	326,  325,	323,
			  322,	320,  319,	318,  317,	316,  314,	313,  312,	311,
			  310,	309,  308,	307,  306,	305,  303,	300,  299,	298,

			  297,	294,  293,	292,  290,	289,  288,	287,  286,	285,
			  284,	283,  281,	280,  279,	278,  277,	276,  275,	274,
			  272,	271,  270,	269,  268,	267,  266,	265,  264,	263,
			  262,	260,  259,	257,  256,	255,  254,	253,  252,	251,
			  250,	249,  248,	247,  245,	244,  243,	240,  239,	238,
			  237,	236,  235,	234,  233,	232,  231,	230,  229,	228,
			  227,	226,  224,	223,  222,	221,  220,	219,  218,	217,
			  216,	215,  214,	213,  212,	211,  210,	209,  208,	207,
			  206,	205,  204,	203,  202,	200,  199,	198,  197,	196,
			  195,	194,  193,	192,  191,	190,  189,	188,  187,	185,

			  184,	183,  182,	181,  180,	179,  178,	176,  175,	174,
			  173,	172,  171,	170,  169,	167,  166,	165,  164,	163,
			  162,	161,  160,	159,  158,	157,  156,	155,  154,	153,
			  152,	151,  150,	149,  148,	147,  146,	145,  144,	143,
			  142,	141,  140,	139,  138,	137,  136,	135,  134,	133,
			  132,	131,  130,	129,  128,	127,  126,	125,  124,	123,
			  122,	121,  120,	119,  118,	117,  115,	114,  113,	112,
			  111,	110,  109,	108,  106,	105,  104,	103,  102,	101,
			  100,	 99,   98,	 92,   91,	 89,   88,	 86,   85,	 84,
			   83,	 80,   78,	 77,   75,	 73,   71,	 70,   69,	 67,

			   66,	 65,   64,	 63,   62,	 61,   59,	 58,   56,	 54,
			   53,	 52,   50,	 49,   48,	 46,   41,	 38,   36,	 35,
			   34,	 33,   30,	 26,   23,	 21,   18,	 16,   10,	  7,
				6,	  5,	3,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760, yy_Dummy>>)
		end

	yy_base_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
				0,	  0,	0,	832,  833,	829,  827,	825,   54,	 53,
			  820,	 55,   16,	 26,   27,	 29,  773,	 28,  790,	 31,
			   44,	785,   35,	773,   47,	 52,  772,	 47,   62,	 69,
			  776,	833,  833,	785,  818,	816,  814,	833,  814,	833,
			  117,	808,   99,	103,  118,	 91,  779,	 83,  765,	762,
			  772,	 91,  765,	762,  766,	 95,  759,	 91,  759,	774,
			   98,	770,  757,	767,  759,	769,  750,	761,   35,	748,
			  774,	755,   78,	755,  101,	740,  110,	747,  760,	114,
			  741,	 82,  108,	755,  753,	745,  748,	119,  732,	737,
			  123,	736,  735,	167,  150,	833,  152,	156,  774,	773,

			  748,	733,  730,	737,  731,	728,  728,	142,  725,	725,
			  719,	730,  726,	722,  717,	734,  135,	719,  728,	719,
			  718,	725,  716,	723,  722,	712,  705,	717,  718,	714,
			  716,	701,  710,	717,  712,	713,  706,	709,  712,	709,
			  706,	696,  685,	698,  693,	702,  704,	699,  702,	690,
			  696,	696,  680,	693,  675,	687,  690,	690,  687,	673,
			  671,	676,  676,	676,  669,	714,  708,	707,  173,	695,
			  664,	672,  662,	675,  662,	660,  675,	833,  671,	676,
			  668,	658,  670,	653,  661,	659,  833,	655,  648,	648,
			  663,	658,  645,	656,  643,	642,  639,	644,  651,	638,

			  635,	173,  648,	637,  632,	647,  640,	633,  633,	644,
			  637,	632,  624,	635,  636,	621,  661,	619,  620,	617,
			  630,	629,  624,	613,  613,	833,  626,	612,  619,	626,
			  606,	607,  606,	643,  618,	612,  643,	642,  609,	601,
			  614,	833,  833,	606,  619,	594,  154,	603,  593,	606,
			  592,	595,  616,	594,  604,	584,  594,	583,  176,	600,
			  581,	833,  597,	589,  588,	579,  586,	599,  573,	572,
			  590,	582,  584,	833,  574,	584,  567,	566,  570,	564,
			  567,	592,  176,	562,  564,	575,  568,	559,  566,	556,
			  568,	833,  558,	557,  565,	833,  183,	564,  547,	564,

			  549,	833,  158,	545,  193,	549,  556,	554,  541,	546,
			  558,	562,  533,	542,  541,	833,  549,	548,  551,	545,
			  556,	153,  532,	533,  833,	529,  541,	531,  532,	526,
			  527,	522,  526,	833,  524,	523,  524,	534,  516,	533,
			  510,	197,  524,	199,  507,	833,  529,	517,  523,	518,
			  525,	524,  190,	510,  504,	497,  518,	499,  514,	833,
			  520,	510,  499,	510,  500,	833,  504,	507,  506,	495,
			  508,	491,  502,	492,  491,	496,  498,	483,  494,	487,
			  482,	480,  496,	492,  478,	833,  475,	510,  491,	486,
			  833,	485,  472,	472,  480,	482,  493,	171,  472,	459,

			  481,	464,  460,	463,  473,	489,  472,	456,  469,	459,
			  833,	467,  457,	456,  833,	450,  453,	449,  454,	452,
			  447,	458,  447,	833,  452,	455,  451,	453,  466,	447,
			  197,	833,  448,	450,  435,	833,  472,	434,  431,	428,
			  441,	443,  833,	427,  428,	439,  833,	427,  441,	445,
			  421,	424,  833,	429,  428,	422,  422,	833,  833,	429,
			  424,	833,  417,	428,  833,	415,  833,	410,  833,	411,
			  833,	444,  411,	410,  404,	416,  418,	414,  416,	401,
			  409,	408,  408,	396,  398,	404,  398,	399,  395,	833,
			  400,	427,  390,	392,  391,	403,  394,	833,  393,	386,

			  387,	394,  393,	388,  833,	401,  390,	205,  382,	379,
			  375,	386,  368,	374,  383,	380,  381,	382,  370,	371,
			  404,	372,  375,	376,  377,	363,  354,	358,  365,	833,
			  364,	833,  353,	356,  366,	833,  364,	356,  366,	361,
			  341,	350,  342,	357,  352,	356,  340,	339,  343,	341,
			  340,	207,  833,	833,  340,	338,  833,	347,  337,	345,
			  331,	347,  352,	833,  332,	333,  339,	329,  323,	833,
			  317,	324,  335,	833,  333,	334,  329,	833,  330,	320,
			  319,	331,  317,	833,  313,	324,  314,	310,  319,	833,
			  320,	305,  318,	307,  316,	315,  833,	305,  301,	312,

			  302,	833,  295,	307,  309,	294,  305,	296,  285,	833,
			  304,	833,  288,	312,  298,	288,  833,	833,  298,	320,
			  833,	833,  833,	 45,  833,	833,   54,	127,  159,	173,
			  833,	189,  178,	171,  177,	833,  207,	193,  191,	195,
			  183,	192,  833,	833,  187,	185,  186,	833,  833,	204,
			  191,	190,  226,	195,  207,	833,  206,	200,  199,	205,
			  196,	833,  200,	212,  209,	210,  833,	217,  207,	205,
			  217,	205,  206,	212,  212,	214,  208,	225,  833,	239,
			  833,	220,  232,	219,  217,	222,  223,	233,  833,	226,
			  225,	236,  233,	833,  220,	223,  236,	833,  231,	833,

			  228,	236,  241,	249,  833,	833,  833,	234,  239,	238,
			  245,	246,  239,	245,  249,	258,  833,	241,  248,	833,
			  833,	249,  246,	249,  241,	251,  248,	263,  833,	268,
			  255,	257,  265,	259,  265,	257,  257,	263,  265,	264,
			  833,	265,  833,	272,  269,	278,  270,	271,  271,	282,
			  274,	833,  833,	275,  276,	272,  833,	273,  833,	833,
			  833,	323,  325,	327,  329,	330, yy_Dummy>>)
		end

	yy_def_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
				0,	760,	1,	760,  760,	760,  760,	761,  762,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  761,	760,  762,	760,
			  763,	760,  760,	760,  764,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	763,  760,	760,  760,	760,  760,	760,

			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	765,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,

			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,

			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,

			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,

			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,

			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,

			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
			  760,	760,  760,	760,  760,	760,  760,	760,  760,	760,
				0,	760,  760,	760,  760,	760, yy_Dummy>>)
		end

	yy_ec_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
				0,	  1,	1,	  1,	1,	  1,	1,	  1,	1,	  2,
				3,	  1,	1,	  2,	1,	  1,	1,	  1,	1,	  1,
				1,	  1,	1,	  1,	1,	  1,	1,	  1,	1,	  1,
				1,	  1,	2,	  1,	4,	  5,	1,	  1,	1,	  1,
				1,	  1,	1,	  6,	1,	  6,	7,	  1,	8,	  8,
				8,	  8,	8,	  8,	8,	  8,	8,	  8,	1,	  1,
				1,	  1,	1,	  1,	1,	  9,   10,	 11,   12,	 13,
			   14,	 15,   16,	 17,   18,	 18,   19,	 20,   21,	 22,
			   23,	 24,   25,	 26,   27,	 18,   28,	 29,   18,	 18,
			   18,	 30,	1,	 31,	1,	  1,	1,	 32,   33,	 34,

			   35,	 36,   37,	 38,   39,	 40,   41,	 42,   43,	 44,
			   45,	 46,   47,	 18,   48,	 49,   50,	 51,   52,	 53,
			   54,	 55,   56,	  1,	1,	  1,	1,	  1,	1,	  1,
				1,	  1,	1,	  1,	1,	  1,	1,	  1,	1,	  1,
				1,	  1,	1,	  1,	1,	  1,	1,	  1,	1,	  1,
				1,	  1,	1,	  1,	1,	  1,	1,	  1,	1,	  1,
				1,	  1,	1,	  1,	1,	  1,	1,	  1,	1,	  1,
				1,	  1,	1,	  1,	1,	  1,	1,	  1,	1,	  1,
				1,	  1,	1,	  1,	1,	  1,	1,	  1,	1,	  1,
				1,	  1,	1,	  1,	1,	  1,	1,	  1,	1,	  1,

				1,	  1,	1,	  1,	1,	  1,	1,	  1,	1,	  1,
				1,	  1,	1,	  1,	1,	  1,	1,	  1,	1,	  1,
				1,	  1,	1,	  1,	1,	  1,	1,	  1,	1,	  1,
				1,	  1,	1,	  1,	1,	  1,	1,	  1,	1,	  1,
				1,	  1,	1,	  1,	1,	  1,	1,	  1,	1,	  1,
				1,	  1,	1,	  1,	1,	  1,	1, yy_Dummy>>)
		end

	yy_meta_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
				0,	  1,	1,	  1,	1,	  1,	1,	  2,	1,	  1,
				1,	  1,	1,	  1,	1,	  1,	1,	  1,	1,	  1,
				1,	  1,	1,	  1,	1,	  1,	1,	  1,	1,	  1,
				1,	  1,	1,	  1,	1,	  1,	1,	  1,	1,	  1,
				1,	  1,	1,	  1,	1,	  1,	1,	  1,	1,	  1,
				1,	  1,	1,	  1,	1,	  1,	1, yy_Dummy>>)
		end

	yy_accept_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
				0,	  0,	0,	108,  106,	  1,	2,	106,  106,	106,
			  106,	102,  106,	106,  106,	106,  106,	106,  106,	106,
			  106,	106,  106,	106,  106,	106,  106,	106,  106,	106,
			  106,	  3,	4,	106,	1,	  2,	0,	101,	0,	  6,
				0,	  0,  102,	105,	0,	  0,	0,	  0,	0,	  0,
				0,	  0,	0,	  0,	0,	  0,	0,	  0,	0,	  0,
				0,	  0,	0,	  0,	0,	  0,	0,	  0,	0,	  0,
				0,	  0,	0,	  0,	0,	  0,	0,	  0,	0,	  0,
				0,	  0,	0,	  0,	0,	  0,	0,	  0,	0,	  0,
				0,	  0,	0,	  5,	0,	103,  105,	103,	0,	104,

				0,	  0,	0,	  0,	0,	  0,	0,	  0,	0,	  0,
				0,	  0,	0,	  0,	0,	  0,	0,	  0,	0,	  0,
				0,	  0,	0,	  0,	0,	  0,	0,	  0,	0,	  0,
				0,	  0,	0,	  0,	0,	  0,	0,	  0,	0,	  0,
				0,	  0,	0,	  0,	0,	  0,	0,	  0,	0,	  0,
				0,	  0,	0,	  0,	0,	  0,	0,	  0,	0,	  0,
				0,	  0,	0,	  0,	0,	  5,	0,	105,	0,	  0,
				0,	  0,	0,	  0,	0,	  0,	0,	 76,	0,	  0,
				0,	  0,	0,	  0,	0,	  0,   80,	  0,	0,	  0,
				0,	  0,	0,	  0,	0,	  0,	0,	  0,	0,	  0,

				0,	  0,	0,	  0,	0,	  0,	0,	  0,	0,	  0,
				0,	  0,	0,	  0,	0,	  0,	0,	  0,	0,	  0,
				0,	  0,	0,	  0,	0,	 60,	0,	  0,	0,	  0,
				0,	  0,	0,	  0,	0,	  0,	0,	104,	0,	  0,
				0,	 49,   42,	  0,   30,	  0,	0,	  0,	0,	  0,
				0,	  0,	0,	  0,	0,	  0,	0,	  0,	0,	  0,
				0,	 25,	0,	  0,	0,	  0,	0,	  0,	0,	  0,
				0,	  0,	0,	 41,	0,	  0,	0,	  0,	0,	  0,
				0,	 72,	0,	  0,	0,	  0,	0,	  0,	0,	  0,
				0,	 59,	0,	  0,	0,	 48,	0,	  0,	0,	  0,

				0,	 81,	0,	  0,	0,	  0,	0,	  0,	0,	  0,
				0,	  0,	0,	  0,	0,	 85,	0,	  0,	0,	  0,
			   43,	  0,	0,	  0,   10,	  0,	0,	  0,	0,	  0,
				0,	  0,	0,	 22,	0,	  0,	0,	  0,	0,	  0,
				0,	  0,	0,	  0,	0,	 28,	0,	  0,	0,	  0,
				0,	  0,   84,	  0,	0,	  0,	0,	  0,	0,	 58,
				0,	  0,	0,	  0,	0,	 75,	0,	  0,	0,	  0,
				0,	  0,	0,	  0,	0,	  0,	0,	  0,	0,	  0,
				0,	  0,	0,	  0,	0,	  8,	0,	  0,	0,	  0,
			   24,	  0,	0,	  0,	0,	  0,	0,	  0,	0,	  0,

				0,	  0,	0,	  0,	0,	  0,	0,	  0,	0,	  0,
			   74,	  0,	0,	  0,   31,	  0,	0,	  0,	0,	  0,
				0,	  0,	0,	 68,	0,	  0,	0,	  0,	0,	  0,
				0,	 17,	0,	  0,	0,	 32,	0,	  0,	0,	  0,
				0,	  0,	7,	  0,	0,	  0,   15,	  0,	0,	  0,
				0,	  0,   77,	  0,	0,	  0,	0,	 21,   35,	  0,
				0,	100,	0,	  0,   82,	  0,   53,	  0,   34,	  0,
			   64,	  0,	0,	  0,	0,	  0,	0,	  0,	0,	  0,
				0,	  0,	0,	  0,	0,	  0,	0,	  0,	0,	 23,
				0,	  0,	0,	  0,	0,	  0,	0,	 96,	0,	  0,

				0,	  0,	0,	  0,   98,	  0,	0,	 29,	0,	  0,
				0,	  0,	0,	  0,	0,	  0,	0,	  0,	0,	  0,
				0,	  0,	0,	  0,	0,	  0,	0,	  0,	0,	 94,
				0,	 92,	0,	  0,	0,	 73,	0,	  0,	0,	  0,
				0,	  0,	0,	  0,	0,	  0,	0,	  0,	0,	  0,
				0,	 56,   57,	 50,	0,	  0,   33,	  0,	0,	  0,
				0,	  0,	0,	 13,	0,	  0,	0,	  0,	0,	 99,
				0,	  0,	0,	 36,	0,	  0,	0,	 67,	0,	  0,
				0,	  0,	0,	 79,	0,	  0,	0,	  0,	0,	 14,
				0,	  0,	0,	  0,	0,	  0,   95,	  0,	0,	  0,

				0,	 97,	0,	  0,	0,	  0,	0,	  0,	0,	 61,
				0,	 44,	0,	  0,	0,	  0,   78,	 51,	0,	  0,
			   63,	 93,   91,	  0,   46,	 20,	0,	  0,	0,	  0,
				9,	  0,	0,	  0,	0,	 39,	0,	  0,	0,	  0,
				0,	  0,   88,	 26,	0,	  0,	0,	 16,   37,	  0,
				0,	  0,	0,	  0,	0,	 19,	0,	  0,	0,	  0,
				0,	 12,	0,	  0,	0,	  0,   90,	  0,	0,	  0,
				0,	  0,	0,	  0,	0,	  0,	0,	  0,   18,	  0,
			   70,	  0,	0,	  0,	0,	  0,	0,	  0,   87,	  0,
				0,	  0,	0,	 69,	0,	  0,	0,	 83,	0,	 27,

				0,	  0,	0,	  0,   89,	 52,   55,	  0,	0,	  0,
				0,	  0,	0,	  0,	0,	  0,   86,	  0,	0,	 62,
			   11,	  0,	0,	  0,	0,	  0,	0,	  0,   54,	  0,
				0,	  0,	0,	  0,	0,	  0,	0,	  0,	0,	  0,
			   47,	  0,   38,	  0,	0,	  0,	0,	  0,	0,	  0,
				0,	 71,   40,	  0,	0,	  0,   45,	  0,   65,	 66,
				0, yy_Dummy>>)
		end

feature {NONE} -- Constants

	yyJam_base: INTEGER is 833
			-- Position in `yy_nxt'/`yy_chk' tables
			-- where default jam table starts

	yyJam_state: INTEGER is 760
			-- State id corresponding to jam state

	yyTemplate_mark: INTEGER is 761
			-- Mark between normal states and templates

	yyNull_equiv_class: INTEGER is 1
			-- Equivalence code for NULL character

	yyReject_used: BOOLEAN is false
			-- Is `reject' called?

	yyVariable_trail_context: BOOLEAN is false
			-- Is there a regular expression with
			-- both leading and trailing parts having
			-- variable length?

	yyReject_or_variable_trail_context: BOOLEAN is false
			-- Is `reject' called or is there a
			-- regular expression with both leading
			-- and trailing parts having variable length?

	yyNb_rules: INTEGER is 107
			-- Number of rules

	yyEnd_of_buffer: INTEGER is 108
			-- End of buffer rule code

	yyLine_used: BOOLEAN is true
			-- Are line and column numbers used?

	yyPosition_used: BOOLEAN is false
			-- Is `position' used?

	INITIAL: INTEGER is 0
			-- Start condition codes

feature -- User-defined features



feature {NONE} -- Local variables

		i_, nb_: INTEGER
		char_: CHARACTER
		str_: STRING
		code_: INTEGER
		line_count_multiple_value: INTEGER
		
feature {NONE} -- Initialization

		make is
						-- Create a new Eiffel scanner.
				do
						make_with_buffer (Empty_buffer)
						create eif_buffer.make (Init_buffer_size)
						eif_lineno := 1
			line_count_multiple_value := 100
				end

feature -- Initialization

		reset is
						-- Reset scanner before scanning next input.
				do
						reset_compressed_scanner_skeleton
						eif_lineno := 1
						eif_buffer.wipe_out
				end

feature -- Access

		eif_buffer: STRING
						-- Buffer for lexial tokens

		eif_lineno: INTEGER
						-- Current line number

feature {NONE} -- Constants

		Init_buffer_size: INTEGER is 256
								-- Initial size for `eif_buffer'
		
		line_count_multiple: INTEGER is
			-- The value used for printing line count
		do
			if eif_lineno <= 500 then
				line_count_multiple_value := 100
			elseif eif_lineno <= 2000 then
				line_count_multiple_value := 500
			elseif eif_lineno <=10000 then
				line_count_multiple_value := 2000
			elseif eif_lineno <= 50000 then
				line_count_multiple_value := 10000
			else 
				line_count_multiple_value := 50000
			end
			
			Result := line_count_multiple_value
		end
	
invariant

		eif_buffer_not_void: eif_buffer /= Void
		eif_lineno_positive: eif_lineno > 0
		line_count_multiple_positive: line_count_multiple > 0 and line_count_multiple <= 50000
		
end -- class EIFFEL_SCANNER
