indexing

	description: "Parser token codes"
	generator: "geyacc version 3.4"

class RIB_TOKENS

inherit

	YY_PARSER_TOKENS

feature -- Last values

	last_any_value: ANY
	last_integer_value: INTEGER
	last_double_value: DOUBLE
	last_string_value: STRING

feature -- Access

	token_name (a_token: INTEGER): STRING is
			-- Name of token `a_token'
		do
			inspect a_token
			when 0 then
				Result := "EOF token"
			when -1 then
				Result := "Error token"
			when BRACKET_LEFT then
				Result := "BRACKET_LEFT"
			when BRACKET_RIGHT then
				Result := "BRACKET_RIGHT"
			when RIB_INTEGER then
				Result := "RIB_INTEGER"
			when RIB_REAL then
				Result := "RIB_REAL"
			when RIB_STRING then
				Result := "RIB_STRING"
			when RIB_VERSION then
				Result := "RIB_VERSION"
			when RIB_DECLARE then
				Result := "RIB_DECLARE"
			when RIB_READARCHIVE then
				Result := "RIB_READARCHIVE"
			when RIB_FORMAT then
				Result := "RIB_FORMAT"
			when RIB_FRAMEASPECTRATIO then
				Result := "RIB_FRAMEASPECTRATIO"
			when RIB_SCREENWINDOW then
				Result := "RIB_SCREENWINDOW"
			when RIB_CROPWINDOW then
				Result := "RIB_CROPWINDOW"
			when RIB_PROJECTION then
				Result := "RIB_PROJECTION"
			when RIB_CLIPPING then
				Result := "RIB_CLIPPING"
			when RIB_DEPTHOFFIELD then
				Result := "RIB_DEPTHOFFIELD"
			when RIB_PIXELVARIANCE then
				Result := "RIB_PIXELVARIANCE"
			when RIB_PIXELSAMPLES then
				Result := "RIB_PIXELSAMPLES"
			when RIB_PIXELFILTER then
				Result := "RIB_PIXELFILTER"
			when RIB_EXPOSURE then
				Result := "RIB_EXPOSURE"
			when RIB_IMAGER then
				Result := "RIB_IMAGER"
			when RIB_SHUTTER then
				Result := "RIB_SHUTTER"
			when RIB_QUANTIZE then
				Result := "RIB_QUANTIZE"
			when RIB_DISPLAY then
				Result := "RIB_DISPLAY"
			when RIB_COLORSAMPLES then
				Result := "RIB_COLORSAMPLES"
			when RIB_RELATIVEDETAIL then
				Result := "RIB_RELATIVEDETAIL"
			when RIB_OPTION then
				Result := "RIB_OPTION"
			when RIB_ATTRIBUTE then
				Result := "RIB_ATTRIBUTE"
			when RIB_COLOR then
				Result := "RIB_COLOR"
			when RIB_OPACITY then
				Result := "RIB_OPACITY"
			when RIB_SURFACE then
				Result := "RIB_SURFACE"
			when RIB_ATMOSPHERE then
				Result := "RIB_ATMOSPHERE"
			when RIB_INTERIOR then
				Result := "RIB_INTERIOR"
			when RIB_EXTERIOR then
				Result := "RIB_EXTERIOR"
			when RIB_ILLUMINATE then
				Result := "RIB_ILLUMINATE"
			when RIB_DISPLACEMENT then
				Result := "RIB_DISPLACEMENT"
			when RIB_TEXTURECOORDINATES then
				Result := "RIB_TEXTURECOORDINATES"
			when RIB_REVERSEORIENTATION then
				Result := "RIB_REVERSEORIENTATION"
			when RIB_HIDER then
				Result := "RIB_HIDER"
			when RIB_SHADINGRATE then
				Result := "RIB_SHADINGRATE"
			when RIB_SHADINGINTERPOLATION then
				Result := "RIB_SHADINGINTERPOLATION"
			when RIB_MATTE then
				Result := "RIB_MATTE"
			when RIB_BOUND then
				Result := "RIB_BOUND"
			when RIB_DETAIL then
				Result := "RIB_DETAIL"
			when RIB_DETAILRANGE then
				Result := "RIB_DETAILRANGE"
			when RIB_GEOMETRICAPPROXIMATION then
				Result := "RIB_GEOMETRICAPPROXIMATION"
			when RIB_ORIENTATION then
				Result := "RIB_ORIENTATION"
			when RIB_SIDES then
				Result := "RIB_SIDES"
			when RIB_BASIS then
				Result := "RIB_BASIS"
			when RIB_TRIMCURVE then
				Result := "RIB_TRIMCURVE"
			when RIB_LIGHTSOURCE then
				Result := "RIB_LIGHTSOURCE"
			when RIB_AREALIGHTSOURCE then
				Result := "RIB_AREALIGHTSOURCE"
			when RIB_IDENTITY then
				Result := "RIB_IDENTITY"
			when RIB_TRANSFORM then
				Result := "RIB_TRANSFORM"
			when RIB_CONCATTRANSFORM then
				Result := "RIB_CONCATTRANSFORM"
			when RIB_PERSPECTIVE then
				Result := "RIB_PERSPECTIVE"
			when RIB_TRANSLATE then
				Result := "RIB_TRANSLATE"
			when RIB_ROTATE then
				Result := "RIB_ROTATE"
			when RIB_SCALE then
				Result := "RIB_SCALE"
			when RIB_SKEW then
				Result := "RIB_SKEW"
			when RIB_DEFORMATION then
				Result := "RIB_DEFORMATION"
			when RIB_COORDINATESYSTEM then
				Result := "RIB_COORDINATESYSTEM"
			when RIB_COORDSYSTRANSFORM then
				Result := "RIB_COORDSYSTRANSFORM"
			when RIB_MAKETEXTURE then
				Result := "RIB_MAKETEXTURE"
			when RIB_MAKEBUMP then
				Result := "RIB_MAKEBUMP"
			when RIB_MAKELATLONGENVIRONMENT then
				Result := "RIB_MAKELATLONGENVIRONMENT"
			when RIB_MAKECUBEFACEENVIRONMENT then
				Result := "RIB_MAKECUBEFACEENVIRONMENT"
			when RIB_MAKESHADOW then
				Result := "RIB_MAKESHADOW"
			when RIB_POLYGON then
				Result := "RIB_POLYGON"
			when RIB_GENERALPOLYGON then
				Result := "RIB_GENERALPOLYGON"
			when RIB_POINTSPOLYGON then
				Result := "RIB_POINTSPOLYGON"
			when RIB_POINTSGENERALPOLYGON then
				Result := "RIB_POINTSGENERALPOLYGON"
			when RIB_PATCH then
				Result := "RIB_PATCH"
			when RIB_PATCHMESH then
				Result := "RIB_PATCHMESH"
			when RIB_NUPATCH then
				Result := "RIB_NUPATCH"
			when RIB_SPHERE then
				Result := "RIB_SPHERE"
			when RIB_CONE then
				Result := "RIB_CONE"
			when RIB_CYLINDER then
				Result := "RIB_CYLINDER"
			when RIB_HYPERBOLOID then
				Result := "RIB_HYPERBOLOID"
			when RIB_PARABOLOID then
				Result := "RIB_PARABOLOID"
			when RIB_POINTS then
				Result := "RIB_POINTS"
			when RIB_CURVES then
				Result := "RIB_CURVES"
			when RIB_SUBDIVISIONMESH then
				Result := "RIB_SUBDIVISIONMESH"
			when RIB_DISK then
				Result := "RIB_DISK"
			when RIB_TORUS then
				Result := "RIB_TORUS"
			when RIB_GEOMETRY then
				Result := "RIB_GEOMETRY"
			when RIB_OBJECTINSTANCE then
				Result := "RIB_OBJECTINSTANCE"
			when RIB_ATTRIBUTEBEGIN then
				Result := "RIB_ATTRIBUTEBEGIN"
			when RIB_ATTRIBUTEEND then
				Result := "RIB_ATTRIBUTEEND"
			when RIB_TRANSFORMBEGIN then
				Result := "RIB_TRANSFORMBEGIN"
			when RIB_TRANSFORMEND then
				Result := "RIB_TRANSFORMEND"
			when RIB_OBJECTBEGIN then
				Result := "RIB_OBJECTBEGIN"
			when RIB_OBJECTEND then
				Result := "RIB_OBJECTEND"
			when RIB_MOTIONBEGIN then
				Result := "RIB_MOTIONBEGIN"
			when RIB_MOTIONEND then
				Result := "RIB_MOTIONEND"
			when RIB_SOLIDBEGIN then
				Result := "RIB_SOLIDBEGIN"
			when RIB_SOLIDEND then
				Result := "RIB_SOLIDEND"
			when RIB_WORLDBEGIN then
				Result := "RIB_WORLDBEGIN"
			when RIB_WORLDEND then
				Result := "RIB_WORLDEND"
			when RIB_FRAMEBEGIN then
				Result := "RIB_FRAMEBEGIN"
			when RIB_FRAMEEND then
				Result := "RIB_FRAMEEND"
			when RIB_DIRECTIVE then
				Result := "RIB_DIRECTIVE"
			else
				Result := yy_character_token_name (a_token)
			end
		end

feature -- Token codes

	BRACKET_LEFT: INTEGER is 258
	BRACKET_RIGHT: INTEGER is 259
	RIB_INTEGER: INTEGER is 260
	RIB_REAL: INTEGER is 261
	RIB_STRING: INTEGER is 262
	RIB_VERSION: INTEGER is 263
	RIB_DECLARE: INTEGER is 264
	RIB_READARCHIVE: INTEGER is 265
	RIB_FORMAT: INTEGER is 266
	RIB_FRAMEASPECTRATIO: INTEGER is 267
	RIB_SCREENWINDOW: INTEGER is 268
	RIB_CROPWINDOW: INTEGER is 269
	RIB_PROJECTION: INTEGER is 270
	RIB_CLIPPING: INTEGER is 271
	RIB_DEPTHOFFIELD: INTEGER is 272
	RIB_PIXELVARIANCE: INTEGER is 273
	RIB_PIXELSAMPLES: INTEGER is 274
	RIB_PIXELFILTER: INTEGER is 275
	RIB_EXPOSURE: INTEGER is 276
	RIB_IMAGER: INTEGER is 277
	RIB_SHUTTER: INTEGER is 278
	RIB_QUANTIZE: INTEGER is 279
	RIB_DISPLAY: INTEGER is 280
	RIB_COLORSAMPLES: INTEGER is 281
	RIB_RELATIVEDETAIL: INTEGER is 282
	RIB_OPTION: INTEGER is 283
	RIB_ATTRIBUTE: INTEGER is 284
	RIB_COLOR: INTEGER is 285
	RIB_OPACITY: INTEGER is 286
	RIB_SURFACE: INTEGER is 287
	RIB_ATMOSPHERE: INTEGER is 288
	RIB_INTERIOR: INTEGER is 289
	RIB_EXTERIOR: INTEGER is 290
	RIB_ILLUMINATE: INTEGER is 291
	RIB_DISPLACEMENT: INTEGER is 292
	RIB_TEXTURECOORDINATES: INTEGER is 293
	RIB_REVERSEORIENTATION: INTEGER is 294
	RIB_HIDER: INTEGER is 295
	RIB_SHADINGRATE: INTEGER is 296
	RIB_SHADINGINTERPOLATION: INTEGER is 297
	RIB_MATTE: INTEGER is 298
	RIB_BOUND: INTEGER is 299
	RIB_DETAIL: INTEGER is 300
	RIB_DETAILRANGE: INTEGER is 301
	RIB_GEOMETRICAPPROXIMATION: INTEGER is 302
	RIB_ORIENTATION: INTEGER is 303
	RIB_SIDES: INTEGER is 304
	RIB_BASIS: INTEGER is 305
	RIB_TRIMCURVE: INTEGER is 306
	RIB_LIGHTSOURCE: INTEGER is 307
	RIB_AREALIGHTSOURCE: INTEGER is 308
	RIB_IDENTITY: INTEGER is 309
	RIB_TRANSFORM: INTEGER is 310
	RIB_CONCATTRANSFORM: INTEGER is 311
	RIB_PERSPECTIVE: INTEGER is 312
	RIB_TRANSLATE: INTEGER is 313
	RIB_ROTATE: INTEGER is 314
	RIB_SCALE: INTEGER is 315
	RIB_SKEW: INTEGER is 316
	RIB_DEFORMATION: INTEGER is 317
	RIB_COORDINATESYSTEM: INTEGER is 318
	RIB_COORDSYSTRANSFORM: INTEGER is 319
	RIB_MAKETEXTURE: INTEGER is 320
	RIB_MAKEBUMP: INTEGER is 321
	RIB_MAKELATLONGENVIRONMENT: INTEGER is 322
	RIB_MAKECUBEFACEENVIRONMENT: INTEGER is 323
	RIB_MAKESHADOW: INTEGER is 324
	RIB_POLYGON: INTEGER is 325
	RIB_GENERALPOLYGON: INTEGER is 326
	RIB_POINTSPOLYGON: INTEGER is 327
	RIB_POINTSGENERALPOLYGON: INTEGER is 328
	RIB_PATCH: INTEGER is 329
	RIB_PATCHMESH: INTEGER is 330
	RIB_NUPATCH: INTEGER is 331
	RIB_SPHERE: INTEGER is 332
	RIB_CONE: INTEGER is 333
	RIB_CYLINDER: INTEGER is 334
	RIB_HYPERBOLOID: INTEGER is 335
	RIB_PARABOLOID: INTEGER is 336
	RIB_POINTS: INTEGER is 337
	RIB_CURVES: INTEGER is 338
	RIB_SUBDIVISIONMESH: INTEGER is 339
	RIB_DISK: INTEGER is 340
	RIB_TORUS: INTEGER is 341
	RIB_GEOMETRY: INTEGER is 342
	RIB_OBJECTINSTANCE: INTEGER is 343
	RIB_ATTRIBUTEBEGIN: INTEGER is 344
	RIB_ATTRIBUTEEND: INTEGER is 345
	RIB_TRANSFORMBEGIN: INTEGER is 346
	RIB_TRANSFORMEND: INTEGER is 347
	RIB_OBJECTBEGIN: INTEGER is 348
	RIB_OBJECTEND: INTEGER is 349
	RIB_MOTIONBEGIN: INTEGER is 350
	RIB_MOTIONEND: INTEGER is 351
	RIB_SOLIDBEGIN: INTEGER is 352
	RIB_SOLIDEND: INTEGER is 353
	RIB_WORLDBEGIN: INTEGER is 354
	RIB_WORLDEND: INTEGER is 355
	RIB_FRAMEBEGIN: INTEGER is 356
	RIB_FRAMEEND: INTEGER is 357
	RIB_DIRECTIVE: INTEGER is 358

end
