
indexing
	description: "Factory for creating RenderMan filters"
	patterns: "none"
	date: "$Date: 2006-12-06 13:14:08 -0500 (Wed, 06 Dec 2006) $"
	revision: "$Revision: 271 $"
	status: "unreviewed"


class
		
	FILTER_FACTORY

creation
	make

feature -- Initialization

	make is
			-- 
		do

		end

feature -- Access
feature -- Measurement
feature -- Comparison
feature -- Status report
	
	valid_pixelfilter_name (str: STRING): BOOLEAN is
			-- Check if the pixelfilter name is one of "box", "catmull-rom", 
			-- "gaussian", "sinc", or "triangle"
		do
			Result := str.is_equal ("%"box%"") or 
				str.is_equal ("%"catmull-rom%"") or
				str.is_equal ("%"gaussian%"") or
				str.is_equal ("%"sinc%"") or
				str.is_equal ("%"triangle%"") 
		end
	
feature -- Status setting
feature -- Cursor movement
feature -- Element change
feature -- Removal
feature -- Resizing
feature -- Transformation
feature -- Conversion
feature -- Duplication
feature -- Basic operations
	
	factory (name: STRING): RI_FILTER_FUNCTION is
			-- Take `name' and convert it into an appropriate filter class.
		require 
			name_is_valid: name /= Void and then valid_pixelfilter_name (name)
		do
			if name.is_equal ("%"gaussian%"") then
				create {RI_GAUSSIAN_FILTER} Result
			else
				create {RI_GAUSSIAN_FILTER} Result
			end
		ensure 
			filter_made: Result /= Void
		end

feature -- Miscellaneous
feature -- Obsolete
feature -- Inapplicable
feature {NONE} -- Implementation

end -- FILTER_FACTORY

