

indexing
	description: "A table of all options"
	patterns: "none"
	status: "unreviewed"




class 

	OPTIONS_TABLE

inherit

	DS_HASH_TABLE [PARAMETER_LIST, STRING]

creation
	make

feature -- Access

	get_doubles (category, name: STRING): DOUBLE_ARRAYED_LIST is
			-- Return the values for option `category' with `name'
		require 
			name_not_void: name /= Void
			category_not_void: category /= Void
			has_category: has (category)
			has_name: has_name (category, name)
		local
			parameters: PARAMETER_LIST
		do
			parameters := item (category)
			Result := parameters.item (parameters.index_of_tag (name)).second.second
		ensure 
			default: true
		end 

	get_strings (category, name: STRING): DS_ARRAYED_LIST [STRING] is
			-- Return the string values for option `category' with `name'
		require 
			name_not_void: name /= Void
			category_not_void: category /= Void
			has_category: has (category)
			has_name: has_name (category, name)
		local
			parameters: PARAMETER_LIST
		do
			parameters := item (category)
			Result := parameters.item (parameters.index_of_tag (name)).second.first
		ensure 
			default: true
		end 

feature -- Status Report

	has_name (category, name: STRING): BOOLEAN is
			-- Does option `category' have `name'
		require 
			name_not_void: name /= Void
			category_not_void: category /= Void
			has_category: has (category)
		local
			parameters: PARAMETER_LIST
		do
			parameters := item (category)
			Result := parameters.has_tag (name)
		end 

end -- OPTIONS_TABLE

