

indexing
	description: ""
	status: "Mark Bolstad"
	names: x, y
	representation: linked
	access: fixed, fifo, lifo, index, key, cursor, membership, min, max
	size: resizable
	contents: generic
	date: "$Date: 2006-06-23 10:34:45 -0400 (Fri, 23 Jun 2006) $"
	revision: "$Revision: 226 $"
	



class
	
	PARAMETER_LIST

inherit
	
	DS_BILINKED_LIST [PAIR [STRING,
							NAND_PAIR [DS_ARRAYED_LIST [STRING],
									   DOUBLE_ARRAYED_LIST]]]
		redefine
			make
		end

creation
	make

feature -- Initialization
	
	make is
			-- Initialize the parameter list
		do
			Precursor
			
--			object_comparison := true
		end 

feature -- Initialization
feature -- Access
	
	has_tag (tag: STRING): BOOLEAN is
			-- Does parameter_list include `tag'?
		require
			tag_not_void: tag /= Void and then tag.count >= 1
		do
			from
				start
			until
				Result or after
			loop
				if item_for_iteration.first.is_equal (tag) then
					Result := true
				end
				
				forth
			end
		end
	
	index_of_tag (tag: STRING): INTEGER is
			-- Does parameter_list include `tag'? 
			-- 0 if not in list
		require
			tag_not_void: tag /= Void and then tag.count >= 1
		local
			flag: BOOLEAN
		do
			from
				start
				Result := 0
			until
				flag or after
			loop
				if item_for_iteration.first.is_equal (tag) then
					flag := true
				end
				
				Result := Result + 1
				forth
			end
			
			if not flag then
				Result := 0
			end
		ensure
			Result_is_in_range: Result >= 0 and Result <= count
		end
	
feature -- Measurement
feature -- Comparison
feature -- Status report
	
	print_parameter_list is
			-- Print the pairs in `parameters'
		local
			vals: DOUBLE_ARRAYED_LIST
			strings: DS_ARRAYED_LIST [STRING]
		do
			from
				start
			variant
				count - index + 1
			until
				after
			loop
				io.put_string (item_for_iteration.first)
				io.put_string (" ")
				
				check
					item_for_iteration.second.first = Void xor 
						item_for_iteration.second.second = Void
				end
				
				if item_for_iteration.second.first /= Void then
					strings := item_for_iteration.second.first
					io.put_string ("[")
					
					from
						strings.start
					variant
						strings.count - strings.index + 1
					until
						strings.after
					loop
						io.put_string (strings.item_for_iteration)
						io.put_string (" ")
						strings.forth
					end
					
					io.put_string ("]")
				else
					vals := item_for_iteration.second.second
					io.put_string ("[")
					
					from
						vals.start
					variant
						vals.count - vals.index + 1
					until
						vals.after
					loop
						io.put_double (vals.item_for_iteration)
						io.put_string (" ")
						vals.forth
					end
					
					io.put_string ("]")
				end
				io.put_string (" ")
				forth
			end
			
			io.put_string ("%N")
		ensure 
			default: true
		end -- print_parameter_list

feature -- Status setting
feature -- Cursor movement
feature -- Element change
	
	put_string (tag: STRING; value: DS_ARRAYED_LIST [STRING]) is
			-- Add a string to the parameter list
		require 
			not_void: tag /= Void and value /= Void
		local
			xp: NAND_PAIR[ DS_ARRAYED_LIST [STRING], DOUBLE_ARRAYED_LIST]
			p: PAIR [STRING, NAND_PAIR [DS_ARRAYED_LIST [STRING],
										DOUBLE_ARRAYED_LIST]]
		do
			create xp.put_first (value)
			create p.put (tag, xp)
			force_last (p)
		end -- put_string
	
	put_array (tag: STRING; value: DOUBLE_ARRAYED_LIST) is
			-- Add an array to the parameter
		require 
			not_void: tag /= Void and value /= Void and value.count > 0
		local
			xp: NAND_PAIR [DS_ARRAYED_LIST [STRING], DOUBLE_ARRAYED_LIST]
			p: PAIR [STRING, NAND_PAIR [DS_ARRAYED_LIST [STRING],
										DOUBLE_ARRAYED_LIST]]
		do
			create xp.put_second (value)
			create p.put (tag, xp)
			force_last (p)
		end -- put_array
	
	put_pair (tag: STRING; value: NAND_PAIR[DS_ARRAYED_LIST [STRING],
											DOUBLE_ARRAYED_LIST]) is
			-- Add a tagged pair to the list
		require 
			not_void: tag /= Void and value /= Void
		local
			p: PAIR [STRING, NAND_PAIR [DS_ARRAYED_LIST [STRING],
										DOUBLE_ARRAYED_LIST]]
		do
			create p.put (tag, value)
			force_last (p)
		end -- put_pair

feature -- Removal
feature -- Resizing
feature -- Transformation
feature -- Conversion
feature -- Duplication
feature -- Basic operations
feature -- Miscellaneous
feature -- Obsolete
feature -- Inapplicable
feature {NONE} -- Implementation

end -- PARAMETER_LIST

