

indexing
	description: "Interface class for RenderMan filters"
	patterns: "none"
	date: "$Date: 2006-12-06 13:14:08 -0500 (Wed, 06 Dec 2006) $"
	revision: "$Revision: 271 $"
	status: "unreviewed"




deferred class 
	
	RI_FILTER_FUNCTION
	
inherit
	
	BASIC_NUMERIC
		redefine
			default_create
		end

feature -- Initialization
	
	default_create is
			-- Create the darn thing.
		do
			width := 2
			height := 2
		end

	make (new_width, new_height: DOUBLE) is
			-- Create a filter of width `new_width' and height `new_height'
		require
			new_width_positive: new_width > 0
			new_height_positive: new_height > 0
		do
			width := new_width
			height := new_height
		end
	
feature -- Access
feature -- Measurement
feature -- Comparison
feature -- Status report
	
	width: DOUBLE
			-- The support of the filter (in pixels) in the x
			-- direction, i.e., `width'. Note that the filter is
			-- centered, so a `width' of 3 covers 1 pixel to the left 
			-- and right of the current pixel.

	height: DOUBLE
			-- The support of the filter (in pixels) in the y
			-- direction, i.e., `height'. Note that the filter is
			-- centered, so a `height' of 3 covers 1 pixel above and
			-- below the current pixel.

feature -- Status setting
	
	set_width (new_width: DOUBLE) is
			-- Set `width' to `new_width'.
		require 
			new_width_positive: new_width > 0
		do
			width := new_width
		ensure 
			width_set: width = new_width
		end

	set_height (new_height: DOUBLE) is
			-- Set `height' to `new_height'.
		require 
			new_height_positive: new_height > 0
		do
			height := new_height
		ensure 
			height_set: height = new_height
		end

feature -- Cursor movement
feature -- Element change
feature -- Removal
feature -- Resizing
feature -- Transformation
feature -- Conversion
feature -- Duplication
feature -- Basic operations
	
	apply (x, y: DOUBLE): DOUBLE  is
			-- Return the weight of the filter at the point `x', `y'.
		deferred
		end

feature -- Miscellaneous
feature -- Obsolete
feature -- Inapplicable
feature {NONE} -- Implementation
	
invariant
	width_is_positive: width > 0
	height_is_positive: height > 0
	
end -- RI_FILTER_FUNCTION

