

indexing
	description: "Gaussian filters"
	patterns: "none"
	date: "$Date: 2006-12-06 13:14:08 -0500 (Wed, 06 Dec 2006) $"
	revision: "$Revision: 271 $"
	status: "unreviewed"




class
	
	RI_GAUSSIAN_FILTER
	
inherit
	
	RI_FILTER_FUNCTION

creation
	default_create, make

feature -- Basic operations
	
	apply (x, y: DOUBLE): DOUBLE  is
			-- Return the weight of the filter at the point `x', `y'.
		local
			d, w, d2, w2: DOUBLE
		do
			d2 := x * x + y * y
			d := square_root (d2)
			w2 := 0.5 * (width * width + height * height)
			w := square_root (w2)
			if d > w then
				Result := 0
			else
				Result := exp (-d2) - exp (-w2)
			end
		end
	
end -- RI_GAUSSIAN_FILTER

