

indexing
	description: "Class for ouputting the SL AST to a stack machine"
	names: "action"
	contents: "generic"
	patterns: "strategy"


class 

	STACK_ACTION

inherit
	
	SL_ACTION
		redefine
			finalize, post_action
		end

creation
	make
	
feature -- Initialization
	
	make (output_file_name: STRING) is
			-- Initialize the action
		local
			file: KL_TEXT_OUTPUT_FILE
			std_out: KL_STDOUT_FILE
		do
			default_create

			if not output_file_name.is_equal ("-") then
				create file.make (output_file_name)
			end
			if file = Void then
				create std_out.make
				shader_file := std_out
			else
				file.open_write
				shader_file := file
			end

			reverse_order := true
		end

feature -- Access

	shader_file: KI_CHARACTER_OUTPUT_STREAM
			-- The stream to output
	
feature -- Comparison
feature -- Status report
feature -- Status setting
	
	push (node: PARSE_NODE) is
			-- Increase depth in tree
		do
		end 

	pop (node: PARSE_NODE) is
			-- Increase depth in tree
		do
		end 
	
feature -- Cursor movement
feature -- Element change
feature -- Removal
feature -- Resizing
feature -- Transformation
feature -- Conversion
feature -- Duplication
feature -- Basic operations
	
	post_action (node: PARSE_NODE) is
			-- Apply this action to `node'
		do
			node.stack_output (Current)
		end 

	finalize is
			-- Do any necessary finalization
		do
			if shader_file.is_closable then
				shader_file.close
			end
		end
	
feature -- Miscellaneous
feature -- Obsolete
feature -- Inapplicable
feature {NONE} -- Implementation
	
invariant
	
end -- STACK_ACTION

