

indexing
	description: "Ray tracing acceleration structure"
	names: "acceleration"
	representation: "none"
	access: "index", "cursor"
	size: "resizable"
	contents: "generic"
	patterns: "template"



deferred class 

	SCENE_ACCELERATOR [G]
	
inherit

	SCENE_VOLUME
	
	BASIC_NUMERIC
		undefine
			copy, is_equal, default_create, out
		end
	
	NUMERIC_CONVERSION
		undefine
			copy, is_equal, default_create, out
		end
	
feature -- Initialization
feature -- Access
feature -- Measurement
feature -- Comparison
feature -- Status report
	
	has_extents: BOOLEAN is
			-- Does this volume have extents?
		do
			Result := extents /= Void
		end
	
feature -- Status setting
feature -- Cursor movement
feature -- Element change
	
	set_space_transform (xform: TRANSFORM) is
			-- Set the transform to bring this object into the space 
			-- defined by `xform'
		require 
			xform_not_void: xform /= Void
		do
			space_transform := xform	
		end 

feature -- Removal
	
	discard_items is 
			-- Remove all the elements
		deferred
		end
			
feature -- Resizing
feature -- Transformation
feature -- Conversion
feature -- Duplication
feature -- Basic operations
	
	add_object (drawable: SCENE_DRAWABLE) is
			-- Place the `drawable' into the accelerator
		require 
			drawable_not_void: drawable /= Void
		deferred
		ensure 
			default: true
		end 
	
	cull (action: CULLING_ACTION) is
			-- A traversal that culls geometry not in the viewing 
			-- frustrum
		do
		end 

feature -- Miscellaneous
feature -- Obsolete
feature -- Inapplicable
feature {NONE} -- Implementation
	
	space_transform: TRANSFORM
			-- A transform to bring the bound into the space of the 
			-- calling object
	
end -- SCENE_ACCELERATOR

