

indexing
	description: "Action that culls nodes and places them into a buckets"
	patterns: "none"
	date: "$Date: 2006-12-06 13:14:08 -0500 (Wed, 06 Dec 2006) $"
	revision: "$Revision: 271 $"
	status: "unreviewed"




class 

	BUCKETING_CULL_ACTION
	
inherit
	
	CULLING_ACTION
		rename
			make as culling_make
		export
			{CULLING_ACTION} culling_make
		redefine
			default_create, add_drawable
		end

creation
	make

feature -- Initialization
	
	default_create is
			-- 
		do
			Precursor

			if culled_pool = Void then
				create {SCENE_DRAWABLE_POOL} culled_pool.make (100)
			else
				culled_pool.wipe_out
			end
			
		end
	make (new_camera: SCENE_CAMERA; x_count, y_count, 
			new_x_resolution, new_y_resolution: INTEGER) is
			-- Initialize with `new_camera'
		require
			new_camera_not_void: new_camera /= Void
			x_count_positive: x_count > 0
			y_count_positive: y_count > 0
			new_x_resolution: new_x_resolution > 0
			new_y_resolution: new_y_resolution > 0
		do
			culling_make (new_camera)

			bucket_count_in_x := x_count
			bucket_count_in_y := y_count
			
			create buckets.make (bucket_count_in_x, bucket_count_in_y,
								 new_x_resolution, new_y_resolution,
								 camera.x_resolution, camera.y_resolution)
		end
	
feature -- Access

	buckets: BUCKET_TABLE
			-- The unculled drawable items sorted into the first 
			-- bucket that the screen space bounding box touches
	
	bucket_count_in_x, bucket_count_in_y: INTEGER
			-- The number of buckets in x and y respectively

	culled_pool: SCENE_POOL
			-- The pool of culled drawable items
	
feature -- Measurement
feature -- Comparison
feature -- Status report
feature -- Status setting
feature -- Cursor movement
feature -- Element change
	
	add_drawable (geometry: SCENE_GEOMETRY) is
			-- Add `geometry' to the drawable pool
		local
			drawable: SCENE_DRAWABLE
			bucket_item: BUCKET_ENTITY
			x, y: DOUBLE
		do
			Precursor (geometry)
			
			create drawable
			drawable.put (geometry, current_state.item, 
						  current_transform.item)
			if not culled then
				create bucket_item.make (last_point.z, drawable)
				x := last_point.x
				-- If the point projects <= 0 add a small offset to stick 
				-- it in the first bucket
				if x <= 1 then
					x := 1.1
				end
				y := last_point.y
				if y <= 1 then
					y := 1.1
				end
				buckets.put (bucket_item, x, y)
			else
				if gathering then
					culled_pool.put_last (drawable)
				end
			end
		end 

feature -- Removal
feature -- Resizing
feature -- Transformation
feature -- Conversion
feature -- Duplication
feature -- Basic operations
feature -- Miscellaneous
feature -- Obsolete
feature -- Inapplicable
feature {NONE} -- Implementation
	
invariant
	
	buckets_not_void: buckets /= Void
	culled_pool_not_void: culled_pool /= Void
	
end -- CULL_ACTION

