

indexing
	description: "Action for culling nodes"
	patterns: "none"
	date: "$Date: 2006-12-06 13:14:08 -0500 (Wed, 06 Dec 2006) $"
	revision: "$Revision: 271 $"
	status: "unreviewed"




class 

	CULL_ACTION
	
inherit
	
	CULLING_ACTION
		redefine
			default_create, add_drawable
		end

creation
	default_create, make, make_with_pool

feature -- Initialization
	
	default_create is
			-- 
		do
			Precursor

			if pool = Void then
				create {SCENE_DRAWABLE_POOL} pool.make (100)
				create {SCENE_DRAWABLE_POOL} culled_pool.make (100)
			else
				pool.wipe_out
				culled_pool.wipe_out
			end
			
		end
	
	make_with_pool (new_pool: SCENE_POOL) is
			-- Initialize with `new_pool'
		require
			new_pool_not_void: new_pool /= Void
		do
			default_create
			
			pool := new_pool
		ensure
			pool_set: pool = new_pool
		end
	
feature -- Access

	pool: SCENE_POOL
			-- The pool of drawable items
	
	culled_pool: SCENE_POOL
			-- The pool of culled drawable items
	
feature -- Measurement
feature -- Comparison
feature -- Status report
feature -- Status setting
feature -- Cursor movement
feature -- Element change
	
	add_drawable (geometry: SCENE_GEOMETRY) is
			-- Add `geometry' to the drawable pool
		local
			drawable: SCENE_DRAWABLE
		do
			Precursor (geometry)
			
			create drawable
			drawable.put (geometry, current_state.item, 
						  current_transform.item)
			if not culled then
				pool.put_last (drawable)
			else
				if gathering then
					culled_pool.put_last (drawable)
				end
			end
		ensure then
			count_increased: (not gathering implies old pool.count + 1 = pool.count ) or
							 (gathering implies old culled_pool.count + 1 = culled_pool.count ) 
		end 

feature -- Removal
feature -- Resizing
feature -- Transformation
feature -- Conversion
feature -- Duplication
feature -- Basic operations
feature -- Miscellaneous
feature -- Obsolete
feature -- Inapplicable
feature {NONE} -- Implementation
	
invariant
	
	pool_not_void: pool /= Void
	culled_pool_not_void: culled_pool /= Void
	
end -- CULL_ACTION

