

indexing
	description: "Action for working with GLSL shaders"
	names: "action", "GLSL"
	representation: "fixed"
	access: "traversal"
	size: "variable"
	contents: "SCENE_GLSL_ELEMENTS"
	patterns: "none"
	date: "$Date: 2006-06-23 10:34:45 -0400 (Fri, 23 Jun 2006) $"
	author: "Mark A. Bolstad"
	status: "unreviewed"




class 

	GLSL_SHADER_ACTION

inherit
	
	SCENE_ACTION
		redefine
			default_create
		end

creation
	default_create

feature -- Initialization

	default_create is
			-- 
		do
			Precursor

			create shader_list.make (10)
		end

feature -- Access

	shader_list: DS_ARRAYED_LIST [SCENE_GEOMETRY]
			-- A list of all the shaders found in the scene graph
	
feature -- Measurement

	count: INTEGER is
			-- The number of shaders found
		do
			Result := shader_list.count
		ensure
			Result_not_negative: Result >= 0
			Result_correct: Result = shader_list.count
		end
	
feature -- Comparison
feature -- Status report
feature -- Status setting
	
	push (node: SCENE_NODE) is
			-- Increase depth in tree
		do
		end 

	pop (node: SCENE_NODE) is
			-- Increase depth in tree
		do
		end 
	
feature -- Cursor movement
feature -- Element change
feature -- Removal
feature -- Resizing
feature -- Transformation
feature -- Conversion
feature -- Duplication
feature -- Basic operations
	
	apply (node: SCENE_OBJECT) is
			-- Apply this action to `node'
		local
			sg: SCENE_GEOMETRY
		do
			sg ?= node
			if sg /= Void then
				if sg.valid_key ("SCENE_GLSL_SHADER_ELEMENT") or
					sg.valid_key ("SCENE_SHADER_ELEMENT") then
					shader_list.force_last (sg)
				end
			end
		end 

feature -- Miscellaneous
feature -- Obsolete
feature -- Inapplicable
feature {NONE} -- Implementation

invariant
		count_correct: shader_list.count = count
		shader_list_not_void: shader_list /= Void
		
end -- GLSL_SHADER_ACTION

