

indexing
   description: "Action node for printing node data"
	patterns: "none"
	date: "$Date: 2006-12-06 13:14:08 -0500 (Wed, 06 Dec 2006) $"
	revision: "$Revision: 271 $"
	status: "unreviewed"


class 

	PRINT_ACTION
	
inherit
	
	SCENE_ACTION
		rename
			io as general_io
		redefine
			default_create
		end

creation
	default_create

feature -- Initialization

	default_create is
			-- 
		do
			Precursor
			
			show_default_values := false
			print_all_values := false
			print_count := 10
		end

feature -- Access
	
	io: IO_INDENTED_MEDIUM is
			-- The io_medium to use for printing
		once
			create Result.make
		end
	
feature -- Measurement
feature -- Comparison
feature -- Status report 
	
	show_default_values: BOOLEAN
			-- Print default values of SCENE_FIELD objects?
	
	print_all_values: BOOLEAN
			-- In a field of multiple values, should it print all of 
			-- the values, or a subset?
	
	print_count: INTEGER
			-- If not `print_all_values' then print the first 
			-- `print_count' values, and the last `print_count` 
			-- values.
	
feature -- Status setting
	
	push (node: SCENE_NODE) is
			-- Increase depth in tree
		do
			io.push
		end 

	pop (node: SCENE_NODE) is
			-- Increase depth in tree
		do
			io.pop
		end 

	set_showing_of_defaults (value: BOOLEAN) is
			-- 
		do
			show_default_values := value
		ensure 
			show_default_values_set: show_default_values = value
		end 

	set_print_all_values (value: BOOLEAN) is
			-- Set `print_all_values' to `value'
		do
			print_all_values := value
		ensure 
			print_all_values_set: print_all_values = value
		end 

	set_print_count (how_many: INTEGER) is
			-- Set `print_all_values' to `value'
		require
			how_many_is_positive: how_many > 0
		do
			print_count := how_many
		ensure 
			print_count_set: print_count = how_many
		end 

feature -- Cursor movement
feature -- Element change
feature -- Removal
feature -- Resizing
feature -- Transformation
feature -- Conversion
feature -- Duplication
feature -- Basic operations
	
	apply (object: SCENE_OBJECT) is
			-- Apply the print action to `object`
		do
			object.print_object (Current)
		end 

feature -- Miscellaneous
feature -- Obsolete
feature -- Inapplicable
feature {NONE} -- Implementation

invariant
	
	print_count_is_positive: print_count > 0
	
end -- PRINT_ACTION

