

indexing
	description: "Abstract class for applying actions to scene nodes"
	patterns: "strategy"
	date: "$Date: 2006-12-06 13:14:08 -0500 (Wed, 06 Dec 2006) $"
	revision: "$Revision: 271 $"
	status: "unreviewed"




deferred class 

	SCENE_ACTION

inherit
	
	SINGLETON_ACCESSOR
		redefine
			singleton, default_create
		end

	ANY
		redefine
			default_create
		end

feature -- Initialization
	
	default_create is
			-- Initialize the action
		do
			terminate_action := false
			singleton.next_id
			identifier := singleton.last_id
		end

feature -- Access
	
	identifier: INTEGER
			-- A guaranteed unique value to identify this instance of 
			-- an action
	
feature -- Measurement
feature -- Comparison
feature -- Status report
	
	terminate_action: BOOLEAN
			-- Should the traversal stop this action
	
feature -- Status setting
	
	push (node: SCENE_NODE) is
			-- Increase depth in tree
		deferred
		end 

	pop (node: SCENE_NODE) is
			-- Increase depth in tree
		deferred
		end 
	
feature -- Cursor movement
feature -- Element change
feature -- Removal
feature -- Resizing
feature -- Transformation
feature -- Conversion
feature -- Duplication
feature -- Basic operations
	
	apply (node: SCENE_OBJECT) is
			-- Apply this action to `node'
		require 
			node_not_void: node /= Void
		deferred
		end 

feature -- Miscellaneous
feature -- Obsolete
feature -- Inapplicable
feature {NONE} -- Implementation
	
	singleton: OBJECT_IDENTIFIER is
			-- Create the id generator
		once
			create Result
		end
	
invariant

	identifier_strictly_positive: identifier > 0

end -- SCENE_ACTION

