

indexing
	description: "Defines the default state of the scene graph at this point. The state elements in %
	% this node have precedence over  those higher in the graph, and are overridden %
	% by state elements lower in the graph. "
	patterns: "none"
	date: "$Date: 2006-12-06 13:14:08 -0500 (Wed, 06 Dec 2006) $"
	revision: "$Revision: 271 $"
	status: "unreviewed"




class 

	SCENE_DEFAULT_STATE
	
inherit
	
	SCENE_STATE_ELEMENT_TABLE
		rename
			item as iteration_item
		redefine
			is_equal, default_create, copy
		end
	
	SCENE_GROUP
		undefine
			detailed_memory_usage
		redefine
			is_equal, copy, default_create, traverse_node, print_features
		end

creation
	default_create, make

feature -- Initialization

	default_create is
			-- 
		do
			Precursor {SCENE_GROUP}
			Precursor {SCENE_STATE_ELEMENT_TABLE}
		end

feature -- Access
feature -- Measurement
feature -- Comparison
	
	is_equal (other: like Current): BOOLEAN is
			-- Are we equal?
		do
			Result := Precursor {SCENE_GROUP} (other)
			if Result then
				Result := Precursor {SCENE_STATE_ELEMENT_TABLE} (other)
			end
		end
	
feature -- Status report
feature -- Status setting
feature -- Cursor movement
feature -- Element change
	
	copy (other: like Current) is
			-- Make `Current' a copy of `other'
		do
			Precursor {SCENE_GROUP} (other)
			Precursor {SCENE_STATE_ELEMENT_TABLE} (other)
		end 

feature -- Removal
feature -- Resizing
feature -- Transformation
feature -- Conversion
feature -- Duplication
feature -- Basic operations
feature -- Miscellaneous
feature -- Obsolete
feature -- Inapplicable
feature {NONE} -- Implementation
	
	traverse_node (action: SCENE_ACTION) is
			-- Traverse this node
		do
			-- Fix: Insert state traversal
			Precursor (action)
		end
	
	print_features (action: PRINT_ACTION) is
			-- print the node's features
		do
			Precursor (action)
			
			if element_count > 0 then
				action.io.put_string ("	 state_elements = ")
				action.push (Current)
				action.push (Current)
				
				action_print (action)
				
				action.pop (Current)
				action.pop (Current)
				action.io.put_new_line
			end
		end 
	
end -- SCENE_DEFAULT_STATE

