

indexing
	description: "Node that defines the beginning of the world"
	patterns: "none"
	date: "$Date: 2006-12-06 13:14:08 -0500 (Wed, 06 Dec 2006) $"
	revision: "$Revision: 271 $"
	status: "unreviewed"




class 

	SCENE_WORLD
	
inherit
	
	SCENE_TRANSFORM
		redefine
			default_create, print_features, cull
		end

creation
	default_create, make

feature -- Initialization
	
	default_create is
			-- Initialize the world and it's structures
		do
			Precursor
			
			create global_lights.make 
		end
	
feature -- Access
	
	global_lights: SCENE_LIGHTS
			-- Defines all of the  lights that are used for the entire 
			-- scene. 
	
feature -- Measurement
feature -- Comparison
feature -- Status report
feature -- Status setting
feature -- Cursor movement
feature -- Element change
	
	append_light (light: LIGHT_SOURCE) is
			-- Append the `xform', `light' pair into the `global_lights'.
		require 
			light_not_void: light /= Void
		do
			global_lights.append_light (light)
		ensure 
			global_lights_updated: old global_lights.count = global_lights.count - 1
		end 

feature -- Removal
feature -- Resizing
feature -- Transformation
feature -- Conversion
feature -- Duplication
feature -- Basic operations
	
	cull (action: CULLING_ACTION) is
			-- A traversal that culls geometry not in the viewing 
			-- frustrum
		do
			action.set_global_lights (global_lights)
			
			Precursor (action)
		end 

feature -- Miscellaneous
feature -- Obsolete
feature -- Inapplicable
feature {NONE} -- Implementation
	
	print_features (action: PRINT_ACTION) is
			-- print the group's features
		do
			Precursor (action)
			
		end 
	
end -- SCENE_WORLD

