

indexing
	description: "State Element for face culling"
	patterns: "none"
	date: "$Date: 2006-12-06 13:14:08 -0500 (Wed, 06 Dec 2006) $"
	revision: "$Revision: 271 $"
	status: "unreviewed"




class 

	SCENE_CULL_ELEMENT
	
inherit
	
	SCENE_STATE_ELEMENT
		redefine
			print_features, default_create
		end

creation
	default_create, make

feature -- Initialization

	default_create is
			-- Initialize the cull mode to `off`
		do
			Precursor
			cull_mode := off
		ensure then
			cull_mode_off: cull_mode = off
		end

	make (mode: INTEGER) is
			-- Initialize the cull mode to `mode`
		require
			mode_is_valid: mode >= back and mode <= front_and_back
		do
			default_create
			cull_mode := mode
		ensure
			cull_mode_set: cull_mode = mode
		end

feature -- Access
	
	back, off, front, front_and_back: INTEGER is unique
			-- Culling modes
	
	cull_mode: INTEGER
			-- The current culling mode
	
feature -- Measurement
	
	count: INTEGER_64 is 1
			-- There's only one cull_mode
	
feature -- Comparison
feature -- Status report
feature -- Status setting
	
	set_cull_mode (mode: INTEGER) is
			-- Set `cull_mode` to `mode`
		require 
			mode_is_valid: mode >= back and mode <= front_and_back
		do
			cull_mode := mode
		ensure
			cull_mode_set: cull_mode = mode
		end 

feature -- Cursor movement
feature -- Element change
feature -- Removal
feature -- Resizing
feature -- Transformation
feature -- Conversion
feature -- Duplication
feature -- Basic operations
feature -- Miscellaneous
feature -- Obsolete
feature -- Inapplicable
feature {NONE} -- Implementation
	
	print_features (action: PRINT_ACTION) is
			-- print the node's features
		do
			Precursor (action)
			
			action.io.put_string ("	 cull_mode = ")
			inspect
				cull_mode
			when back then
				action.io.put_string ("back")
			when off then
				action.io.put_string ("off")
			when front then
				action.io.put_string ("front")
			when front_and_back then
				action.io.put_string ("front_and_back")
			end
			action.io.put_new_line
		end 
	
invariant
	
	cull_mode_correct: cull_mode >= back and cull_mode <= front_and_back
	
end -- SCENE_CULL_ELEMENT

