

indexing
	description: "State element for indexed color values"
	patterns: "none"
	date: "$Date: 2007-03-29 13:43:21 -0400 (Thu, 29 Mar 2007) $"
	revision: "$Revision: 286 $"
	status: "unreviewed"




class 

	SCENE_INDEXED_COLOR_ELEMENT
	
inherit
	
	SCENE_COLOR_ELEMENT
		undefine
			i_th, item, 
			count, after, start, forth, add_item, insert_item,
			replace_item, remove_item, remove_all_values
		redefine
			make_from_list, default_create
		end
	
	SCENE_INDEXED_MULTI_ELEMENT [RGBA_COLOR]
		rename
			make as multi_make -- matches make from above
		undefine
			print_features
		redefine
			make_from_list, default_create
		end

creation
	default_create, make, make_from_list, make_from_coordinates_and_indices

feature -- Initialization

	default_create is
			-- Create the element with a single, white color
		local
			c: RGBA_COLOR
		do
			Precursor {SCENE_INDEXED_MULTI_ELEMENT}
			
			create c
			add_item (c)
		end

	make_from_list (vals: RGBA_COLOR_ARRAYED_LIST) is
			-- Initialize the element with `vals'
		local
			i: INTEGER_64
		do
			default_create
			values := vals
			
			indices.item_for_iteration.wipe_out
			
			from
				i := 1
			invariant
				i_at_least_one: i >= 1
				i_small_enough: i <= 1 + values.count
			variant
				i_increasing: 1 + values.count - i
			until
				i > values.count
			loop
				indices.item_for_iteration.force_last (i)
				i := i + 1
			end
		end
	
	make_from_coordinates_and_indices (vals: RGBA_COLOR_ARRAYED_LIST; 
									   new_indices: INTEGER_64_ARRAYED_LIST) is
			-- Initialize the element with `vals' and `new_indices'
		do
			default_create
			values := vals
			indices.start
			indices.replace_at (new_indices)
		end
	
	make_from_color_element (element: SCENE_COLOR_ELEMENT) is
			-- Initialize the element with `vals'
		do
			make_from_list (element.values)
		ensure then
			values_set: values.is_equal (element.values)
		end
	
end -- SCENE_INDEXED_COLOR_ELEMENT

