

indexing
	description: "Abstract class for state elements with multiple elements"
	patterns: "none"
	date: "$Date: 2006-12-06 13:14:08 -0500 (Wed, 06 Dec 2006) $"
	revision: "$Revision: 271 $"
	status: "unreviewed"




deferred class 

	SCENE_MULTI_ELEMENT [G]
	
inherit
	
	SCENE_STATE_ELEMENT

feature -- Initialization

	make is
			--
		do
			default_create
		end
	
	make_from_element (element: like Current) is
			-- Initialize the element with `vals'
		require
			element_not_void: element /= Void
		deferred
		end
	
feature -- Access
	
	i_th (i: INTEGER_64): G is
			-- 
		require 
			valid_key: i >= 1 and i <= count
		deferred
		end 

	has (v: G): BOOLEAN is
			-- Does `v' appear in array?
		deferred
		end
	
	item: G is
			-- The item at the cursor
		deferred
		end 

feature -- Measurement
	
	count: INTEGER_64 is
			-- The number of values
		deferred
		end

feature -- Comparison
feature -- Status report
	
	after: BOOLEAN is
			-- Is the cursor off the end?
		deferred
		end
	
feature -- Status setting
feature -- Cursor movement
	
	start is
			-- Move to the beginning of the elements
		deferred
		end
	
	forth is
			-- Move to the	cursor one element
		deferred
		end
	
feature -- Element change
	
	add_item (value: G) is
			-- add `value' as a new item
		require 
			value_not_void: value /= Void
		deferred
		ensure 
			count_increased_by_one: count = old count + 1
		end
	
	insert_item (value: G; index: INTEGER_64) is
			-- insert `value' at `index'
		require 
			index_is_positive: index >= 1
			index_less_than_count: index <= count
			value_not_void: value /= Void
		deferred
		ensure 
			count_increased_by_one: count = old count + 1
			value_at_index: value = i_th (index)
		end
	
	replace_item (value: G; index: INTEGER_64) is
			-- replace the item at `index' with `value'
		require 
			index_is_positive: index >= 1
			index_less_than_count: index <= count
			value_not_void: value /= Void
		deferred
		ensure 
			value_at_index: value.is_equal (i_th (index))
			count_unchanged: count = old count
		end

feature -- Removal
	
	remove_item (value: G) is
			-- remove the item corresponding to `value'
		require 
			value_not_void: value /= Void
			value_is_item: has (value)
		deferred
		ensure 
			value_is_removed: not has (value)
		end
	
	remove_all_values is
			-- remove all values
		deferred
		ensure 
			count_is_zero: count = 0
		end

feature -- Resizing
feature -- Transformation
feature -- Conversion
feature -- Duplication
feature -- Basic operations
feature -- Miscellaneous
feature -- Obsolete
feature -- Inapplicable
feature {NONE} -- Implementation
	
end -- SCENE_MULTI_ELEMENT

