

indexing
	description: "State element for normal values"
	patterns: "none"
	date: "$Date: 2006-12-06 13:14:08 -0500 (Wed, 06 Dec 2006) $"
	revision: "$Revision: 271 $"
	status: "unreviewed"




class 

	SCENE_NORMAL_ELEMENT
	
inherit
	
	SCENE_LARGE_MULTI_ELEMENT [NORMAL]
		rename
			make as multi_make
		redefine
			print_features, add_item, insert_item, replace_item
		end


creation
	default_create, make, make_from_list

feature -- Initialization

	make (normal: NORMAL) is
			-- Create the element with a single vector
		require
			normal_not_void: normal /= Void
		do
			multi_make
			add_item (normal)
		ensure
			count_is_one: count = 1
			first_item_is_normal: normal.is_equal (i_th (1))
		end

	make_from_list (vals: NORMAL_ARRAYED_LIST) is
			-- Initialize the element with `vals'
		do
			default_create
			values := vals
		end
	
feature -- Access

	values: NORMAL_ARRAYED_LIST
			-- The element values

feature -- Measurement
feature -- Comparison
feature -- Status report
feature -- Status setting
feature -- Cursor movement
feature -- Element change
	
	add_item (value: NORMAL) is
			-- add `value' as a new item
		local
			v: NORMAL
		do
			v := value.twin
			v.normalize
			
			Precursor (v)
		end
	
	insert_item (value: NORMAL; index: INTEGER_64) is
			-- insert `value' at `index'
		local
			v: NORMAL
		do
			v := value.twin
			v.normalize
			
			Precursor (v, index)
		end
	
	replace_item (value: NORMAL; index: INTEGER_64) is
			-- replace the item at `index' with `value'
		local
			v: NORMAL
		do
			v := value.twin
			v.normalize
			
			Precursor (v, index)
		end

feature -- Removal
feature -- Resizing
feature -- Transformation
feature -- Conversion
feature -- Duplication
feature -- Basic operations
feature -- Miscellaneous
feature -- Obsolete
feature -- Inapplicable
feature {NONE} -- Implementation

	initialize is
			-- Initialize the `values' elements
		do
			create values
		end
	
	print_features (action: PRINT_ACTION) is
			-- print the node's features
		do
			Precursor (action)
			
			action.io.put_string ("	 normals = ")
			action.io.push
			
			print_values (action)
			
			action.io.pop
		end
	
end -- SCENE_NORMAL_ELEMENT

