

indexing
	description: "State element for opacity values"
	patterns: "none"
	date: "$Date: 2006-12-06 13:14:08 -0500 (Wed, 06 Dec 2006) $"
	revision: "$Revision: 271 $"
	status: "unreviewed"




class 

	SCENE_OPACITY_ELEMENT
	
inherit
	
	SCENE_LARGE_MULTI_ELEMENT [RGB_COLOR]
		rename
			make as multi_make
		redefine
			print_features, default_create
		end

creation
	default_create, make

feature -- Initialization

	default_create is
			-- Create a single, multi-channel, opaque element
		local
			c: RGB_COLOR
		do
			Precursor
			create c
			add_item (c)
		end

	make (color: RGB_COLOR) is
			-- Create the element with a single, white color
		require
			color_not_void: color /= Void
		do
			default_create
			
			values.wipe_out
			
			add_item (color)
		ensure
			count_is_one: count = 1
			first_item_is_color: color.is_equal (i_th (1))
		end

	make_from_list (vals: RGB_COLOR_ARRAYED_LIST) is
			-- Initialize the element with `vals'
		do
			default_create
			values := vals
		end
	
feature -- Access

	values: RGB_COLOR_ARRAYED_LIST
			-- The element values

feature {NONE} -- Implementation

	initialize is
			-- Initialize the `values' elements
		do
			create values
		end
	
	print_features (action: PRINT_ACTION) is
			-- print the node's features
		do
			Precursor (action)
			
			action.io.put_string ("	 opacities = ")
			action.io.push
			
			print_values (action)
			
			action.io.pop
		end
	
end -- SCENE_COLOR_ELEMENT

