

indexing
	description: "Factory for creating state elements"
	patterns: "factory"
	status: "unreviewed"




class 

	SCENE_STATE_ELEMENT_FACTORY
	
inherit
	
	ANY
		redefine
			default_create
		end

creation
	default_create, make

feature -- Initialization

	default_create, make is
			-- Initialize the factory
		local
			se: SCENE_STATE_ELEMENT
		do
			create table
			create element_list.make (5)
			
			create {SCENE_COLOR_ELEMENT} se
			table.add_element (se)
			element_list.force_last (se)
			
			create {SCENE_CULL_ELEMENT} se
			table.add_element (se)
			element_list.force_last (se)
		
			create {SCENE_INDEXED_COLOR_ELEMENT} se
			table.add_element (se)		
			element_list.force_last (se)
			
			create {SCENE_INDEXED_NORMAL_ELEMENT} se
			table.add_element (se)		
			element_list.force_last (se)
			
			create {SCENE_LIGHT_ELEMENT} se
			table.add_element (se)
			element_list.force_last (se)
			
			create {SCENE_NORMAL_ELEMENT} se
			table.add_element (se)
			element_list.force_last (se)
			
			create {SCENE_OPACITY_ELEMENT} se
			table.add_element (se)		
			element_list.force_last (se)
			
			create {SCENE_ORIENTATION_ELEMENT} se
			table.add_element (se)		
			element_list.force_last (se)
			
			create {SCENE_SIDES_ELEMENT} se
			table.add_element (se)		
			element_list.force_last (se)
			
			create {SCENE_SHADING_RATE_ELEMENT} se
			table.add_element (se)		
			element_list.force_last (se)
			
			create {SCENE_GLSL_SHADER_ELEMENT} se
			table.add_element (se)		
			element_list.force_last (se)
		end

feature -- Access
	
	element_list: DS_ARRAYED_LIST [SCENE_STATE_ELEMENT] 
			-- A list of the all state elements in their default state
	
feature -- Measurement
feature -- Comparison
feature -- Status report
feature -- Status setting
feature -- Cursor movement
feature -- Element change
feature -- Removal
feature -- Resizing
feature -- Transformation
feature -- Conversion
feature -- Duplication
feature -- Basic operations
feature -- Miscellaneous
feature -- Obsolete
feature -- Inapplicable
feature {NONE} -- Implementation
	
	table: SCENE_STATE_ELEMENT_TABLE
	
invariant
	
	table_not_void: table /= Void
	element_list_not_void: element_list /= Void
	
end -- SCENE_STATE_ELEMENT_FACTORY

