

indexing
	description: "Ambient lights (i.e., constant illumination everywhere)"
	patterns: "none"
	date: "$Date: 2007-01-09 16:27:59 -0500 (Tue, 09 Jan 2007) $"
	revision: "$Revision: 278 $"
	status: "unreviewed"




class 

	AMBIENT_LIGHT_SOURCE
	
inherit
	
	LIGHT_SOURCE
		redefine
			draw, ambient
		end

creation
	default_create, make

feature -- Initialization
feature -- Access
feature -- Measurement
feature -- Comparison
feature -- Status report
feature -- Status setting
feature -- Cursor movement
feature -- Element change
feature -- Removal
feature -- Resizing
feature -- Transformation
feature -- Conversion
feature -- Duplication
feature -- Basic operations

	draw (renderer: RENDERER) is
			-- `Draw' the scene through the camera's lens
		local
			color: RGBA_COLOR
		do
			renderer.set_diffuse_light_color (dynamic_id, black)
			renderer.set_specular_light_color (dynamic_id, black)
			color := light_color.i_th (1).scale (intensity)
			renderer.set_ambient_light_color (dynamic_id, color)
			renderer.set_constant_attenuation (dynamic_id, constant_attenuation)
			renderer.set_linear_attenuation (dynamic_id, linear_attenuation)
			renderer.set_quadratic_attenuation (dynamic_id, quadratic_attenuation)
		end 
	
	generate_sample_point: POINT3 is
			-- Generate a point on the light
		do
			create Result
		end 
	
	intersect (scene: SCENE_ACCELERATOR [SCENE_DRAWABLE]; origin: POINT3;
			   info: INTERSECTION_DATA) is
			-- Intersect the `scene' with a ray at `origin'
		do
			illumination_at_point := light_color.i_th (1).scale (intensity)
		end
	
	compute_illumination (point: SHADING_DATA; camera: SCENE_CAMERA) is
			-- Compute the illumination at `point'
		do
			illumination_at_point := light_color.i_th (1).scale (intensity)
		end 

	ambient: RGBA_COLOR is
			-- Compute the `ambient' illumination at `shading_point'
		do
			Result := light_color.i_th (1).scale (intensity)
		end 

feature -- Miscellaneous
feature -- Obsolete
feature -- Inapplicable
feature {NONE} -- Implementation

end -- AMBIENT_LIGHT_SOURCE

