

indexing
	description: "Factory for creating LIGHT_SOURCE descendants"
	patterns: "abstract factory"
	date: "$Date: 2006-12-06 13:14:08 -0500 (Wed, 06 Dec 2006) $"
	revision: "$Revision: 271 $"
	status: "unreviewed"




class 

	LIGHT_SOURCE_FACTORY
	
creation
	default_create
	
feature -- Initialization
feature -- Access
	
	new_light_source (the_handle: INTEGER;
					  the_shader: STRING;
					  parameters: PARAMETER_LIST): LIGHT_SOURCE is
			-- Generate a new approriate light source based on the 
			-- `parameters' 
		require
			handle_positive: the_handle > 0
			valid_shader: the_shader /= Void and then the_shader.count > 0
		do
			if the_shader.is_equal ("%"pointlight%"") then
				create {POINT_LIGHT_SOURCE} Result.make (the_handle,
														 the_shader,
														 parameters)
			elseif the_shader.is_equal ("%"ambientlight%"") then
				create {AMBIENT_LIGHT_SOURCE} Result.make (the_handle,
														   the_shader,
														   parameters)
			elseif the_shader.is_equal ("%"distantlight%"") then
				create {DISTANT_LIGHT_SOURCE} Result.make (the_handle,
														   the_shader,
														   parameters)
			elseif the_shader.is_equal ("%"spotlight%"") then
				create {SPOT_LIGHT_SOURCE} Result.make (the_handle,
														the_shader,
														parameters)
			else
				-- Unsure of the light source, make it a point light
				io.put_string ("Unknown light source type: using a %"pointlight%"%N%N")
				create {POINT_LIGHT_SOURCE} Result.make (the_handle,
														 the_shader,
														 parameters)
			end
		ensure 
			Result_not_void: Result /= Void
		end 

feature -- Measurement
feature -- Comparison
feature -- Status report
feature -- Status setting
feature -- Cursor movement
feature -- Element change
feature -- Removal
feature -- Resizing
feature -- Transformation
feature -- Conversion
feature -- Duplication
feature -- Basic operations
feature -- Miscellaneous
feature -- Obsolete
feature -- Inapplicable
feature {NONE} -- Implementation

end -- LIGHT_SOURCE_FACTORY

