

indexing
	description: "Global light state"
	patterns: "none"
	date: "$Date: 2006-12-06 13:14:08 -0500 (Wed, 06 Dec 2006) $"
	revision: "$Revision: 271 $"
	status: "unreviewed"




class 

	SCENE_LIGHTS
	
inherit
	
	SCENE_OBJECT
		undefine
			copy, is_equal
		redefine
			default_create
		end
	
	DS_BILINKED_LIST [LIGHT_SOURCE]
		redefine
			make, default_create
		end

creation
	make

feature -- Initialization
	
	default_create is
		local
			comparator: KL_COMPARABLE_COMPARATOR [LIGHT_SOURCE]
		do
			Precursor {SCENE_OBJECT}
			Precursor {DS_BILINKED_LIST}
			create comparator.make
			create sorter.make (comparator)
		end
	
	make is
		do
			default_create
			Precursor
		end
	
feature -- Access
feature -- Measurement
feature -- Comparison
feature -- Status report
feature -- Status setting
feature -- Cursor movement
feature -- Element change
		
	append_light (light: LIGHT_SOURCE) is
			-- Append the `xform', `light' pair into the `global_lights'.
		require 
			light_not_void: light /= Void
		do
			force_last (light)
			sorter.sort (Current)
		ensure 
			updated: old count = count - 1
		end 

	illuminate (on: BOOLEAN) is
			-- Request all lights be turned off
		do
			from
				start
			until
				after
			loop
				if on then
					item_for_iteration.enable_light
				else
					item_for_iteration.disable_light
				end
				forth
			end
		end
	
	reset (renderer: RENDERER) is
			-- Request all lights be turned off
		do
			from
				start
			until
				after
			loop
				item_for_iteration.reset (renderer)
				
				forth
			end
		end
	
feature -- Removal
feature -- Resizing
feature -- Transformation
feature -- Conversion
feature -- Duplication
feature -- Basic operations
	
	apply (renderer: RENDERER) is
			-- apply the `renderer' to `Current'.
		do
			from
				start
			until
				after
			loop
				item_for_iteration.apply (renderer)
				
				forth
			end
		end
	
feature -- Miscellaneous
feature -- Obsolete
feature -- Inapplicable
feature {NONE} -- Implementation

	sorter: DS_SHELL_SORTER [LIGHT_SOURCE]
			-- The light source sorter

end -- SCENE_LIGHTS

