

indexing
	description: "Contains information about public, modifiable attributes"
	patterns: "none"
	status: "unreviewed"




class 

	SCENE_ATTRIBUTE_INFO [G]

inherit
	
	SCENE_ATTRIBUTE

creation
	make

feature -- Initialization
	
	make (attribute_name: STRING; 
		  attribute_index: INTEGER;
		  assertion_function: FUNCTION [ANY, TUPLE [G], BOOLEAN];
		  assignment_procedure: PROCEDURE [ANY, TUPLE [G]]) is
			-- Make a new info record
		require
			attribute_name_not_void: attribute_name /= Void
			attribute_index_positive: attribute_index >=1
			assertion_function_not_void: assertion_function /= Void					 
			assignment_procedure_not_void: assignment_procedure /= Void
		do
			name := attribute_name.twin
			index := attribute_index
			is_valid := assertion_function
			set_attribute := assignment_procedure
		ensure
			name_set: name.is_equal (attribute_name)
			index_set: index = attribute_index
			is_valid_set: is_valid = assertion_function 
			set_attribute_set: set_attribute = assignment_procedure
		end

feature -- Access
	
	is_valid: FUNCTION [ANY, TUPLE [G], BOOLEAN]
			-- Agent that checks if a value is valid
	
	set_attribute: PROCEDURE [ANY, TUPLE [G]]
			-- Agent used to set an attribute
	
feature -- Measurement
feature -- Comparison
feature -- Status report
feature -- Status setting
feature -- Cursor movement
feature -- Element change
feature -- Removal
feature -- Resizing
feature -- Transformation
feature -- Conversion
feature -- Duplication
feature -- Basic operations
feature -- Miscellaneous
feature -- Obsolete
feature -- Inapplicable
feature {NONE} -- Implementation
	
invariant
	
	is_valid_not_void: is_valid /= Void
	set_attribute_not_void: set_attribute /= Void
	
end -- SCENE_ATTRIBUTE_INFO

