

indexing
	description: "Abstract class for all scene graph objects"
	patterns: "none"
	date: "$Date: 2006-12-06 13:14:08 -0500 (Wed, 06 Dec 2006) $"
	revision: "$Revision: 271 $"
	status: "unreviewed"




deferred class 

	SCENE_OBJECT
	
inherit
	
	MEMORY_REPORTER
		redefine
			default_create
		end

	WRAPPED_INTERNALS
		export
			{NONE} all
		redefine
			default_create
		end
	
feature -- Initialization
	
	default_create is
			-- Initalize a node my calling `make'
		do
		end
	
feature -- Access
	
	user_data: ANY
			-- Reference to data that a user wants to associate with 
			-- a node
	
	attributes: DS_ARRAYED_LIST [SCENE_ATTRIBUTE] is
			-- Exported attributes
		do
			if cached_attributes = Void then
				create cached_attributes.make (2)
				add_attributes (cached_attributes)
			end
			
			Result := cached_attributes
		end
	
feature -- Measurement
feature -- Comparison
feature -- Status report
feature -- Status setting
feature -- Cursor movement
feature -- Element change
	
	set_user_data (new_data: ANY) is
			-- Set `user_data' to `new_data'
		do
			user_data := new_data
		ensure 
			user_data_set: user_data = new_data
		end 

feature -- Removal
feature -- Resizing
feature -- Transformation
feature -- Conversion
feature -- Duplication
feature -- Basic operations
	
	print_object (action: PRINT_ACTION) is
			-- Create a representation of self
		require 
			action_not_void: action /= Void
		do
			print_class_name (action)
			print_features (action)
		end 

feature -- Miscellaneous
feature -- Obsolete
feature -- Inapplicable
feature {NONE} -- Implementation
	
	formatter: DOUBLE_FORMATTER
			-- Available to all descendants; Up to them to create
	
	cached_attributes: DS_ARRAYED_LIST [SCENE_ATTRIBUTE] 
			-- Exported attributes; created only when requested
	
	add_attributes (the_attributes: DS_ARRAYED_LIST [SCENE_ATTRIBUTE]) is
			-- Add public modifiable attributes to `attributes'
		require
			the_attributes_not_void: the_attributes /= Void
		do
		end 

	print_class_name (action: PRINT_ACTION) is
			-- print the object's features
		require 
			action_not_void: action /= Void
		do
			action.io.put_new_line
			action.io.put_string (class_name)
			action.io.put_character (':')
			action.io.put_new_line			
		end
	
	print_features (action: PRINT_ACTION) is
			-- print the object's features
		require 
			action_not_void: action /= Void
		do
			action.io.put_string ("	 user_data = ")
			if user_data = Void then
				action.io.put_string ("Void")
			else
				action.io.put_string (user_data.out)
			end
			action.io.put_new_line
		end
	
	index_of_field (name: STRING): INTEGER is
			-- What is the index of field `field_name'
		require 
			name_not_void: name /= Void
		local
			i: INTEGER
			found: BOOLEAN
		do
			from
				i := 1
				found := false
			invariant
				i_at_least_one: i >= 1
				i_small_enough: i <= 1 + number_of_fields
			variant
				i_increasing: 1 + number_of_fields - i
			until
				i > number_of_fields or found
			loop
				if name_of_field (i).is_equal (name) then
					Result := i
					found := true
				end
				
				i := i + 1
			end
		ensure
			Result_is_in_range: Result >= 1 and Result <= number_of_fields
		end 

end -- SCENE_OBJECT

