indexing
	description: "Parser for RenderMan Shading Language"
	patterns: "none"
	date: "$Date: 2006-12-06 13:14:08 -0500 (Wed, 06 Dec 2006) $"
	revision: "$Revision: 271 $"
	status: "unreviewed"




class 

	SL_PARSER

inherit
	
	YY_PARSER_SKELETON
		rename
			make as make_parser_skeleton
		redefine
			report_error
		end

	SL_SCANNER
		rename
			make as make_sl_scanner
		end
	
	KL_SHARED_EXCEPTIONS
	KL_SHARED_ARGUMENTS

	SL_TYPES
		undefine
			default_create, copy, is_equal
		end

	NUMERIC_CONVERSION
		undefine
			default_create, copy, is_equal
		end

creation

	make


feature {NONE} -- Implementation

	yy_build_parser_tables is
			-- Build parser tables.
		do
			yytranslate := yytranslate_template
			yyr1 := yyr1_template
			yytypes1 := yytypes1_template
			yytypes2 := yytypes2_template
			yydefact := yydefact_template
			yydefgoto := yydefgoto_template
			yypact := yypact_template
			yypgoto := yypgoto_template
			yytable := yytable_template
			yycheck := yycheck_template
		end

	yy_create_value_stacks is
			-- Create value stacks.
		do
		end

	yy_init_value_stacks is
			-- Initialize value stacks.
		do
			yyvsp1 := -1
			yyvsp2 := -1
			yyvsp3 := -1
			yyvsp4 := -1
			yyvsp5 := -1
			yyvsp6 := -1
			yyvsp7 := -1
		end

	yy_clear_value_stacks is
			-- Clear objects in semantic value stacks so that
			-- they can be collected by the garbage collector.
		do
			if yyvs1 /= Void then
				yyvs1.clear_all
			end
			if yyvs2 /= Void then
				yyvs2.clear_all
			end
			if yyvs3 /= Void then
				yyvs3.clear_all
			end
			if yyvs4 /= Void then
				yyvs4.clear_all
			end
			if yyvs5 /= Void then
				yyvs5.clear_all
			end
			if yyvs6 /= Void then
				yyvs6.clear_all
			end
			if yyvs7 /= Void then
				yyvs7.clear_all
			end
		end

	yy_push_last_value (yychar1: INTEGER) is
			-- Push semantic value associated with token `last_token'
			-- (with internal id `yychar1') on top of corresponding
			-- value stack.
		do
			inspect yytypes2.item (yychar1)
			when 1 then
				yyvsp1 := yyvsp1 + 1
				if yyvsp1 >= yyvsc1 then
					if yyvs1 = Void then
						debug ("GEYACC")
							std.error.put_line ("Create yyvs1")
						end
						create yyspecial_routines1
						yyvsc1 := yyInitial_yyvs_size
						yyvs1 := yyspecial_routines1.make (yyvsc1)
					else
						debug ("GEYACC")
							std.error.put_line ("Resize yyvs1")
						end
						yyvsc1 := yyvsc1 + yyInitial_yyvs_size
						yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
					end
				end
				yyvs1.put (last_any_value, yyvsp1)
			when 2 then
				yyvsp2 := yyvsp2 + 1
				if yyvsp2 >= yyvsc2 then
					if yyvs2 = Void then
						debug ("GEYACC")
							std.error.put_line ("Create yyvs2")
						end
						create yyspecial_routines2
						yyvsc2 := yyInitial_yyvs_size
						yyvs2 := yyspecial_routines2.make (yyvsc2)
					else
						debug ("GEYACC")
							std.error.put_line ("Resize yyvs2")
						end
						yyvsc2 := yyvsc2 + yyInitial_yyvs_size
						yyvs2 := yyspecial_routines2.resize (yyvs2, yyvsc2)
					end
				end
				yyvs2.put (last_string_value, yyvsp2)
			when 4 then
				yyvsp4 := yyvsp4 + 1
				if yyvsp4 >= yyvsc4 then
					if yyvs4 = Void then
						debug ("GEYACC")
							std.error.put_line ("Create yyvs4")
						end
						create yyspecial_routines4
						yyvsc4 := yyInitial_yyvs_size
						yyvs4 := yyspecial_routines4.make (yyvsc4)
					else
						debug ("GEYACC")
							std.error.put_line ("Resize yyvs4")
						end
						yyvsc4 := yyvsc4 + yyInitial_yyvs_size
						yyvs4 := yyspecial_routines4.resize (yyvs4, yyvsc4)
					end
				end
				yyvs4.put (last_real_value, yyvsp4)
			else
				debug ("GEYACC")
					std.error.put_string ("Error in parser: not a token type: ")
					std.error.put_integer (yytypes2.item (yychar1))
					std.error.put_new_line
				end
				abort
			end
		end

	yy_push_error_value is
			-- Push semantic value associated with token 'error'
			-- on top of corresponding value stack.
		local
			yyval1: ANY
		do
			yyvsp1 := yyvsp1 + 1
			if yyvsp1 >= yyvsc1 then
				if yyvs1 = Void then
					debug ("GEYACC")
						std.error.put_line ("Create yyvs1")
					end
					create yyspecial_routines1
					yyvsc1 := yyInitial_yyvs_size
					yyvs1 := yyspecial_routines1.make (yyvsc1)
				else
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs1")
					end
					yyvsc1 := yyvsc1 + yyInitial_yyvs_size
					yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
				end
			end
			yyvs1.put (yyval1, yyvsp1)
		end

	yy_pop_last_value (yystate: INTEGER) is
			-- Pop semantic value from stack when in state `yystate'.
		local
			yy_type_id: INTEGER
		do
			yy_type_id := yytypes1.item (yystate)
			inspect yy_type_id
			when 1 then
				yyvsp1 := yyvsp1 - 1
			when 2 then
				yyvsp2 := yyvsp2 - 1
			when 3 then
				yyvsp3 := yyvsp3 - 1
			when 4 then
				yyvsp4 := yyvsp4 - 1
			when 5 then
				yyvsp5 := yyvsp5 - 1
			when 6 then
				yyvsp6 := yyvsp6 - 1
			when 7 then
				yyvsp7 := yyvsp7 - 1
			else
				debug ("GEYACC")
					std.error.put_string ("Error in parser: unknown type id: ")
					std.error.put_integer (yy_type_id)
					std.error.put_new_line
				end
				abort
			end
		end

feature {NONE} -- Semantic actions

	yy_do_action (yy_act: INTEGER) is
			-- Execute semantic action.
		local
			yyval3: PARSE_NODE
			yyval2: STRING
			yyval5: TYPE_AND_SPACE
			yyval6: INTEGER
			yyval7: FUNCTION_CALL_PARSE_NODE
			yyval4: REAL
		do
			inspect yy_act
when 1 then
--|#line 142 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 142")
end

root_node := yyvs3.item (yyvsp3) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 2 then
--|#line 144 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 144")
end

root_node.add_last (yyvs3.item (yyvsp3)) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp3 := yyvsp3 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 3 then
--|#line 147 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 147")
end

yyval3 := yyvs3.item (yyvsp3) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 4 then
--|#line 149 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 149")
end

yyval3 := yyvs3.item (yyvsp3) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 5 then
--|#line 152 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 152")
end

				create {SHADER_PARSE_NODE} yyval3.make (yyvs2.item (yyvsp2), yyvs2.item (yyvsp2 - 1))
				yyval3.set_file_name (file_name)
				yyval3.set_line_number (eif_lineno)
				yyval3.add_last (yyvs3.item (yyvsp3))
				
				-- Copy initializers from the formals list to local 
				-- variable definitions
					   if yyvs3.item (yyvsp3 - 1) /= Void and then yyvs3.item (yyvsp3 - 1).children.count > 0 then
						   children := yyvs3.item (yyvsp3 - 1).children
						   from
							   children.start
						   until
							   children.after
						   loop
							   variable ?= children.item_for_iteration
							   check
								   variable_not_void: variable /= Void
							   end
							   
							   variable.set_as_parameter
							   
							   if variable.children.count > 0 then
								   variable.children.start
								   --create {CAST_PARSE_NODE} node.make (variable.variable.type)
								   --node.add_last (variable.children.item)
								   variable.variable.set_default_value (variable.children.item_for_iteration)
								   variable.children.remove_at
							   end
							   children.forth
						   end
						   
					   end
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 8
	yyvsp3 := yyvsp3 -1
	yyvsp2 := yyvsp2 -2
	yyvsp1 := yyvsp1 -4
	yyvs3.put (yyval3, yyvsp3)
end
when 6 then
--|#line 188 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 188")
end

				  create {SHADER_PARSE_NODE} yyval3.make (yyvs2.item (yyvsp2), yyvs2.item (yyvsp2 - 1))
				  yyval3.set_file_name (file_name)
				  yyval3.set_line_number (eif_lineno)
				  create node
				  yyval3.add_first (node)
				  yyval3.add_last (yyvs3.item (yyvsp3))
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 7
	yyvsp2 := yyvsp2 -2
	yyvsp1 := yyvsp1 -4
	yyvs3.put (yyval3, yyvsp3)
end
when 7 then
--|#line 199 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 199")
end

		decl ?= yyvs3.item (yyvsp3 - 2)
					   if yyvs3.item (yyvsp3 - 1) /= Void then
						   create tmp_string.make (10)
						   children := yyvs3.item (yyvsp3 - 1).children
						   from
							   children.start
						   until
							   children.after
						   loop
							   variable ?= children.item_for_iteration
							   check
								   variable_not_void: variable /= Void
							   end
							   
							   if variable.variable.is_default_storage then
								   variable.variable.set_default_storage_class (varying)
							   end
							   
							   tmp_string.append_character (encoded_type (variable.variable.type))
							   children.forth
						   end
					   end
					   
					   create func.make_user_defined (decl.type, decl.name, decl.name,
													  tmp_string, yyvs3.item (yyvsp3), yyvs3.item (yyvsp3 - 1))
					   create functions.make (1)
					   functions.force_last (func)
					   function_list.put (functions, decl.name)
					   create yyval3
					   yyval3.set_file_name (file_name)
					   yyval3.set_line_number (eif_lineno)
					   name_stack.remove_at
		
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 6
	yyvsp3 := yyvsp3 -2
	yyvsp1 := yyvsp1 -3
	yyvs3.put (yyval3, yyvsp3)
end
when 8 then
--|#line 235 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 235")
end

				decl ?= yyvs3.item (yyvsp3 - 1)
				create func.make_user_defined (decl.type, decl.name, decl.name,
											   "", yyvs3.item (yyvsp3), Void)
				create functions.make (1)
				functions.force_last (func)
				function_list.put (functions, decl.name)
				create yyval3
				yyval3.set_file_name (file_name)
				yyval3.set_line_number (eif_lineno)
				name_stack.remove_at
		
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 5
	yyvsp3 := yyvsp3 -1
	yyvsp1 := yyvsp1 -3
	yyvs3.put (yyval3, yyvsp3)
end
when 9 then
--|#line 250 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 250")
end

				tmp_string := name_stack.item_for_iteration.twin
				tmp_string.append (yyvs2.item (yyvsp2))
				create {DECLARATION_PARSE_NODE} yyval3.make_with_type (tmp_string, yyvs5.item (yyvsp5).type)
				yyval3.set_file_name (file_name)
				yyval3.set_line_number (eif_lineno)
				tmp_string.append ("::")
				name_stack.put_first (tmp_string)
				name_stack.start
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp3 := yyvsp3 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 10 then
--|#line 262 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 262")
end

				tmp_string := name_stack.item_for_iteration.twin
				tmp_string.append (yyvs2.item (yyvsp2))
				create {DECLARATION_PARSE_NODE} yyval3.make (tmp_string)
				yyval3.set_file_name (file_name)
				yyval3.set_line_number (eif_lineno)
				tmp_string.append ("::")
				name_stack.put_first (tmp_string)
				name_stack.start
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 11 then
--|#line 273 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 273")
end

				tmp_string := name_stack.item_for_iteration.twin
				tmp_string.append (yyvs2.item (yyvsp2))
				create {DECLARATION_PARSE_NODE} yyval3.make_with_type (tmp_string, yyvs5.item (yyvsp5).type)
				yyval3.set_file_name (file_name)
				yyval3.set_line_number (eif_lineno)
				tmp_string.append ("::")
				name_stack.put_first (tmp_string)
				name_stack.start
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp3 := yyvsp3 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 12 then
--|#line 284 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 284")
end

				tmp_string := name_stack.item_for_iteration.twin
				tmp_string.append (yyvs2.item (yyvsp2))
				create {DECLARATION_PARSE_NODE} yyval3.make (tmp_string)
				yyval3.set_file_name (file_name)
				yyval3.set_line_number (eif_lineno)
				tmp_string.append ("::")
				name_stack.put_first (tmp_string)
				name_stack.start
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 13 then
--|#line 297 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 297")
end

create yyval2.make_from_string ("lightsource") 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp2 := yyvsp2 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp2 >= yyvsc2 then
		if yyvs2 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs2")
			end
			create yyspecial_routines2
			yyvsc2 := yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.make (yyvsc2)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs2")
			end
			yyvsc2 := yyvsc2 + yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.resize (yyvs2, yyvsc2)
		end
	end
	yyvs2.put (yyval2, yyvsp2)
end
when 14 then
--|#line 299 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 299")
end

create yyval2.make_from_string ("surface") 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp2 := yyvsp2 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp2 >= yyvsc2 then
		if yyvs2 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs2")
			end
			create yyspecial_routines2
			yyvsc2 := yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.make (yyvsc2)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs2")
			end
			yyvsc2 := yyvsc2 + yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.resize (yyvs2, yyvsc2)
		end
	end
	yyvs2.put (yyval2, yyvsp2)
end
when 15 then
--|#line 300 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 300")
end

create yyval2.make_from_string ("volume") 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp2 := yyvsp2 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp2 >= yyvsc2 then
		if yyvs2 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs2")
			end
			create yyspecial_routines2
			yyvsc2 := yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.make (yyvsc2)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs2")
			end
			yyvsc2 := yyvsc2 + yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.resize (yyvs2, yyvsc2)
		end
	end
	yyvs2.put (yyval2, yyvsp2)
end
when 16 then
--|#line 301 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 301")
end

create yyval2.make_from_string ("displacement") 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp2 := yyvsp2 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp2 >= yyvsc2 then
		if yyvs2 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs2")
			end
			create yyspecial_routines2
			yyvsc2 := yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.make (yyvsc2)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs2")
			end
			yyvsc2 := yyvsc2 + yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.resize (yyvs2, yyvsc2)
		end
	end
	yyvs2.put (yyval2, yyvsp2)
end
when 17 then
--|#line 302 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 302")
end

create yyval2.make_from_string ("transformation") 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp2 := yyvsp2 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp2 >= yyvsc2 then
		if yyvs2 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs2")
			end
			create yyspecial_routines2
			yyvsc2 := yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.make (yyvsc2)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs2")
			end
			yyvsc2 := yyvsc2 + yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.resize (yyvs2, yyvsc2)
		end
	end
	yyvs2.put (yyval2, yyvsp2)
end
when 18 then
--|#line 303 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 303")
end

create yyval2.make_from_string ("imager") 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp2 := yyvsp2 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp2 >= yyvsc2 then
		if yyvs2 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs2")
			end
			create yyspecial_routines2
			yyvsc2 := yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.make (yyvsc2)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs2")
			end
			yyvsc2 := yyvsc2 + yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.resize (yyvs2, yyvsc2)
		end
	end
	yyvs2.put (yyval2, yyvsp2)
end
when 19 then
--|#line 306 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 306")
end

				  create yyval3
				  yyval3.set_file_name (file_name)
				  yyval3.set_line_number (eif_lineno)
				  
				  children := yyvs3.item (yyvsp3).children
					   from
						   children.start
					   until
						   children.after
					   loop
						   variable ?= children.item_for_iteration
						   if variable /= Void then
							   yyval3.add_last (variable)
						   end
						   children.forth
					   end
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 20 then
--|#line 327 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 327")
end

				children := yyvs3.item (yyvsp3).children
					   from
						   children.start
					   until
						   children.after
					   loop
						   variable ?= children.item_for_iteration
						   if variable /= Void then
							   yyvs3.item (yyvsp3 - 1).add_last (variable)
						   end
						   children.forth
					   end
					   yyval3 := yyvs3.item (yyvsp3 - 1)
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp3 := yyvsp3 -1
	yyvsp1 := yyvsp1 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 21 then
--|#line 344 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 344")
end

yyval3 := yyvs3.item (yyvsp3) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 22 then
--|#line 347 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 347")
end

				  create yyval3
				  yyval3.set_file_name (file_name)
				  yyval3.set_line_number (eif_lineno)
				  children := yyvs3.item (yyvsp3).children
				  from
					  children.start
				  until
					  children.after
				  loop
					  declaration ?= children.item_for_iteration
					  if declaration /= Void then
						  tmp_string := name_stack.item_for_iteration.twin
						  tmp_string.append (declaration.name)
						  if variable_list.has (tmp_string) then
							  create variable.make (variable_list.item (tmp_string))
							  variable.set_file_name (file_name)
							  variable.set_line_number (eif_lineno)
							  variable.variable.set_type (yyvs5.item (yyvsp5).type)
							  if yyvs5.item (yyvsp5).storage_set then
								  variable.variable.set_storage_class (yyvs5.item (yyvsp5).storage_class)
							  end
							  yyval3.add_last (variable)
							  if declaration.children.count > 0 then
								  if variable.variable.is_array then
									  -- FIX: Add initializers
								  else
									  create assigner.make (variable.variable)
									  assigner.set_file_name (file_name)
									  assigner.set_line_number (eif_lineno)
									  assigner.disable_duplication
									  declaration.children.start
									  assigner.add_last (declaration.children.item_for_iteration)
									  variable.add_last (assigner)
									  declaration.children.wipe_out
								  end
							  end
						  end
					  end
					  children.forth
				  end
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp5 := yyvsp5 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 23 then
--|#line 391 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 391")
end

				  create yyval3
				  yyval3.set_file_name (file_name)
				  yyval3.set_line_number (eif_lineno)
				  children := yyvs3.item (yyvsp3).children
				  from
					  children.start
				  until
					  children.after
				  loop
					  declaration ?= children.item_for_iteration
					  if declaration /= Void then
						  tmp_string := name_stack.item_for_iteration.twin
						  tmp_string.append (declaration.name)
						  if variable_list.has (tmp_string) then
							  -- Loop over previous scopes looking 
							  -- for the external declaration
							  from
								  name_stack.start
								  name_stack.forth
								  found := false
							  until
								  name_stack.after or found
							  loop
								  tmp_string := name_stack.item_for_iteration.twin
								  tmp_string.append (declaration.name)
								  if variable_list.has (tmp_string) then
									  found := true
								  else
									  name_stack.forth
								  end
							  end
							  name_stack.start
							  if found then
								  create variable.make (variable_list.item (tmp_string))
								  variable.set_line_number (eif_lineno)
								  yyval3.add_last (variable)
							  else
								  report_error ("Missing external definition")
							  end
						  end
					  end
					  
					  children.forth
				  end
				  
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -1
	yyvsp5 := yyvsp5 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 24 then
--|#line 440 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 440")
end

				create yyval5.make_with_storage (yyvs5.item (yyvsp5).type, yyvs5.item (yyvsp5).space, yyvs6.item (yyvsp6))
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp6 := yyvsp6 -1
	yyvs5.put (yyval5, yyvsp5)
end
when 25 then
--|#line 445 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 445")
end

yyval5 := yyvs5.item (yyvsp5) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs5.put (yyval5, yyvsp5)
end
when 26 then
--|#line 448 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 448")
end

				  create yyval3
				  yyval3.set_file_name (file_name)
				  yyval3.set_line_number (eif_lineno)
				  yyval3.add_last (yyvs3.item (yyvsp3))
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 27 then
--|#line 456 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 456")
end

				yyvs3.item (yyvsp3 - 1).add_last (yyvs3.item (yyvsp3))
				yyval3 := yyvs3.item (yyvsp3 - 1)
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp3 := yyvsp3 -1
	yyvsp1 := yyvsp1 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 28 then
--|#line 463 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 463")
end

				create {DECLARATION_PARSE_NODE} yyval3.make (yyvs2.item (yyvsp2))
				yyval3.set_file_name (file_name)
				yyval3.set_line_number (eif_lineno)
				yyval3.add_last (yyvs3.item (yyvsp3))
				
				tmp_string := name_stack.item_for_iteration.twin
				tmp_string.append (yyvs2.item (yyvsp2))
				
				create var.make (void_type, tmp_string)
				variable_list.put (var, tmp_string)
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 29 then
--|#line 477 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 477")
end

				create {DECLARATION_PARSE_NODE} yyval3.make (yyvs2.item (yyvsp2))
				yyval3.set_file_name (file_name)
				yyval3.set_line_number (eif_lineno)
				
				tmp_string := name_stack.item_for_iteration.twin
				tmp_string.append (yyvs2.item (yyvsp2))
				
				create var.make (void_type, tmp_string)
				variable_list.put (var, tmp_string)
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 30 then
--|#line 489 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 489")
end

				create {DECLARATION_PARSE_NODE} yyval3.make (yyvs2.item (yyvsp2))
				yyval3.set_file_name (file_name)
				yyval3.set_line_number (eif_lineno)
				
				tmp_string := name_stack.item_for_iteration.twin
				tmp_string.append (yyvs2.item (yyvsp2))
				
				create var.make_as_array (void_type, tmp_string, real_64_truncated_to_integer (yyvs4.item (yyvsp4)))
				variable_list.put (var, tmp_string)
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -2
	yyvsp4 := yyvsp4 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 31 then
--|#line 501 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 501")
end

				create {DECLARATION_PARSE_NODE} yyval3.make (yyvs2.item (yyvsp2))
				yyval3.set_file_name (file_name)
				yyval3.set_line_number (eif_lineno)
				yyval3.add_last (yyvs3.item (yyvsp3))
				
				tmp_string := name_stack.item_for_iteration.twin
				tmp_string.append (yyvs2.item (yyvsp2))
				
				create var.make_as_array (void_type, tmp_string, real_64_truncated_to_integer (yyvs4.item (yyvsp4)))
				variable_list.put (var, tmp_string)
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 5
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -2
	yyvsp4 := yyvsp4 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 32 then
--|#line 514 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 514")
end

				create {DECLARATION_PARSE_NODE} yyval3.make (yyvs2.item (yyvsp2))
				yyval3.set_file_name (file_name)
				yyval3.set_line_number (eif_lineno)
				yyval3.add_last (yyvs3.item (yyvsp3))
				
				tmp_string := name_stack.item_for_iteration.twin
				tmp_string.append (yyvs2.item (yyvsp2))
				
				create var.make (void_type, tmp_string)
				variable_list.put (var, tmp_string)
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 33 then
--|#line 527 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 527")
end

				create {DECLARATION_PARSE_NODE} yyval3.make (yyvs2.item (yyvsp2))
				yyval3.set_file_name (file_name)
				yyval3.set_line_number (eif_lineno)
				
				tmp_string := name_stack.item_for_iteration.twin
				tmp_string.append (yyvs2.item (yyvsp2))
				
				create var.make (void_type, tmp_string)
				variable_list.put (var, tmp_string)
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 34 then
--|#line 539 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 539")
end

				create {DECLARATION_PARSE_NODE} yyval3.make (yyvs2.item (yyvsp2))
				yyval3.set_file_name (file_name)
				yyval3.set_line_number (eif_lineno)
				
				tmp_string := name_stack.item_for_iteration.twin
				tmp_string.append (yyvs2.item (yyvsp2))
				
				create var.make_as_array (void_type, tmp_string, real_64_truncated_to_integer (yyvs4.item (yyvsp4)))
				variable_list.put (var, tmp_string)
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -2
	yyvsp4 := yyvsp4 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 35 then
--|#line 551 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 551")
end

				create {DECLARATION_PARSE_NODE} yyval3.make (yyvs2.item (yyvsp2))
				yyval3.set_file_name (file_name)
				yyval3.set_line_number (eif_lineno)
				yyval3.add_last (yyvs3.item (yyvsp3))
				
				tmp_string := name_stack.item_for_iteration.twin
				tmp_string.append (yyvs2.item (yyvsp2))
				
				create var.make_as_array (void_type, tmp_string, real_64_truncated_to_integer (yyvs4.item (yyvsp4)))
				variable_list.put (var, tmp_string)
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 5
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -2
	yyvsp4 := yyvsp4 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 36 then
--|#line 566 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 566")
end

yyval3 := yyvs3.item (yyvsp3) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 37 then
--|#line 570 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 570")
end

				create yyval3
				
				children := yyvs3.item (yyvsp3).children
				from
					children.start
				until
					children.after
				loop
					yyval3.add_last (children.item_for_iteration)
					children.forth
				end
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp1 := yyvsp1 -3
	yyvs3.put (yyval3, yyvsp3)
end
when 38 then
--|#line 587 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 587")
end

				  create yyval3
				  yyval3.set_file_name (file_name)
				  yyval3.set_line_number (eif_lineno)
				  yyval3.add_last (yyvs3.item (yyvsp3))
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 39 then
--|#line 595 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 595")
end

				  yyval3 := yyvs3.item (yyvsp3 - 1)
				  yyval3.add_last (yyvs3.item (yyvsp3)) 
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp3 := yyvsp3 -1
	yyvsp1 := yyvsp1 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 40 then
--|#line 602 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 602")
end

yyval6 := varying 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp6 := yyvsp6 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp6 >= yyvsc6 then
		if yyvs6 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs6")
			end
			create yyspecial_routines6
			yyvsc6 := yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.make (yyvsc6)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs6")
			end
			yyvsc6 := yyvsc6 + yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.resize (yyvs6, yyvsc6)
		end
	end
	yyvs6.put (yyval6, yyvsp6)
end
when 41 then
--|#line 604 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 604")
end

yyval6 := uniform 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp6 := yyvsp6 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp6 >= yyvsc6 then
		if yyvs6 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs6")
			end
			create yyspecial_routines6
			yyvsc6 := yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.make (yyvsc6)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs6")
			end
			yyvsc6 := yyvsc6 + yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.resize (yyvs6, yyvsc6)
		end
	end
	yyvs6.put (yyval6, yyvsp6)
end
when 42 then
--|#line 607 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 607")
end

create yyval5.make (float_type, Void) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp5 := yyvsp5 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp5 >= yyvsc5 then
		if yyvs5 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs5")
			end
			create yyspecial_routines5
			yyvsc5 := yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.make (yyvsc5)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs5")
			end
			yyvsc5 := yyvsc5 + yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.resize (yyvs5, yyvsc5)
		end
	end
	yyvs5.put (yyval5, yyvsp5)
end
when 43 then
--|#line 609 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 609")
end

create yyval5.make (string_type, Void) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp5 := yyvsp5 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp5 >= yyvsc5 then
		if yyvs5 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs5")
			end
			create yyspecial_routines5
			yyvsc5 := yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.make (yyvsc5)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs5")
			end
			yyvsc5 := yyvsc5 + yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.resize (yyvs5, yyvsc5)
		end
	end
	yyvs5.put (yyval5, yyvsp5)
end
when 44 then
--|#line 610 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 610")
end

create yyval5.make (void_type, Void) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp5 := yyvsp5 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp5 >= yyvsc5 then
		if yyvs5 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs5")
			end
			create yyspecial_routines5
			yyvsc5 := yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.make (yyvsc5)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs5")
			end
			yyvsc5 := yyvsc5 + yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.resize (yyvs5, yyvsc5)
		end
	end
	yyvs5.put (yyval5, yyvsp5)
end
when 45 then
--|#line 611 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 611")
end

yyval5 := yyvs5.item (yyvsp5) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs5.put (yyval5, yyvsp5)
end
when 46 then
--|#line 612 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 612")
end

yyval5 := yyvs5.item (yyvsp5) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs5.put (yyval5, yyvsp5)
end
when 47 then
--|#line 613 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 613")
end

yyval5 := yyvs5.item (yyvsp5) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs5.put (yyval5, yyvsp5)
end
when 48 then
--|#line 614 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 614")
end

yyval5 := yyvs5.item (yyvsp5) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs5.put (yyval5, yyvsp5)
end
when 49 then
--|#line 615 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 615")
end

yyval5 := yyvs5.item (yyvsp5) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs5.put (yyval5, yyvsp5)
end
when 50 then
--|#line 618 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 618")
end

create yyval5.make (point_type, yyvs2.item (yyvsp2)) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp5 := yyvsp5 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp2 := yyvsp2 -1
	if yyvsp5 >= yyvsc5 then
		if yyvs5 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs5")
			end
			create yyspecial_routines5
			yyvsc5 := yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.make (yyvsc5)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs5")
			end
			yyvsc5 := yyvsc5 + yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.resize (yyvs5, yyvsc5)
		end
	end
	yyvs5.put (yyval5, yyvsp5)
end
when 51 then
--|#line 620 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 620")
end

create yyval5.make (point_type, Void) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp5 := yyvsp5 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp5 >= yyvsc5 then
		if yyvs5 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs5")
			end
			create yyspecial_routines5
			yyvsc5 := yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.make (yyvsc5)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs5")
			end
			yyvsc5 := yyvsc5 + yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.resize (yyvs5, yyvsc5)
		end
	end
	yyvs5.put (yyval5, yyvsp5)
end
when 52 then
--|#line 623 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 623")
end

create yyval5.make (color_type, yyvs2.item (yyvsp2)) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp5 := yyvsp5 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp2 := yyvsp2 -1
	if yyvsp5 >= yyvsc5 then
		if yyvs5 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs5")
			end
			create yyspecial_routines5
			yyvsc5 := yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.make (yyvsc5)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs5")
			end
			yyvsc5 := yyvsc5 + yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.resize (yyvs5, yyvsc5)
		end
	end
	yyvs5.put (yyval5, yyvsp5)
end
when 53 then
--|#line 625 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 625")
end

create yyval5.make (color_type, Void) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp5 := yyvsp5 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp5 >= yyvsc5 then
		if yyvs5 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs5")
			end
			create yyspecial_routines5
			yyvsc5 := yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.make (yyvsc5)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs5")
			end
			yyvsc5 := yyvsc5 + yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.resize (yyvs5, yyvsc5)
		end
	end
	yyvs5.put (yyval5, yyvsp5)
end
when 54 then
--|#line 628 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 628")
end

create yyval5.make (vector_type, yyvs2.item (yyvsp2)) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp5 := yyvsp5 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp2 := yyvsp2 -1
	if yyvsp5 >= yyvsc5 then
		if yyvs5 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs5")
			end
			create yyspecial_routines5
			yyvsc5 := yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.make (yyvsc5)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs5")
			end
			yyvsc5 := yyvsc5 + yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.resize (yyvs5, yyvsc5)
		end
	end
	yyvs5.put (yyval5, yyvsp5)
end
when 55 then
--|#line 630 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 630")
end

create yyval5.make (vector_type, Void) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp5 := yyvsp5 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp5 >= yyvsc5 then
		if yyvs5 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs5")
			end
			create yyspecial_routines5
			yyvsc5 := yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.make (yyvsc5)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs5")
			end
			yyvsc5 := yyvsc5 + yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.resize (yyvs5, yyvsc5)
		end
	end
	yyvs5.put (yyval5, yyvsp5)
end
when 56 then
--|#line 633 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 633")
end

create yyval5.make (normal_type, yyvs2.item (yyvsp2)) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp5 := yyvsp5 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp2 := yyvsp2 -1
	if yyvsp5 >= yyvsc5 then
		if yyvs5 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs5")
			end
			create yyspecial_routines5
			yyvsc5 := yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.make (yyvsc5)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs5")
			end
			yyvsc5 := yyvsc5 + yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.resize (yyvs5, yyvsc5)
		end
	end
	yyvs5.put (yyval5, yyvsp5)
end
when 57 then
--|#line 635 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 635")
end

create yyval5.make (normal_type, Void) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp5 := yyvsp5 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp5 >= yyvsc5 then
		if yyvs5 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs5")
			end
			create yyspecial_routines5
			yyvsc5 := yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.make (yyvsc5)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs5")
			end
			yyvsc5 := yyvsc5 + yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.resize (yyvs5, yyvsc5)
		end
	end
	yyvs5.put (yyval5, yyvsp5)
end
when 58 then
--|#line 638 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 638")
end

create yyval5.make (matrix_type, yyvs2.item (yyvsp2)) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp5 := yyvsp5 + 1
	yyvsp1 := yyvsp1 -1
	yyvsp2 := yyvsp2 -1
	if yyvsp5 >= yyvsc5 then
		if yyvs5 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs5")
			end
			create yyspecial_routines5
			yyvsc5 := yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.make (yyvsc5)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs5")
			end
			yyvsc5 := yyvsc5 + yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.resize (yyvs5, yyvsc5)
		end
	end
	yyvs5.put (yyval5, yyvsp5)
end
when 59 then
--|#line 640 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 640")
end

create yyval5.make (matrix_type, Void) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp5 := yyvsp5 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp5 >= yyvsc5 then
		if yyvs5 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs5")
			end
			create yyspecial_routines5
			yyvsc5 := yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.make (yyvsc5)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs5")
			end
			yyvsc5 := yyvsc5 + yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.resize (yyvs5, yyvsc5)
		end
	end
	yyvs5.put (yyval5, yyvsp5)
end
when 60 then
--|#line 643 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 643")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs2.put (yyval2, yyvsp2)
end
when 61 then
--|#line 647 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 647")
end

				  create yyval3
				  yyval3.set_file_name (file_name)
				  yyval3.set_line_number (eif_lineno)
				  yyval3.add_last (yyvs3.item (yyvsp3))
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 62 then
--|#line 655 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 655")
end

				  yyval3 := yyvs3.item (yyvsp3 - 1)
				  yyval3.add_last (yyvs3.item (yyvsp3)) 
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp3 := yyvsp3 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 63 then
--|#line 662 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 662")
end

				yyval3 := yyvs3.item (yyvsp3)
				yyval3.disable_duplication
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 64 then
--|#line 668 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 668")
end

				  create {DROP_PARSE_NODE} yyval3
				  yyval3.set_file_name (file_name)
				  yyval3.set_line_number (eif_lineno)
				  yyval3.add_last (yyvs7.item (yyvsp7))
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp3 := yyvsp3 + 1
	yyvsp7 := yyvsp7 -1
	yyvsp1 := yyvsp1 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 65 then
--|#line 675 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 675")
end

				  create {DROP_PARSE_NODE} yyval3
				  yyval3.set_file_name (file_name)
				  yyval3.set_line_number (eif_lineno)
				  yyval3.add_last (yyvs3.item (yyvsp3))
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 66 then
--|#line 682 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 682")
end

				  create yyval3
				  yyval3.set_file_name (file_name)
				  yyval3.set_line_number (eif_lineno)
				  yyval3.add_last (yyvs3.item (yyvsp3))
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 67 then
--|#line 689 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 689")
end

yyval3 := yyvs3.item (yyvsp3) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 68 then
--|#line 690 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 690")
end

yyval3 := yyvs3.item (yyvsp3) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 69 then
--|#line 691 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 691")
end

				if yyvs3.item (yyvsp3).children.count > 0 then
					children := yyvs3.item (yyvsp3).children
					from
						children.start
					until
						children.after
					loop
						variable ?= children.item_for_iteration
						check
							variable_not_void: variable /= Void
						end
						
						if variable.variable.is_default_storage then
							variable.variable.set_default_storage_class (varying)
						end
						
						-- Relink the initialisers
						if variable.children.count > 0 then
							variable.children.start
							-- variable.children.item.update_storage
							children.remove_at
							children.put_left (variable.children.item_for_iteration)
							variable.children.item_for_iteration.set_parent (yyvs3.item (yyvsp3))
						else
							children.remove_at
						end
					end
				end
				yyval3 := yyvs3.item (yyvsp3)
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 70 then
--|#line 723 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 723")
end

yyval3 := yyvs3.item (yyvsp3) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 71 then
--|#line 724 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 724")
end

yyval3 := yyvs3.item (yyvsp3) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 72 then
--|#line 725 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 725")
end

create yyval3 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp3 := yyvsp3 + 1
	yyvsp1 := yyvsp1 -2
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 73 then
--|#line 726 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 726")
end

create yyval3 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 74 then
--|#line 727 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 727")
end

				create {CONDITIONAL_PARSE_NODE} yyval3
				yyval3.set_file_name (file_name)
				yyval3.set_line_number (eif_lineno)
				yyval3.add_last (yyvs3.item (yyvsp3 - 1))				
				yyval3.add_last (yyvs3.item (yyvsp3))				
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp3 := yyvsp3 -1
	yyvsp1 := yyvsp1 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 75 then
--|#line 735 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 735")
end

				create {CONDITIONAL_PARSE_NODE} yyval3
				yyval3.set_file_name (file_name)
				yyval3.set_line_number (eif_lineno)
				yyval3.add_last (yyvs3.item (yyvsp3 - 2))				
				yyval3.add_last (yyvs3.item (yyvsp3 - 1))				
				yyval3.add_last (yyvs3.item (yyvsp3))				
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 5
	yyvsp3 := yyvsp3 -2
	yyvsp1 := yyvsp1 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 76 then
--|#line 748 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 748")
end

				create {WHILE_PARSE_NODE} yyval3
				yyval3.set_file_name (file_name)
				yyval3.set_line_number (eif_lineno)
				yyval3.add_last (yyvs3.item (yyvsp3 - 1))				
				yyval3.add_last (yyvs3.item (yyvsp3))				
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp3 := yyvsp3 -1
	yyvsp1 := yyvsp1 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 77 then
--|#line 757 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 757")
end

				create yyval3
				yyval3.set_file_name (file_name)
				yyval3.set_line_number (eif_lineno)
				yyval3.add_last (yyvs3.item (yyvsp3 - 3))				
				create {WHILE_PARSE_NODE} tmp_node
				tmp_node.set_file_name (file_name)
				tmp_node.set_line_number (eif_lineno)
				tmp_node.add_last (yyvs3.item (yyvsp3 - 2))				
				tmp_node.add_last (yyvs3.item (yyvsp3))				
				tmp_node.add_last (yyvs3.item (yyvsp3 - 1))
				yyval3.add_last (tmp_node)
				yyvs3.item (yyvsp3 - 3).disable_duplication
				yyvs3.item (yyvsp3 - 1).disable_duplication
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 9
	yyvsp3 := yyvsp3 -3
	yyvsp1 := yyvsp1 -5
	yyvs3.put (yyval3, yyvsp3)
end
when 78 then
--|#line 773 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 773")
end

				create {SOLAR_PARSE_NODE} yyval3
				yyval3.set_file_name (file_name)
				yyval3.set_line_number (eif_lineno)
				yyval3.add_last (yyvs3.item (yyvsp3))
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp1 := yyvsp1 -3
	yyvs3.put (yyval3, yyvsp3)
end
when 79 then
--|#line 780 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 780")
end

				create {SOLAR_PARSE_NODE} yyval3.make (true)
				yyval3.set_file_name (file_name)
				yyval3.set_line_number (eif_lineno)
				create node
				node.set_file_name (file_name)
				node.set_line_number (eif_lineno)
				node.add_first (yyvs3.item (yyvsp3 - 2))
				node.add_first (yyvs3.item (yyvsp3 - 1))
				
				yyval3.add_last (node)				
				yyval3.add_last (yyvs3.item (yyvsp3))
				yyvs3.item (yyvsp3 - 2).disable_duplication
				yyvs3.item (yyvsp3 - 1).disable_duplication
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 7
	yyvsp3 := yyvsp3 -2
	yyvsp1 := yyvsp1 -4
	yyvs3.put (yyval3, yyvsp3)
end
when 80 then
--|#line 796 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 796")
end

				create {ILLUMINATE_PARSE_NODE} yyval3
				yyval3.set_file_name (file_name)
				yyval3.set_line_number (eif_lineno)
				yyval3.add_last (yyvs3.item (yyvsp3 - 1))
				yyval3.add_last (yyvs3.item (yyvsp3))
				yyvs3.item (yyvsp3 - 1).disable_duplication
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 5
	yyvsp3 := yyvsp3 -1
	yyvsp1 := yyvsp1 -3
	yyvs3.put (yyval3, yyvsp3)
end
when 81 then
--|#line 805 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 805")
end

				create {ILLUMINATE_PARSE_NODE} yyval3.make (true)
				yyval3.set_file_name (file_name)
				yyval3.set_line_number (eif_lineno)
				create node
				node.set_file_name (file_name)
				node.set_line_number (eif_lineno)
				node.add_first (yyvs3.item (yyvsp3 - 3))
				node.add_first (yyvs3.item (yyvsp3 - 2))
				node.add_first (yyvs3.item (yyvsp3 - 1))
				
				yyval3.add_last (node)				
				yyval3.add_last (yyvs3.item (yyvsp3))
				yyvs3.item (yyvsp3 - 3).disable_duplication
				yyvs3.item (yyvsp3 - 2).disable_duplication
				yyvs3.item (yyvsp3 - 1).disable_duplication
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 9
	yyvsp3 := yyvsp3 -3
	yyvsp1 := yyvsp1 -5
	yyvs3.put (yyval3, yyvsp3)
end
when 82 then
--|#line 823 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 823")
end

				create {ILLUMINANCE_PARSE_NODE} yyval3
				yyval3.set_file_name (file_name)
				yyval3.set_line_number (eif_lineno)
				create node
				node.set_file_name (file_name)
				node.set_line_number (eif_lineno)
				node.add_first (yyvs3.item (yyvsp3 - 1))
				create {FLOAT_CONSTANT_PARSE_NODE}tmp_node.make (0)
				node.add_first (tmp_node)
				yyval3.add_last (node)				
				yyval3.add_last (yyvs3.item (yyvsp3))
				yyvs3.item (yyvsp3 - 1).disable_duplication
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 5
	yyvsp3 := yyvsp3 -1
	yyvsp1 := yyvsp1 -3
	yyvs3.put (yyval3, yyvsp3)
end
when 83 then
--|#line 838 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 838")
end

				create {ILLUMINANCE_PARSE_NODE} yyval3.make (true)
				yyval3.set_file_name (file_name)
				yyval3.set_line_number (eif_lineno)
				create node
				node.set_file_name (file_name)
				node.set_line_number (eif_lineno)
				node.add_first (yyvs3.item (yyvsp3 - 2))
				node.add_first (yyvs3.item (yyvsp3 - 1))
				yyval3.add_last (node)				
				yyval3.add_last (yyvs3.item (yyvsp3))
				yyvs3.item (yyvsp3 - 2).disable_duplication
				yyvs3.item (yyvsp3 - 1).disable_duplication
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 7
	yyvsp3 := yyvsp3 -2
	yyvsp1 := yyvsp1 -4
	yyvs3.put (yyval3, yyvsp3)
end
when 84 then
--|#line 853 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 853")
end

				create {ILLUMINANCE_PARSE_NODE} yyval3.make (true)
				yyval3.set_file_name (file_name)
				yyval3.set_line_number (eif_lineno)
				create node
				node.set_file_name (file_name)
				node.set_line_number (eif_lineno)
				node.add_first (yyvs3.item (yyvsp3 - 3))
				node.add_first (yyvs3.item (yyvsp3 - 2))
				node.add_first (yyvs3.item (yyvsp3 - 1))
				yyval3.add_last (node)				
				yyval3.add_last (yyvs3.item (yyvsp3))
				yyvs3.item (yyvsp3 - 3).disable_duplication
				yyvs3.item (yyvsp3 - 2).disable_duplication
				yyvs3.item (yyvsp3 - 1).disable_duplication
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 9
	yyvsp3 := yyvsp3 -3
	yyvsp1 := yyvsp1 -5
	yyvs3.put (yyval3, yyvsp3)
end
when 85 then
--|#line 870 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 870")
end

				create {ILLUMINANCE_PARSE_NODE} yyval3.make (true)
				yyval3.set_file_name (file_name)
				yyval3.set_line_number (eif_lineno)
				create node
				node.set_file_name (file_name)
				node.set_line_number (eif_lineno)
				node.add_first (yyvs3.item (yyvsp3 - 4))
				node.add_first (yyvs3.item (yyvsp3 - 3))
				node.add_first (yyvs3.item (yyvsp3 - 2))
				node.add_first (yyvs3.item (yyvsp3 - 1))
				yyval3.add_last (node)				
				yyval3.add_last (yyvs3.item (yyvsp3))
				yyvs3.item (yyvsp3 - 4).disable_duplication
				yyvs3.item (yyvsp3 - 3).disable_duplication
				yyvs3.item (yyvsp3 - 2).disable_duplication
				yyvs3.item (yyvsp3 - 1).disable_duplication
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 11
	yyvsp3 := yyvsp3 -4
	yyvsp1 := yyvsp1 -6
	yyvs3.put (yyval3, yyvsp3)
end
when 86 then
--|#line 891 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 891")
end

yyval3 := yyvs3.item (yyvsp3) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp4 := yyvsp4 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 87 then
--|#line 893 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 893")
end

yyval3 := yyvs3.item (yyvsp3) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 88 then
--|#line 896 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 896")
end

				  create yyval3
				  yyval3.set_file_name (file_name)
				  yyval3.set_line_number (eif_lineno)
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 89 then
--|#line 903 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 903")
end

				  create yyval3
				  yyval3.set_file_name (file_name)
				  yyval3.set_line_number (eif_lineno)
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 90 then
--|#line 911 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 911")
end

yyval3 := yyvs3.item (yyvsp3)
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 91 then
--|#line 913 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 913")
end

				check
					has_operator_plus: function_list.has ("operator.")
				end
				create	{FUNCTION_CALL_PARSE_NODE} yyval3.make (function_list.item ("operator."))
				yyval3.set_file_name (file_name)
				yyval3.set_line_number (eif_lineno)
				yyval3.add_last (yyvs3.item (yyvsp3 - 1))
				yyval3.add_last (yyvs3.item (yyvsp3))
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp3 := yyvsp3 -1
	yyvsp1 := yyvsp1 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 92 then
--|#line 924 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 924")
end

				check
					has_operator_plus: function_list.has ("operator/")
				end
				create	{FUNCTION_CALL_PARSE_NODE} yyval3.make (function_list.item ("operator/"))
				yyval3.set_file_name (file_name)
				yyval3.set_line_number (eif_lineno)
				yyval3.add_last (yyvs3.item (yyvsp3 - 1))
				yyval3.add_last (yyvs3.item (yyvsp3))
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp3 := yyvsp3 -1
	yyvsp1 := yyvsp1 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 93 then
--|#line 935 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 935")
end

				check
					has_operator_plus: function_list.has ("operator*")
				end
				create	{FUNCTION_CALL_PARSE_NODE} yyval3.make (function_list.item ("operator*"))
				yyval3.set_file_name (file_name)
				yyval3.set_line_number (eif_lineno)
				yyval3.add_last (yyvs3.item (yyvsp3 - 1))
				yyval3.add_last (yyvs3.item (yyvsp3))
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp3 := yyvsp3 -1
	yyvsp1 := yyvsp1 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 94 then
--|#line 946 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 946")
end

				check
					has_operator_plus: function_list.has ("operator^")
				end
				create	{FUNCTION_CALL_PARSE_NODE} yyval3.make (function_list.item ("operator^"))
				yyval3.set_file_name (file_name)
				yyval3.set_line_number (eif_lineno)
				yyval3.add_last (yyvs3.item (yyvsp3 - 1))
				yyval3.add_last (yyvs3.item (yyvsp3))
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp3 := yyvsp3 -1
	yyvsp1 := yyvsp1 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 95 then
--|#line 957 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 957")
end

				check
					has_operator_plus: function_list.has ("operator+")
				end
				create	{FUNCTION_CALL_PARSE_NODE} yyval3.make (function_list.item ("operator+"))
				yyval3.set_file_name (file_name)
				yyval3.set_line_number (eif_lineno)
				yyval3.add_last (yyvs3.item (yyvsp3 - 1))
				yyval3.add_last (yyvs3.item (yyvsp3))
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp3 := yyvsp3 -1
	yyvsp1 := yyvsp1 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 96 then
--|#line 968 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 968")
end

				check
					has_operator_plus: function_list.has ("operator-")
				end
				create	{FUNCTION_CALL_PARSE_NODE} yyval3.make (function_list.item ("operator-"))
				yyval3.set_file_name (file_name)
				yyval3.set_line_number (eif_lineno)
				yyval3.add_last (yyvs3.item (yyvsp3 - 1))
				yyval3.add_last (yyvs3.item (yyvsp3))
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp3 := yyvsp3 -1
	yyvsp1 := yyvsp1 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 97 then
--|#line 979 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 979")
end

				check
					has_operator_plus: function_list.has ("operator-")
				end
				create	{FUNCTION_CALL_PARSE_NODE} yyval3.make (function_list.item ("operator-"))
				yyval3.set_file_name (file_name)
				yyval3.set_line_number (eif_lineno)
				yyval3.add_last (yyvs3.item (yyvsp3))
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 98 then
--|#line 989 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 989")
end

yyval3 := yyvs3.item (yyvsp3)
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 99 then
--|#line 990 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 990")
end

				yyvs3.item (yyvsp3 - 1).resolve_type (nil_type)
				yyvs3.item (yyvsp3).resolve_type (nil_type)
				if yyvs3.item (yyvsp3 - 1).type = yyvs3.item (yyvsp3).type then
					create	{TERIARY_CONSTRUCT_PARSE_NODE} yyval3
					yyval3.set_file_name (file_name)
					yyval3.set_line_number (eif_lineno)
					yyval3.add_last (yyvs3.item (yyvsp3 - 2))
					yyval3.add_last (yyvs3.item (yyvsp3 - 1))
					yyval3.add_last (yyvs3.item (yyvsp3))
				else
					create yyval3
				end
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 5
	yyvsp3 := yyvsp3 -2
	yyvsp1 := yyvsp1 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 100 then
--|#line 1008 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1008")
end

				  create yyval3
				  yyval3.set_file_name (file_name)
				  yyval3.set_line_number (eif_lineno)
				  create cast.make (yyvs5.item (yyvsp5).type)
				  cast.set_file_name (file_name)
				  cast.set_line_number (eif_lineno)
				  cast.add_last (yyvs3.item (yyvsp3))

				  tmp_integer := yyvs5.item (yyvsp5).type
				  if yyvs5.item (yyvsp5).space /= Void and then not yyvs5.item (yyvsp5).space.is_equal ("") and
					( tmp_integer = point_type or
					  tmp_integer = normal_type or
					  tmp_integer = vector_type or
					  tmp_integer = matrix_type) then
					inspect tmp_integer
					when normal_type then
						tmp_string.make_from_string ("ntransform")
					when vector_type then
						tmp_string.make_from_string ("vtransform")
					when matrix_type then
						tmp_string.make_from_string ("mtransform")
					else
						create tmp_string.make_from_string ("transform")
					end

					create {FUNCTION_CALL_PARSE_NODE} yyval3.make (function_list.item (tmp_string))
					yyval3.set_file_name (file_name)
					yyval3.set_line_number (eif_lineno)
					create str_node.make (yyvs5.item (yyvsp5).space)
					yyval3.add_last (str_node)
					create str_node.make ("current")
					yyval3.add_last (str_node)
					yyval3.add_last (cast)
				  else
					yyval3 := cast
				  end
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp5 := yyvsp5 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 101 then
--|#line 1050 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1050")
end

				  create {FLOAT_CONSTANT_PARSE_NODE} yyval3.make (yyvs4.item (yyvsp4))
				  yyval3.set_file_name (file_name)
				  yyval3.set_line_number (eif_lineno)
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp4 := yyvsp4 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 102 then
--|#line 1057 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1057")
end

yyval3 := yyvs3.item (yyvsp3) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 103 then
--|#line 1058 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1058")
end

				  create {VARIABLE_PARSE_NODE} yyval3.make (variable_list.item (yyvs2.item (yyvsp2)))
				  yyval3.set_file_name (file_name)
				  yyval3.set_line_number (eif_lineno)
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 104 then
--|#line 1064 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1064")
end

				  create {VARIABLE_ARRAY_PARSE_NODE} yyval3.make (variable_list.item (yyvs2.item (yyvsp2)))
				  yyval3.set_file_name (file_name)
				  yyval3.set_line_number (eif_lineno)
				  yyval3.add_last (yyvs3.item (yyvsp3))
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 105 then
--|#line 1071 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1071")
end

				  create {STRING_CONSTANT_PARSE_NODE} yyval3.make (yyvs2.item (yyvsp2))
				  yyval3.set_file_name (file_name)
				  yyval3.set_line_number (eif_lineno)
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 106 then
--|#line 1077 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1077")
end

yyval3 := yyvs7.item (yyvsp7) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp7 := yyvsp7 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 107 then
--|#line 1078 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1078")
end

yyval3 := yyvs3.item (yyvsp3) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 108 then
--|#line 1079 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1079")
end

yyval3 := yyvs3.item (yyvsp3) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 109 then
--|#line 1080 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1080")
end

yyval3 := yyvs3.item (yyvsp3) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 110 then
--|#line 1081 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1081")
end

				  create {TRIPLE_PARSE_NODE} yyval3
				  yyval3.set_file_name (file_name)
				  yyval3.set_line_number (eif_lineno)
				  yyval3.add_last (yyvs3.item (yyvsp3 - 2))
				  yyval3.add_last (yyvs3.item (yyvsp3 - 1))
				  yyval3.add_last (yyvs3.item (yyvsp3))				  
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 7
	yyvsp3 := yyvsp3 -2
	yyvsp1 := yyvsp1 -4
	yyvs3.put (yyval3, yyvsp3)
end
when 111 then
--|#line 1090 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1090")
end

				  create {HEX_TUPLE_PARSE_NODE} yyval3
				  yyval3.set_file_name (file_name)
				  yyval3.set_line_number (eif_lineno)
				  yyval3.add_last (yyvs3.item (yyvsp3 - 15))
				  yyval3.add_last (yyvs3.item (yyvsp3 - 14))
				  yyval3.add_last (yyvs3.item (yyvsp3 - 13))
				  yyval3.add_last (yyvs3.item (yyvsp3 - 12))
				  yyval3.add_last (yyvs3.item (yyvsp3 - 11))
				  yyval3.add_last (yyvs3.item (yyvsp3 - 10))
				  yyval3.add_last (yyvs3.item (yyvsp3 - 9))
				  yyval3.add_last (yyvs3.item (yyvsp3 - 8))
				  yyval3.add_last (yyvs3.item (yyvsp3 - 7))
				  yyval3.add_last (yyvs3.item (yyvsp3 - 6))
				  yyval3.add_last (yyvs3.item (yyvsp3 - 5))
				  yyval3.add_last (yyvs3.item (yyvsp3 - 4))
				  yyval3.add_last (yyvs3.item (yyvsp3 - 3))
				  yyval3.add_last (yyvs3.item (yyvsp3 - 2))
				  yyval3.add_last (yyvs3.item (yyvsp3 - 1))
				  yyval3.add_last (yyvs3.item (yyvsp3))
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 33
	yyvsp3 := yyvsp3 -15
	yyvsp1 := yyvsp1 -17
	yyvs3.put (yyval3, yyvsp3)
end
when 112 then
--|#line 1114 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1114")
end

create {RELATIONAL_OPERATOR_PARSE_NODE} yyval3.make (greater_than_operator) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 113 then
--|#line 1116 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1116")
end

create {RELATIONAL_OPERATOR_PARSE_NODE} yyval3.make (greater_than_or_equal_operator) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 114 then
--|#line 1117 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1117")
end

create {RELATIONAL_OPERATOR_PARSE_NODE} yyval3.make (less_than_operator) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 115 then
--|#line 1118 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1118")
end

create {RELATIONAL_OPERATOR_PARSE_NODE} yyval3.make (less_than_or_equal_operator) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 116 then
--|#line 1119 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1119")
end

create {RELATIONAL_OPERATOR_PARSE_NODE} yyval3.make (equal_operator) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 117 then
--|#line 1120 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1120")
end

create {RELATIONAL_OPERATOR_PARSE_NODE} yyval3.make (not_equal_operator) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 118 then
--|#line 1123 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1123")
end

yyval3 := yyvs3.item (yyvsp3) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 119 then
--|#line 1125 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1125")
end

				yyval3 := yyvs3.item (yyvsp3 - 1)
				  yyval3.set_file_name (file_name)
				  yyval3.set_line_number (eif_lineno)
				yyval3.add_last (yyvs3.item (yyvsp3 - 2))
				yyval3.add_last (yyvs3.item (yyvsp3))
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp3 := yyvsp3 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 120 then
--|#line 1133 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1133")
end

				  create {LOGICAL_OPERATION_PARSE_NODE} yyval3.make (and_operator)
				  yyval3.set_file_name (file_name)
				  yyval3.set_line_number (eif_lineno)
				  yyval3.add_last (yyvs3.item (yyvsp3 - 1))
				  yyval3.add_last (yyvs3.item (yyvsp3))
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp3 := yyvsp3 -1
	yyvsp1 := yyvsp1 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 121 then
--|#line 1141 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1141")
end

				  create {LOGICAL_OPERATION_PARSE_NODE} yyval3.make (or_operator)
				  yyval3.set_file_name (file_name)
				  yyval3.set_line_number (eif_lineno)
				  yyval3.add_last (yyvs3.item (yyvsp3 - 1))
				  yyval3.add_last (yyvs3.item (yyvsp3))
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp3 := yyvsp3 -1
	yyvsp1 := yyvsp1 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 122 then
--|#line 1149 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1149")
end

				  create {LOGICAL_OPERATION_PARSE_NODE} yyval3.make (negation_operator)
				  yyval3.set_file_name (file_name)
				  yyval3.set_line_number (eif_lineno)
				  yyval3.add_last (yyvs3.item (yyvsp3))
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 123 then
--|#line 1158 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1158")
end

				  create {ASSIGN_PARSE_NODE} yyval3.make (variable_list.item (yyvs2.item (yyvsp2)))
				  yyval3.set_file_name (file_name)
				  yyval3.set_line_number (eif_lineno)
				  yyval3.add_last (yyvs3.item (yyvsp3))
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 124 then
--|#line 1166 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1166")
end

				  create {ASSIGN_PARSE_NODE} yyval3.make (variable_list.item (yyvs2.item (yyvsp2)))
				  yyval3.set_file_name (file_name)
				  yyval3.set_line_number (eif_lineno)
				  check
					  has_operator_plus: function_list.has ("operator+")
				  end
				  create  {FUNCTION_CALL_PARSE_NODE} node.make (function_list.item ("operator+"))
				  node.set_file_name (file_name)
				  node.set_line_number (eif_lineno)
				  create {VARIABLE_PARSE_NODE} tmp_node.make (variable_list.item (yyvs2.item (yyvsp2)))
				  node.add_last (tmp_node)
				  node.add_last (yyvs3.item (yyvsp3))
				  yyval3.add_last (node)
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 125 then
--|#line 1182 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1182")
end

				  create {ASSIGN_PARSE_NODE} yyval3.make (variable_list.item (yyvs2.item (yyvsp2)))
				  yyval3.set_file_name (file_name)
				  yyval3.set_line_number (eif_lineno)
				  check
					  has_operator_minus: function_list.has ("operator-")
				  end
				  create  {FUNCTION_CALL_PARSE_NODE} node.make (function_list.item ("operator-"))
				  node.set_file_name (file_name)
				  node.set_line_number (eif_lineno)
				  create {VARIABLE_PARSE_NODE} tmp_node.make (variable_list.item (yyvs2.item (yyvsp2)))
				  node.add_last (tmp_node)
				  node.add_last (yyvs3.item (yyvsp3))
				  yyval3.add_last (node)
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 126 then
--|#line 1198 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1198")
end

				  create {ASSIGN_PARSE_NODE} yyval3.make (variable_list.item (yyvs2.item (yyvsp2)))
				  yyval3.set_file_name (file_name)
				  yyval3.set_line_number (eif_lineno)
				  check
					  has_operator_multiply: function_list.has ("operator*")
				  end
				  create  {FUNCTION_CALL_PARSE_NODE} node.make (function_list.item ("operator*"))
				  node.set_file_name (file_name)
				  node.set_line_number (eif_lineno)
				  create {VARIABLE_PARSE_NODE} tmp_node.make (variable_list.item (yyvs2.item (yyvsp2)))
				  node.add_last (tmp_node)
				  node.add_last (yyvs3.item (yyvsp3))
				  yyval3.add_last (node)
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 127 then
--|#line 1214 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1214")
end

				  create {ASSIGN_PARSE_NODE} yyval3.make (variable_list.item (yyvs2.item (yyvsp2)))
				  yyval3.set_file_name (file_name)
				  yyval3.set_line_number (eif_lineno)
				  check
					  has_operator_divide: function_list.has ("operator/")
				  end
				  create  {FUNCTION_CALL_PARSE_NODE} node.make (function_list.item ("operator/"))
				  node.set_file_name (file_name)
				  node.set_line_number (eif_lineno)
				  create {VARIABLE_PARSE_NODE} tmp_node.make (variable_list.item (yyvs2.item (yyvsp2)))
				  node.add_last (tmp_node)
				  node.add_last (yyvs3.item (yyvsp3))
				  yyval3.add_last (node)
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 128 then
--|#line 1230 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1230")
end

				  create {ARRAY_ASSIGN_PARSE_NODE} yyval3.make (variable_list.item (yyvs2.item (yyvsp2)))
				  yyval3.set_file_name (file_name)
				  yyval3.set_line_number (eif_lineno)
				  yyval3.add_last (yyvs3.item (yyvsp3))
				  yyval3.add_last (yyvs3.item (yyvsp3 - 1))
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 6
	yyvsp3 := yyvsp3 -1
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -3
	yyvs3.put (yyval3, yyvsp3)
end
when 129 then
--|#line 1238 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1238")
end

				  create {ARRAY_ASSIGN_PARSE_NODE} yyval3.make (variable_list.item (yyvs2.item (yyvsp2)))
				  yyval3.set_file_name (file_name)
				  yyval3.set_line_number (eif_lineno)
				  check
					  has_operator_plus: function_list.has ("operator+")
				  end
				  create  {FUNCTION_CALL_PARSE_NODE} node.make (function_list.item ("operator+"))
				  node.set_file_name (file_name)
				  node.set_line_number (eif_lineno)
				  create {VARIABLE_ARRAY_PARSE_NODE} tmp_node.make (variable_list.item (yyvs2.item (yyvsp2)))
				  node.add_last (yyvs3.item (yyvsp3 - 1).twin)
				  node.add_last (tmp_node)
				  node.add_last (yyvs3.item (yyvsp3))
				  yyval3.add_last (node)
				  yyval3.add_last (yyvs3.item (yyvsp3 - 1))
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 6
	yyvsp3 := yyvsp3 -1
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -3
	yyvs3.put (yyval3, yyvsp3)
end
when 130 then
--|#line 1256 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1256")
end

				  create {ARRAY_ASSIGN_PARSE_NODE} yyval3.make (variable_list.item (yyvs2.item (yyvsp2)))
				  yyval3.set_file_name (file_name)
				  yyval3.set_line_number (eif_lineno)
				  check
					  has_operator_minus: function_list.has ("operator-")
				  end
				  create  {FUNCTION_CALL_PARSE_NODE} node.make (function_list.item ("operator-"))
				  node.set_file_name (file_name)
				  node.set_line_number (eif_lineno)
				  create {VARIABLE_ARRAY_PARSE_NODE} tmp_node.make (variable_list.item (yyvs2.item (yyvsp2)))
				  node.add_last (yyvs3.item (yyvsp3 - 1).twin)
				  node.add_last (tmp_node)
				  node.add_last (yyvs3.item (yyvsp3))
				  yyval3.add_last (node)
				  yyval3.add_last (yyvs3.item (yyvsp3 - 1))
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 6
	yyvsp3 := yyvsp3 -1
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -3
	yyvs3.put (yyval3, yyvsp3)
end
when 131 then
--|#line 1274 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1274")
end

				  create {ARRAY_ASSIGN_PARSE_NODE} yyval3.make (variable_list.item (yyvs2.item (yyvsp2)))
				  yyval3.set_file_name (file_name)
				  yyval3.set_line_number (eif_lineno)
				  check
					  has_operator_multiply: function_list.has ("operator*")
				  end
				  create  {FUNCTION_CALL_PARSE_NODE} node.make (function_list.item ("operator*"))
				  node.set_file_name (file_name)
				  node.set_line_number (eif_lineno)
				  create {VARIABLE_ARRAY_PARSE_NODE} tmp_node.make (variable_list.item (yyvs2.item (yyvsp2)))
				  node.add_last (yyvs3.item (yyvsp3 - 1).twin)
				  node.add_last (tmp_node)
				  node.add_last (yyvs3.item (yyvsp3))
				  yyval3.add_last (node)
				  yyval3.add_last (yyvs3.item (yyvsp3 - 1))
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 6
	yyvsp3 := yyvsp3 -1
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -3
	yyvs3.put (yyval3, yyvsp3)
end
when 132 then
--|#line 1292 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1292")
end

				  create {ARRAY_ASSIGN_PARSE_NODE} yyval3.make (variable_list.item (yyvs2.item (yyvsp2)))
				  yyval3.set_file_name (file_name)
				  yyval3.set_line_number (eif_lineno)
				  check
					  has_operator_divide: function_list.has ("operator/")
				  end
				  create  {FUNCTION_CALL_PARSE_NODE} node.make (function_list.item ("operator/"))
				  node.set_file_name (file_name)
				  node.set_line_number (eif_lineno)
				  create {VARIABLE_ARRAY_PARSE_NODE} tmp_node.make (variable_list.item (yyvs2.item (yyvsp2)))
				  node.add_last (yyvs3.item (yyvsp3 - 1).twin)
				  node.add_last (tmp_node)
				  node.add_last (yyvs3.item (yyvsp3))
				  yyval3.add_last (node)
				  yyval3.add_last (yyvs3.item (yyvsp3 - 1))
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 6
	yyvsp3 := yyvsp3 -1
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -3
	yyvs3.put (yyval3, yyvsp3)
end
when 133 then
--|#line 1312 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1312")
end

				check
					function_exists: function_list.has (yyvs2.item (yyvsp2))
				end
				
				create yyval7.make (function_list.item (yyvs2.item (yyvsp2)))
				yyval7.set_file_name (file_name)
				yyval7.set_line_number (eif_lineno)
				yyval7.copy_children (yyvs3.item (yyvsp3))
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp7 := yyvsp7 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -2
	yyvsp3 := yyvsp3 -1
	if yyvsp7 >= yyvsc7 then
		if yyvs7 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs7")
			end
			create yyspecial_routines7
			yyvsc7 := yyInitial_yyvs_size
			yyvs7 := yyspecial_routines7.make (yyvsc7)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs7")
			end
			yyvsc7 := yyvsc7 + yyInitial_yyvs_size
			yyvs7 := yyspecial_routines7.resize (yyvs7, yyvsc7)
		end
	end
	yyvs7.put (yyval7, yyvsp7)
end
when 134 then
--|#line 1324 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1324")
end

				check
					function_exists: function_list.has (yyvs2.item (yyvsp2))
				end
				
				create yyval7.make (function_list.item (yyvs2.item (yyvsp2)))
				yyval7.set_file_name (file_name)
				yyval7.set_line_number (eif_lineno)
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp7 := yyvsp7 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -2
	if yyvsp7 >= yyvsc7 then
		if yyvs7 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs7")
			end
			create yyspecial_routines7
			yyvsc7 := yyInitial_yyvs_size
			yyvs7 := yyspecial_routines7.make (yyvsc7)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs7")
			end
			yyvsc7 := yyvsc7 + yyInitial_yyvs_size
			yyvs7 := yyspecial_routines7.resize (yyvs7, yyvsc7)
		end
	end
	yyvs7.put (yyval7, yyvsp7)
end
when 135 then
--|#line 1336 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1336")
end

				  create yyval3
				  yyval3.set_file_name (file_name)
				  yyval3.set_line_number (eif_lineno)
				  yyval3.add_last (yyvs3.item (yyvsp3))
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 136 then
--|#line 1344 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1344")
end

				yyvs3.item (yyvsp3 - 1).add_last (yyvs3.item (yyvsp3))
				yyval3 := yyvs3.item (yyvsp3 - 1)
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp3 := yyvsp3 -1
	yyvsp1 := yyvsp1 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 137 then
--|#line 1351 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1351")
end

				yyval3 := yyvs3.item (yyvsp3 - 3)
				yyval3.add_first (yyvs3.item (yyvsp3 - 2))
				yyval3.add_last (yyvs3.item (yyvsp3 - 1))

				if yyvs3.item (yyvsp3).children.count > 0 then
					from
						yyvs3.item (yyvsp3).children.start
					until
						yyvs3.item (yyvsp3).children.after
					loop
						yyval3.add_last (yyvs3.item (yyvsp3).children.item_for_iteration)
						yyvs3.item (yyvsp3).children.forth
					end
				end
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 6
	yyvsp3 := yyvsp3 -3
	yyvsp1 := yyvsp1 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 138 then
--|#line 1369 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1369")
end

				yyval3 := yyvs3.item (yyvsp3 - 2)
				yyval3.add_first (yyvs3.item (yyvsp3 - 1))
				create {FLOAT_CONSTANT_PARSE_NODE} node.make (0)
				yyval3.add_last (node)

				if yyvs3.item (yyvsp3).children.count > 0 then
					from
						yyvs3.item (yyvsp3).children.start
					until
						yyvs3.item (yyvsp3).children.after
					loop
						yyval3.add_last (yyvs3.item (yyvsp3).children.item_for_iteration)
						yyvs3.item (yyvsp3).children.forth
					end
				end
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 5
	yyvsp3 := yyvsp3 -2
	yyvsp1 := yyvsp1 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 139 then
--|#line 1387 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1387")
end

				yyval3 := yyvs3.item (yyvsp3 - 2)
				yyval3.add_first (yyvs3.item (yyvsp3 - 1))
				yyval3.add_last (yyvs3.item (yyvsp3))
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 5
	yyvsp3 := yyvsp3 -2
	yyvsp1 := yyvsp1 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 140 then
--|#line 1393 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1393")
end

				yyval3 := yyvs3.item (yyvsp3 - 1)
				yyval3.add_first (yyvs3.item (yyvsp3))
				create {FLOAT_CONSTANT_PARSE_NODE} node.make (0)
				yyval3.add_last (node)
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp3 := yyvsp3 -1
	yyvsp1 := yyvsp1 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 141 then
--|#line 1402 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1402")
end

				  check
					  has_operator_texture: function_list.has ("texture")
				  end
				  create  {FUNCTION_CALL_PARSE_NODE} yyval3.make (function_list.item ("texture"))
				  yyval3.set_file_name (file_name)
				  yyval3.set_line_number (eif_lineno)
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 142 then
--|#line 1412 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1412")
end

				  check
					  has_operator_environment: function_list.has ("environment")
				  end
				  create  {FUNCTION_CALL_PARSE_NODE} yyval3.make (function_list.item ("environment"))
				  yyval3.set_file_name (file_name)
				  yyval3.set_line_number (eif_lineno)
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 143 then
--|#line 1421 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1421")
end

				  check
					  has_operator_bump: function_list.has ("bump")
				  end
				  create  {FUNCTION_CALL_PARSE_NODE} yyval3.make (function_list.item ("bump"))
				  yyval3.set_file_name (file_name)
				  yyval3.set_line_number (eif_lineno)
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 144 then
--|#line 1430 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1430")
end

				  check
					  has_operator_shadow: function_list.has ("shadow")
				  end
				  create  {FUNCTION_CALL_PARSE_NODE} yyval3.make (function_list.item ("shadow"))
				  yyval3.set_file_name (file_name)
				  yyval3.set_line_number (eif_lineno)
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 145 then
--|#line 1441 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1441")
end

				  create {VARIABLE_PARSE_NODE } yyval3.make (variable_list.item (yyvs2.item (yyvsp2)))
				  yyval3.set_file_name (file_name)
				  yyval3.set_line_number (eif_lineno)
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 146 then
--|#line 1448 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1448")
end

				  create {STRING_CONSTANT_PARSE_NODE} yyval3.make (yyvs2.item (yyvsp2))
				  yyval3.set_file_name (file_name)
				  yyval3.set_line_number (eif_lineno)
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 147 then
--|#line 1456 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1456")
end

yyval3 := yyvs3.item (yyvsp3) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyvs3.put (yyval3, yyvsp3)
end
when 148 then
--|#line 1460 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1460")
end

				  create yyval3
				  yyval3.set_file_name (file_name)
				  yyval3.set_line_number (eif_lineno)
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 149 then
--|#line 1467 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1467")
end

				yyval3 := yyvs3.item (yyvsp3 - 1)
				yyval3.add_last (yyvs3.item (yyvsp3))
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp3 := yyvsp3 -1
	yyvsp1 := yyvsp1 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 150 then
--|#line 1474 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1474")
end

yyval4 := yyvs4.item (yyvsp4)
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs4.put (yyval4, yyvsp4)
end
when 151 then
--|#line 1479 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1479")
end

yyval6 := atmosphere
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp6 := yyvsp6 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp6 >= yyvsc6 then
		if yyvs6 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs6")
			end
			create yyspecial_routines6
			yyvsc6 := yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.make (yyvsc6)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs6")
			end
			yyvsc6 := yyvsc6 + yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.resize (yyvs6, yyvsc6)
		end
	end
	yyvs6.put (yyval6, yyvsp6)
end
when 152 then
--|#line 1481 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1481")
end

yyval6 := displacement
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp6 := yyvsp6 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp6 >= yyvsc6 then
		if yyvs6 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs6")
			end
			create yyspecial_routines6
			yyvsc6 := yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.make (yyvsc6)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs6")
			end
			yyvsc6 := yyvsc6 + yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.resize (yyvs6, yyvsc6)
		end
	end
	yyvs6.put (yyval6, yyvsp6)
end
when 153 then
--|#line 1482 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1482")
end

yyval6 := lightsource
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp6 := yyvsp6 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp6 >= yyvsc6 then
		if yyvs6 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs6")
			end
			create yyspecial_routines6
			yyvsc6 := yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.make (yyvsc6)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs6")
			end
			yyvsc6 := yyvsc6 + yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.resize (yyvs6, yyvsc6)
		end
	end
	yyvs6.put (yyval6, yyvsp6)
end
when 154 then
--|#line 1483 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1483")
end

yyval6 := surface
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp6 := yyvsp6 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp6 >= yyvsc6 then
		if yyvs6 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs6")
			end
			create yyspecial_routines6
			yyvsc6 := yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.make (yyvsc6)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs6")
			end
			yyvsc6 := yyvsc6 + yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.resize (yyvs6, yyvsc6)
		end
	end
	yyvs6.put (yyval6, yyvsp6)
end
when 155 then
--|#line 1484 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1484")
end

yyval6 := attribute
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp6 := yyvsp6 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp6 >= yyvsc6 then
		if yyvs6 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs6")
			end
			create yyspecial_routines6
			yyvsc6 := yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.make (yyvsc6)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs6")
			end
			yyvsc6 := yyvsc6 + yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.resize (yyvs6, yyvsc6)
		end
	end
	yyvs6.put (yyval6, yyvsp6)
end
when 156 then
--|#line 1485 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1485")
end

yyval6 := option
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp6 := yyvsp6 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp6 >= yyvsc6 then
		if yyvs6 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs6")
			end
			create yyspecial_routines6
			yyvsc6 := yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.make (yyvsc6)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs6")
			end
			yyvsc6 := yyvsc6 + yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.resize (yyvs6, yyvsc6)
		end
	end
	yyvs6.put (yyval6, yyvsp6)
end
when 157 then
--|#line 1486 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1486")
end

yyval6 := rendererinfo
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp6 := yyvsp6 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp6 >= yyvsc6 then
		if yyvs6 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs6")
			end
			create yyspecial_routines6
			yyvsc6 := yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.make (yyvsc6)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs6")
			end
			yyvsc6 := yyvsc6 + yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.resize (yyvs6, yyvsc6)
		end
	end
	yyvs6.put (yyval6, yyvsp6)
end
when 158 then
--|#line 1487 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1487")
end

yyval6 := incident
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp6 := yyvsp6 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp6 >= yyvsc6 then
		if yyvs6 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs6")
			end
			create yyspecial_routines6
			yyvsc6 := yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.make (yyvsc6)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs6")
			end
			yyvsc6 := yyvsc6 + yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.resize (yyvs6, yyvsc6)
		end
	end
	yyvs6.put (yyval6, yyvsp6)
end
when 159 then
--|#line 1488 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1488")
end

yyval6 := opposite
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp6 := yyvsp6 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp6 >= yyvsc6 then
		if yyvs6 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs6")
			end
			create yyspecial_routines6
			yyvsc6 := yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.make (yyvsc6)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs6")
			end
			yyvsc6 := yyvsc6 + yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.resize (yyvs6, yyvsc6)
		end
	end
	yyvs6.put (yyval6, yyvsp6)
end
when 160 then
--|#line 1489 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1489")
end

yyval6 := textureinfo
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp6 := yyvsp6 + 1
	yyvsp1 := yyvsp1 -1
	if yyvsp6 >= yyvsc6 then
		if yyvs6 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs6")
			end
			create yyspecial_routines6
			yyvsc6 := yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.make (yyvsc6)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs6")
			end
			yyvsc6 := yyvsc6 + yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.resize (yyvs6, yyvsc6)
		end
	end
	yyvs6.put (yyval6, yyvsp6)
end
when 161 then
--|#line 1492 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1492")
end

				  if yyvs3.item (yyvsp3).type = string_type and is_variable (yyvs2.item (yyvsp2)) then
					  check
						  has_variable: variable_list.has (yyvs2.item (yyvsp2))
					  end

					  create {COMMUNICATION_FUNCTION_PARSE_NODE} yyval3.make (yyvs6.item (yyvsp6), variable_list.item (yyvs2.item (yyvsp2)))
					  yyval3.add_last (yyvs3.item (yyvsp3))
				  else
					  create yyval3
				  end
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 6
	yyvsp6 := yyvsp6 -1
	yyvsp1 := yyvsp1 -3
	yyvsp2 := yyvsp2 -1
	yyvs3.put (yyval3, yyvsp3)
end
when 162 then
--|#line 1506 "sl_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'sl_parser.y' at line 1506")
end

				  if yyvs3.item (yyvsp3 - 1).type = string_type and yyvs3.item (yyvsp3).type = string_type and is_variable (yyvs2.item (yyvsp2)) then
					  check
						  has_variable: variable_list.has (yyvs2.item (yyvsp2))
					  end

					  str_node ?= yyvs3.item (yyvsp3 - 1)
					  check
						  str_node_not_void: str_node /= Void
					  end
					  
					  create {COMMUNICATION_FUNCTION_PARSE_NODE} yyval3.make_with_arguments (yyvs6.item (yyvsp6), str_node.value, variable_list.item (yyvs2.item (yyvsp2)))
					  yyval3.add_last (yyvs3.item (yyvsp3))
				  else
					  create yyval3
				  end
				
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 8
	yyvsp3 := yyvsp3 -1
	yyvsp6 := yyvsp6 -1
	yyvsp1 := yyvsp1 -4
	yyvsp2 := yyvsp2 -1
	yyvs3.put (yyval3, yyvsp3)
end
			else
				debug ("GEYACC")
					std.error.put_string ("Error in parser: unknown rule id: ")
					std.error.put_integer (yy_act)
					std.error.put_new_line
				end
				abort
			end
		end

	yy_do_error_action (yy_act: INTEGER) is
			-- Execute error action.
		do
			inspect yy_act
			when 342 then
					-- End-of-file expected action.
				report_eof_expected_error
			else
					-- Default action.
				report_error ("parse error")
			end
		end

feature {NONE} -- Table templates

	yytranslate_template: SPECIAL [INTEGER] is
		once
			Result := yyfixed_array (<<
				0,	  2,	2,	  2,	2,	  2,	2,	  2,	2,	  2,
				2,	  2,	2,	  2,	2,	  2,	2,	  2,	2,	  2,
				2,	  2,	2,	  2,	2,	  2,	2,	  2,	2,	  2,
				2,	  2,	2,	  2,	2,	  2,	2,	  2,	2,	  2,
				2,	  2,	2,	  2,	2,	  2,	2,	  2,	2,	  2,
				2,	  2,	2,	  2,	2,	  2,	2,	  2,	2,	  2,
				2,	  2,	2,	  2,	2,	  2,	2,	  2,	2,	  2,
				2,	  2,	2,	  2,	2,	  2,	2,	  2,	2,	  2,
				2,	  2,	2,	  2,	2,	  2,	2,	  2,	2,	  2,
				2,	  2,	2,	  2,	2,	  2,	2,	  2,	2,	  2,

				2,	  2,	2,	  2,	2,	  2,	2,	  2,	2,	  2,
				2,	  2,	2,	  2,	2,	  2,	2,	  2,	2,	  2,
				2,	  2,	2,	  2,	2,	  2,	2,	  2,	2,	  2,
				2,	  2,	2,	  2,	2,	  2,	2,	  2,	2,	  2,
				2,	  2,	2,	  2,	2,	  2,	2,	  2,	2,	  2,
				2,	  2,	2,	  2,	2,	  2,	2,	  2,	2,	  2,
				2,	  2,	2,	  2,	2,	  2,	2,	  2,	2,	  2,
				2,	  2,	2,	  2,	2,	  2,	2,	  2,	2,	  2,
				2,	  2,	2,	  2,	2,	  2,	2,	  2,	2,	  2,
				2,	  2,	2,	  2,	2,	  2,	2,	  2,	2,	  2,

				2,	  2,	2,	  2,	2,	  2,	2,	  2,	2,	  2,
				2,	  2,	2,	  2,	2,	  2,	2,	  2,	2,	  2,
				2,	  2,	2,	  2,	2,	  2,	2,	  2,	2,	  2,
				2,	  2,	2,	  2,	2,	  2,	2,	  2,	2,	  2,
				2,	  2,	2,	  2,	2,	  2,	2,	  2,	2,	  2,
				2,	  2,	2,	  2,	2,	  2,	1,	  2,	3,	  4,
				5,	  6,	7,	  8,	9,	 10,   11,	 12,   13,	 14,
			   15,	 16,   17,	 18,   19,	 20,   21,	 22,   23,	 24,
			   25,	 26,   27,	 28,   29,	 30,   31,	 32,   33,	 34,
			   35,	 36,   37,	 38,   39,	 40,   41,	 42,   43,	 44,

			   45,	 46,   47,	 48,   49,	 50,   51,	 52,   53,	 54,
			   55,	 56,   57,	 58,   59,	 60,   61,	 62,   63,	 64,
			   65,	 66,   67,	 68,   69,	 70,   71,	 72,   73,	 74,
			   75,	 76,   77,	 78,   79,	 80, yyDummy>>)
		end

	yyr1_template: SPECIAL [INTEGER] is
		once
			Result := yyfixed_array (<<
				0,	 82,   82,	 83,   83,	 84,   84,	 85,   85,	 86,
			   86,	 86,   86,	 87,   87,	 87,   87,	 87,   87,	 88,
			   88,	 88,   89,	 89,   90,	 90,   91,	 91,   92,	 92,
			   92,	 92,   92,	 92,   92,	 92,   93,	 95,   94,	 94,
			   96,	 96,   97,	 97,   97,	 97,   97,	 97,   97,	 97,
			   98,	 98,   99,	 99,  100,	100,  101,	101,  102,	102,
			  103,	104,  104,	105,  105,	105,  105,	105,  105,	105,
			  105,	105,  105,	105,  105,	105,  106,	106,  106,	106,
			  106,	106,  106,	106,  106,	106,  107,	107,  108,	108,
			  109,	109,  109,	109,  109,	109,  109,	109,  109,	109,

			   81,	110,  110,	110,  110,	110,  110,	110,  110,	110,
			  110,	110,  112,	112,  112,	112,  112,	112,  111,	111,
			  111,	111,  111,	113,  113,	113,  113,	113,  113,	113,
			  113,	113,  113,	114,  114,	115,  115,	116,  116,	116,
			  116,	117,  117,	117,  117,	118,  118,	119,  120,	120,
			  121,	122,  122,	122,  122,	122,  122,	122,  122,	122,
			  122,	123,  123, yyDummy>>)
		end

	yytypes1_template: SPECIAL [INTEGER] is
		once
			Result := yyfixed_array (<<
				3,	  1,	1,	  1,	1,	  1,	1,	  1,	1,	  1,
				1,	  1,	1,	  1,	1,	  1,	1,	  2,	2,	  3,
				3,	  3,	3,	  3,	2,	  5,	6,	  5,	5,	  5,
				5,	  5,	5,	  2,	2,	  2,	2,	  2,	2,	  1,
				1,	  3,	1,	  1,	3,	  3,	5,	  2,	2,	  2,
				5,	  1,	5,	  1,	1,	  2,	2,	  3,	3,	  1,
				1,	  1,	1,	  1,	1,	  1,	1,	  1,	1,	  1,
				1,	  1,	1,	  1,	1,	  1,	1,	  1,	1,	  1,
				1,	  1,	1,	  2,	3,	  3,	5,	  3,	3,	  3,
				3,	  3,	3,	  7,	6,	  3,	3,	  3,	1,	  1,

				1,	  3,	1,	  3,	1,	  1,	3,	  1,	1,	  1,
				2,	  4,	1,	  1,	1,	  1,	1,	  1,	1,	  2,
				3,	  5,	3,	  3,	3,	  3,	7,	  3,	3,	  4,
				3,	  1,	3,	  3,	3,	  1,	3,	  1,	1,	  1,
				1,	  1,	1,	  1,	1,	  2,	2,	  1,	3,	  1,
				4,	  1,	1,	  1,	1,	  3,	3,	  4,	4,	  3,
				1,	  1,	1,	  3,	3,	  3,	3,	  3,	3,	  3,
				1,	  1,	3,	  1,	1,	  1,	1,	  1,	1,	  1,
				1,	  1,	1,	  1,	1,	  1,	3,	  1,	1,	  1,
				1,	  3,	3,	  3,	1,	  3,	3,	  3,	3,	  3,

				3,	  1,	3,	  3,	3,	  1,	1,	  1,	3,	  1,
				3,	  1,	1,	  1,	1,	  1,	1,	  1,	1,	  3,
				3,	  3,	3,	  3,	3,	  3,	3,	  3,	3,	  3,
				2,	  2,	3,	  1,	1,	  1,	1,	  1,	1,	  1,
				3,	  3,	1,	  3,	3,	  3,	3,	  3,	3,	  3,
				1,	  1,	1,	  1,	1,	  3,	3,	  3,	3,	  1,
				1,	  1,	1,	  1,	3,	  2,	3,	  1,	1,	  1,
				1,	  1,	1,	  1,	3,	  3,	3,	  1,	3,	  1,
				1,	  1,	3,	  3,	3,	  3,	3,	  1,	1,	  3,
				3,	  3,	3,	  3,	3,	  3,	1,	  1,	3,	  3,

				2,	  1,	1,	  1,	1,	  1,	1,	  1,	1,	  1,
				3,	  3,	3,	  3,	3,	  3,	1,	  1,	3,	  3,
				1,	  3,	1,	  3,	1,	  3,	1,	  3,	1,	  3,
				1,	  3,	1,	  3,	1,	  3,	1,	  3,	1,	  3,
				1,	  3,	1,	  1,	1, yyDummy>>)
		end

	yytypes2_template: SPECIAL [INTEGER] is
		once
			Result := yyfixed_array (<<
				1,	  1,	1,	  2,	2,	  1,	1,	  1,	1,	  1,
				1,	  1,	1,	  1,	1,	  1,	1,	  1,	1,	  1,
				1,	  1,	1,	  1,	1,	  1,	1,	  1,	1,	  1,
				1,	  1,	1,	  1,	1,	  1,	1,	  1,	1,	  1,
				1,	  1,	1,	  1,	1,	  1,	1,	  1,	1,	  1,
				1,	  1,	1,	  1,	1,	  1,	1,	  1,	1,	  1,
				1,	  1,	1,	  1,	1,	  1,	1,	  1,	1,	  1,
				1,	  1,	1,	  1,	1,	  1,	1,	  1,	1,	  4,
				2, yyDummy>>)
		end

	yydefact_template: SPECIAL [INTEGER] is
		once
			Result := yyfixed_array (<<
				0,	 13,   16,	 17,   18,	 15,   14,	 40,   41,	 59,
			   44,	 55,   57,	 53,   43,	 51,   42,	  0,	0,	  0,
				1,	  3,	4,	  0,	0,	  0,	0,	 25,   45,	 46,
			   47,	 48,   49,	 60,   58,	 54,   56,	 52,   50,	 12,
			   10,	  2,	0,	  0,	0,	 19,	0,	  0,	0,	  0,
			   24,	  0,	0,	 21,	0,	 33,   29,	 22,   26,	  0,
			   11,	  9,	0,	  0,	0,	  0,   88,	 89,	0,	  0,
				0,	 73,	0,	160,  153,	159,  158,	157,  156,	155,
			  151,	152,  154,	  0,   70,	  0,	0,	  0,   61,	 68,
				0,	 87,	0,	  0,	0,	  0,   23,	 20,	0,	  0,

				0,	 32,	0,	 28,	0,	  0,	0,	  0,	0,	  0,
			  105,	150,	0,	  0,  144,	143,  142,	141,	0,	103,
			   98,	  0,	0,	 90,	0,	108,  106,	102,	0,	101,
			  107,	  0,	0,	  0,	0,	 72,	0,	  0,	0,	  0,
				0,	  0,	0,	 12,   69,	 33,   29,	  8,   62,	 67,
			   86,	 63,   64,	  0,   65,	  0,   36,	  0,	0,	 27,
				0,	  0,	0,	  0,	0,	  0,  122,	 97,	0,	  0,
				0,	  0,  100,	  0,	0,	  0,	0,	117,  116,	115,
			  114,	113,  112,	  0,	0,	 66,	0,	  0,	0,	  0,
				0,	  0,   76,	 74,   71,	127,  126,	125,  124,	123,

				0,	134,  135,	  0,	0,	  7,   34,	 30,	0,	  0,
			   78,	  0,	0,	  0,	0,	  0,	0,	109,  118,	  0,
			   91,	 92,   94,	 96,   95,	 93,  119,	120,  121,	  0,
			  146,	145,	0,	  0,	0,	  0,	0,	133,	0,	  0,
			   35,	 31,	6,	  0,	0,	  0,   82,	  0,   80,	  0,
			  104,	  0,	0,	  0,  140,	  0,	0,	  0,   75,	  0,
				0,	  0,	0,	  0,  136,	103,	0,	  0,	5,	  0,
				0,	  0,	0,	  0,   99,	  0,  148,	139,	0,	  0,
			  138,	  0,  132,	131,  130,	129,  128,	161,	0,	  0,
			   38,	 79,	0,	 83,	0,	  0,  147,	137,  149,	  0,

				0,	  0,   37,	  0,	0,	  0,	0,	110,	0,	162,
			   39,	  0,   84,	 81,	0,	 77,	0,	  0,   85,	  0,
				0,	  0,	0,	  0,	0,	  0,	0,	  0,	0,	  0,
				0,	  0,	0,	  0,	0,	  0,	0,	  0,	0,	  0,
				0,	  0,  111,	  0,	0, yyDummy>>)
		end

	yydefgoto_template: SPECIAL [INTEGER] is
		once
			Result := yyfixed_array (<<
			  120,	 19,   20,	 21,   84,	 23,   24,	 44,   85,	 86,
			   57,	 58,  101,	289,  240,	 26,  121,	 28,   29,	 30,
			   31,	 32,   34,	 87,   88,	 89,   90,	 91,  132,	123,
			  124,	186,  125,	126,  203,	127,  128,	232,  255,	256,
			  129,	 94,  130, yyDummy>>)
		end

	yypact_template: SPECIAL [INTEGER] is
		once
			Result := yyfixed_array (<<
			 1838, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,	119,
			 -32768,  119,	119,  119, -32768,	119, -32768,  168,	166, 1820,
			 -32768, -32768, -32768, 1791,	192,  123,	417, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768,  162,	365,  -11, -32768,	 87,  160,	159,  155,
			 -32768, 1278,	 87,  878,	152,   77,	  3,   95, -32768, 1781,
			 -32768, -32768,  153,	136,  134,	771, -32768, -32768,  133,	771,
			  771, -32768, 1230, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768,  262, -32768,	126,  121, 1182, -32768, -32768,
			  124,	 52,  122,	108,  112,	104,   95, -32768, 1278,  771,

			   52, -32768,	 52, -32768,   87,	 96,  -14,	694,  771,	771,
			 -32768, -32768,  771,	771, -32768, -32768, -32768, -32768,  771,	199,
			 -32768,  771, 1669, -32768,   13, -32768, -32768, -32768,	 93, -32768,
			 -32768,  771,	745,  926,	926, -32768, 1134,	771,  771,	771,
			  771,	771,  771,	771, -32768,   50,	 31, -32768, -32768, -32768,
			 -32768, -32768, -32768,  771, -32768, 1086,  745,	 83,   63, -32768,
			 1278,	 43, 1278, 1627, 1277,	503, -32768, -32768,  447,	 -3,
			  771,	617, -32768,  771,	771,  771,	771, -32768, -32768, -32768,
			 -32768, -32768, -32768,  771,	771, -32768,  771,	771,  771,	771,
				1, 1644, -32768,   41, -32768,	745,  745,	745,  745,	745,

			 1709, -32768,	745,   85, 1602, -32768,   33,	 33, 1038, 1278,
			 -32768,  771,	771, 1278,	771, 1278,	771, -32768, -32768, 1694,
			 -32768,  -10,	-31,  -27,	-27,  -10,	745, -32768,   -9,	668,
			 -32768, -32768,  -18,	771, 1278,	120,  771, -32768,	848,   18,
			 -32768, -32768, -32768,  990, 1369,  422, -32768, 1584, -32768, 1559,
			  120,	771,  771,	771, -32768,   80,	 65,  -28, -32768,	771,
			  771,	771,  771,	771,  745,	407, 1541,	771, -32768, 1278,
			  771, 1278,  771,	771,  745, 1684,  745, -32768,	 51,  771,
			 -32768,  771,	745,  745,	745,  745,	745, -32768,   28,	-19,
			  745, -32768,	205, -32768, 1344,	 34, -32768, -32768,  745, 1323,

				9,	771, -32768,  771, 1278, 1278,	771, -32768, 1278, -32768,
			  745, 1298, -32768, -32768, 1516, -32768, 1278,  771, -32768, 1498,
			  771, 1473,  771, 1455,  771, 1430,  771, 1412,  771, 1387,
			  771,	842,  771,	765,  771,	688,  771,	611,  771,	 78,
			  771,	101, -32768,   25, -32768, yyDummy>>)
		end

	yypgoto_template: SPECIAL [INTEGER] is
		once
			Result := yyfixed_array (<<
			 -32768, -32768,  186, -32768,	 10, -32768, -32768,  145,	-17,   11,
			  154,	 99,  -54, -32768,	 -6, -32768,	0, -32768, -32768, -32768,
			 -32768, -32768,   82,	-71,  -78, -32768, -32768, -32768,	 79, -32768,
			  -66, -32768,	349,  297, -32768, -32768, -32768, -32768, -32768,	-53,
			  -69, -32768,	231, yyDummy>>)
		end

	yytable_template: SPECIAL [INTEGER] is
		once
			Result := yyfixed_array (<<
			   27,	136,  103,	133,  134,	231,   45,	281,  184,	148,
			   22,	 25,  184,	254,  302,	301,  253,	161,  252,	 27,
			   54,	 53,  150,	 27,   53,	344,   50,	155,  218,	 22,
			   25,	157,  300,	158,   46,	189,   97,	188,  187,	102,
			  309,	 99,   45,	 27,  174,	173,  166,	175,  174,	173,
			  267,	 27,  169,	 27,   52,	192,  193,	187,  148,	 27,
			  189,	 61,  188,	187,   46,	307,  173,	102,  306,	 99,
			   46,	239,   27,	184,  183,	209,  189,	148,  188,	187,
			   60,	230,  297,	234,  210,	279,  100,	 27,   99,	208,
			   56,	 55,  103,	 35,   36,	 37,  280,	 38,   27,	279,

			  207,	182,  181,	180,  179,	178,  177,	176,  175,	174,
			  173,	277,  340,	100,  253,	 99,  237,	184,  183,	236,
			  206,	227,  228,	190,  146,	145,   49,	 48,  160,	104,
			  148,	111,  342,	 27,   27,	246,   27,	248,  243,	154,
			  184,	183,  153,	152,  122,	182,  181,	180,  179,	178,
			  177,	176,  175,	174,  173,	 27,  258,	151,  263,	149,
			   27,	144,   27,	131,  109,	148,  108,	257,  182,	181,
			  180,	179,  178,	177,  176,	175,  174,	173,  156,	262,
			  261,	260,  259,	107,   98,	 61,  163,	164,  165,	 60,
			   59,	291,  167,	293,   51,	 47,   40,	168,   39,	 33,

			  172,	241,  278,	159,  106,	 41,   96,	  0,   27,	 27,
			  191,	  0,	0,	 27,	0,	 27,  195,	196,  197,	198,
			  199,	200,  202,	  0,	0,	  0,  312,	313,	0,	171,
			  315,	  0,  204,	  0,   27,	170,  304,	141,  318,	303,
				0,	  0,	0,	 27,  184,	183,	0,	  0,	0,	219,
			  202,	  0,  220,	221,  222,	223,	0,	  0,  140,	139,
			  138,	137,  224,	225,	0,	226,	0,	  0,  229,	 27,
				0,	 27,  182,	181,  180,	179,  178,	177,  176,	175,
			  174,	173,   95,	  0,	0,	  0,	0,	  0,	0,	  0,
			  244,	245,  143,	247,	0,	249,	0,	  0,  142,	  0,

			  141,	  0,	0,	 95,   27,	 27,	0,	  0,   27,	  0,
				0,	  0,	0,	  0,	0,	264,   27,	266,   95,	  0,
				0,	140,  139,	138,  137,	  0,	0,	  0,	0,	 95,
			  274,	275,  276,	  0,	0,	  0,	0,	  0,  282,	283,
			  284,	285,  286,	  0,	0,	  0,  290,	  0,   93,	292,
				0,	294,  295,	  0,	0,	  0,	0,	  0,  298,	  0,
			  299,	  0,	0,	  0,   95,	 95,	0,	 95,	0,	 93,
			   16,	 15,   14,	 13,   12,	 11,   10,	  9,	8,	  7,
			  310,	  0,  311,	  0,   93,	314,   95,	  0,	0,	  0,
				0,	 95,	0,	 95,	0,	 93,  319,	  0,	0,	321,

			   92,	323,	0,	325,	0,	327,	0,	329,	0,	331,
				0,	333,	0,	335,	0,	337,	0,	339,	0,	341,
				0,	 92,   16,	 15,   14,	 13,   12,	 11,   10,	  9,
			   93,	 93,	0,	 93,	0,	  0,   92,	171,  287,	 95,
			   95,	  0,	0,	170,   95,	141,   95,	 92,	0,	  0,
				0,	  0,   93,	271,	0,	  0,  270,	 93,	0,	 93,
				0,	184,  183,	  0,	0,	 95,  140,	139,  138,	137,
				0,	  0,	0,	  0,   95,	  0,	0,	  0,  217,	  0,
				0,	216,   92,	 92,	0,	 92,  184,	183,	0,	182,
			  181,	180,  179,	178,  177,	176,  175,	174,  173,	  0,

			   95,	  0,   95,	  0,   92,	 93,   93,	  0,	0,	 92,
			   93,	 92,   93,	  0,  182,	181,  180,	179,  178,	177,
			  176,	175,  174,	173,	0,	  0,	0,	  0,	0,	  0,
				0,	 93,	0,	  0,  215,	 95,   95,	214,	0,	 95,
			   93,	  0,  184,	183,	0,	  0,	0,	 95,	0,	  0,
				0,	  0,	0,	  0,	0,	  0,	0,	 92,   92,	  0,
				0,	  0,   92,	  0,   92,	  0,   93,	  0,   93,	  0,
			  182,	181,  180,	179,  178,	177,  176,	175,  174,	173,
				0,	  0,	0,	 92,	0,	  0,	0,	  0,	0,	  0,
				0,	  0,   92,	  0,	0,	  0,	0,	  0,	0,	  0,

				0,	 93,   93,	  0,	0,	 93,	0,	  0,	0,	  0,
				0,	  0,	0,	 93,	0,	  0,	0,	  0,   92,	  0,
			   92,	119,   16,	 15,   14,	 13,   12,	 11,   10,	  9,
				0,	  0,   82,	  0,	0,	  0,   81,	  0,   80,	 79,
			   78,	 77,   76,	 75,   74,	338,   73,	118,  201,	  0,
			  184,	183,	0,	 92,   92,	  0,	0,	 92,	0,	  0,
				0,	  0,	0,	  0,	0,	 92,	0,	  0,  117,	116,
			  115,	114,	0,	  0,	0,	  0,	0,	  0,  182,	181,
			  180,	179,  178,	177,  176,	175,  174,	173,	0,	  0,
			  113,	  0,	0,	  0,	0,	112,  111,	110,  119,	 16,

			   15,	 14,   13,	 12,   11,	 10,	9,	184,  183,	 82,
				0,	  0,	0,	 81,	0,	 80,   79,	 78,   77,	 76,
			   75,	 74,  336,	 73,  118,	162,	0,	184,  183,	  0,
				0,	  0,  251,	  0,	0,	182,  181,	180,  179,	178,
			  177,	176,  175,	174,  173,	117,  116,	115,  114,	  0,
				0,	  0,	0,	  0,	0,	182,  181,	180,  179,	178,
			  177,	176,  175,	174,  173,	  0,	0,	113,	0,	  0,
				0,	  0,  112,	111,  110,	119,   16,	 15,   14,	 13,
			   12,	 11,   10,	  9,  184,	183,   82,	  0,	0,	  0,
			   81,	  0,   80,	 79,   78,	 77,   76,	 75,   74,	334,

			   73,	118,	0,	  0,  184,	183,	0,	  0,	0,	  0,
				0,	  0,  182,	181,  180,	179,  178,	177,  176,	175,
			  174,	173,  117,	116,  115,	114,	0,	  0,	0,	  0,
				0,	  0,  182,	181,  180,	179,  178,	177,  176,	175,
			  174,	173,	0,	  0,  113,	  0,	0,	  0,	0,	112,
			  111,	110,  265,	 16,   15,	 14,   13,	 12,   11,	 10,
				9,	  0,	0,	 82,	0,	  0,	0,	 81,	0,	 80,
			   79,	 78,   77,	 76,   75,	 74,  332,	 73,  118,	  0,
				0,	184,  183,	 16,   15,	 14,   13,	 12,   11,	 10,
				9,	  8,	7,	  0,	0,	  0,	0,	  0,	0,	117,

			  116,	115,  114,	  0,	0,	  0,   43,	  0,	0,	182,
			  181,	180,  179,	178,  177,	176,  175,	174,  173,	  0,
				0,	113,	0,	  0,	0,	  0,  112,	111,  110,	 18,
			   83,	 16,   15,	 14,   13,	 12,   11,	 10,	9,	  8,
				7,	 82,	0,	  0,	0,	 81,	0,	 80,   79,	 78,
			   77,	 76,   75,	 74,   43,	 73,	0,	  0,   72,	  0,
				0,	 71,	0,	  0,	0,	  0,	0,	 70,	0,	 69,
			   68,	 67,   66,	 65,   64,	 63,   62,	  0,	0,	  0,
				0,	  0,	0,	  0,	0,	  0,	0,	  0,	0,	189,
				0,	188,  187,	 18,   83,	 16,   15,	 14,   13,	 12,

			   11,	 10,	9,	  8,	7,	 82,	0,	  0,	0,	 81,
				0,	 80,   79,	 78,   77,	 76,   75,	 74,   43,	 73,
				0,	  0,   72,	268,	0,	 71,	0,	  0,	0,	  0,
				0,	 70,	0,	 69,   68,	 67,   66,	 65,   64,	 63,
			   62,	 18,   83,	 16,   15,	 14,   13,	 12,   11,	 10,
				9,	  8,	7,	 82,	0,	  0,	0,	 81,	0,	 80,
			   79,	 78,   77,	 76,   75,	 74,   43,	 73,	0,	  0,
			   72,	242,	0,	 71,	0,	  0,	0,	  0,	0,	 70,
				0,	 69,   68,	 67,   66,	 65,   64,	 63,   62,	 18,
			   83,	 16,   15,	 14,   13,	 12,   11,	 10,	9,	  8,

				7,	 82,	0,	  0,	0,	 81,	0,	 80,   79,	 78,
			   77,	 76,   75,	 74,   43,	 73,	0,	  0,   72,	205,
				0,	 71,	0,	  0,	0,	  0,	0,	 70,	0,	 69,
			   68,	 67,   66,	 65,   64,	 63,   62,	 18,   83,	 16,
			   15,	 14,   13,	 12,   11,	 10,	9,	  8,	7,	 82,
				0,	  0,	0,	 81,	0,	 80,   79,	 78,   77,	 76,
			   75,	 74,   43,	 73,	0,	  0,   72,	194,	0,	 71,
				0,	  0,	0,	  0,	0,	 70,	0,	 69,   68,	 67,
			   66,	 65,   64,	 63,   62,	 18,   83,	 16,   15,	 14,
			   13,	 12,   11,	 10,	9,	  8,	7,	 82,	0,	  0,

				0,	 81,	0,	 80,   79,	 78,   77,	 76,   75,	 74,
			   43,	 73,	0,	  0,   72,	147,	0,	 71,	0,	  0,
				0,	  0,	0,	 70,	0,	 69,   68,	 67,   66,	 65,
			   64,	 63,   62,	 18,   83,	 16,   15,	 14,   13,	 12,
			   11,	 10,	9,	  8,	7,	 82,	0,	  0,	0,	 81,
				0,	 80,   79,	 78,   77,	 76,   75,	 74,   43,	 73,
				0,	  0,   72,	135,	0,	 71,	0,	  0,	0,	  0,
				0,	 70,	0,	 69,   68,	 67,   66,	 65,   64,	 63,
			   62,	 18,   83,	 16,   15,	 14,   13,	 12,   11,	 10,
				9,	  8,	7,	 82,	0,	  0,	0,	 81,	0,	 80,

			   79,	 78,   77,	 76,   75,	 74,   43,	 73,  213,	  0,
			   72,	212,	0,	 71,	0,	  0,  184,	183,	0,	 70,
				0,	 69,   68,	 67,   66,	 65,   64,	 63,   62,	316,
				0,	  0,	0,	  0,	0,	  0,	0,	184,  183,	  0,
				0,	  0,	0,	  0,  182,	181,  180,	179,  178,	177,
			  176,	175,  174,	173,  308,	  0,	0,	  0,	0,	  0,
				0,	  0,  184,	183,	0,	182,  181,	180,  179,	178,
			  177,	176,  175,	174,  173,	305,	0,	  0,	0,	  0,
				0,	  0,	0,	184,  183,	  0,	0,	  0,	0,	  0,
			  182,	181,  180,	179,  178,	177,  176,	175,  174,	173,

			  269,	  0,	0,	  0,	0,	  0,	0,	  0,  184,	183,
				0,	182,  181,	180,  179,	178,  177,	176,  175,	174,
			  173,	330,	0,	  0,	0,	  0,  184,	183,	0,	  0,
				0,	  0,	0,	  0,	0,	  0,  182,	181,  180,	179,
			  178,	177,  176,	175,  174,	173,  328,	  0,	0,	  0,
				0,	184,  183,	  0,  182,	181,  180,	179,  178,	177,
			  176,	175,  174,	173,  326,	  0,	0,	  0,	0,	184,
			  183,	  0,	0,	  0,	0,	  0,	0,	  0,	0,	182,
			  181,	180,  179,	178,  177,	176,  175,	174,  173,	324,
				0,	  0,	0,	  0,  184,	183,	0,	182,  181,	180,

			  179,	178,  177,	176,  175,	174,  173,	322,	0,	  0,
				0,	  0,  184,	183,	0,	  0,	0,	  0,	0,	  0,
				0,	  0,  182,	181,  180,	179,  178,	177,  176,	175,
			  174,	173,  320,	  0,	0,	  0,	0,	184,  183,	  0,
			  182,	181,  180,	179,  178,	177,  176,	175,  174,	173,
			  317,	  0,	0,	  0,	0,	184,  183,	  0,	0,	  0,
				0,	  0,	0,	  0,	0,	182,  181,	180,  179,	178,
			  177,	176,  175,	174,  173,	288,	0,	  0,	0,	  0,
			  184,	183,	0,	182,  181,	180,  179,	178,  177,	176,
			  175,	174,  173,	273,	0,	  0,	0,	  0,  184,	183,

				0,	  0,	0,	  0,	0,	  0,	0,	  0,  182,	181,
			  180,	179,  178,	177,  176,	175,  174,	173,  272,	  0,
				0,	  0,	0,	184,  183,	  0,  182,	181,  180,	179,
			  178,	177,  176,	175,  174,	173,  238,	  0,	0,	  0,
				0,	184,  183,	  0,	0,	  0,	0,	  0,	0,	  0,
				0,	182,  181,	180,  179,	178,  177,	176,  175,	174,
			  173,	211,	0,	  0,	0,	  0,  184,	183,	0,	182,
			  181,	180,  179,	178,  177,	176,  175,	174,  173,	233,
				0,	  0,	0,	184,  183,	  0,	0,	  0,	0,	  0,
				0,	  0,	0,	  0,  182,	181,  180,	179,  178,	177,

			  176,	175,  174,	173,  185,	  0,	0,	  0,  184,	183,
				0,	182,  181,	180,  179,	178,  177,	176,  175,	174,
			  173,	296,	0,	184,  183,	  0,	0,	  0,	0,	  0,
				0,	250,	0,	184,  183,	  0,  182,	181,  180,	179,
			  178,	177,  176,	175,  174,	173,  235,	  0,  184,	183,
				0,	182,  181,	180,  179,	178,  177,	176,  175,	174,
			  173,	182,  181,	180,  179,	178,  177,	176,  175,	174,
			  173,	  0,	0,	  0,	0,	  0,  182,	181,  180,	179,
			  178,	177,  176,	175,  174,	173,   16,	 15,   14,	 13,
			   12,	 11,   10,	  9,	8,	  7,   16,	 15,   14,	 13,

			   12,	 11,   10,	  9,	8,	  7,	0,	  0,	0,	 43,
				0,	  0,  105,	  0,	0,	  0,	0,	  0,	0,	 43,
			  343,	  0,   42,	 18,   17,	 16,   15,	 14,   13,	 12,
			   11,	 10,	9,	  8,	7,	  6,	5,	  4,	3,	  2,
				1,	 18,   17,	 16,   15,	 14,   13,	 12,   11,	 10,
				9,	  8,	7,	  6,	5,	  4,	3,	  2,	1, yyDummy>>)
		end

	yycheck_template: SPECIAL [INTEGER] is
		once
			Result := yyfixed_array (<<
				0,	 72,   56,	 69,   70,	  4,   23,	 35,   39,	 87,
				0,	  0,   39,	 31,   33,	 34,   34,	 31,   36,	 19,
			   31,	 35,   91,	 23,   35,	  0,   26,	 98,   31,	 19,
			   19,	100,	4,	102,   23,	 63,   53,	 65,   66,	 36,
			   31,	 38,   59,	 43,   75,	 76,  112,	 74,   75,	 76,
			   32,	 51,  118,	 53,   43,	133,  134,	 66,  136,	 59,
			   63,	 30,   65,	 66,   53,	 31,   76,	 36,   34,	 38,
			   59,	 38,   72,	 39,   40,	 32,   63,	155,   65,	 66,
			   30,	 80,   31,	 42,  162,	 34,   36,	 87,   38,	160,
				3,	  4,  146,	 11,   12,	 13,   31,	 15,   98,	 34,

			   37,	 67,   68,	 69,   70,	 71,   72,	 73,   74,	 75,
			   76,	 31,   34,	 36,   34,	 38,   31,	 39,   40,	 34,
			   37,	187,  188,	 30,	3,	  4,	3,	  4,   32,	 34,
			  208,	 79,   31,	133,  134,	213,  136,	215,  209,	 35,
			   39,	 40,   30,	 35,   65,	 67,   68,	 69,   70,	 71,
			   72,	 73,   74,	 75,   76,	155,  234,	 35,   38,	 35,
			  160,	 35,  162,	 30,   30,	243,   30,	233,   67,	 68,
			   69,	 70,   71,	 72,   73,	 74,   75,	 76,   99,	 59,
			   60,	 61,   62,	 30,   32,	 30,  107,	108,  109,	 30,
			   30,	269,  113,	271,   32,	  3,   30,	118,   30,	 80,

			  121,	207,  255,	104,   59,	 19,   52,	 -1,  208,	209,
			  131,	 -1,   -1,	213,   -1,	215,  137,	138,  139,	140,
			  141,	142,  143,	 -1,   -1,	 -1,  304,	305,   -1,	 30,
			  308,	 -1,  153,	 -1,  234,	 36,   31,	 38,  316,	 34,
			   -1,	 -1,   -1,	243,   39,	 40,   -1,	 -1,   -1,	170,
			  171,	 -1,  173,	174,  175,	176,   -1,	 -1,   59,	 60,
			   61,	 62,  183,	184,   -1,	186,   -1,	 -1,  189,	269,
			   -1,	271,   67,	 68,   69,	 70,   71,	 72,   73,	 74,
			   75,	 76,   51,	 -1,   -1,	 -1,   -1,	 -1,   -1,	 -1,
			  211,	212,   30,	214,   -1,	216,   -1,	 -1,   36,	 -1,

			   38,	 -1,   -1,	 72,  304,	305,   -1,	 -1,  308,	 -1,
			   -1,	 -1,   -1,	 -1,   -1,	236,  316,	238,   87,	 -1,
			   -1,	 59,   60,	 61,   62,	 -1,   -1,	 -1,   -1,	 98,
			  251,	252,  253,	 -1,   -1,	 -1,   -1,	 -1,  259,	260,
			  261,	262,  263,	 -1,   -1,	 -1,  267,	 -1,   51,	270,
			   -1,	272,  273,	 -1,   -1,	 -1,   -1,	 -1,  279,	 -1,
			  281,	 -1,   -1,	 -1,  133,	134,   -1,	136,   -1,	 72,
				5,	  6,	7,	  8,	9,	 10,   11,	 12,   13,	 14,
			  301,	 -1,  303,	 -1,   87,	306,  155,	 -1,   -1,	 -1,
			   -1,	160,   -1,	162,   -1,	 98,  317,	 -1,   -1,	320,

			   51,	322,   -1,	324,   -1,	326,   -1,	328,   -1,	330,
			   -1,	332,   -1,	334,   -1,	336,   -1,	338,   -1,	340,
			   -1,	 72,	5,	  6,	7,	  8,	9,	 10,   11,	 12,
			  133,	134,   -1,	136,   -1,	 -1,   87,	 30,   31,	208,
			  209,	 -1,   -1,	 36,  213,	 38,  215,	 98,   -1,	 -1,
			   -1,	 -1,  155,	 31,   -1,	 -1,   34,	160,   -1,	162,
			   -1,	 39,   40,	 -1,   -1,	234,   59,	 60,   61,	 62,
			   -1,	 -1,   -1,	 -1,  243,	 -1,   -1,	 -1,   31,	 -1,
			   -1,	 34,  133,	134,   -1,	136,   39,	 40,   -1,	 67,
			   68,	 69,   70,	 71,   72,	 73,   74,	 75,   76,	 -1,

			  269,	 -1,  271,	 -1,  155,	208,  209,	 -1,   -1,	160,
			  213,	162,  215,	 -1,   67,	 68,   69,	 70,   71,	 72,
			   73,	 74,   75,	 76,   -1,	 -1,   -1,	 -1,   -1,	 -1,
			   -1,	234,   -1,	 -1,   31,	304,  305,	 34,   -1,	308,
			  243,	 -1,   39,	 40,   -1,	 -1,   -1,	316,   -1,	 -1,
			   -1,	 -1,   -1,	 -1,   -1,	 -1,   -1,	208,  209,	 -1,
			   -1,	 -1,  213,	 -1,  215,	 -1,  269,	 -1,  271,	 -1,
			   67,	 68,   69,	 70,   71,	 72,   73,	 74,   75,	 76,
			   -1,	 -1,   -1,	234,   -1,	 -1,   -1,	 -1,   -1,	 -1,
			   -1,	 -1,  243,	 -1,   -1,	 -1,   -1,	 -1,   -1,	 -1,

			   -1,	304,  305,	 -1,   -1,	308,   -1,	 -1,   -1,	 -1,
			   -1,	 -1,   -1,	316,   -1,	 -1,   -1,	 -1,  269,	 -1,
			  271,	  4,	5,	  6,	7,	  8,	9,	 10,   11,	 12,
			   -1,	 -1,   15,	 -1,   -1,	 -1,   19,	 -1,   21,	 22,
			   23,	 24,   25,	 26,   27,	 34,   29,	 30,   31,	 -1,
			   39,	 40,   -1,	304,  305,	 -1,   -1,	308,   -1,	 -1,
			   -1,	 -1,   -1,	 -1,   -1,	316,   -1,	 -1,   51,	 52,
			   53,	 54,   -1,	 -1,   -1,	 -1,   -1,	 -1,   67,	 68,
			   69,	 70,   71,	 72,   73,	 74,   75,	 76,   -1,	 -1,
			   73,	 -1,   -1,	 -1,   -1,	 78,   79,	 80,	4,	  5,

				6,	  7,	8,	  9,   10,	 11,   12,	 39,   40,	 15,
			   -1,	 -1,   -1,	 19,   -1,	 21,   22,	 23,   24,	 25,
			   26,	 27,   34,	 29,   30,	 31,   -1,	 39,   40,	 -1,
			   -1,	 -1,   64,	 -1,   -1,	 67,   68,	 69,   70,	 71,
			   72,	 73,   74,	 75,   76,	 51,   52,	 53,   54,	 -1,
			   -1,	 -1,   -1,	 -1,   -1,	 67,   68,	 69,   70,	 71,
			   72,	 73,   74,	 75,   76,	 -1,   -1,	 73,   -1,	 -1,
			   -1,	 -1,   78,	 79,   80,	  4,	5,	  6,	7,	  8,
				9,	 10,   11,	 12,   39,	 40,   15,	 -1,   -1,	 -1,
			   19,	 -1,   21,	 22,   23,	 24,   25,	 26,   27,	 34,

			   29,	 30,   -1,	 -1,   39,	 40,   -1,	 -1,   -1,	 -1,
			   -1,	 -1,   67,	 68,   69,	 70,   71,	 72,   73,	 74,
			   75,	 76,   51,	 52,   53,	 54,   -1,	 -1,   -1,	 -1,
			   -1,	 -1,   67,	 68,   69,	 70,   71,	 72,   73,	 74,
			   75,	 76,   -1,	 -1,   73,	 -1,   -1,	 -1,   -1,	 78,
			   79,	 80,	4,	  5,	6,	  7,	8,	  9,   10,	 11,
			   12,	 -1,   -1,	 15,   -1,	 -1,   -1,	 19,   -1,	 21,
			   22,	 23,   24,	 25,   26,	 27,   34,	 29,   30,	 -1,
			   -1,	 39,   40,	  5,	6,	  7,	8,	  9,   10,	 11,
			   12,	 13,   14,	 -1,   -1,	 -1,   -1,	 -1,   -1,	 51,

			   52,	 53,   54,	 -1,   -1,	 -1,   28,	 -1,   -1,	 67,
			   68,	 69,   70,	 71,   72,	 73,   74,	 75,   76,	 -1,
			   -1,	 73,   -1,	 -1,   -1,	 -1,   78,	 79,   80,	  3,
				4,	  5,	6,	  7,	8,	  9,   10,	 11,   12,	 13,
			   14,	 15,   -1,	 -1,   -1,	 19,   -1,	 21,   22,	 23,
			   24,	 25,   26,	 27,   28,	 29,   -1,	 -1,   32,	 -1,
			   -1,	 35,   -1,	 -1,   -1,	 -1,   -1,	 41,   -1,	 43,
			   44,	 45,   46,	 47,   48,	 49,   50,	 -1,   -1,	 -1,
			   -1,	 -1,   -1,	 -1,   -1,	 -1,   -1,	 -1,   -1,	 63,
			   -1,	 65,   66,	  3,	4,	  5,	6,	  7,	8,	  9,

			   10,	 11,   12,	 13,   14,	 15,   -1,	 -1,   -1,	 19,
			   -1,	 21,   22,	 23,   24,	 25,   26,	 27,   28,	 29,
			   -1,	 -1,   32,	 33,   -1,	 35,   -1,	 -1,   -1,	 -1,
			   -1,	 41,   -1,	 43,   44,	 45,   46,	 47,   48,	 49,
			   50,	  3,	4,	  5,	6,	  7,	8,	  9,   10,	 11,
			   12,	 13,   14,	 15,   -1,	 -1,   -1,	 19,   -1,	 21,
			   22,	 23,   24,	 25,   26,	 27,   28,	 29,   -1,	 -1,
			   32,	 33,   -1,	 35,   -1,	 -1,   -1,	 -1,   -1,	 41,
			   -1,	 43,   44,	 45,   46,	 47,   48,	 49,   50,	  3,
				4,	  5,	6,	  7,	8,	  9,   10,	 11,   12,	 13,

			   14,	 15,   -1,	 -1,   -1,	 19,   -1,	 21,   22,	 23,
			   24,	 25,   26,	 27,   28,	 29,   -1,	 -1,   32,	 33,
			   -1,	 35,   -1,	 -1,   -1,	 -1,   -1,	 41,   -1,	 43,
			   44,	 45,   46,	 47,   48,	 49,   50,	  3,	4,	  5,
				6,	  7,	8,	  9,   10,	 11,   12,	 13,   14,	 15,
			   -1,	 -1,   -1,	 19,   -1,	 21,   22,	 23,   24,	 25,
			   26,	 27,   28,	 29,   -1,	 -1,   32,	 33,   -1,	 35,
			   -1,	 -1,   -1,	 -1,   -1,	 41,   -1,	 43,   44,	 45,
			   46,	 47,   48,	 49,   50,	  3,	4,	  5,	6,	  7,
				8,	  9,   10,	 11,   12,	 13,   14,	 15,   -1,	 -1,

			   -1,	 19,   -1,	 21,   22,	 23,   24,	 25,   26,	 27,
			   28,	 29,   -1,	 -1,   32,	 33,   -1,	 35,   -1,	 -1,
			   -1,	 -1,   -1,	 41,   -1,	 43,   44,	 45,   46,	 47,
			   48,	 49,   50,	  3,	4,	  5,	6,	  7,	8,	  9,
			   10,	 11,   12,	 13,   14,	 15,   -1,	 -1,   -1,	 19,
			   -1,	 21,   22,	 23,   24,	 25,   26,	 27,   28,	 29,
			   -1,	 -1,   32,	 33,   -1,	 35,   -1,	 -1,   -1,	 -1,
			   -1,	 41,   -1,	 43,   44,	 45,   46,	 47,   48,	 49,
			   50,	  3,	4,	  5,	6,	  7,	8,	  9,   10,	 11,
			   12,	 13,   14,	 15,   -1,	 -1,   -1,	 19,   -1,	 21,

			   22,	 23,   24,	 25,   26,	 27,   28,	 29,   31,	 -1,
			   32,	 34,   -1,	 35,   -1,	 -1,   39,	 40,   -1,	 41,
			   -1,	 43,   44,	 45,   46,	 47,   48,	 49,   50,	 31,
			   -1,	 -1,   -1,	 -1,   -1,	 -1,   -1,	 39,   40,	 -1,
			   -1,	 -1,   -1,	 -1,   67,	 68,   69,	 70,   71,	 72,
			   73,	 74,   75,	 76,   31,	 -1,   -1,	 -1,   -1,	 -1,
			   -1,	 -1,   39,	 40,   -1,	 67,   68,	 69,   70,	 71,
			   72,	 73,   74,	 75,   76,	 31,   -1,	 -1,   -1,	 -1,
			   -1,	 -1,   -1,	 39,   40,	 -1,   -1,	 -1,   -1,	 -1,
			   67,	 68,   69,	 70,   71,	 72,   73,	 74,   75,	 76,

			   31,	 -1,   -1,	 -1,   -1,	 -1,   -1,	 -1,   39,	 40,
			   -1,	 67,   68,	 69,   70,	 71,   72,	 73,   74,	 75,
			   76,	 34,   -1,	 -1,   -1,	 -1,   39,	 40,   -1,	 -1,
			   -1,	 -1,   -1,	 -1,   -1,	 -1,   67,	 68,   69,	 70,
			   71,	 72,   73,	 74,   75,	 76,   34,	 -1,   -1,	 -1,
			   -1,	 39,   40,	 -1,   67,	 68,   69,	 70,   71,	 72,
			   73,	 74,   75,	 76,   34,	 -1,   -1,	 -1,   -1,	 39,
			   40,	 -1,   -1,	 -1,   -1,	 -1,   -1,	 -1,   -1,	 67,
			   68,	 69,   70,	 71,   72,	 73,   74,	 75,   76,	 34,
			   -1,	 -1,   -1,	 -1,   39,	 40,   -1,	 67,   68,	 69,

			   70,	 71,   72,	 73,   74,	 75,   76,	 34,   -1,	 -1,
			   -1,	 -1,   39,	 40,   -1,	 -1,   -1,	 -1,   -1,	 -1,
			   -1,	 -1,   67,	 68,   69,	 70,   71,	 72,   73,	 74,
			   75,	 76,   34,	 -1,   -1,	 -1,   -1,	 39,   40,	 -1,
			   67,	 68,   69,	 70,   71,	 72,   73,	 74,   75,	 76,
			   34,	 -1,   -1,	 -1,   -1,	 39,   40,	 -1,   -1,	 -1,
			   -1,	 -1,   -1,	 -1,   -1,	 67,   68,	 69,   70,	 71,
			   72,	 73,   74,	 75,   76,	 34,   -1,	 -1,   -1,	 -1,
			   39,	 40,   -1,	 67,   68,	 69,   70,	 71,   72,	 73,
			   74,	 75,   76,	 34,   -1,	 -1,   -1,	 -1,   39,	 40,

			   -1,	 -1,   -1,	 -1,   -1,	 -1,   -1,	 -1,   67,	 68,
			   69,	 70,   71,	 72,   73,	 74,   75,	 76,   34,	 -1,
			   -1,	 -1,   -1,	 39,   40,	 -1,   67,	 68,   69,	 70,
			   71,	 72,   73,	 74,   75,	 76,   34,	 -1,   -1,	 -1,
			   -1,	 39,   40,	 -1,   -1,	 -1,   -1,	 -1,   -1,	 -1,
			   -1,	 67,   68,	 69,   70,	 71,   72,	 73,   74,	 75,
			   76,	 34,   -1,	 -1,   -1,	 -1,   39,	 40,   -1,	 67,
			   68,	 69,   70,	 71,   72,	 73,   74,	 75,   76,	 35,
			   -1,	 -1,   -1,	 39,   40,	 -1,   -1,	 -1,   -1,	 -1,
			   -1,	 -1,   -1,	 -1,   67,	 68,   69,	 70,   71,	 72,

			   73,	 74,   75,	 76,   35,	 -1,   -1,	 -1,   39,	 40,
			   -1,	 67,   68,	 69,   70,	 71,   72,	 73,   74,	 75,
			   76,	 37,   -1,	 39,   40,	 -1,   -1,	 -1,   -1,	 -1,
			   -1,	 37,   -1,	 39,   40,	 -1,   67,	 68,   69,	 70,
			   71,	 72,   73,	 74,   75,	 76,   37,	 -1,   39,	 40,
			   -1,	 67,   68,	 69,   70,	 71,   72,	 73,   74,	 75,
			   76,	 67,   68,	 69,   70,	 71,   72,	 73,   74,	 75,
			   76,	 -1,   -1,	 -1,   -1,	 -1,   67,	 68,   69,	 70,
			   71,	 72,   73,	 74,   75,	 76,	5,	  6,	7,	  8,
				9,	 10,   11,	 12,   13,	 14,	5,	  6,	7,	  8,

				9,	 10,   11,	 12,   13,	 14,   -1,	 -1,   -1,	 28,
			   -1,	 -1,   31,	 -1,   -1,	 -1,   -1,	 -1,   -1,	 28,
				0,	 -1,   31,	  3,	4,	  5,	6,	  7,	8,	  9,
			   10,	 11,   12,	 13,   14,	 15,   16,	 17,   18,	 19,
			   20,	  3,	4,	  5,	6,	  7,	8,	  9,   10,	 11,
			   12,	 13,   14,	 15,   16,	 17,   18,	 19,   20, yyDummy>>)
		end

feature {NONE} -- Semantic value stacks

	yyvs1: SPECIAL [ANY]
			-- Stack for semantic values of type ANY

	yyvsc1: INTEGER
			-- Capacity of semantic value stack `yyvs1'

	yyvsp1: INTEGER
			-- Top of semantic value stack `yyvs1'

	yyspecial_routines1: KL_SPECIAL_ROUTINES [ANY]
			-- Routines that ought to be in SPECIAL [ANY]

	yyvs2: SPECIAL [STRING]
			-- Stack for semantic values of type STRING

	yyvsc2: INTEGER
			-- Capacity of semantic value stack `yyvs2'

	yyvsp2: INTEGER
			-- Top of semantic value stack `yyvs2'

	yyspecial_routines2: KL_SPECIAL_ROUTINES [STRING]
			-- Routines that ought to be in SPECIAL [STRING]

	yyvs3: SPECIAL [PARSE_NODE]
			-- Stack for semantic values of type PARSE_NODE

	yyvsc3: INTEGER
			-- Capacity of semantic value stack `yyvs3'

	yyvsp3: INTEGER
			-- Top of semantic value stack `yyvs3'

	yyspecial_routines3: KL_SPECIAL_ROUTINES [PARSE_NODE]
			-- Routines that ought to be in SPECIAL [PARSE_NODE]

	yyvs4: SPECIAL [REAL]
			-- Stack for semantic values of type REAL

	yyvsc4: INTEGER
			-- Capacity of semantic value stack `yyvs4'

	yyvsp4: INTEGER
			-- Top of semantic value stack `yyvs4'

	yyspecial_routines4: KL_SPECIAL_ROUTINES [REAL]
			-- Routines that ought to be in SPECIAL [REAL]

	yyvs5: SPECIAL [TYPE_AND_SPACE]
			-- Stack for semantic values of type TYPE_AND_SPACE

	yyvsc5: INTEGER
			-- Capacity of semantic value stack `yyvs5'

	yyvsp5: INTEGER
			-- Top of semantic value stack `yyvs5'

	yyspecial_routines5: KL_SPECIAL_ROUTINES [TYPE_AND_SPACE]
			-- Routines that ought to be in SPECIAL [TYPE_AND_SPACE]

	yyvs6: SPECIAL [INTEGER]
			-- Stack for semantic values of type INTEGER

	yyvsc6: INTEGER
			-- Capacity of semantic value stack `yyvs6'

	yyvsp6: INTEGER
			-- Top of semantic value stack `yyvs6'

	yyspecial_routines6: KL_SPECIAL_ROUTINES [INTEGER]
			-- Routines that ought to be in SPECIAL [INTEGER]

	yyvs7: SPECIAL [FUNCTION_CALL_PARSE_NODE]
			-- Stack for semantic values of type FUNCTION_CALL_PARSE_NODE

	yyvsc7: INTEGER
			-- Capacity of semantic value stack `yyvs7'

	yyvsp7: INTEGER
			-- Top of semantic value stack `yyvs7'

	yyspecial_routines7: KL_SPECIAL_ROUTINES [FUNCTION_CALL_PARSE_NODE]
			-- Routines that ought to be in SPECIAL [FUNCTION_CALL_PARSE_NODE]

feature {NONE} -- Constants

	yyFinal: INTEGER is 344
			-- Termination state id

	yyFlag: INTEGER is -32768
			-- Most negative INTEGER

	yyNtbase: INTEGER is 81
			-- Number of tokens

	yyLast: INTEGER is 1858
			-- Upper bound of `yytable' and `yycheck'

	yyMax_token: INTEGER is 335
			-- Maximum token id
			-- (upper bound of `yytranslate'.)

	yyNsyms: INTEGER is 124
			-- Number of symbols
			-- (terminal and nonterminal)

feature -- User-defined features



feature {NONE} -- Initialization
	
	make is
			-- Create a new RenderMan parser.
		do
			make_sl_scanner
			make_parser_skeleton
			create name_stack.make
			name_stack.put_first ("")
			name_stack.start
		end
	
feature {NONE} -- Implementation

	var: SL_VARIABLE
	func: SL_FUNCTION

	functions: DS_ARRAYED_LIST [SL_FUNCTION]
	
	name_stack: DS_LINKED_LIST [STRING]
	tmp_string: STRING
	tmp_integer: INTEGER
	
	root_node, node: PARSE_NODE
	children: DS_LINKED_LIST [PARSE_NODE]
	decl, declaration: DECLARATION_PARSE_NODE
	variable: VARIABLE_PARSE_NODE
	cast: CAST_PARSE_NODE
	assigner: ASSIGN_PARSE_NODE
	tmp_node: PARSE_NODE
	str_node: STRING_CONSTANT_PARSE_NODE
	found: BOOLEAN
	
feature -- Status report

	is_function (name: STRING): BOOLEAN is
			-- Is `name' a function?
		local
			str: STRING
		do
			str := name_stack.item_for_iteration.twin
			str.append (name)
			
			Result := function_list.has (str)
			
			-- Check global name space
			if not Result then
				Result := function_list.has (name)
			end
		end
	
	function_name (name: STRING): STRING is
			-- Return the `name' of the function in the current 
			-- scoping space
		local
			str: STRING
		do
			str := name_stack.item_for_iteration.twin
			str.append (name)
			
			if function_list.has (str) then
				Result := str
			else
				Result := name
			end
		end
	
	is_variable (name: STRING): BOOLEAN is
			-- Is `name' a variable?
		local
			str: STRING
		do
			str := name_stack.item_for_iteration.twin
			str.append (name)
			
			Result := variable_list.has (str)
			
			-- Check global name space
			if not Result then
				Result := variable_list.has (name)
			end
		end
	
	variable_name (name: STRING): STRING is
			-- Return the `name' of the variable in the current 
			-- scoping space
		local
			str: STRING
		do
			str := name_stack.item_for_iteration.twin
			str.append (name)
			
			if variable_list.has (str) then
				Result := str
			else
				Result := name
			end
		end
	
feature -- Error handling

	report_error (a_message: STRING) is
			-- Print error message.
		local
			f_buffer: YY_FILE_BUFFER
		do
			f_buffer ?= input_buffer
			if f_buffer /= Void then
				std.error.put_string (file_name)
				std.error.put_string (", line ")
			else
				std.error.put_string ("line ")
			end
			std.error.put_integer (eif_lineno)
			std.error.put_string (": ")
			std.error.put_string (a_message)
			std.error.put_character ('%N')
		end
	
invariant
	
	name_stack_not_void: name_stack /= Void
	name_stack_not_empty: not name_stack.is_empty

end -- class SL_PARSER
