indexing
	description: "Parser for RIB files"
	names: "RenderMan"
	representation: "none"
	access: "fixed"
	size: "fixed"
	contents: "RI_API"
	patterns: "none"
	date: "$DateTime: 2002/02/01 12:32:26 $"
	revision: "$Revision: 286 $"
	author: "$Author: bolstad $"
	status: "unreviewed"

class 
	
	RIB_PARSER

inherit

	YY_PARSER_SKELETON
		rename
			make as make_parser_skeleton
		undefine
			default_create
		redefine
			report_error
		end

	RIB_SCANNER
		rename
			make as make_rib_scanner
		undefine
			default_create
		end
	
	RI_API
	
	KL_SHARED_EXCEPTIONS
		undefine
			default_create
		end

	KL_SHARED_ARGUMENTS
		undefine
			default_create
		end

	NUMERIC_CONVERSION
		undefine
			default_create
		end

creation

	make


feature {NONE} -- Implementation

	yy_build_parser_tables is
			-- Build parser tables.
		do
			yytranslate := yytranslate_template
			yyr1 := yyr1_template
			yytypes1 := yytypes1_template
			yytypes2 := yytypes2_template
			yydefact := yydefact_template
			yydefgoto := yydefgoto_template
			yypact := yypact_template
			yypgoto := yypgoto_template
			yytable := yytable_template
			yycheck := yycheck_template
		end

	yy_create_value_stacks is
			-- Create value stacks.
		do
		end

	yy_init_value_stacks is
			-- Initialize value stacks.
		do
			yyvsp1 := -1
			yyvsp2 := -1
			yyvsp3 := -1
			yyvsp4 := -1
			yyvsp5 := -1
			yyvsp6 := -1
			yyvsp7 := -1
		end

	yy_clear_value_stacks is
			-- Clear objects in semantic value stacks so that
			-- they can be collected by the garbage collector.
		do
			if yyvs1 /= Void then
				yyvs1.clear_all
			end
			if yyvs2 /= Void then
				yyvs2.clear_all
			end
			if yyvs3 /= Void then
				yyvs3.clear_all
			end
			if yyvs4 /= Void then
				yyvs4.clear_all
			end
			if yyvs5 /= Void then
				yyvs5.clear_all
			end
			if yyvs6 /= Void then
				yyvs6.clear_all
			end
			if yyvs7 /= Void then
				yyvs7.clear_all
			end
		end

	yy_push_last_value (yychar1: INTEGER) is
			-- Push semantic value associated with token `last_token'
			-- (with internal id `yychar1') on top of corresponding
			-- value stack.
		do
			inspect yytypes2.item (yychar1)
			when 1 then
				yyvsp1 := yyvsp1 + 1
				if yyvsp1 >= yyvsc1 then
					if yyvs1 = Void then
						debug ("GEYACC")
							std.error.put_line ("Create yyvs1")
						end
						create yyspecial_routines1
						yyvsc1 := yyInitial_yyvs_size
						yyvs1 := yyspecial_routines1.make (yyvsc1)
					else
						debug ("GEYACC")
							std.error.put_line ("Resize yyvs1")
						end
						yyvsc1 := yyvsc1 + yyInitial_yyvs_size
						yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
					end
				end
				yyvs1.put (last_any_value, yyvsp1)
			when 2 then
				yyvsp2 := yyvsp2 + 1
				if yyvsp2 >= yyvsc2 then
					if yyvs2 = Void then
						debug ("GEYACC")
							std.error.put_line ("Create yyvs2")
						end
						create yyspecial_routines2
						yyvsc2 := yyInitial_yyvs_size
						yyvs2 := yyspecial_routines2.make (yyvsc2)
					else
						debug ("GEYACC")
							std.error.put_line ("Resize yyvs2")
						end
						yyvsc2 := yyvsc2 + yyInitial_yyvs_size
						yyvs2 := yyspecial_routines2.resize (yyvs2, yyvsc2)
					end
				end
				yyvs2.put (last_integer_value, yyvsp2)
			when 3 then
				yyvsp3 := yyvsp3 + 1
				if yyvsp3 >= yyvsc3 then
					if yyvs3 = Void then
						debug ("GEYACC")
							std.error.put_line ("Create yyvs3")
						end
						create yyspecial_routines3
						yyvsc3 := yyInitial_yyvs_size
						yyvs3 := yyspecial_routines3.make (yyvsc3)
					else
						debug ("GEYACC")
							std.error.put_line ("Resize yyvs3")
						end
						yyvsc3 := yyvsc3 + yyInitial_yyvs_size
						yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
					end
				end
				yyvs3.put (last_double_value, yyvsp3)
			when 4 then
				yyvsp4 := yyvsp4 + 1
				if yyvsp4 >= yyvsc4 then
					if yyvs4 = Void then
						debug ("GEYACC")
							std.error.put_line ("Create yyvs4")
						end
						create yyspecial_routines4
						yyvsc4 := yyInitial_yyvs_size
						yyvs4 := yyspecial_routines4.make (yyvsc4)
					else
						debug ("GEYACC")
							std.error.put_line ("Resize yyvs4")
						end
						yyvsc4 := yyvsc4 + yyInitial_yyvs_size
						yyvs4 := yyspecial_routines4.resize (yyvs4, yyvsc4)
					end
				end
				yyvs4.put (last_string_value, yyvsp4)
			else
				debug ("GEYACC")
					std.error.put_string ("Error in parser: not a token type: ")
					std.error.put_integer (yytypes2.item (yychar1))
					std.error.put_new_line
				end
				abort
			end
		end

	yy_push_error_value is
			-- Push semantic value associated with token 'error'
			-- on top of corresponding value stack.
		local
			yyval1: ANY
		do
			yyvsp1 := yyvsp1 + 1
			if yyvsp1 >= yyvsc1 then
				if yyvs1 = Void then
					debug ("GEYACC")
						std.error.put_line ("Create yyvs1")
					end
					create yyspecial_routines1
					yyvsc1 := yyInitial_yyvs_size
					yyvs1 := yyspecial_routines1.make (yyvsc1)
				else
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs1")
					end
					yyvsc1 := yyvsc1 + yyInitial_yyvs_size
					yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
				end
			end
			yyvs1.put (yyval1, yyvsp1)
		end

	yy_pop_last_value (yystate: INTEGER) is
			-- Pop semantic value from stack when in state `yystate'.
		local
			yy_type_id: INTEGER
		do
			yy_type_id := yytypes1.item (yystate)
			inspect yy_type_id
			when 1 then
				yyvsp1 := yyvsp1 - 1
			when 2 then
				yyvsp2 := yyvsp2 - 1
			when 3 then
				yyvsp3 := yyvsp3 - 1
			when 4 then
				yyvsp4 := yyvsp4 - 1
			when 5 then
				yyvsp5 := yyvsp5 - 1
			when 6 then
				yyvsp6 := yyvsp6 - 1
			when 7 then
				yyvsp7 := yyvsp7 - 1
			else
				debug ("GEYACC")
					std.error.put_string ("Error in parser: unknown type id: ")
					std.error.put_integer (yy_type_id)
					std.error.put_new_line
				end
				abort
			end
		end

feature {NONE} -- Semantic actions

	yy_do_action (yy_act: INTEGER) is
			-- Execute semantic action.
		local
			yyval1: ANY
			yyval7: PARAMETER_LIST
			yyval5: DS_ARRAYED_LIST [STRING]
			yyval6: DOUBLE_ARRAYED_LIST
			yyval3: DOUBLE
		do
			inspect yy_act
when 1 then
--|#line 104 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 104")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 2 then
--|#line 107 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 107")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 3 then
--|#line 108 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 108")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 4 then
--|#line 110 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 110")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 5 then
--|#line 111 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 111")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 6 then
--|#line 112 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 112")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 7 then
--|#line 113 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 113")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 8 then
--|#line 114 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 114")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 9 then
--|#line 115 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 115")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 10 then
--|#line 116 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 116")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 11 then
--|#line 117 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 117")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 12 then
--|#line 118 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 118")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 13 then
--|#line 119 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 119")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 14 then
--|#line 120 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 120")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 15 then
--|#line 121 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 121")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 16 then
--|#line 122 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 122")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 17 then
--|#line 124 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 124")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp3 := yyvsp3 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 18 then
--|#line 126 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 126")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 19 then
--|#line 128 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 128")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp4 := yyvsp4 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 20 then
--|#line 131 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 131")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 21 then
--|#line 132 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 132")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 22 then
--|#line 135 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 135")
end

		if yyvs4.item (yyvsp4) /= Void and then yyvs4.item (yyvsp4).count > 0 then
			str2 := ri_declare (yyvs4.item (yyvsp4), Void)
		else
			rib_error ("Declare", "`name' must not be empty")
		end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp4 := yyvsp4 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 23 then
--|#line 143 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 143")
end

		if (str1 /= Void and then str1.count > 0) and
			(yyvs4.item (yyvsp4) /= Void and then yyvs4.item (yyvsp4).count > 0) then
			str2 := ri_declare (str1, yyvs4.item (yyvsp4))
		else
			rib_error ("Declare", "`name' and `declaration' must not be empty")
		end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp1 := yyvsp1 -1
	yyvsp4 := yyvsp4 -2
	yyvs1.put (yyval1, yyvsp1)
end
when 24 then
--|#line 143 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 143")
end

	str1 ?= yyvs4.item (yyvsp4)
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 25 then
--|#line 158 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 158")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 26 then
--|#line 159 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 159")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 27 then
--|#line 161 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 161")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 28 then
--|#line 162 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 162")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 29 then
--|#line 163 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 163")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 30 then
--|#line 164 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 164")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 31 then
--|#line 165 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 165")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 32 then
--|#line 166 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 166")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 33 then
--|#line 167 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 167")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 34 then
--|#line 168 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 168")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 35 then
--|#line 169 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 169")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 36 then
--|#line 170 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 170")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 37 then
--|#line 171 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 171")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 38 then
--|#line 172 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 172")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 39 then
--|#line 173 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 173")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 40 then
--|#line 174 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 174")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 41 then
--|#line 175 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 175")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 42 then
--|#line 176 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 176")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 43 then
--|#line 177 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 177")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 44 then
--|#line 178 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 178")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 45 then
--|#line 179 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 179")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 46 then
--|#line 181 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 181")
end

		check 
			yyvs6.item (yyvsp6).count = 3
		end
	
		if	yyvs6.item (yyvsp6).item (1) < 0 then
			yyvs6.item (yyvsp6).replace (camera.default_x_resolution, 1)
		end
	
		if	yyvs6.item (yyvsp6).item (2) < 0 then
			yyvs6.item (yyvsp6).replace (camera.default_y_resolution, 2)
		end
	
		if	yyvs6.item (yyvsp6).item (3) < 0 then
			yyvs6.item (yyvsp6).replace (camera.default_pixel_aspect_ratio, 3)
		end
	
			ri_format (real_64_truncated_to_integer (yyvs6.item (yyvsp6).item (1)),
					real_64_truncated_to_integer (yyvs6.item (yyvsp6).item (2)), yyvs6.item (yyvsp6).item (3))
		debug ("semantics")
			io.put_string ("Format ")
			print_values (yyvs6.item (yyvsp6), false)
			io.put_string ("%N%N")
		end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp6 := yyvsp6 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 47 then
--|#line 208 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 208")
end

		if is_frame_aspect_ratio_valid (yyvs3.item (yyvsp3)) then
			ri_frame_aspect_ratio (yyvs3.item (yyvsp3))
			debug ("semantics")
				io.put_string ("FrameAspectRatio ")
				io.put_double (yyvs3.item (yyvsp3))
				io.put_string ("%N%N")
			end
		else
			rib_error ("FrameAspectRatio",
					   generate_frame_aspect_ratio_error_message (yyvs3.item (yyvsp3)))	
		end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp3 := yyvsp3 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 48 then
--|#line 223 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 223")
end

		if is_screen_window_valid (yyvs6.item (yyvsp6).item (1), yyvs6.item (yyvsp6).item (2),
								   yyvs6.item (yyvsp6).item (3), yyvs6.item (yyvsp6).item (4)) then
			ri_screen_window (yyvs6.item (yyvsp6).item (1), yyvs6.item (yyvsp6).item (2),
							yyvs6.item (yyvsp6).item (3), yyvs6.item (yyvsp6).item (4))
			debug ("semantics")
				io.put_string ("ScreenWindow ")
				print_values (yyvs6.item (yyvsp6), true)
				io.put_string ("%N%N")
			end
		else
			rib_error ("ScreenWindow",
					   generate_screen_window_error_message (yyvs6.item (yyvsp6).item (1),
															 yyvs6.item (yyvsp6).item (2),
															 yyvs6.item (yyvsp6).item (3),
															 yyvs6.item (yyvsp6).item (4)))
		end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp6 := yyvsp6 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 49 then
--|#line 243 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 243")
end

				
		if is_crop_window_valid (yyvs6.item (yyvsp6).item (1), yyvs6.item (yyvsp6).item (2),
								 yyvs6.item (yyvsp6).item (3), yyvs6.item (yyvsp6).item (4)) then
			ri_crop_window (yyvs6.item (yyvsp6).item (1), yyvs6.item (yyvsp6).item (2),
						  yyvs6.item (yyvsp6).item (3), yyvs6.item (yyvsp6).item (4))
			debug ("semantics")
				io.put_string ("CropWindow ")
				print_values (yyvs6.item (yyvsp6), true)
				io.put_string ("%N%N")
			end
		else
			rib_error ("CropWindow",
					   generate_crop_window_error_message (yyvs6.item (yyvsp6).item (1),
														   yyvs6.item (yyvsp6).item (2),
														   yyvs6.item (yyvsp6).item (3),
														   yyvs6.item (yyvsp6).item (4)))
		end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp6 := yyvsp6 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 50 then
--|#line 264 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 264")
end

		if is_projection_valid (yyvs4.item (yyvsp4), parameters) then
			ri_projection (yyvs4.item (yyvsp4), parameters)
			
			debug ("semantics")
				io.put_string ("Projection ")
				io.put_string (yyvs4.item (yyvsp4))
				io.put_string (" ")
				parameters.print_parameter_list
				io.put_string ("%N%N")
			end
		else
			rib_error ("Projection",
					   generate_projection_error_message (yyvs4.item (yyvsp4),
														  parameters))
		end
				
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp1 := yyvsp1 -1
	yyvsp4 := yyvsp4 -1
	yyvsp7 := yyvsp7 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 51 then
--|#line 264 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 264")
end

reset_variables 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 52 then
--|#line 286 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 286")
end

		if is_clipping_valid (yyvs6.item (yyvsp6).item (1), yyvs6.item (yyvsp6).item (2)) then
			ri_clipping (yyvs6.item (yyvsp6).item (1), yyvs6.item (yyvsp6).item (2))
			debug ("semantics")
				io.put_string ("Clipping ")
				print_values (yyvs6.item (yyvsp6), false)
				io.put_string ("%N%N")
			end
		else
			rib_error ("Clipping",
					   generate_clipping_error_message (yyvs6.item (yyvsp6).item (1),
														yyvs6.item (yyvsp6).item (2)))
		end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp6 := yyvsp6 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 53 then
--|#line 302 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 302")
end

		ri_depth_of_field (infinity, 0, 0)
		debug ("semantics")
			io.put_string ("DepthOfField - ")
			io.put_string ("%N%N")
		end					
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 54 then
--|#line 311 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 311")
end

		if is_depth_of_field_valid (yyvs6.item (yyvsp6).item (1), yyvs6.item (yyvsp6).item (2), yyvs6.item (yyvsp6).item (3)) then
			ri_depth_of_field (yyvs6.item (yyvsp6).item (1), yyvs6.item (yyvsp6).item (2), yyvs6.item (yyvsp6).item (3))
			debug ("semantics")
				io.put_string ("DepthOfField - ")
				print_values (yyvs6.item (yyvsp6), false)
				io.put_string ("%N%N")
			end					
		else
			rib_error ("DepthOfField",
					   generate_depth_of_field_error_message (yyvs6.item (yyvsp6).item (1),
															  yyvs6.item (yyvsp6).item (2),
															  yyvs6.item (yyvsp6).item (3)))
		end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp6 := yyvsp6 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 55 then
--|#line 328 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 328")
end

		if is_shutter_valid (yyvs6.item (yyvsp6).item (1), yyvs6.item (yyvsp6).item (2)) then
			ri_shutter (yyvs6.item (yyvsp6).item (1), yyvs6.item (yyvsp6).item (2))
			debug ("semantics")
				io.put_string ("Shutter ")
				print_values (yyvs6.item (yyvsp6), false)
				io.put_string ("%N%N")
			end					
		else
			rib_error ("Shutter",
					   generate_shutter_error_message (yyvs6.item (yyvsp6).item (1),
													   yyvs6.item (yyvsp6).item (2)))
		end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp6 := yyvsp6 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 56 then
--|#line 344 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 344")
end

		if is_pixel_variance_valid (yyvs3.item (yyvsp3)) then
			ri_pixel_variance (yyvs3.item (yyvsp3))
			debug ("semantics")
				io.put_string ("PixelVariance ")
				io.put_double (yyvs3.item (yyvsp3))
				io.put_string ("%N%N")
			end					
		else
			rib_error ("PixelVariance",
					   generate_pixel_variance_error_message (yyvs3.item (yyvsp3)))
		end					
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp3 := yyvsp3 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 57 then
--|#line 359 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 359")
end

		if is_pixel_samples_valid (yyvs6.item (yyvsp6).item (1), yyvs6.item (yyvsp6).item (2)) then
			ri_pixel_samples (yyvs6.item (yyvsp6).item (1), yyvs6.item (yyvsp6).item (2))
			debug ("semantics")
				io.put_string ("PixelSamples ")
				print_values (yyvs6.item (yyvsp6), false)
				io.put_string ("%N%N")
			end					
		else
			rib_error ("PixelSamples",
					   generate_pixel_samples_error_message (yyvs6.item (yyvsp6).item (1),
															 yyvs6.item (yyvsp6).item (2)))
		end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp6 := yyvsp6 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 58 then
--|#line 375 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 375")
end

		if is_pixel_filter_valid (yyvs4.item (yyvsp4), yyvs6.item (yyvsp6).item (1),
								  yyvs6.item (yyvsp6).item (2)) then
			ri_pixel_filter (filter_factory.factory (yyvs4.item (yyvsp4)), yyvs6.item (yyvsp6).item (1), yyvs6.item (yyvsp6).item (2))
			debug ("semantics")
				io.put_string ("PixelFilter ")
				io.put_string (yyvs4.item (yyvsp4))
				io.put_string (" ")
				print_values (yyvs6.item (yyvsp6), false)
				io.put_string ("%N%N")
			end					
		else
			rib_error ("PixelFilter",
					   generate_pixel_filter_error_message (yyvs4.item (yyvsp4),
															yyvs6.item (yyvsp6).item (1),
															yyvs6.item (yyvsp6).item (2)))
		end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp4 := yyvsp4 -1
	yyvsp6 := yyvsp6 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 59 then
--|#line 395 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 395")
end

		if is_exposure_valid (yyvs6.item (yyvsp6).item (1), yyvs6.item (yyvsp6).item (2)) then
			ri_exposure (yyvs6.item (yyvsp6).item (1), yyvs6.item (yyvsp6).item (2))
			debug ("semantics")
				io.put_string ("Exposure ")
				print_values (yyvs6.item (yyvsp6), false)
				io.put_string ("%N%N")
			end					
		else
			rib_error ("Exposure",
					   generate_exposure_error_message (yyvs6.item (yyvsp6).item (1),
														yyvs6.item (yyvsp6).item (2)))
		end	
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp6 := yyvsp6 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 60 then
--|#line 411 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 411")
end

		if is_imager_valid (str1, yyvs7.item (yyvsp7)) then
			ri_imager (str1, yyvs7.item (yyvsp7))
			debug ("semantics")
				io.put_string ("Imager ")
				io.put_string (yyvs4.item (yyvsp4))
				io.put_string (" ")
				yyvs7.item (yyvsp7).print_parameter_list
				io.put_string ("%N%N")
			end
		else
			rib_error ("Imager",
					   generate_imager_error_message (str1, yyvs7.item (yyvsp7)))
		end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp1 := yyvsp1 -1
	yyvsp4 := yyvsp4 -1
	yyvsp7 := yyvsp7 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 61 then
--|#line 411 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 411")
end

	str1 ?= yyvs4.item (yyvsp4)
	reset_variables
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 62 then
--|#line 433 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 433")
end

		if is_quantize_valid (yyvs4.item (yyvsp4),
							  real_64_truncated_to_integer (yyvs6.item (yyvsp6).item (1)),
							  real_64_truncated_to_integer (yyvs6.item (yyvsp6).item (2)),
							  real_64_truncated_to_integer (yyvs6.item (yyvsp6).item (3)),
							  real_64_truncated_to_integer (yyvs6.item (yyvsp6).item (4))) then
			ri_quantize (yyvs4.item (yyvsp4),
						real_64_truncated_to_integer (yyvs6.item (yyvsp6).item (1)),
						real_64_truncated_to_integer (yyvs6.item (yyvsp6).item (2)),
						real_64_truncated_to_integer (yyvs6.item (yyvsp6).item (3)),
						yyvs6.item (yyvsp6).item (4))
			debug ("semantics")
				io.put_string ("Quantize ")
				print_values (yyvs6.item (yyvsp6), false)
				io.put_string ("%N%N")
			end
		else
			rib_error ("Quantize", 
					   generate_quantize_error_message (yyvs4.item (yyvsp4),
														real_64_truncated_to_integer (yyvs6.item (yyvsp6).item (1)),
														real_64_truncated_to_integer (yyvs6.item (yyvsp6).item (2)),
														real_64_truncated_to_integer (yyvs6.item (yyvsp6).item (3)),
														yyvs6.item (yyvsp6).item (4)))
		end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp4 := yyvsp4 -1
	yyvsp6 := yyvsp6 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 63 then
--|#line 460 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 460")
end

		if is_display_valid (str1, str2, str3, yyvs7.item (yyvsp7)) then
			ri_display (str1, str2, str3, yyvs7.item (yyvsp7))
			debug ("semantics")
				io.put_string ("Display ")
				io.put_string (str1)
				io.put_string (" ")
				io.put_string (str2)
				io.put_string (" ")
				io.put_string (str3)
				yyvs7.item (yyvsp7).print_parameter_list
				io.put_string ("%N%N")
			end
		else
			rib_error ("Display",
					   generate_display_error_message (str1, str2, str3, yyvs7.item (yyvsp7)))
		end	
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 8
	yyvsp1 := yyvsp1 -3
	yyvsp4 := yyvsp4 -3
	yyvsp7 := yyvsp7 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 64 then
--|#line 460 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 460")
end

	str1 ?= yyvs4.item (yyvsp4)
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 65 then
--|#line 460 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 460")
end

	str2 ?= yyvs4.item (yyvsp4)
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 66 then
--|#line 460 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 460")
end

	str3 ?= yyvs4.item (yyvsp4)
	reset_variables
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 67 then
--|#line 493 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 493")
end

		if is_hider_valid (str1, yyvs7.item (yyvsp7)) then
			ri_hider (str1, yyvs7.item (yyvsp7))
			
			debug ("semantics")
				io.put_string ("Hider ")
				io.put_string (str1)
				io.put_string (" ")
				yyvs7.item (yyvsp7).print_parameter_list
				io.put_string ("%N%N")
			end
		else
			rib_error ("Hider",
					   generate_hider_error_message (str1, yyvs7.item (yyvsp7)))
		end	
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp1 := yyvsp1 -1
	yyvsp4 := yyvsp4 -1
	yyvsp7 := yyvsp7 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 68 then
--|#line 493 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 493")
end

	str1 ?= yyvs4.item (yyvsp4)
	reset_variables
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 69 then
--|#line 516 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 516")
end

		if is_color_samples_valid (yyvs6.item (yyvsp6).count.to_integer_32, tmp_array, yyvs6.item (yyvsp6)) then
			ri_color_samples (yyvs6.item (yyvsp6).count.to_integer_32, tmp_array, yyvs6.item (yyvsp6))
			
			debug ("semantics")
				io.put_string ("ColorSamples ")
				print_values (tmp_array, true)
				io.put_string (" ")
				print_values (yyvs6.item (yyvsp6), true)
				io.put_string ("%N%N")
			end
		else
			rib_error ("ColorSamples",
					   generate_color_samples_error_message (yyvs6.item (yyvsp6).count.to_integer_32,
															 tmp_array,
															 yyvs6.item (yyvsp6)))
		end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 5
	yyvsp1 := yyvsp1 -2
	yyvsp6 := yyvsp6 -2
	yyvs1.put (yyval1, yyvsp1)
end
when 70 then
--|#line 516 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 516")
end

reset_variables 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 71 then
--|#line 516 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 516")
end

	tmp_array := yyvs6.item (yyvsp6)
	reset_variables 
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 72 then
--|#line 543 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 543")
end

		if is_relative_detail_valid (yyvs3.item (yyvsp3)) then
			ri_relative_detail (yyvs3.item (yyvsp3))
			
			debug ("semantics")
				io.put_string ("RelativeDetail ")
				io.put_double (yyvs3.item (yyvsp3))
				io.put_string ("%N%N")
			end
		else
			rib_error ("RelativeDetail",
					   generate_relative_detail_error_message (yyvs3.item (yyvsp3)))
		end						
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp3 := yyvsp3 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 73 then
--|#line 559 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 559")
end

		if is_option_valid (str1, yyvs7.item (yyvsp7)) then
			ri_option (str1, yyvs7.item (yyvsp7))
			
			debug ("semantics")
				io.put_string ("Option ")
				io.put_string (str1)
				io.put_string (" ")
				yyvs7.item (yyvsp7).print_parameter_list
				io.put_string ("%N%N")
			end
		else
			rib_error ("Option",
					   generate_option_error_message (str1, yyvs7.item (yyvsp7)))
		end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp1 := yyvsp1 -1
	yyvsp4 := yyvsp4 -1
	yyvsp7 := yyvsp7 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 74 then
--|#line 559 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 559")
end

	str1 ?= yyvs4.item (yyvsp4)
	reset_variables
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 75 then
--|#line 583 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 583")
end

yyval7 := yyvs7.item (yyvsp7)
		debug ("semantics")
			io.put_string ("ParameterList: ")
			parameters.print_parameter_list
			io.put_string ("%N%N")
		end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs7.put (yyval7, yyvsp7)
end
when 76 then
--|#line 592 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 592")
end

yyval7 := parameters 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp7 := yyvsp7 + 1
	if yyvsp7 >= yyvsc7 then
		if yyvs7 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs7")
			end
			create yyspecial_routines7
			yyvsc7 := yyInitial_yyvs_size
			yyvs7 := yyspecial_routines7.make (yyvsc7)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs7")
			end
			yyvsc7 := yyvsc7 + yyInitial_yyvs_size
			yyvs7 := yyspecial_routines7.resize (yyvs7, yyvsc7)
		end
	end
	yyvs7.put (yyval7, yyvsp7)
end
when 77 then
--|#line 594 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 594")
end

yyval7 := parameters
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs7.put (yyval7, yyvsp7)
end
when 78 then
--|#line 597 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 597")
end

	strings.force_last (yyvs4.item (yyvsp4))
	parameters.put_string (yyvs4.item (yyvsp4 - 1), strings)
	create strings.make (1)
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 + 1
	yyvsp4 := yyvsp4 -2
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 79 then
--|#line 604 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 604")
end

	parameters.put_string (yyvs4.item (yyvsp4), strings)
	create strings.make (1)
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp1 := yyvsp1 -1
	yyvsp4 := yyvsp4 -1
	yyvsp5 := yyvsp5 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 80 then
--|#line 610 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 610")
end

	parameters.put_array (yyvs4.item (yyvsp4), yyvs6.item (yyvsp6))
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 + 1
	yyvsp4 := yyvsp4 -1
	yyvsp6 := yyvsp6 -1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 81 then
--|#line 615 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 615")
end

strings.force_last (yyvs4.item (yyvsp4)) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp5 := yyvsp5 + 1
	yyvsp4 := yyvsp4 -1
	if yyvsp5 >= yyvsc5 then
		if yyvs5 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs5")
			end
			create yyspecial_routines5
			yyvsc5 := yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.make (yyvsc5)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs5")
			end
			yyvsc5 := yyvsc5 + yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.resize (yyvs5, yyvsc5)
		end
	end
	yyvs5.put (yyval5, yyvsp5)
end
when 82 then
--|#line 617 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 617")
end

strings.force_last (yyvs4.item (yyvsp4)) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp4 := yyvsp4 -1
	yyvs5.put (yyval5, yyvsp5)
end
when 83 then
--|#line 620 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 620")
end

	yyval6 := yyvs6.item (yyvsp6) 
	create values.make (1)
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs6.put (yyval6, yyvsp6)
end
when 84 then
--|#line 625 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 625")
end

	yyval6 := yyvs6.item (yyvsp6)
	create values.make (1)
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs6.put (yyval6, yyvsp6)
end
when 85 then
--|#line 631 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 631")
end

yyval6 := yyvs6.item (yyvsp6) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyvs6.put (yyval6, yyvsp6)
end
when 86 then
--|#line 634 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 634")
end

yyval6 := yyvs6.item (yyvsp6) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyvs6.put (yyval6, yyvsp6)
end
when 87 then
--|#line 638 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 638")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 88 then
--|#line 639 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 639")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 89 then
--|#line 641 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 641")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 90 then
--|#line 642 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 642")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 91 then
--|#line 643 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 643")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 92 then
--|#line 644 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 644")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 93 then
--|#line 645 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 645")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 94 then
--|#line 646 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 646")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 95 then
--|#line 647 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 647")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 96 then
--|#line 648 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 648")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 97 then
--|#line 649 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 649")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 98 then
--|#line 650 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 650")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 99 then
--|#line 651 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 651")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 100 then
--|#line 652 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 652")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 101 then
--|#line 653 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 653")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 102 then
--|#line 654 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 654")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 103 then
--|#line 655 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 655")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 104 then
--|#line 656 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 656")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 105 then
--|#line 657 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 657")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 106 then
--|#line 658 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 658")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 107 then
--|#line 659 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 659")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 108 then
--|#line 660 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 660")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 109 then
--|#line 661 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 661")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 110 then
--|#line 662 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 662")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 111 then
--|#line 664 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 664")
end

	if is_attribute_valid (str1, yyvs7.item (yyvsp7)) then
		  ri_attribute (str1, yyvs7.item (yyvsp7))
		  
		  debug ("semantics")
			  io.put_string ("Attribute")
			  io.put_string (" ")
			  io.put_string (str1)
			  io.put_string (" ")
			  yyvs7.item (yyvsp7).print_parameter_list
			  io.put_string ("%N%N")
		  end
	else
		  rib_error ("Attribute",
					 generate_attribute_error_message (str1, yyvs7.item (yyvsp7)))
	end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp1 := yyvsp1 -1
	yyvsp4 := yyvsp4 -1
	yyvsp7 := yyvsp7 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 112 then
--|#line 664 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 664")
end

	str1 ?= yyvs4.item (yyvsp4)
	reset_variables
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 113 then
--|#line 688 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 688")
end

		if yyvs6.item (yyvsp6).count > 0 and then yyvs6.item (yyvsp6).count = color_samples then
			create tmp_color.make (yyvs6.item (yyvsp6).item (1), yyvs6.item (yyvsp6).item (2), yyvs6.item (yyvsp6).item (3), 1)
			ri_color (tmp_color)
			
			debug ("semantics")
				io.put_string ("Color ")
				print_values (yyvs6.item (yyvsp6), true)
				io.put_string ("%N%N")
			end
		else
			create str1.make (30)
			str1.append ("The number of color elements %
						%does not match ColorSamples. ")
			str1.append ("Found ")
			str1.append_string (yyvs6.item (yyvsp6).count.out)
			str1.append (" color entries. ColorSamples is ")
			str1.append_string (color_samples.out)
			str1.append (". The call is ignored.%N%N")
			io.put_string (yyvs6.item (yyvsp6).out)
			rib_error ("Color", str1)
		end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -1
	yyvsp6 := yyvsp6 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 114 then
--|#line 688 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 688")
end

	reset_variables
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 115 then
--|#line 717 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 717")
end

		if yyvs6.item (yyvsp6).count > 0	 and then yyvs6.item (yyvsp6).count = color_samples then
			create tmp_opacity.make (yyvs6.item (yyvsp6).item (1), yyvs6.item (yyvsp6).item (2), yyvs6.item (yyvsp6).item (3))
			ri_opacity (tmp_opacity)
			debug ("semantics")
				io.put_string ("Opacity ")
				print_values (yyvs6.item (yyvsp6), true)
				io.put_string ("%N%N")
			end
		else
			create str1.make (30)
			str1.append ("The number of color elements %
						%does not match ColorSamples. ")
			str1.append ("Found ")
			str1.append_string (yyvs6.item (yyvsp6).count.out)
			str1.append (" color entries. ColorSamples is ")
			str1.append_string (color_samples.out)
			str1.append (". The call is ignored.%N%N")
			rib_error ("Opacity",str1)
		end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -1
	yyvsp6 := yyvsp6 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 116 then
--|#line 717 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 717")
end

	reset_variables
	
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 117 then
--|#line 745 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 745")
end

		if is_surface_valid (str1, yyvs7.item (yyvsp7)) then
			ri_surface (str1, yyvs7.item (yyvsp7))
			
			debug ("semantics")
				io.put_string ("Surface ")
				io.put_string (str1)
				io.put_string (" ")
				yyvs7.item (yyvsp7).print_parameter_list
				io.put_string ("%N%N")
			end
		else
			rib_error ("Surface",
					   generate_surface_error_message (str1, yyvs7.item (yyvsp7)))
		end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp1 := yyvsp1 -1
	yyvsp4 := yyvsp4 -1
	yyvsp7 := yyvsp7 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 118 then
--|#line 745 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 745")
end

	str1 ?= yyvs4.item (yyvsp4) 
	reset_variables
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 119 then
--|#line 768 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 768")
end

		if is_atmosphere_valid (str1, yyvs7.item (yyvsp7)) then
			ri_atmosphere (str1, yyvs7.item (yyvsp7))
			
			debug ("semantics")
				io.put_string ("Atmosphere ")
				io.put_string (str1)
				io.put_string (" ")
				yyvs7.item (yyvsp7).print_parameter_list
				io.put_string ("%N%N")
			end
		else
			rib_error ("Atmosphere",
					   generate_atmosphere_error_message (str1, yyvs7.item (yyvsp7)))
		end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp1 := yyvsp1 -1
	yyvsp4 := yyvsp4 -1
	yyvsp7 := yyvsp7 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 120 then
--|#line 768 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 768")
end

	str1 ?= yyvs4.item (yyvsp4) 
	reset_variables
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 121 then
--|#line 791 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 791")
end

		if is_interior_valid (str1, yyvs7.item (yyvsp7)) then
			ri_interior (str1, yyvs7.item (yyvsp7))
			debug ("semantics")
				io.put_string ("Interior ")
				io.put_string (str1)
				io.put_string (" ")
				yyvs7.item (yyvsp7).print_parameter_list
				io.put_string ("%N%N")
			end
		else
			rib_error ("Interior",
					   generate_interior_error_message (str1, yyvs7.item (yyvsp7)))
		end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp1 := yyvsp1 -1
	yyvsp4 := yyvsp4 -1
	yyvsp7 := yyvsp7 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 122 then
--|#line 791 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 791")
end

	str1 ?= yyvs4.item (yyvsp4) 
	reset_variables
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 123 then
--|#line 813 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 813")
end

		if is_exterior_valid (str1, yyvs7.item (yyvsp7)) then
			ri_exterior (str1, yyvs7.item (yyvsp7))
			
			debug ("semantics")
				io.put_string ("Exterior ")
				io.put_string (str1)
				io.put_string (" ")
				yyvs7.item (yyvsp7).print_parameter_list
				io.put_string ("%N%N")
			end
		else
			rib_error ("Exterior",
					   generate_exterior_error_message (str1, yyvs7.item (yyvsp7)))
		end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp1 := yyvsp1 -1
	yyvsp4 := yyvsp4 -1
	yyvsp7 := yyvsp7 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 124 then
--|#line 813 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 813")
end

	str1 ?= yyvs4.item (yyvsp4) 
	reset_variables
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 125 then
--|#line 836 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 836")
end

		if valid_handle (light_mapping.item (tmp_index)) then
			if (yyvs2.item (yyvsp2) /= 0 implies not is_active (light_mapping.item (tmp_index))) and
				(yyvs2.item (yyvsp2) = 0 implies is_active (light_mapping.item (tmp_index))) then
				if yyvs2.item (yyvsp2) /= 0 then
					ri_illuminate (light_mapping.item (tmp_index), true)
				else
					ri_illuminate (light_mapping.item (tmp_index), false)
				end
				
				debug ("semantics")
					io.put_string ("Illuminate ")
					io.put_integer (light_mapping.item (tmp_index))
					io.put_string (" ")
					io.put_integer (yyvs2.item (yyvsp2))
					io.put_string ("%N%N")
				end
			end
		else
			rib_error ("Illuminate",
					   "`handle' is not valid. It was either %
					   %never valid, or belonged to a light %
					   %that was deleted by scoping rules. %
					   %The call is ignored.")
		end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp1 := yyvsp1 -1
	yyvsp2 := yyvsp2 -2
	yyvs1.put (yyval1, yyvsp1)
end
when 126 then
--|#line 836 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 836")
end

tmp_index := yyvs2.item (yyvsp2) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 127 then
--|#line 866 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 866")
end

		if is_displacement_valid (str1, yyvs7.item (yyvsp7)) then
			ri_displacement (str1, yyvs7.item (yyvsp7))
			
			debug ("semantics")
				io.put_string ("Displacement ")
				io.put_string (str1)
				io.put_string (" ")
				yyvs7.item (yyvsp7).print_parameter_list
				io.put_string ("%N%N")
			end
		else
			rib_error ("Displacement",
					   generate_displacement_error_message (str1, yyvs7.item (yyvsp7)))
		end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp1 := yyvsp1 -1
	yyvsp4 := yyvsp4 -1
	yyvsp7 := yyvsp7 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 128 then
--|#line 866 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 866")
end

	str1 ?= yyvs4.item (yyvsp4) 
	reset_variables
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 129 then
--|#line 889 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 889")
end

		ri_texture_coordinates (yyvs6.item (yyvsp6).item (1), yyvs6.item (yyvsp6).item (2), 
							  yyvs6.item (yyvsp6).item (3), yyvs6.item (yyvsp6).item (4),
							  yyvs6.item (yyvsp6).item (5), yyvs6.item (yyvsp6).item (6),
							  yyvs6.item (yyvsp6).item (7), yyvs6.item (yyvsp6).item (8))
		debug ("semantics")
			io.put_string ("TextureCoordinates ")
			print_values (yyvs6.item (yyvsp6), true)
			io.put_string ("%N%N")
		end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp6 := yyvsp6 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 130 then
--|#line 902 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 902")
end

		if is_shading_rate_valid (yyvs3.item (yyvsp3)) then
			ri_shading_rate (yyvs3.item (yyvsp3))
			
			debug ("semantics")
				io.put_string ("ShadingRate ")
				io.put_double (yyvs3.item (yyvsp3))
				io.put_string ("%N%N")
			end
		else
			rib_error ("ShadingRate",
					   generate_shading_rate_error_message (yyvs3.item (yyvsp3)))
		end			
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp3 := yyvsp3 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 131 then
--|#line 918 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 918")
end

		if is_shading_interpolation_valid (yyvs4.item (yyvsp4)) then
			ri_shading_interpolation (yyvs4.item (yyvsp4))
			debug ("semantics")
				io.put_string ("ShadingInterpolation ")
				io.put_string (yyvs4.item (yyvsp4))
				io.put_string ("%N%N")
			end
		else
			rib_error ("ShadingInterpolation",
					   generate_shading_interpolation_error_message (yyvs4.item (yyvsp4)))
		end						
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp4 := yyvsp4 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 132 then
--|#line 933 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 933")
end

		if yyvs2.item (yyvsp2) = 0 then
			ri_matte (false)
		else
			ri_matte (true)
		end
	
		debug ("semantics")
			io.put_string ("Matte ")
			if yyvs2.item (yyvsp2) = 0 then
				io.put_boolean (false)
			else
				io.put_boolean (true)
			end
			io.put_string ("%N%N")
		end
	
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 133 then
--|#line 953 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 953")
end

	pt1.make (yyvs6.item (yyvsp6).item (1), yyvs6.item (yyvsp6).item (3), yyvs6.item (yyvsp6).item (5))
	pt2.make (yyvs6.item (yyvsp6).item (2), yyvs6.item (yyvsp6).item (4), yyvs6.item (yyvsp6).item (6))
	box.make (pt1, pt2)
	
	ri_bound (box)
	
		debug ("semantics")
			io.put_string ("Bound ")
			print_values (yyvs6.item (yyvsp6), true)
			io.put_string ("%N%N")
		end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp6 := yyvsp6 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 134 then
--|#line 968 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 968")
end

	pt1.make (yyvs6.item (yyvsp6).item (1), yyvs6.item (yyvsp6).item (3), yyvs6.item (yyvsp6).item (5))
	pt2.make (yyvs6.item (yyvsp6).item (2), yyvs6.item (yyvsp6).item (4), yyvs6.item (yyvsp6).item (6))
	box.make (pt1, pt2)
	
	ri_detail (box)
			
		debug ("semantics")
			io.put_string ("Detail ")
			print_values (yyvs6.item (yyvsp6), true)
			io.put_string ("%N%N")
		end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp6 := yyvsp6 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 135 then
--|#line 983 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 983")
end

		if is_detail_range_valid (yyvs6.item (yyvsp6).item (1), yyvs6.item (yyvsp6).item (2),
								  yyvs6.item (yyvsp6).item (3), yyvs6.item (yyvsp6).item (4)) then
			ri_detail_range (yyvs6.item (yyvsp6).item (1), yyvs6.item (yyvsp6).item (2),
						   yyvs6.item (yyvsp6).item (3), yyvs6.item (yyvsp6).item (4))
			
			debug ("semantics")
				io.put_string ("DetailRange	 ")
				print_values (yyvs6.item (yyvsp6), true)
				io.put_string ("%N%N")
			end
		else
			rib_error ("DetailRange ",
					   generate_detail_range_error_message (yyvs6.item (yyvsp6).item (1),
															yyvs6.item (yyvsp6).item (2),
															yyvs6.item (yyvsp6).item (3), 
															yyvs6.item (yyvsp6).item (4)))
		end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp6 := yyvsp6 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 136 then
--|#line 1004 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1004")
end

		if is_geometric_approximation_valid (yyvs4.item (yyvsp4), yyvs3.item (yyvsp3)) then
			ri_geometric_approximation (yyvs4.item (yyvsp4), yyvs3.item (yyvsp3))
			
			debug ("semantics")
				io.put_string ("GeometricApproximation ")
				io.put_string (yyvs4.item (yyvsp4))
				io.put_string (" ")
				io.put_double (yyvs3.item (yyvsp3))
				io.put_string ("%N%N")
			end
		else
			rib_error ("GeometricApproximation",
					   generate_geometric_approximation_error_message (yyvs4.item (yyvsp4), yyvs3.item (yyvsp3)))
		end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp4 := yyvsp4 -1
	yyvsp3 := yyvsp3 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 137 then
--|#line 1022 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1022")
end

		if is_orientation_valid (yyvs4.item (yyvsp4)) then
			ri_orientation (yyvs4.item (yyvsp4))
			
			debug ("semantics")
				io.put_string ("Orientation ")
				io.put_string (yyvs4.item (yyvsp4))
				io.put_string ("%N%N")
			end
		else
			rib_error ("Orientation",
					   generate_orientation_error_message (yyvs4.item (yyvsp4)))
		end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp4 := yyvsp4 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 138 then
--|#line 1038 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1038")
end

		ri_reverse_orientation 
		
		debug ("semantics")
			io.put_string ("ReverseOrientation ")
			io.put_string ("%N%N")
		end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 139 then
--|#line 1048 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1048")
end

		if is_sides_valid (yyvs2.item (yyvsp2)) then
			ri_sides (yyvs2.item (yyvsp2))
			
			debug ("semantics")
				io.put_string ("Sides ")
				io.put_integer (yyvs2.item (yyvsp2))
				io.put_string ("%N%N")
			end
		else
			rib_error ("Sides",
					   generate_sides_error_message (yyvs2.item (yyvsp2)))
		end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 140 then
--|#line 1064 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1064")
end

	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 5
	yyvsp1 := yyvsp1 -2
	yyvsp3 := yyvsp3 -2
	yyvs1.put (yyval1, yyvsp1)
end
when 141 then
--|#line 1068 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1068")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp1 := yyvsp1 + 1
	yyvsp4 := yyvsp4 -1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 142 then
--|#line 1069 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1069")
end

	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp1 := yyvsp1 + 1
	yyvsp6 := yyvsp6 -1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 143 then
--|#line 1073 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1073")
end

	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 10
	yyvsp6 := yyvsp6 -9
	yyvs1.put (yyval1, yyvsp1)
end
when 144 then
--|#line 1080 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1080")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 145 then
--|#line 1081 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1081")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 146 then
--|#line 1083 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1083")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 147 then
--|#line 1084 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1084")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 148 then
--|#line 1085 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1085")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 149 then
--|#line 1087 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1087")
end

		if is_light_source_valid (str1, yyvs7.item (yyvsp7)) then
			if valid_handle (yyvs2.item (yyvsp2)) then
				if verbose then
					io.put_string ("There already exists a light with %
								   %sequence number ")
					io.put_integer (yyvs2.item (yyvsp2))
					io.put_string (". Inserting light as last element of list%N")
				end
				
				-- This insures that a light will always be added, as 
				-- opposed to overwriting a current light
				tmp_index := ri_light_source (str1, yyvs7.item (yyvsp7))
				light_mapping.force (tmp_index, tmp_index)
			else			
				tmp_index := ri_light_source (str1, yyvs7.item (yyvsp7))
				light_mapping.force (tmp_index, yyvs2.item (yyvsp2))
			end

			debug ("semantics")
				io.put_string ("LightSource ")
				io.put_string (str1)
				io.put_string (" ")
				io.put_integer (tmp_index)
				io.put_string (" ")
				yyvs7.item (yyvsp7).print_parameter_list
				io.put_string ("%N%N")
			end
		else
			rib_error ("LightSource",
					   generate_light_source_error_message (str1, yyvs7.item (yyvsp7)))
		end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 6
	yyvsp1 := yyvsp1 -2
	yyvsp4 := yyvsp4 -1
	yyvsp2 := yyvsp2 -1
	yyvsp7 := yyvsp7 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 150 then
--|#line 1087 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1087")
end

str1 ?= yyvs4.item (yyvsp4) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 151 then
--|#line 1087 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1087")
end

reset_variables 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 152 then
--|#line 1126 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1126")
end

		if is_light_source_valid (str1, yyvs7.item (yyvsp7)) then
			tmp_index := ri_light_source (str1, yyvs7.item (yyvsp7))
			light_mapping.force (tmp_index, tmp_index)

			debug ("semantics")
				io.put_string ("LightSource ")
				io.put_string (str1)
				io.put_string (" ")
				io.put_integer (tmp_index)
				io.put_string (" ")
				yyvs7.item (yyvsp7).print_parameter_list
				io.put_string ("%N%N")
			end
		else
			rib_error ("LightSource",
					   generate_light_source_error_message (str1, yyvs7.item (yyvsp7)))
		end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 7
	yyvsp1 := yyvsp1 -3
	yyvsp4 := yyvsp4 -2
	yyvsp7 := yyvsp7 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 153 then
--|#line 1126 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1126")
end

str1 ?= yyvs4.item (yyvsp4) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 154 then
--|#line 1126 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1126")
end

str2 ?= yyvs1.item (yyvsp1)
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 155 then
--|#line 1126 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1126")
end

reset_variables 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 156 then
--|#line 1152 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1152")
end

		if is_light_source_valid (str1, yyvs7.item (yyvsp7)) then
			if valid_handle (yyvs2.item (yyvsp2)) then
				if verbose then
					io.put_string ("There already exists a light with %
								   %sequence number ")
					io.put_integer (yyvs2.item (yyvsp2))
					io.put_string (". Inserting light as last element of list%N")
				end
				
				-- This insures that a light will always be added, as 
				-- opposed to overwriting a current light
				tmp_index := ri_area_light_source (str1, yyvs7.item (yyvsp7))
				light_mapping.force (tmp_index, tmp_index)
			else			
				tmp_index := ri_area_light_source (str1, yyvs7.item (yyvsp7))
				light_mapping.force (tmp_index, yyvs2.item (yyvsp2))
			end
			
			debug ("semantics")
				io.put_string ("AreaLightSource ")
				io.put_string (str1)
				io.put_string (" ")
				io.put_integer (tmp_index)
				io.put_string (" ")
				yyvs7.item (yyvsp7).print_parameter_list
				io.put_string ("%N%N")
			end
		else
			rib_error ("AreaLightSource",
							  generate_light_source_error_message (str1, yyvs7.item (yyvsp7)))
		end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 6
	yyvsp1 := yyvsp1 -2
	yyvsp4 := yyvsp4 -1
	yyvsp2 := yyvsp2 -1
	yyvsp7 := yyvsp7 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 157 then
--|#line 1152 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1152")
end

str1 ?= yyvs4.item (yyvsp4) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 158 then
--|#line 1152 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1152")
end

reset_variables 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 159 then
--|#line 1193 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1193")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 160 then
--|#line 1194 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1194")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 161 then
--|#line 1196 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1196")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 162 then
--|#line 1197 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1197")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 163 then
--|#line 1198 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1198")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 164 then
--|#line 1199 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1199")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 165 then
--|#line 1200 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1200")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 166 then
--|#line 1201 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1201")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 167 then
--|#line 1202 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1202")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 168 then
--|#line 1203 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1203")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 169 then
--|#line 1204 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1204")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 170 then
--|#line 1205 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1205")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 171 then
--|#line 1206 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1206")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 172 then
--|#line 1208 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1208")
end

	ri_identity
		
	debug ("semantics")
		  io.put_string ("Identity ")
		  io.put_string ("%N%N")
	end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 173 then
--|#line 1218 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1218")
end

	tmp_transform.make_from_list (yyvs6.item (yyvsp6))
	-- Matricies loaded from RenderMan are in column-major order. 
	-- The scene graph expects row-major
	tmp_transform.transpose
	ri_transform (tmp_transform)
	
	debug ("semantics")
		  io.put_string ("Transform ")
		  print_values (yyvs6.item (yyvsp6), true)
		  io.put_string ("%N%N")
	end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp6 := yyvsp6 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 174 then
--|#line 1233 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1233")
end

	tmp_transform.make_from_list (yyvs6.item (yyvsp6))
	-- Matricies loaded from RenderMan are in column-major order. 
	-- The scene graph expects row-major
	tmp_transform.transpose
	ri_concat_transform (tmp_transform)
	
	debug ("semantics")
		  io.put_string ("ConcatTransform ")
		  print_values (yyvs6.item (yyvsp6), true)
		  io.put_string ("%N%N")
	end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp6 := yyvsp6 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 175 then
--|#line 1248 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1248")
end

	if is_perspective_valid (yyvs3.item (yyvsp3)) then
		  ri_perspective (yyvs3.item (yyvsp3))
		  
		  debug ("semantics")
			  io.put_string ("Perspective ")
			  io.put_string (yyvs3.item (yyvsp3).out)
			  io.put_string ("%N%N")
		  end
	else
		  rib_error ("Perspective",
					 generate_perspective_error_message (yyvs3.item (yyvsp3)))
	end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp3 := yyvsp3 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 176 then
--|#line 1264 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1264")
end

	ri_translate (yyvs6.item (yyvsp6).item (1), yyvs6.item (yyvsp6).item (2), yyvs6.item (yyvsp6).item (3))
	
	debug ("semantics")
		  io.put_string ("Translate ")
		  print_values (yyvs6.item (yyvsp6), false)
		  io.put_string ("%N%N")
	end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp6 := yyvsp6 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 177 then
--|#line 1275 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1275")
end

	if is_rotate_valid (yyvs6.item (yyvsp6).item (1), yyvs6.item (yyvsp6).item (2),
						  yyvs6.item (yyvsp6).item (3), yyvs6.item (yyvsp6).item (4)) then
		  ri_rotate (yyvs6.item (yyvsp6).item (1), yyvs6.item (yyvsp6).item (2),
					yyvs6.item (yyvsp6).item (3), yyvs6.item (yyvsp6).item (4))
		  
		  debug ("semantics")
			  io.put_string ("Rotate ")
			  print_values (yyvs6.item (yyvsp6), false)
			  io.put_string ("%N%N")
		  end
	else
		  rib_error ("Rotate",
					 generate_rotate_error_message (yyvs6.item (yyvsp6).item (1), yyvs6.item (yyvsp6).item (2),
													yyvs6.item (yyvsp6).item (3), yyvs6.item (yyvsp6).item (4)))
	end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp6 := yyvsp6 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 178 then
--|#line 1294 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1294")
end

	ri_scale (yyvs6.item (yyvsp6).item (1), yyvs6.item (yyvsp6).item (2), yyvs6.item (yyvsp6).item (3))
	
	debug ("semantics")
		  io.put_string ("Scale ")
		  print_values (yyvs6.item (yyvsp6), false)
		  io.put_string ("%N%N")
	end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp6 := yyvsp6 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 179 then
--|#line 1305 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1305")
end

	if is_skew_valid (yyvs6.item (yyvsp6).item (1),
						yyvs6.item (yyvsp6).item (2), yyvs6.item (yyvsp6).item (3), yyvs6.item (yyvsp6).item (4),
						yyvs6.item (yyvsp6).item (5), yyvs6.item (yyvsp6).item (6), yyvs6.item (yyvsp6).item (7)) then
		  ri_skew (yyvs6.item (yyvsp6).item (1),
				  yyvs6.item (yyvsp6).item (2), yyvs6.item (yyvsp6).item (3), yyvs6.item (yyvsp6).item (4),
				  yyvs6.item (yyvsp6).item (5), yyvs6.item (yyvsp6).item (6), yyvs6.item (yyvsp6).item (7))
		  
		  debug ("semantics")
			  io.put_string ("Skew ")
			  print_values (yyvs6.item (yyvsp6), true)
			  io.put_string ("%N%N")
		  end
	else
		  rib_error ("Skew",
					 generate_skew_error_message (yyvs6.item (yyvsp6).item (1), yyvs6.item (yyvsp6).item (2),
												  yyvs6.item (yyvsp6).item (3), yyvs6.item (yyvsp6).item (4),
												  yyvs6.item (yyvsp6).item (5), yyvs6.item (yyvsp6).item (6),
												  yyvs6.item (yyvsp6).item (7)))
	end
	
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp6 := yyvsp6 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 180 then
--|#line 1329 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1329")
end

	if is_deformation_valid (str1, yyvs7.item (yyvsp7)) then
		  ri_deformation (str1, yyvs7.item (yyvsp7))
		  
		  debug ("semantics")
			  io.put_string ("Deformation")
			  io.put_string (" ")
			  io.put_string (yyvs4.item (yyvsp4))
			  io.put_string (" ")
			  yyvs7.item (yyvsp7).print_parameter_list
			  io.put_string ("%N%N")
		  end
	else
		  rib_error ("Deformation",
					 generate_deformation_error_message (str1, yyvs7.item (yyvsp7)))
	end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp1 := yyvsp1 -1
	yyvsp4 := yyvsp4 -1
	yyvsp7 := yyvsp7 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 181 then
--|#line 1329 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1329")
end

	str1 ?= yyvs4.item (yyvsp4)
	reset_variables
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 182 then
--|#line 1353 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1353")
end

	if is_coordinate_system_valid (yyvs4.item (yyvsp4)) then
		  ri_coordinate_system (yyvs4.item (yyvsp4))
		  
		  debug ("semantics")
			  io.put_string ("CoordinateSystem ")
			  io.put_string (yyvs4.item (yyvsp4))
			  io.put_string ("%N%N")
		  end
	else
		  rib_error ("CoordinateSystem",
					 generate_coordinate_system_error_message (yyvs4.item (yyvsp4)))
	end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp4 := yyvsp4 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 183 then
--|#line 1369 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1369")
end

	if is_coordinate_sys_transform_valid (yyvs4.item (yyvsp4)) and then
		  has_coordinate_system (yyvs4.item (yyvsp4)) then
		  ri_coord_sys_transform (yyvs4.item (yyvsp4))
		  
		  debug ("semantics")
			  io.put_string ("CoordSysTransform ")
			  io.put_string (yyvs4.item (yyvsp4))
			  io.put_string ("%N%N")
		  end
	else
		  rib_error ("CoordSysTransform",
					 generate_coordinate_sys_transform_error_message (yyvs4.item (yyvsp4)))
	end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp4 := yyvsp4 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 184 then
--|#line 1387 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1387")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 185 then
--|#line 1388 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1388")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 186 then
--|#line 1389 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1389")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 187 then
--|#line 1390 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1390")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 188 then
--|#line 1391 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1391")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 189 then
--|#line 1393 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1393")
end

	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 8
	yyvsp4 := yyvsp4 -5
	yyvsp6 := yyvsp6 -1
	yyvsp7 := yyvsp7 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 190 then
--|#line 1398 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1398")
end

	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 8
	yyvsp4 := yyvsp4 -5
	yyvsp6 := yyvsp6 -1
	yyvsp7 := yyvsp7 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 191 then
--|#line 1403 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1403")
end

	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 7
	yyvsp4 := yyvsp4 -5
	yyvsp7 := yyvsp7 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 192 then
--|#line 1409 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1409")
end

	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 12
	yyvsp4 := yyvsp4 -8
	yyvsp3 := yyvsp3 -1
	yyvsp6 := yyvsp6 -1
	yyvsp7 := yyvsp7 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 193 then
--|#line 1416 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1416")
end

	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp4 := yyvsp4 -2
	yyvsp7 := yyvsp7 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 194 then
--|#line 1421 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1421")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 195 then
--|#line 1422 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1422")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 196 then
--|#line 1423 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1423")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 197 then
--|#line 1424 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1424")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 198 then
--|#line 1426 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1426")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 199 then
--|#line 1427 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1427")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 200 then
--|#line 1429 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1429")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 201 then
--|#line 1430 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1430")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 202 then
--|#line 1431 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1431")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 203 then
--|#line 1432 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1432")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 204 then
--|#line 1434 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1434")
end

	if yyvs7.item (yyvsp7).has_tag ("%"P%"") then
		  -- Assume that a single polygon will not need 64 bit verticies
		  tmp_index := yyvs7.item (yyvsp7).item (yyvs7.item (yyvsp7).index_of_tag ("%"P%"")).second.second.count.to_integer_32
	end
	
	ri_polygon (tmp_index, yyvs7.item (yyvsp7))
	
	debug ("semantics")
		  io.put_string ("Polygon")
		  io.put_string (" ")
		  yyvs7.item (yyvsp7).print_parameter_list
		  io.put_string ("%N%N")
	end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -1
	yyvsp7 := yyvsp7 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 205 then
--|#line 1434 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1434")
end

	reset_variables
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 206 then
--|#line 1455 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1455")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp6 := yyvsp6 -1
	yyvsp7 := yyvsp7 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 207 then
--|#line 1457 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1457")
end

	tmp_index := tmp_array.count.to_integer_32
	
	ri_points_polygons (tmp_index, int_array, int_array_64, yyvs7.item (yyvsp7))
	
	debug ("semantics")
		  io.put_string ("PointsPolygons")
		  io.put_string (" ")
		  print_values (tmp_array, true)
		  print_values (tmp_array1, true)
		  yyvs7.item (yyvsp7).print_parameter_list
		  io.put_string ("%N%N")
	end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 7
	yyvsp1 := yyvsp1 -3
	yyvsp6 := yyvsp6 -2
	yyvsp7 := yyvsp7 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 208 then
--|#line 1457 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1457")
end

reset_variables 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 209 then
--|#line 1457 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1457")
end

	tmp_array := yyvs6.item (yyvsp6)
	create int_array.make (tmp_array.count)
	from
		  tmp_array.start
	until
		  tmp_array.after
	loop
		  int_array.force_last (real_64_truncated_to_integer (tmp_array.item_for_iteration))
		  tmp_array.forth
	end
	
	reset_variables
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 210 then
--|#line 1457 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1457")
end

	tmp_array1 := yyvs6.item (yyvsp6)
	create int_array_64.make (tmp_array1.count)
	from
		  tmp_array1.start
	until
		  tmp_array1.after
	loop
		  -- Convert to 1-based indicies
		  int_array_64.force_last (real_64_truncated_to_integer_64 (tmp_array1.item_for_iteration) + 1)
		  tmp_array1.forth
	end
	
	reset_variables
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 211 then
--|#line 1506 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1506")
end

	tmp_index := tmp_array.count.to_integer_32
	
	ri_points_general_polygons (tmp_index, int_array, int_array1, int_array_64, yyvs7.item (yyvsp7))
	
	debug ("semantics")
		  io.put_string ("PointsGeneralPolygons")
		  io.put_string (" ")
		  print_values (tmp_array, true)
		  print_values (tmp_array1, true)
		  print_values (tmp_array2, true)
		  yyvs7.item (yyvsp7).print_parameter_list
		  io.put_string ("%N%N")
	end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 9
	yyvsp1 := yyvsp1 -4
	yyvsp6 := yyvsp6 -3
	yyvsp7 := yyvsp7 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 212 then
--|#line 1506 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1506")
end

reset_variables 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 213 then
--|#line 1506 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1506")
end

	tmp_array := yyvs6.item (yyvsp6)
	create int_array.make (tmp_array.count)
	from
		  tmp_array.start
	until
		  tmp_array.after
	loop
		  int_array.force_last (real_64_truncated_to_integer (tmp_array.item_for_iteration))
		  tmp_array.forth
	end
	
	reset_variables
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 214 then
--|#line 1506 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1506")
end

	tmp_array1 := yyvs6.item (yyvsp6)
	create int_array1.make (tmp_array1.count)
	from
		  tmp_array1.start
	until
		  tmp_array1.after
	loop
		  -- Convert to 1-based indicies
		  int_array1.force_last (real_64_truncated_to_integer (tmp_array1.item_for_iteration))
		  tmp_array1.forth
	end
	
	reset_variables
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 215 then
--|#line 1506 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1506")
end

	tmp_array2 := yyvs6.item (yyvsp6)
	create int_array_64.make (tmp_array2.count)
	from
		  tmp_array2.start
	until
		  tmp_array2.after
	loop
		  -- Convert to 1-based indicies
		  int_array_64.force_last (real_64_truncated_to_integer_64 (tmp_array2.item_for_iteration) + 1)
		  tmp_array2.forth
	end
	
	reset_variables
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 216 then
--|#line 1572 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1572")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 217 then
--|#line 1573 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1573")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 218 then
--|#line 1575 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1575")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 219 then
--|#line 1576 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1576")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 220 then
--|#line 1577 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1577")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 221 then
--|#line 1578 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1578")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 222 then
--|#line 1580 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1580")
end

		if is_patch_valid (yyvs4.item (yyvsp4), parameters) then
			ri_patch (yyvs4.item (yyvsp4), parameters)
			
			debug ("semantics")
				io.put_string ("Patch ")
				io.put_string (yyvs4.item (yyvsp4))
				io.put_string (" ")
				parameters.print_parameter_list
				io.put_string ("%N%N")
			end
		else
			rib_error ("Patch",
					   generate_patch_error_message (yyvs4.item (yyvsp4), parameters))
		end
				
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp1 := yyvsp1 -1
	yyvsp4 := yyvsp4 -1
	yyvsp7 := yyvsp7 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 223 then
--|#line 1580 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1580")
end

reset_variables 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 224 then
--|#line 1602 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1602")
end

		if is_patch_mesh_valid (yyvs4.item (yyvsp4 - 2), yyvs2.item (yyvsp2 - 1), yyvs4.item (yyvsp4 - 1), yyvs2.item (yyvsp2), yyvs4.item (yyvsp4), parameters) then
			ri_patch_mesh (yyvs4.item (yyvsp4 - 2), yyvs2.item (yyvsp2 - 1), yyvs4.item (yyvsp4 - 1), yyvs2.item (yyvsp2), yyvs4.item (yyvsp4), parameters)
			
			debug ("semantics")
				io.put_string ("PatchMesh ")
				io.put_string (yyvs4.item (yyvsp4 - 2))
				io.put_string (" ")
				io.put_string (yyvs2.item (yyvsp2 - 1).out)
				io.put_string (" ")
				io.put_string (yyvs4.item (yyvsp4 - 1))
				io.put_string (" ")
				io.put_string (yyvs2.item (yyvsp2).out)
				io.put_string (" ")
				io.put_string (yyvs4.item (yyvsp4))
				io.put_string (" ")
				parameters.print_parameter_list
				io.put_string ("%N%N")
			end
		else
			rib_error ("PatchMesh",
					   generate_patch_mesh_error_message (yyvs4.item (yyvsp4 - 2), yyvs2.item (yyvsp2 - 1), yyvs4.item (yyvsp4 - 1), yyvs2.item (yyvsp2), yyvs4.item (yyvsp4), parameters))
		end
				
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 8
	yyvsp1 := yyvsp1 -1
	yyvsp4 := yyvsp4 -3
	yyvsp2 := yyvsp2 -2
	yyvsp7 := yyvsp7 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 225 then
--|#line 1602 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1602")
end

reset_variables 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 226 then
--|#line 1631 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1631")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 11
	yyvsp1 := yyvsp1 -2
	yyvsp4 := yyvsp4 -1
	yyvsp6 := yyvsp6 -5
	yyvsp5 := yyvsp5 -1
	yyvsp7 := yyvsp7 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 227 then
--|#line 1635 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1635")
end

	debug ("semantics")
		  io.put_string ("NuPatch")
		  io.put_string (" ")
		  io.put_integer (yyvs2.item (yyvsp2 - 3))
		  io.put_string (" ")
		  io.put_integer (yyvs2.item (yyvsp2 - 2))
		  io.put_string (" ")
		  print_values (tmp_array, true)
		  io.put_double (yyvs3.item (yyvsp3 - 3))
		  io.put_string (" ")
		  io.put_double (yyvs3.item (yyvsp3 - 2))
		  io.put_string (" ")
		  io.put_integer (yyvs2.item (yyvsp2 - 1))
		  io.put_string (" ")
		  io.put_integer (yyvs2.item (yyvsp2))
		  io.put_string (" ")
		  print_values (tmp_array1, true)
		  io.put_double (yyvs3.item (yyvsp3 - 1))
		  io.put_string (" ")
		  io.put_double (yyvs3.item (yyvsp3))		  
		  io.put_string (" ")
		  yyvs7.item (yyvsp7).print_parameter_list
		  io.put_string ("%N%N")
	end
	
	ri_nu_patch (yyvs2.item (yyvsp2 - 3), yyvs2.item (yyvsp2 - 2), tmp_array, yyvs3.item (yyvsp3 - 3), yyvs3.item (yyvsp3 - 2), yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2), tmp_array1, yyvs3.item (yyvsp3 - 1), yyvs3.item (yyvsp3), yyvs7.item (yyvsp7))
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 15
	yyvsp1 := yyvsp1 -3
	yyvsp2 := yyvsp2 -4
	yyvsp6 := yyvsp6 -2
	yyvsp3 := yyvsp3 -4
	yyvsp7 := yyvsp7 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 228 then
--|#line 1635 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1635")
end

reset_variables 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 229 then
--|#line 1635 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1635")
end

	tmp_array := yyvs6.item (yyvsp6)
	reset_variables 
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 230 then
--|#line 1635 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1635")
end

	tmp_array1 := yyvs6.item (yyvsp6)
	reset_variables 
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 231 then
--|#line 1678 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1678")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 232 then
--|#line 1679 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1679")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 233 then
--|#line 1681 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1681")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 234 then
--|#line 1682 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1682")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 235 then
--|#line 1683 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1683")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 236 then
--|#line 1684 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1684")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 237 then
--|#line 1685 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1685")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 238 then
--|#line 1686 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1686")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 239 then
--|#line 1687 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1687")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 240 then
--|#line 1689 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1689")
end

	ri_sphere (yyvs6.item (yyvsp6).item (1), yyvs6.item (yyvsp6).item (2), yyvs6.item (yyvsp6).item (3), yyvs6.item (yyvsp6).item (4), yyvs7.item (yyvsp7))
	
	debug ("semantics")
		  io.put_string ("Sphere")
		  io.put_string (" ")
		  print_values (yyvs6.item (yyvsp6), true)
		  io.put_string (" ")
		  yyvs7.item (yyvsp7).print_parameter_list
		  io.put_string ("%N%N")
	end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp1 := yyvsp1 -1
	yyvsp6 := yyvsp6 -1
	yyvsp7 := yyvsp7 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 241 then
--|#line 1689 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1689")
end

	reset_variables
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 242 then
--|#line 1707 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1707")
end

	ri_cone (yyvs6.item (yyvsp6).item (1), yyvs6.item (yyvsp6).item (2), yyvs6.item (yyvsp6).item (3), yyvs7.item (yyvsp7))
	
	debug ("semantics")
		  io.put_string ("Cone")
		  io.put_string (" ")
		  print_values (yyvs6.item (yyvsp6), true)
		  io.put_string (" ")
		  yyvs7.item (yyvsp7).print_parameter_list
		  io.put_string ("%N%N")
	end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp1 := yyvsp1 -1
	yyvsp6 := yyvsp6 -1
	yyvsp7 := yyvsp7 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 243 then
--|#line 1707 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1707")
end

	reset_variables
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 244 then
--|#line 1725 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1725")
end

	ri_cylinder (yyvs6.item (yyvsp6).item (1), yyvs6.item (yyvsp6).item (2), yyvs6.item (yyvsp6).item (3), yyvs6.item (yyvsp6).item (4), yyvs7.item (yyvsp7))
	
	debug ("semantics")
		  io.put_string ("Cylinder")
		  io.put_string (" ")
		  print_values (yyvs6.item (yyvsp6), true)
		  io.put_string (" ")
		  yyvs7.item (yyvsp7).print_parameter_list
		  io.put_string ("%N%N")
	end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp1 := yyvsp1 -1
	yyvsp6 := yyvsp6 -1
	yyvsp7 := yyvsp7 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 245 then
--|#line 1725 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1725")
end

	reset_variables
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 246 then
--|#line 1743 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1743")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp6 := yyvsp6 -1
	yyvsp7 := yyvsp7 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 247 then
--|#line 1745 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1745")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp6 := yyvsp6 -1
	yyvsp7 := yyvsp7 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 248 then
--|#line 1747 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1747")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp6 := yyvsp6 -1
	yyvsp7 := yyvsp7 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 249 then
--|#line 1749 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1749")
end

	ri_torus (yyvs6.item (yyvsp6).item (1), yyvs6.item (yyvsp6).item (2), yyvs6.item (yyvsp6).item (3), yyvs6.item (yyvsp6).item (4), yyvs6.item (yyvsp6).item (5), yyvs7.item (yyvsp7))
	
	debug ("semantics")
		  io.put_string ("Torus")
		  io.put_string (" ")
		  print_values (yyvs6.item (yyvsp6), true)
		  io.put_string (" ")
		  yyvs7.item (yyvsp7).print_parameter_list
		  io.put_string ("%N%N")
	end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp1 := yyvsp1 -1
	yyvsp6 := yyvsp6 -1
	yyvsp7 := yyvsp7 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 250 then
--|#line 1749 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1749")
end

	reset_variables
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 251 then
--|#line 1767 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1767")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 252 then
--|#line 1768 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1768")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 253 then
--|#line 1770 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1770")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 254 then
--|#line 1771 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1771")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 255 then
--|#line 1772 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1772")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 256 then
--|#line 1773 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1773")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 257 then
--|#line 1775 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1775")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp4 := yyvsp4 -1
	yyvsp7 := yyvsp7 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 258 then
--|#line 1777 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1777")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp7 := yyvsp7 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 259 then
--|#line 1779 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1779")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 5
	yyvsp4 := yyvsp4 -2
	yyvsp6 := yyvsp6 -1
	yyvsp7 := yyvsp7 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 260 then
--|#line 1781 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1781")
end

		ri_object_instance (yyvs2.item (yyvsp2))
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 261 then
--|#line 1787 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1787")
end

		ri_attribute_end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp1 := yyvsp1 -3
	yyvs1.put (yyval1, yyvsp1)
end
when 262 then
--|#line 1787 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1787")
end

		ri_attribute_begin
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 263 then
--|#line 1796 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1796")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 264 then
--|#line 1797 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1797")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 265 then
--|#line 1799 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1799")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 266 then
--|#line 1800 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1800")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 267 then
--|#line 1801 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1801")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 268 then
--|#line 1802 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1802")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 269 then
--|#line 1803 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1803")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 270 then
--|#line 1804 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1804")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 271 then
--|#line 1805 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1805")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 272 then
--|#line 1806 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1806")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 273 then
--|#line 1807 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1807")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 274 then
--|#line 1809 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1809")
end

		ri_transform_end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp1 := yyvsp1 -3
	yyvs1.put (yyval1, yyvsp1)
end
when 275 then
--|#line 1809 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1809")
end

		ri_transform_begin
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 276 then
--|#line 1818 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1818")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 277 then
--|#line 1819 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1819")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 278 then
--|#line 1821 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1821")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 279 then
--|#line 1822 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1822")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 280 then
--|#line 1823 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1823")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 281 then
--|#line 1824 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1824")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 282 then
--|#line 1825 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1825")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 283 then
--|#line 1826 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1826")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 284 then
--|#line 1827 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1827")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 285 then
--|#line 1828 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1828")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 286 then
--|#line 1829 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1829")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 287 then
--|#line 1831 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1831")
end

		ri_object_end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 5
	yyvsp1 := yyvsp1 -3
	yyvsp2 := yyvsp2 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 288 then
--|#line 1831 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1831")
end

		ri_object_begin (yyvs2.item (yyvsp2))
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 289 then
--|#line 1840 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1840")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 290 then
--|#line 1841 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1841")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 291 then
--|#line 1843 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1843")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 292 then
--|#line 1844 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1844")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 293 then
--|#line 1846 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1846")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyvs1.put (yyval1, yyvsp1)
end
when 294 then
--|#line 1848 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1848")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 295 then
--|#line 1849 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1849")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 296 then
--|#line 1851 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1851")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 297 then
--|#line 1852 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1852")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 298 then
--|#line 1853 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1853")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 299 then
--|#line 1854 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1854")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 300 then
--|#line 1855 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1855")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 301 then
--|#line 1857 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1857")
end

		ri_attribute_end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp1 := yyvsp1 -3
	yyvs1.put (yyval1, yyvsp1)
end
when 302 then
--|#line 1857 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1857")
end

		ri_attribute_begin
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 303 then
--|#line 1867 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1867")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 304 then
--|#line 1868 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1868")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 305 then
--|#line 1870 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1870")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 306 then
--|#line 1871 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1871")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 307 then
--|#line 1872 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1872")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 308 then
--|#line 1873 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1873")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 309 then
--|#line 1874 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1874")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 310 then
--|#line 1875 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1875")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 311 then
--|#line 1876 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1876")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 312 then
--|#line 1877 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1877")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 313 then
--|#line 1878 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1878")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 314 then
--|#line 1879 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1879")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 315 then
--|#line 1880 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1880")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 316 then
--|#line 1882 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1882")
end

		ri_transform_end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp1 := yyvsp1 -3
	yyvs1.put (yyval1, yyvsp1)
end
when 317 then
--|#line 1882 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1882")
end

		ri_transform_begin
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 318 then
--|#line 1892 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1892")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 319 then
--|#line 1893 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1893")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 320 then
--|#line 1895 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1895")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 321 then
--|#line 1896 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1896")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 322 then
--|#line 1897 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1897")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 323 then
--|#line 1898 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1898")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 324 then
--|#line 1899 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1899")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 325 then
--|#line 1900 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1900")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 326 then
--|#line 1901 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1901")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 327 then
--|#line 1902 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1902")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 328 then
--|#line 1903 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1903")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 329 then
--|#line 1904 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1904")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 330 then
--|#line 1905 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1905")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 331 then
--|#line 1906 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1906")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 332 then
--|#line 1908 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1908")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyvs1.put (yyval1, yyvsp1)
end
when 333 then
--|#line 1910 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1910")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 334 then
--|#line 1911 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1911")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 335 then
--|#line 1913 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1913")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 336 then
--|#line 1914 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1914")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 337 then
--|#line 1915 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1915")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 338 then
--|#line 1916 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1916")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 339 then
--|#line 1917 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1917")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 340 then
--|#line 1918 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1918")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 341 then
--|#line 1920 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1920")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp1 := yyvsp1 -2
	yyvsp4 := yyvsp4 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 342 then
--|#line 1922 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1922")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 343 then
--|#line 1923 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1923")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 344 then
--|#line 1925 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1925")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 345 then
--|#line 1926 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1926")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 346 then
--|#line 1927 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1927")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 347 then
--|#line 1928 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1928")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 348 then
--|#line 1929 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1929")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 349 then
--|#line 1930 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1930")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 350 then
--|#line 1931 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1931")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 351 then
--|#line 1932 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1932")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 352 then
--|#line 1933 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1933")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 353 then
--|#line 1934 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1934")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 354 then
--|#line 1935 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1935")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 355 then
--|#line 1937 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1937")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 356 then
--|#line 1938 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1938")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 357 then
--|#line 1940 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1940")
end

	ri_world_end
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp1 := yyvsp1 -3
	yyvs1.put (yyval1, yyvsp1)
end
when 358 then
--|#line 1940 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1940")
end

	ri_world_begin
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 359 then
--|#line 1949 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1949")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 360 then
--|#line 1950 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1950")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 361 then
--|#line 1952 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1952")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp1 := yyvsp1 -3
	yyvs1.put (yyval1, yyvsp1)
end
when 362 then
--|#line 1954 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1954")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 363 then
--|#line 1955 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1955")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 364 then
--|#line 1957 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1957")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 365 then
--|#line 1958 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1958")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 366 then
--|#line 1959 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1959")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 367 then
--|#line 1960 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1960")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 368 then
--|#line 1961 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1961")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 369 then
--|#line 1962 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1962")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 370 then
--|#line 1963 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1963")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 371 then
--|#line 1964 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1964")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 372 then
--|#line 1965 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1965")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 373 then
--|#line 1966 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1966")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 374 then
--|#line 1967 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1967")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 375 then
--|#line 1969 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1969")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 376 then
--|#line 1970 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1970")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyvs1.put (yyval1, yyvsp1)
end
when 377 then
--|#line 1972 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1972")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 378 then
--|#line 1973 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1973")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs1.put (yyval1, yyvsp1)
end
when 379 then
--|#line 1975 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1975")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 380 then
--|#line 1976 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1976")
end


if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp1 := yyvsp1 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp1 >= yyvsc1 then
		if yyvs1 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs1")
			end
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs1")
			end
			yyvsc1 := yyvsc1 + yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.resize (yyvs1, yyvsc1)
		end
	end
	yyvs1.put (yyval1, yyvsp1)
end
when 381 then
--|#line 1978 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1978")
end

values.force_last (yyvs3.item (yyvsp3)) 
	yyval6 := values 
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp6 := yyvsp6 + 1
	yyvsp3 := yyvsp3 -1
	if yyvsp6 >= yyvsc6 then
		if yyvs6 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs6")
			end
			create yyspecial_routines6
			yyvsc6 := yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.make (yyvsc6)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs6")
			end
			yyvsc6 := yyvsc6 + yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.resize (yyvs6, yyvsc6)
		end
	end
	yyvs6.put (yyval6, yyvsp6)
end
when 382 then
--|#line 1982 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1982")
end

	values.force_last (yyvs3.item (yyvsp3)) 
	yyval6 := values 
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp3 := yyvsp3 -1
	yyvs6.put (yyval6, yyvsp6)
end
when 383 then
--|#line 1988 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1988")
end

	values.force_last (yyvs2.item (yyvsp2)) 
	yyval6 := values 
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp6 := yyvsp6 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp6 >= yyvsc6 then
		if yyvs6 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs6")
			end
			create yyspecial_routines6
			yyvsc6 := yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.make (yyvsc6)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs6")
			end
			yyvsc6 := yyvsc6 + yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.resize (yyvs6, yyvsc6)
		end
	end
	yyvs6.put (yyval6, yyvsp6)
end
when 384 then
--|#line 1993 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1993")
end

	values.force_last (yyvs2.item (yyvsp2)) 
	yyval6 := values 
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyvs6.put (yyval6, yyvsp6)
end
when 385 then
--|#line 1999 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 1999")
end

yyval3 := yyvs2.item (yyvsp2) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvsp3 := yyvsp3 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp3 >= yyvsc3 then
		if yyvs3 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs3")
			end
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs3")
			end
			yyvsc3 := yyvsc3 + yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.resize (yyvs3, yyvsc3)
		end
	end
	yyvs3.put (yyval3, yyvsp3)
end
when 386 then
--|#line 2001 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 2001")
end

yyval3 := yyvs3.item (yyvsp3) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs3.put (yyval3, yyvsp3)
end
when 387 then
--|#line 2004 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 2004")
end

create values.make (2)
	values.force_last (yyvs3.item (yyvsp3 - 1))
	values.force_last (yyvs3.item (yyvsp3))
	yyval6 := values
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 2
	yyvsp6 := yyvsp6 + 1
	yyvsp3 := yyvsp3 -2
	if yyvsp6 >= yyvsc6 then
		if yyvs6 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs6")
			end
			create yyspecial_routines6
			yyvsc6 := yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.make (yyvsc6)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs6")
			end
			yyvsc6 := yyvsc6 + yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.resize (yyvs6, yyvsc6)
		end
	end
	yyvs6.put (yyval6, yyvsp6)
end
when 388 then
--|#line 2011 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 2011")
end

create values.make (3)
	values.force_last (yyvs3.item (yyvsp3 - 2))
	values.force_last (yyvs3.item (yyvsp3 - 1))
	values.force_last (yyvs3.item (yyvsp3))
	yyval6 := values
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp6 := yyvsp6 + 1
	yyvsp3 := yyvsp3 -3
	if yyvsp6 >= yyvsc6 then
		if yyvs6 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs6")
			end
			create yyspecial_routines6
			yyvsc6 := yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.make (yyvsc6)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs6")
			end
			yyvsc6 := yyvsc6 + yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.resize (yyvs6, yyvsc6)
		end
	end
	yyvs6.put (yyval6, yyvsp6)
end
when 389 then
--|#line 2019 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 2019")
end

create values.make (4)
	values.force_last (yyvs3.item (yyvsp3 - 3))
	values.force_last (yyvs3.item (yyvsp3 - 2))
	values.force_last (yyvs3.item (yyvsp3 - 1))
	values.force_last (yyvs3.item (yyvsp3))
	yyval6 := values
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 4
	yyvsp6 := yyvsp6 + 1
	yyvsp3 := yyvsp3 -4
	if yyvsp6 >= yyvsc6 then
		if yyvs6 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs6")
			end
			create yyspecial_routines6
			yyvsc6 := yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.make (yyvsc6)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs6")
			end
			yyvsc6 := yyvsc6 + yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.resize (yyvs6, yyvsc6)
		end
	end
	yyvs6.put (yyval6, yyvsp6)
end
when 390 then
--|#line 2028 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 2028")
end

create values.make (5)
	values.force_last (yyvs3.item (yyvsp3 - 4))
	values.force_last (yyvs3.item (yyvsp3 - 3))
	values.force_last (yyvs3.item (yyvsp3 - 2))
	values.force_last (yyvs3.item (yyvsp3 - 1))
	values.force_last (yyvs3.item (yyvsp3))
	yyval6 := values
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 5
	yyvsp6 := yyvsp6 + 1
	yyvsp3 := yyvsp3 -5
	if yyvsp6 >= yyvsc6 then
		if yyvs6 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs6")
			end
			create yyspecial_routines6
			yyvsc6 := yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.make (yyvsc6)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs6")
			end
			yyvsc6 := yyvsc6 + yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.resize (yyvs6, yyvsc6)
		end
	end
	yyvs6.put (yyval6, yyvsp6)
end
when 391 then
--|#line 2038 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 2038")
end

create values.make (6)
	values.force_last (yyvs3.item (yyvsp3 - 5))
	values.force_last (yyvs3.item (yyvsp3 - 4))
	values.force_last (yyvs3.item (yyvsp3 - 3))
	values.force_last (yyvs3.item (yyvsp3 - 2))
	values.force_last (yyvs3.item (yyvsp3 - 1))
	values.force_last (yyvs3.item (yyvsp3))
	yyval6 := values
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 6
	yyvsp6 := yyvsp6 + 1
	yyvsp3 := yyvsp3 -6
	if yyvsp6 >= yyvsc6 then
		if yyvs6 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs6")
			end
			create yyspecial_routines6
			yyvsc6 := yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.make (yyvsc6)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs6")
			end
			yyvsc6 := yyvsc6 + yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.resize (yyvs6, yyvsc6)
		end
	end
	yyvs6.put (yyval6, yyvsp6)
end
when 392 then
--|#line 2049 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 2049")
end

create values.make (7)
	values.force_last (yyvs3.item (yyvsp3 - 6))
	values.force_last (yyvs3.item (yyvsp3 - 5))
	values.force_last (yyvs3.item (yyvsp3 - 4))
	values.force_last (yyvs3.item (yyvsp3 - 3))
	values.force_last (yyvs3.item (yyvsp3 - 2))
	values.force_last (yyvs3.item (yyvsp3 - 1))
	values.force_last (yyvs3.item (yyvsp3))
	yyval6 := values
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 7
	yyvsp6 := yyvsp6 + 1
	yyvsp3 := yyvsp3 -7
	if yyvsp6 >= yyvsc6 then
		if yyvs6 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs6")
			end
			create yyspecial_routines6
			yyvsc6 := yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.make (yyvsc6)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs6")
			end
			yyvsc6 := yyvsc6 + yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.resize (yyvs6, yyvsc6)
		end
	end
	yyvs6.put (yyval6, yyvsp6)
end
when 393 then
--|#line 2061 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 2061")
end

create values.make (8)
	values.force_last (yyvs3.item (yyvsp3 - 7))
	values.force_last (yyvs3.item (yyvsp3 - 6))
	values.force_last (yyvs3.item (yyvsp3 - 5))
	values.force_last (yyvs3.item (yyvsp3 - 4))
	values.force_last (yyvs3.item (yyvsp3 - 3))
	values.force_last (yyvs3.item (yyvsp3 - 2))
	values.force_last (yyvs3.item (yyvsp3 - 1))
	values.force_last (yyvs3.item (yyvsp3))
	yyval6 := values
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 8
	yyvsp6 := yyvsp6 + 1
	yyvsp3 := yyvsp3 -8
	if yyvsp6 >= yyvsc6 then
		if yyvs6 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs6")
			end
			create yyspecial_routines6
			yyvsc6 := yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.make (yyvsc6)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs6")
			end
			yyvsc6 := yyvsc6 + yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.resize (yyvs6, yyvsc6)
		end
	end
	yyvs6.put (yyval6, yyvsp6)
end
when 394 then
--|#line 2074 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 2074")
end

create values.make (16)
	values.force_last (yyvs3.item (yyvsp3 - 15))
	values.force_last (yyvs3.item (yyvsp3 - 14))
	values.force_last (yyvs3.item (yyvsp3 - 13))
	values.force_last (yyvs3.item (yyvsp3 - 12))
	values.force_last (yyvs3.item (yyvsp3 - 11))
	values.force_last (yyvs3.item (yyvsp3 - 10))
	values.force_last (yyvs3.item (yyvsp3 - 9))
	values.force_last (yyvs3.item (yyvsp3 - 8))
	values.force_last (yyvs3.item (yyvsp3 - 7))
	values.force_last (yyvs3.item (yyvsp3 - 6))
	values.force_last (yyvs3.item (yyvsp3 - 5))
	values.force_last (yyvs3.item (yyvsp3 - 4))
	values.force_last (yyvs3.item (yyvsp3 - 3))
	values.force_last (yyvs3.item (yyvsp3 - 2))
	values.force_last (yyvs3.item (yyvsp3 - 1))
	values.force_last (yyvs3.item (yyvsp3))
	yyval6 := values
	
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 16
	yyvsp6 := yyvsp6 + 1
	yyvsp3 := yyvsp3 -16
	if yyvsp6 >= yyvsc6 then
		if yyvs6 = Void then
			debug ("GEYACC")
				std.error.put_line ("Create yyvs6")
			end
			create yyspecial_routines6
			yyvsc6 := yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.make (yyvsc6)
		else
			debug ("GEYACC")
				std.error.put_line ("Resize yyvs6")
			end
			yyvsc6 := yyvsc6 + yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.resize (yyvs6, yyvsc6)
		end
	end
	yyvs6.put (yyval6, yyvsp6)
end
when 395 then
--|#line 2099 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 2099")
end

yyval6 := yyvs6.item (yyvsp6) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs6.put (yyval6, yyvsp6)
end
when 396 then
--|#line 2101 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 2101")
end

yyval6 := yyvs6.item (yyvsp6) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs6.put (yyval6, yyvsp6)
end
when 397 then
--|#line 2104 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 2104")
end

yyval6 := yyvs6.item (yyvsp6) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyvs6.put (yyval6, yyvsp6)
end
when 398 then
--|#line 2107 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 2107")
end

yyval6 := yyvs6.item (yyvsp6) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs6.put (yyval6, yyvsp6)
end
when 399 then
--|#line 2109 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 2109")
end

yyval6 := yyvs6.item (yyvsp6) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs6.put (yyval6, yyvsp6)
end
when 400 then
--|#line 2112 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 2112")
end

yyval6 := yyvs6.item (yyvsp6) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyvs6.put (yyval6, yyvsp6)
end
when 401 then
--|#line 2115 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 2115")
end

yyval6 := yyvs6.item (yyvsp6) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs6.put (yyval6, yyvsp6)
end
when 402 then
--|#line 2117 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 2117")
end

yyval6 := yyvs6.item (yyvsp6) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs6.put (yyval6, yyvsp6)
end
when 403 then
--|#line 2120 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 2120")
end

yyval6 := yyvs6.item (yyvsp6) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyvs6.put (yyval6, yyvsp6)
end
when 404 then
--|#line 2123 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 2123")
end

yyval6 := yyvs6.item (yyvsp6) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs6.put (yyval6, yyvsp6)
end
when 405 then
--|#line 2125 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 2125")
end

yyval6 := yyvs6.item (yyvsp6) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs6.put (yyval6, yyvsp6)
end
when 406 then
--|#line 2128 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 2128")
end

yyval6 := yyvs6.item (yyvsp6) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyvs6.put (yyval6, yyvsp6)
end
when 407 then
--|#line 2131 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 2131")
end

yyval6 := yyvs6.item (yyvsp6) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs6.put (yyval6, yyvsp6)
end
when 408 then
--|#line 2133 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 2133")
end

yyval6 := yyvs6.item (yyvsp6) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs6.put (yyval6, yyvsp6)
end
when 409 then
--|#line 2136 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 2136")
end

yyval6 := yyvs6.item (yyvsp6) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyvs6.put (yyval6, yyvsp6)
end
when 410 then
--|#line 2139 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 2139")
end

yyval6 := yyvs6.item (yyvsp6) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs6.put (yyval6, yyvsp6)
end
when 411 then
--|#line 2141 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 2141")
end

yyval6 := yyvs6.item (yyvsp6) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 1
	yyvs6.put (yyval6, yyvsp6)
end
when 412 then
--|#line 2144 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 2144")
end

yyval6 := yyvs6.item (yyvsp6) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyvs6.put (yyval6, yyvsp6)
end
when 413 then
--|#line 2147 "rib_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'rib_parser.y' at line 2147")
end

yyval6 := yyvs6.item (yyvsp6) 
if yy_parsing_status = yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 -2
	yyvs6.put (yyval6, yyvsp6)
end
			else
				debug ("GEYACC")
					std.error.put_string ("Error in parser: unknown rule id: ")
					std.error.put_integer (yy_act)
					std.error.put_new_line
				end
				abort
			end
		end

	yy_do_error_action (yy_act: INTEGER) is
			-- Execute error action.
		do
			inspect yy_act
			when 683 then
					-- End-of-file expected action.
				report_eof_expected_error
			else
					-- Default action.
				report_error ("parse error")
			end
		end

feature {NONE} -- Table templates

	yytranslate_template: SPECIAL [INTEGER] is
		once
			Result := yyfixed_array (<<
			    0,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,

			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,

			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    1,    2,    3,    4,
			    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,
			   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,
			   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,
			   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,

			   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,
			   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,
			   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,
			   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,
			   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,
			   95,   96,   97,   98,   99,  100,  101,  102,  103, yyDummy>>)
		end

	yyr1_template: SPECIAL [INTEGER] is
		once
			Result := yyfixed_array (<<
			    0,  134,  135,  135,  137,  137,  137,  137,  137,  137,
			  137,  137,  137,  137,  137,  137,  137,  138,  139,  141,
			  140,  140,  151,  151,  152,  147,  147,  153,  153,  153,
			  153,  153,  153,  153,  153,  153,  153,  153,  153,  153,
			  153,  153,  153,  153,  153,  153,  154,  156,  157,  158,
			  159,  173,  160,  161,  161,  162,  163,  164,  165,  166,
			  167,  174,  168,  155,  175,  176,  177,  169,  178,  170,
			  179,  180,  171,  172,  181,  132,  133,  133,  182,  182,
			  182,  105,  105,  110,  110,  106,  109,  149,  149,  183,
			  183,  183,  183,  183,  183,  183,  183,  183,  183,  183,

			  183,  183,  183,  183,  183,  183,  183,  183,  183,  183,
			  183,  184,  206,  185,  207,  186,  208,  187,  209,  188,
			  210,  189,  211,  190,  212,  191,  213,  192,  214,  193,
			  194,  195,  196,  197,  198,  199,  200,  201,  202,  203,
			  204,  215,  215,  205,  146,  146,  216,  216,  216,  217,
			  220,  221,  218,  222,  223,  224,  219,  225,  226,  148,
			  148,  227,  227,  227,  227,  227,  227,  227,  227,  227,
			  227,  227,  233,  234,  235,  232,  228,  229,  230,  231,
			  236,  239,  237,  238,  150,  150,  150,  150,  150,  240,
			  241,  242,  243,  244,  245,  245,  245,  245,  246,  246,

			  250,  250,  250,  250,  251,  255,  252,  253,  256,  257,
			  258,  254,  259,  260,  261,  262,  247,  247,  263,  263,
			  263,  263,  264,  268,  265,  269,  266,  267,  270,  271,
			  272,  248,  248,  273,  273,  273,  273,  273,  273,  273,
			  274,  281,  275,  282,  276,  283,  277,  278,  279,  280,
			  284,  249,  249,  285,  285,  285,  285,  286,  287,  288,
			  289,  143,  291,  290,  290,  292,  292,  292,  292,  292,
			  292,  292,  292,  292,  142,  294,  293,  293,  295,  295,
			  295,  295,  295,  295,  295,  295,  295,  144,  297,  296,
			  296,  298,  298,  145,  299,  299,  300,  300,  300,  300,

			  300,  301,  303,  302,  302,  304,  304,  304,  304,  304,
			  304,  304,  304,  304,  304,  304,  305,  309,  308,  308,
			  310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
			  310,  310,  306,  311,  311,  312,  312,  312,  312,  312,
			  312,  307,  313,  313,  314,  314,  314,  314,  314,  314,
			  314,  314,  314,  314,  314,  136,  136,  315,  318,  316,
			  316,  319,  317,  317,  322,  322,  322,  322,  322,  322,
			  322,  322,  322,  322,  322,  321,  321,  323,  323,  320,
			  320,  107,  107,  108,  108,  104,  104,  111,  112,  113,
			  114,  115,  116,  117,  118,  119,  119,  120,  121,  121,

			  122,  123,  123,  124,  125,  125,  126,  127,  127,  128,
			  129,  129,  130,  131, yyDummy>>)
		end

	yytypes1_template: SPECIAL [INTEGER] is
		once
			Result := yyfixed_array (<<
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    2,    1,    1,    4,    4,
			    4,    4,    4,    4,    4,    4,    3,    2,    1,    3,
			    6,    6,    6,    3,    6,    3,    6,    6,    3,    1,
			    6,    6,    4,    4,    1,    6,    4,    6,    1,    2,
			    4,    4,    1,    6,    6,    6,    1,    3,    6,    6,

			    6,    6,    2,    4,    3,    4,    1,    3,    6,    6,
			    6,    4,    2,    4,    4,    4,    4,    1,    1,    4,
			    4,    3,    1,    4,    4,    3,    6,    4,    6,    4,
			    6,    3,    6,    6,    4,    6,    6,    3,    6,    4,
			    4,    3,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    4,
			    4,    4,    4,    4,    1,    6,    3,    3,    3,    3,
			    6,    1,    1,    1,    3,    6,    6,    3,    3,    6,

			    6,    3,    1,    6,    3,    1,    1,    1,    1,    1,
			    1,    6,    6,    6,    6,    1,    1,    6,    1,    6,
			    3,    1,    6,    1,    1,    2,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    7,    7,    4,    4,    4,    4,    7,
			    1,    3,    3,    3,    3,    1,    2,    2,    4,    1,

			    3,    6,    1,    1,    1,    3,    7,    1,    3,    7,
			    2,    7,    7,    7,    7,    7,    7,    1,    4,    7,
			    7,    4,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    2,    4,    1,    3,    6,    6,    6,
			    1,    6,    6,    6,    4,    4,    7,    6,    6,    6,
			    6,    6,    2,    4,    4,    1,    1,    6,    1,    1,
			    1,    1,    1,    1,    1,    4,    1,    4,    4,    4,
			    4,    3,    3,    3,    1,    1,    1,    6,    3,    3,
			    3,    6,    1,    1,    1,    4,    1,    1,    1,    1,

			    1,    1,    1,    1,    1,    1,    1,    1,    7,    6,
			    3,    1,    6,    7,    1,    6,    6,    7,    7,    1,
			    1,    1,    2,    2,    1,    6,    6,    7,    7,    4,
			    1,    6,    4,    4,    4,    4,    3,    3,    7,    7,
			    1,    6,    3,    3,    4,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    3,    7,    1,
			    2,    6,    6,    4,    7,    7,    7,    1,    4,    7,

			    1,    1,    4,    5,    4,    7,    6,    6,    3,    3,
			    7,    6,    3,    3,    1,    1,    1,    1,    1,    1,
			    1,    3,    2,    1,    1,    7,    6,    2,    6,    6,
			    4,    1,    4,    7,    7,    3,    3,    6,    3,    7,
			    3,    5,    1,    4,    1,    1,    3,    3,    6,    3,
			    1,    3,    1,    6,    7,    4,    3,    6,    6,    3,
			    7,    1,    6,    3,    6,    2,    7,    7,    3,    6,
			    2,    3,    7,    6,    3,    3,    3,    3,    3,    1,
			    3,    7,    3,    1,    1,    1, yyDummy>>)
		end

	yytypes2_template: SPECIAL [INTEGER] is
		once
			Result := yyfixed_array (<<
			    1,    1,    1,    1,    1,    2,    3,    4,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

			    1,    1,    1,    1, yyDummy>>)
		end

	yydefact_template: SPECIAL [INTEGER] is
		once
			Result := yyfixed_array (<<
			    0,   18,    0,    0,  275,  262,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,  172,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,  138,    0,    0,    0,
			    0,    0,    0,    0,  116,  114,    0,    0,    0,   70,
			    0,    0,    0,    0,    0,    0,    0,    0,   53,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    2,
			    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,
			   14,   15,   16,   20,   25,   27,   28,   29,   30,   31,
			   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,

			   42,   43,   44,   45,   87,   89,   90,   91,   92,   93,
			   94,   95,   96,   97,   98,   99,  100,  101,  102,  103,
			  104,  105,  106,  107,  108,  109,  110,  144,  146,  147,
			  148,  159,  161,  162,  163,  164,  165,  166,  167,  168,
			  169,  170,  171,  184,  185,  186,  187,  188,  296,  299,
			  297,  300,  298,    0,  294,  288,    0,    0,    0,    0,
			    0,    0,    0,  183,  182,  181,  386,  385,    0,    0,
			  407,  179,  408,    0,  178,    0,  177,  176,  175,    0,
			  174,  173,  157,  153,    0,    0,  141,  142,    0,  139,
			  137,    0,    0,  398,  135,  399,    0,    0,  404,  134,

			  405,  133,  132,  131,  130,   68,    0,    0,  410,  129,
			  411,  128,  126,  124,  122,  120,  118,    0,    0,  112,
			   74,   72,    0,   64,    0,    0,   55,   61,   59,    0,
			   57,   56,   54,   52,   51,   49,   48,   47,   46,   19,
			   24,   17,  379,  358,    1,    3,  355,  356,  359,   21,
			  145,   26,  160,   88,  293,  295,    0,  278,  285,  279,
			  280,  281,  282,  283,  286,  284,    0,  276,  265,  272,
			  266,  267,  268,  269,  270,  273,  271,    0,  263,   76,
			    0,    0,    0,    0,   76,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,  381,    0,    0,    0,  136,    0,

			    0,    0,   76,    0,    0,   76,    0,   76,   76,   76,
			   76,   84,   83,  115,  113,   76,   76,   71,    0,   62,
			  387,   76,   58,   76,    0,  380,    0,    0,  360,    0,
			    0,    0,    0,    0,    0,   76,    0,    0,    0,    0,
			    0,    0,    0,    0,  212,  208,    0,  205,  291,  292,
			  194,  195,  196,  197,  198,  200,  201,  202,  203,  216,
			  218,  219,  220,  221,  231,  233,  234,  235,  236,  237,
			  238,  239,  251,  253,  254,  255,  256,    0,  289,  274,
			  277,  261,  264,  193,   75,    0,    0,    0,    0,  180,
			  409,    0,  388,    0,    0,  413,  158,  151,  154,   85,

			  382,    0,    0,  400,  406,    0,   67,  412,    0,  127,
			  125,  123,  121,  119,  117,  111,   73,    0,   65,   60,
			   50,   23,  378,  377,    0,  375,    0,    0,  317,  302,
			  364,  374,  367,  370,  372,  371,  373,  366,  365,  369,
			  368,    0,  362,  260,   76,    0,    0,  401,  250,  402,
			    0,  395,   76,  396,    0,    0,  258,   76,   76,  245,
			  243,  241,    0,    0,  223,    0,    0,   76,   76,  199,
			  217,  232,  252,  287,  290,    0,   77,    0,    0,    0,
			    0,    0,  389,    0,   76,   76,  155,    0,  140,    0,
			    0,   69,    0,  361,  376,    0,  335,  339,  337,  340,

			  338,  336,    0,  333,  320,    0,  357,  363,  257,    0,
			    0,   76,    0,  248,    0,    0,    0,  247,  246,   76,
			   76,   76,  228,    0,   76,  213,  209,  206,  204,   78,
			    0,   80,    0,   76,    0,    0,    0,    0,  156,  149,
			   76,    0,    0,    0,   66,  344,  353,  346,  351,  354,
			  352,  350,  345,  347,  348,  349,    0,  342,  332,  334,
			  321,  330,  323,  328,  331,  329,  327,  322,  324,  325,
			  326,    0,  318,  305,  314,  308,  311,  313,  312,  315,
			  307,    0,  303,  306,  309,  310,  403,    0,  249,  397,
			  383,    0,    0,   76,  244,  242,  240,    0,    0,  222,

			    0,    0,   81,    0,    0,  191,   76,   76,    0,    0,
			  152,    0,  391,    0,   76,  341,  343,  316,  319,  301,
			  304,    0,  384,   86,    0,  259,  229,    0,  214,  210,
			   82,   79,    0,  190,  189,  392,    0,    0,    0,   63,
			  390,    0,    0,  225,    0,   76,    0,    0,    0,  393,
			    0,    0,   76,  215,  207,    0,    0,  143,    0,    0,
			  224,   76,   76,    0,    0,    0,  211,  192,    0,   76,
			    0,    0,  226,    0,    0,    0,    0,  230,    0,   76,
			    0,  227,  394,    0,    0,    0, yyDummy>>)
		end

	yydefgoto_template: SPECIAL [INTEGER] is
		once
			Result := yyfixed_array (<<
			  294,  603,  311,  312,  591,  515,  313,  226,  451,  193,
			  447,  198,  170,  208,  290,  452,  453,  194,  195,  448,
			  449,  199,  200,  171,  172,  209,  210,  187,  383,  384,
			  683,  422,  244,   69,   70,   71,   72,   73,   74,   75,
			   76,   77,   78,   79,   80,   81,   82,   83,  324,   84,
			   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,
			   95,   96,   97,   98,   99,  100,  101,  102,  103,  323,
			  321,  318,  492,  614,  302,  222,  417,  316,  476,  104,
			  105,  106,  107,  108,  109,  110,  111,  112,  113,  114,
			  115,  116,  117,  118,  119,  120,  121,  122,  123,  124,

			  125,  126,  315,  218,  217,  310,  309,  308,  307,  306,
			  305,  188,  127,  128,  129,  130,  292,  485,  293,  486,
			  540,  291,  484,  131,  132,  133,  134,  135,  136,  137,
			  138,  139,  140,  141,  142,  284,  143,  144,  145,  146,
			  147,  349,  350,  351,  352,  353,  354,  355,  356,  357,
			  358,  468,  466,  601,  645,  465,  600,  644,  661,  359,
			  360,  361,  362,  363,  524,  652,  597,  642,  679,  364,
			  365,  366,  367,  368,  369,  370,  371,  521,  520,  519,
			  511,  372,  373,  374,  375,  376,  277,  157,  278,  266,
			  156,  267,  377,  256,  378,  153,  154,  437,  581,  505,

			  582,  438,  439,  440,  571,  504,  572,  502,  503,  556,
			  557,  423,  247,  441,  327,  248,  326,  424,  442,  425, yyDummy>>)
		end

	yypact_template: SPECIAL [INTEGER] is
		once
			Result := yyfixed_array (<<
			 1469, -32768, 2271,  328, -32768, -32768,  325,  323,  322,  321,
			  320,  313,  312,  308,  131,   31,   31,   31,   31,  310,
			  310, -32768,  307,  305,   38,   32,  306,  303,  302,  118,
			  198,  198,  265,  301,   31,  300, -32768,  193,  298,  264,
			  297,  296,  295,  294, -32768, -32768,  293,  287,   31, -32768,
			  285,  282,   31,  281,   31,  279,   31,   31,   31,   31,
			  278,  118,  118,   31,   31,  277,  276,   31, 1277, -32768,
			 -32768, -32768,  106, -32768, -32768, -32768, -32768, -32768,   53,  888,
			   34,  966, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,

			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,  106, -32768,
			   53,   34,  966,  926, -32768, -32768, 2115, 2115,  273,  272,
			  271,  270,  269, -32768, -32768, -32768, -32768, -32768,   31,   31,
			 -32768, -32768, -32768,   31, -32768,   31, -32768, -32768, -32768,   31,
			 -32768, -32768, -32768,  263,   31,   38, -32768, -32768,   31, -32768,
			 -32768,   31,   31, -32768, -32768, -32768,   31,   31, -32768, -32768,

			 -32768, -32768, -32768, -32768, -32768, -32768,   31,   31, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768,   96,   96, -32768,
			 -32768, -32768,   38, -32768,   31,   31, -32768, -32768, -32768,   31,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 1085, -32768,  262, -32768, -32768, -32768, -32768,  104, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768,  505,  106, -32768, -32768,
			 -32768, -32768, -32768,   53,   34,  966, 2048, -32768,  106, -32768,
			 -32768, -32768, -32768, -32768,   53,   34,  966, 1981, -32768, -32768,
			  259,  258,  252,  251, -32768,  253,   31,   31,   31,   31,
			  240,  249,  247,  238, -32768,  162,   38,   32, -32768,  239,

			  237,   31, -32768,  145,   31, -32768,  233, -32768, -32768, -32768,
			 -32768, -32768,   31, -32768, -32768, -32768, -32768, -32768,  229, -32768,
			 -32768, -32768, -32768, -32768,  227, -32768, 1373, 1812, -32768,  195,
			  226,  142,  125,  225,  224, -32768,  118,  131,  118,  125,
			  118,  190,  219,  216, -32768, -32768,   96, -32768,  106, -32768,
			  100,  -11,  170,  -13, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, 2111, -32768, -32768,
			 -32768, -32768, -32768, -32768,  213,  209,  205,  202,  201, -32768,
			 -32768,   31, -32768,   31,   31, -32768, -32768, -32768, -32768, -32768,

			 -32768,   38,   31, -32768, -32768,   31, -32768, -32768,   31, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768,   38, -32768, -32768,
			 -32768, -32768, 1469, -32768, 1181, -32768,  200, 2191, -32768, -32768,
			  106, -32768, -32768,   53,   34,  966, -32768, -32768, -32768, -32768,
			 -32768,  767, -32768, -32768, -32768,   31,   31, -32768, -32768, -32768,
			   31, -32768, -32768, -32768,   58,   58, -32768, -32768, -32768, -32768,
			 -32768, -32768,  182,  181, -32768,   96,   96, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768,   73, -32768,  178,  174,  168,
			  153,   31, -32768,   31, -32768, -32768, -32768,   38, -32768,   31,
			   31, -32768,  144, -32768, -32768, 1812,  106, -32768,   53,   34,

			  966, -32768, 1901, -32768, 1812, 1812, -32768, -32768, -32768,  140,
			   31, -32768,  139, -32768,  135,   58,  126, -32768, -32768, -32768,
			 -32768, -32768, -32768,  120, -32768, -32768, -32768, -32768, -32768, -32768,
			  151, -32768,  113, -32768,   31,   31,   31,   31, -32768, -32768,
			 -32768,   38,   31,   31, -32768,  106, -32768, -32768,   53,   34,
			  966, -32768, -32768, -32768, -32768, -32768, 1544, -32768, -32768, -32768,
			  106, -32768, -32768,   53,   34,  966, -32768, -32768, -32768, -32768,
			 -32768, 1723, -32768,  106, -32768, -32768,   53,   34,  966, -32768,
			 -32768, 1634, -32768, -32768, -32768, -32768, -32768,   31, -32768, -32768,
			 -32768,   47,  111, -32768, -32768, -32768, -32768,   38,   67, -32768,

			   96,   96, -32768,  112,   78, -32768, -32768, -32768,   31,   31,
			 -32768,   38, -32768,   31, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768,   31, -32768, -32768,   76, -32768, -32768,   74, -32768, -32768,
			 -32768, -32768,   31, -32768, -32768, -32768,   31,   38,   31, -32768,
			 -32768,   64,   31, -32768,   96, -32768,   59,   31,   38, -32768,
			   58,   31, -32768, -32768, -32768,   31,   31, -32768,   58,   54,
			 -32768, -32768, -32768,   31,   38,   52, -32768, -32768,   31, -32768,
			   38,   31, -32768,   31,   31,   31,   31, -32768,   31, -32768,
			   31, -32768, -32768,   22,   12, -32768, yyDummy>>)
		end

	yypgoto_template: SPECIAL [INTEGER] is
		once
			Result := yyfixed_array (<<
			  -14, -250,    3, -175, -32768, -431, -204,  -49,   -4,    5,
			  -75,  176,  203,  161, -32768,   27, -32768,  -43, -32768, -32768,
			 -32768,  332, -32768,   21, -32768, -32768, -32768,   91,  413, -32768,
			 -32768,  356, -32768,  -60, -32768, -32768,   65,  212, -125, -127,
			  -31, -131,  204, -32768,  188,  107, -32768,  -66, -32768,  280,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,  -23,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,

			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768,   56,  -50, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768,  -47, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -265, -32768, -32768, -32768, -32768,    4, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,    1,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,   -1,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768,   -3, -32768, -32768, -32768, -32768, -32768, -32768,   72, -32768,
			 -32768,   80, -32768, -32768,  -29, -32768,  194, -387, -32768, -32768,

			 -241, -392, -418, -449, -32768, -32768, -232, -32768, -164, -32768,
			 -219,  275, -32768, -32768, -32768,   89, -32768, -32768, -106,  -90, yyDummy>>)
		end

	yytable_template: SPECIAL [INTEGER] is
		once
			Result := yyfixed_array (<<
			  169,  173,  175,  173,  178,  228,  249,  230,  245,  295,
			  233,  174,  685,  177,  314,  175,  197,  197,  235,  236,
			  204,  176,  684,  207,  516,  262,  273,  185,  250,  260,
			  271,  259,  270,  252,  221,  179,  167,  166,  225,  186,
			  225,  184,  225,  231,  173,  225,  555,  175,  175,  237,
			  173,  623,  622,  241,  232,  570,  585,  670,  253,  665,
			  238,  514,  436,  343,  342,  341,  655,  148,  650,  335,
			  334,  630,  627,  333,  330,  329,  530,  554,  167,  166,
			  529,  643,  249,  602,  592,  632,  569,  584,   21,   20,
			   19,   18,   17,   16,   15,   14,   13,   12,   11,  184,

			  250,  167,  166,  553,  252,   23,   22,  555,  552,  152,
			  180,  181,  568,  583,  624,   66,  631,  567,  580,  630,
			  604,  192,  570,  167,  166,  261,  272,  598,  450,  253,
			  167,  166,  585,  593,  168,  262,  167,  166,  554,  260,
			  590,  259,  467,  589,  586,  445,  273,  167,  166,  407,
			  271,  544,  270,  569,  169,  286,  167,  166,  602,  287,
			  535,  288,  501,  584,  553,  289,  399,  167,  166,  552,
			  347,  346,  345,  344,  297,  534,  436,  298,  175,  568,
			  322,  533,  197,  301,  567,  532,  523,  522,  296,  583,
			  151,  249,  207,  304,  580,  462,  206,  299,  167,  166,

			  443,  196,  249,  167,  166,  242,  150,  495,  480,  479,
			  175,  320,  478,  250,  149,  225,  477,  252,  148,  658,
			  475,  257,  268,  464,  250,  317,  463,  664,  252,  319,
			  551,  455,  454,  444,  421,  261,  418,  501,  410,  566,
			  579,  404,  253,  403,  395,  398,  272,  340,  339,  338,
			  337,  336,  397,  253,  396,  332,  331,  390,  388,  387,
			  152,  525,  526,  265,  276,  386,  385,  325, -150,  212,
			  202,  531,  391,  392,  393,  394,  283,  282,  281,  280,
			  279,  400,  249,  240,  239,  234,  229,  405,  227,  224,
			  408,  551,  223,  457,  220,  459,  432,  461,  400,  401,

			  219,  216,  215,  214,  213,  211,  566,  205,  203,  191,
			  190,  189,  183,  179,  182,  165,  579,  446,  173,  164,
			  163,  348,  175,  169,  175,  173,  175,  162,  161,  160,
			  159,  257,  158,  155,  494,  507,  328,  616,  559,  618,
			  620,  151,  268,  246,  264,  275,  380,  255,  474,  382,
			  472,  471,  470,  402,  469,  295,   68,  150,  458,  251,
			  263,  274,  245,  201,  249,  149,  460,  303,  258,  269,
			  509,  285,  300,  265,  641,    0,    0,  481,    0,  482,
			  483,    0,    0,  250,  276,    0,    0,  252,  488,    0,
			    0,  489,  430,    0,  490,    0,  628,  629,    0,    0,

			    0,    0,    0,    0,  487,    0,    0,    0,    0,    0,
			  432,    0,  253,    0,    0,    0,    0,    0,    0,    0,
			  491,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			  249,  446,  510,    0,  435,    0,  173,    0,    0,    0,
			  653,    0,  348,    0,    0,    0,  512,    0,  250,    0,
			    0,    0,  252,    0,  264,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,  547,  275,    0,  536,    0,  537,
			  263,    0,    0,  562,  575,  542,  543,  253,  258,  249,
			    0,  274,    0,    0,    0,  606,  607,    0,    0,  269,
			  541,    0,  496,    0,  249,    0,  587,    0,  250,    0,

			    0,    0,  252,    0,    0,    0,  430,  249,    0,    0,
			    0,    0,    0,  250,   66,  434,    0,  252,    0,    0,
			  225,  225,  608,  609,    0,  547,  250,  253,  612,  613,
			  252,  433,    0,    0,  500,    0,    0,    0,    0,  431,
			  562,    0,  253,    0,  611,    0,    0,    0,  435,    0,
			  575,    0,    0,    0,    0,  253,    0,    0,    0,    0,
			  545,    0,    0,    0,    0,    0,    0,  496,    0,  560,
			  573,    0,    0,  621,    0,  347,  346,  345,  344,  343,
			  342,  341,  340,  339,  338,  337,  336,  335,  334,  333,
			  332,  331,  330,  329,  635,  636,    0,    0,    0,  638,

			  626,    0,  550,    0,    0,    0,  662,  640,    0,  500,
			    0,  565,  578,    0,  637,  499,    0,    0,  646,    0,
			    0,  545,  647,    0,  649,    0,    0,    0,  651,  434,
			    0,  498,    0,  656,    0,    0,  560,  659,    0,  497,
			  648,  225,  663,    0,    0,  433,  573,    0,    0,  668,
			    0,  657,    0,  431,  671,    0,    0,  674,    0,  675,
			  676,  677,  678,  550,  680,    0,  682,  669,    0,    0,
			    0,    0,    0,  673,    0,    0,    0,    0,  565,    0,
			    0,    0,    0,  549,    0,    0,    0,    0,  578,    0,
			  499,    0,  564,  577,    0,    0,    0,  389,    0,  548,

			    0,    0,    0,    0,    0,    0,  498,  546,  563,  576,
			    0,    0,    0,    0,  497,  406,  561,  574,  409,    0,
			  411,  412,  413,  414,    0,    0,    0,    0,  415,  416,
			    0,    0,    0,    0,  419,    0,  420,    0,    0,    0,
			    0,    0,    0,    0,  549,    0,    0,    0,  456,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,  564,
			  548,    0,    0,    0,    0,    0,    0,    0,  546,  577,
			    0,    0,    0,    0,    0,  563,   66,   65,    0,    0,
			    0,    0,    0,  561,    0,  576,    0,    0,    0,    0,
			    0,    0,    0,  574,    0,    0,   46,   45,   44,   43,

			   42,   41,   40,   39,   38,   37,   36,    0,   34,   33,
			   32,   31,   30,   29,   28,   27,   26,   25,   24,   23,
			   22,   21,   20,   19,   18,   17,   16,   15,   14,   13,
			   12,   11,    0,    0,    0,    0,    0,  347,  346,  345,
			  344,  343,  342,  341,  340,  339,  338,  337,  336,  335,
			  334,  333,  332,  331,  330,  329,  429,  508,  428,    0,
			    3,    0,  427,    0,  426,  513,    0,  506,    0,    0,
			  517,  518,    0,    0,    0,    0,    0,    0,    0,    0,
			  527,  528,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,  538,  539,   64,

			   63,   62,   61,   60,   59,   58,   57,   56,   55,   54,
			   53,   52,   51,   50,   49,   48,   47,    0,    0,    0,
			    0,    0,    0,    0,  588,    0,    0,    0,   35,    0,
			    0,    0,  594,  595,  596,   66,   65,  599,    0,    0,
			    0,    0,    0,    0,    0,    0,  605,    0,    0,    0,
			    0,    0,    0,  610,    0,   46,   45,   44,   43,   42,
			   41,   40,   39,   38,   37,   36,    0,   34,   33,   32,
			   31,   30,   29,   28,   27,   26,   25,   24,   23,   22,
			   21,   20,   19,   18,   17,   16,   15,   14,   13,   12,
			   11,    0,    0,    0,    0,   46,   45,   44,   43,   42,

			   41,   40,   39,   38,   37,   36,  625,   34,   33,   32,
			   31,   30,   29,   28,   27,   26,   25,   24,    0,  633,
			  634,    0,  254,    0,    0,    0,    0,  639,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,  654,    0,
			    0,    0,    0,    0,    0,  660,    0,    0,    0,    0,
			    0,    0,    0,    0,  666,  667,    0,    0,    0,    0,
			    0,    0,  672,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,  681,  -22,  -22,  -22,  -22,  -22,  -22,  -22,

			  -22,  -22,  -22,  -22,  -22,  -22,  -22,  -22,  -22,  -22,
			  -22,  -22,  -22,  -22,  -22,  -22,  -22,  -22,  -22,  -22,
			  -22,  -22,  -22,  -22,  -22,  -22,  -22,  -22,  -22,  -22,
			  -22,  -22,  -22,  -22,  -22,  -22,  -22,  -22,  -22,  -22,
			  -22,  -22,  -22,  -22,  -22,  -22,  -22,  -22,  -22,  -22,
			  -22,  -22,  -22,  -22,  -22,  -22,  -22,  -22,  -22,  -22,
			  -22,  -22,  -22,  -22,  -22,  -22,  -22,  -22,  -22,  -22,
			  -22,  -22,  -22,  -22,  -22,  -22,  -22,  -22,  -22,  -22,
			  -22,  -22,  -22,  -22,  -22,  -22,  -22,  -22,  -22,   67,
			   66,   65,   64,   63,   62,   61,   60,   59,   58,   57,

			   56,   55,   54,   53,   52,   51,   50,   49,   48,   47,
			   46,   45,   44,   43,   42,   41,   40,   39,   38,   37,
			   36,   35,   34,   33,   32,   31,   30,   29,   28,   27,
			   26,   25,   24,   23,   22,   21,   20,   19,   18,   17,
			   16,   15,   14,   13,   12,   11,   10,    9,    8,    7,
			    6,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    5,    0,    4,    0,    3,    0,    2,    0,    0,    0,
			  243,    0,    0,  493,    1,   67,   66,   65,   64,   63,
			   62,   61,   60,   59,   58,   57,   56,   55,   54,   53,

			   52,   51,   50,   49,   48,   47,   46,   45,   44,   43,
			   42,   41,   40,   39,   38,   37,   36,   35,   34,   33,
			   32,   31,   30,   29,   28,   27,   26,   25,   24,   23,
			   22,   21,   20,   19,   18,   17,   16,   15,   14,   13,
			   12,   11,   10,    9,    8,    7,    6,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    5,    0,    4,    0,
			    3,    0,    2,    0,    0,    0,  243,    0,  242,    0,
			    1,   67,   66,   65,   64,   63,   62,   61,   60,   59,
			   58,   57,   56,   55,   54,   53,   52,   51,   50,   49,

			   48,   47,   46,   45,   44,   43,   42,   41,   40,   39,
			   38,   37,   36,   35,   34,   33,   32,   31,   30,   29,
			   28,   27,   26,   25,   24,   23,   22,   21,   20,   19,
			   18,   17,   16,   15,   14,   13,   12,   11,   10,    9,
			    8,    7,    6,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    5,    0,    4,    0,    3,    0,    2,    0,
			    0,    0,  243,    0,    0,    0,    1,   67,   66,   65,
			   64,   63,   62,   61,   60,   59,   58,   57,   56,   55,
			   54,   53,   52,   51,   50,   49,   48,   47,   46,   45,

			   44,   43,   42,   41,   40,   39,   38,   37,   36,   35,
			   34,   33,   32,   31,   30,   29,   28,   27,   26,   25,
			   24,   23,   22,   21,   20,   19,   18,   17,   16,   15,
			   14,   13,   12,   11,   10,    9,    8,    7,    6,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,   66,   65,    0,    0,    0,    5,    0,
			    4,    0,    3,    0,    2,    0,    0,    0,    0,    0,
			    0,    0,    1,   46,   45,   44,   43,   42,   41,   40,
			   39,   38,   37,   36,    0,   34,   33,   32,   31,   30,
			   29,   28,   27,   26,   25,   24,   23,   22,   21,   20,

			   19,   18,   17,   16,   15,   14,   13,   12,   11,    0,
			    0,    0,    0,    0,  347,  346,  345,  344,  343,  342,
			  341,  340,  339,  338,  337,  336,  335,  334,  333,  332,
			  331,  330,  329,  429,    0,  428,    0,    3,    0,  427,
			    0,  426,  615,   66,   65,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,   46,   45,   44,   43,   42,   41,   40,
			   39,   38,   37,   36,    0,   34,   33,   32,   31,   30,
			   29,   28,   27,   26,   25,   24,   23,   22,   21,   20,
			   19,   18,   17,   16,   15,   14,   13,   12,   11,    0,

			    0,    0,    0,    0,  347,  346,  345,  344,  343,  342,
			  341,  340,  339,  338,  337,  336,  335,  334,  333,  332,
			  331,  330,  329,  429,  619,  428,    0,    3,    0,  427,
			    0,  426,   66,   65,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,   46,   45,   44,   43,   42,   41,   40,   39,
			   38,   37,   36,    0,   34,   33,   32,   31,   30,   29,
			   28,   27,   26,   25,   24,   23,   22,   21,   20,   19,
			   18,   17,   16,   15,   14,   13,   12,   11,    0,    0,
			    0,    0,    0,  347,  346,  345,  344,  343,  342,  341,

			  340,  339,  338,  337,  336,  335,  334,  333,  332,  331,
			  330,  329,  429,    0,  428,  617,    3,    0,  427,    0,
			  426,   66,   65,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,   46,   45,   44,   43,   42,   41,   40,   39,   38,
			   37,   36,    0,   34,   33,   32,   31,   30,   29,   28,
			   27,   26,   25,   24,   23,   22,   21,   20,   19,   18,
			   17,   16,   15,   14,   13,   12,   11,    0,    0,    0,
			    0,    0,  347,  346,  345,  344,  343,  342,  341,  340,
			  339,  338,  337,  336,  335,  334,  333,  332,  331,  330,

			  329,  429,    0,  428,    0,    3,    0,  427,    0,  426,
			   66,   65,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			   46,   45,   44,   43,   42,   41,   40,   39,   38,   37,
			   36,    0,   34,   33,   32,   31,   30,   29,   28,   27,
			   26,   25,   24,   23,   22,   21,   20,   19,   18,   17,
			   16,   15,   14,   13,   12,   11,    0,    0,    0,    0,
			    0,  347,  346,  345,  344,  343,  342,  341,  340,  339,
			  338,  337,  336,  335,  334,  333,  332,  331,  330,  329,
			   66,   65,    0,    0,    0,    0,    0,  558,    0,    0,

			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			   46,   45,   44,   43,   42,   41,   40,   39,   38,   37,
			   36,    0,   34,   33,   32,   31,   30,   29,   28,   27,
			   26,   25,   24,   23,   22,   21,   20,   19,   18,   17,
			   16,   15,   14,   13,   12,   11,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,   66,   65,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    5,  381,    4,    0,    3,    0,    2,   46,   45,   44,
			   43,   42,   41,   40,   39,   38,   37,   36,    0,   34,
			   33,   32,   31,   30,   29,   28,   27,   26,   25,   24,

			   23,   22,   21,   20,   19,   18,   17,   16,   15,   14,
			   13,   12,   11,    0,    0,    0,    0,    0,    0,    0,
			   66,    0,    0,    0,   66,   65,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    5,    0,    4,
			  379,    3,    0,    2,   46,   45,   44,   43,   42,   41,
			   40,   39,   38,   37,   36,    0,   34,   33,   32,   31,
			   30,   29,   28,   27,   26,   25,   24,   23,   22,   21,
			   20,   19,   18,   17,   16,   15,   14,   13,   12,   11,
			    0,  347,  346,  345,  344,  343,  342,  341,  340,  339,
			  338,  337,  336,  335,  334,  333,  332,  331,  330,  329,

			   66,   65,    0,    0,    5,  473,    4,    0,    3,    0,
			    2,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			   46,   45,   44,   43,   42,   41,   40,   39,   38,   37,
			   36,    0,   34,   33,   32,   31,   30,   29,   28,   27,
			   26,   25,   24,   23,   22,   21,   20,   19,   18,   17,
			   16,   15,   14,   13,   12,   11,    0,    0,    0,    0,
			    0,  347,  346,  345,  344,  343,  342,  341,  340,  339,
			  338,  337,  336,  335,  334,  333,  332,  331,  330,  329,
			   66,   65,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

			   46,   45,   44,   43,   42,   41,   40,   39,   38,   37,
			   36,    0,   34,   33,   32,   31,   30,   29,   28,   27,
			   26,   25,   24,   23,   22,   21,   20,   19,   18,   17,
			   16,   15,   14,   13,   12,   11, yyDummy>>)
		end

	yycheck_template: SPECIAL [INTEGER] is
		once
			Result := yyfixed_array (<<
			   14,   15,   16,   17,   18,   54,   72,   56,   68,  184,
			   59,   15,    0,   17,  218,   29,   30,   31,   61,   62,
			   34,   16,    0,   37,  455,  156,  157,   24,   78,  156,
			  157,  156,  157,   80,   48,    3,    5,    6,   52,    7,
			   54,    3,   56,   57,   58,   59,  495,   61,   62,   63,
			   64,    4,    5,   67,   58,  504,  505,    5,   81,    5,
			   64,    3,  327,   74,   75,   76,    7,    2,    4,   82,
			   83,    7,    5,   84,   87,   88,    3,  495,    5,    6,
			    7,    7,  148,    7,  515,    7,  504,  505,   54,   55,
			   56,   57,   58,   59,   60,   61,   62,   63,   64,    3,

			  150,    5,    6,  495,  151,   52,   53,  556,  495,    2,
			   19,   20,  504,  505,    3,    9,    4,  504,  505,    7,
			    7,    3,  571,    5,    6,  156,  157,    7,    3,  152,
			    5,    6,  581,    7,    3,  266,    5,    6,  556,  266,
			    5,  266,  346,    4,    4,    3,  277,    5,    6,    4,
			  277,    7,  277,  571,  168,  169,    5,    6,    7,  173,
			    7,  175,  427,  581,  556,  179,    4,    5,    6,  556,
			   70,   71,   72,   73,  188,    7,  441,  191,  192,  571,
			  229,    7,  196,  197,  571,    7,    5,    5,  185,  581,
			    2,  257,  206,  207,  581,    5,    3,  192,    5,    6,

			    5,    3,  268,    5,    6,  101,    2,    7,    7,    7,
			  224,  225,    7,  263,    2,  229,    7,  264,  153,  650,
			    7,  156,  157,    7,  274,  222,    7,  658,  275,  224,
			  495,    7,    7,    7,    7,  266,    7,  502,    5,  504,
			  505,    4,  265,    4,    4,    7,  277,   77,   78,   79,
			   80,   81,    5,  276,    5,   85,   86,    4,    7,    7,
			  153,  465,  466,  156,  157,    7,    7,    5,    5,    5,
			    5,  475,  286,  287,  288,  289,    7,    7,    7,    7,
			    7,  295,  348,    7,    7,    7,    7,  301,    7,    7,
			  304,  556,    7,  336,    7,  338,  327,  340,  312,  296,

			    7,    7,    7,    7,    7,    7,  571,    7,    7,    7,
			    7,    5,    7,    3,    7,    7,  581,  331,  332,    7,
			    7,  256,  336,  337,  338,  339,  340,    7,    7,    7,
			    7,  266,    7,    5,  424,  441,  247,  556,  502,  571,
			  581,  153,  277,   68,  156,  157,  266,  153,  377,  277,
			  353,  352,  351,  297,  350,  530,    0,  153,  337,   79,
			  156,  157,  422,   31,  430,  153,  339,  206,  156,  157,
			  445,  168,  196,  266,  624,   -1,   -1,  391,   -1,  393,
			  394,   -1,   -1,  433,  277,   -1,   -1,  434,  402,   -1,
			   -1,  405,  327,   -1,  408,   -1,  600,  601,   -1,   -1,

			   -1,   -1,   -1,   -1,  401,   -1,   -1,   -1,   -1,   -1,
			  441,   -1,  435,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			  417,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			  496,  445,  446,   -1,  327,   -1,  450,   -1,   -1,   -1,
			  644,   -1,  377,   -1,   -1,   -1,  450,   -1,  498,   -1,
			   -1,   -1,  499,   -1,  266,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,  495,  277,   -1,  481,   -1,  483,
			  266,   -1,   -1,  504,  505,  489,  490,  500,  266,  545,
			   -1,  277,   -1,   -1,   -1,  534,  535,   -1,   -1,  277,
			  487,   -1,  427,   -1,  560,   -1,  510,   -1,  548,   -1,

			   -1,   -1,  549,   -1,   -1,   -1,  441,  573,   -1,   -1,
			   -1,   -1,   -1,  563,    9,  327,   -1,  564,   -1,   -1,
			  534,  535,  536,  537,   -1,  556,  576,  550,  542,  543,
			  577,  327,   -1,   -1,  427,   -1,   -1,   -1,   -1,  327,
			  571,   -1,  565,   -1,  541,   -1,   -1,   -1,  441,   -1,
			  581,   -1,   -1,   -1,   -1,  578,   -1,   -1,   -1,   -1,
			  495,   -1,   -1,   -1,   -1,   -1,   -1,  502,   -1,  504,
			  505,   -1,   -1,  587,   -1,   70,   71,   72,   73,   74,
			   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,
			   85,   86,   87,   88,  608,  609,   -1,   -1,   -1,  613,

			  597,   -1,  495,   -1,   -1,   -1,  655,  621,   -1,  502,
			   -1,  504,  505,   -1,  611,  427,   -1,   -1,  632,   -1,
			   -1,  556,  636,   -1,  638,   -1,   -1,   -1,  642,  441,
			   -1,  427,   -1,  647,   -1,   -1,  571,  651,   -1,  427,
			  637,  655,  656,   -1,   -1,  441,  581,   -1,   -1,  663,
			   -1,  648,   -1,  441,  668,   -1,   -1,  671,   -1,  673,
			  674,  675,  676,  556,  678,   -1,  680,  664,   -1,   -1,
			   -1,   -1,   -1,  670,   -1,   -1,   -1,   -1,  571,   -1,
			   -1,   -1,   -1,  495,   -1,   -1,   -1,   -1,  581,   -1,
			  502,   -1,  504,  505,   -1,   -1,   -1,  284,   -1,  495,

			   -1,   -1,   -1,   -1,   -1,   -1,  502,  495,  504,  505,
			   -1,   -1,   -1,   -1,  502,  302,  504,  505,  305,   -1,
			  307,  308,  309,  310,   -1,   -1,   -1,   -1,  315,  316,
			   -1,   -1,   -1,   -1,  321,   -1,  323,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,  556,   -1,   -1,   -1,  335,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  571,
			  556,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  556,  581,
			   -1,   -1,   -1,   -1,   -1,  571,    9,   10,   -1,   -1,
			   -1,   -1,   -1,  571,   -1,  581,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,  581,   -1,   -1,   29,   30,   31,   32,

			   33,   34,   35,   36,   37,   38,   39,   -1,   41,   42,
			   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,
			   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,
			   63,   64,   -1,   -1,   -1,   -1,   -1,   70,   71,   72,
			   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,
			   83,   84,   85,   86,   87,   88,   89,  444,   91,   -1,
			   93,   -1,   95,   -1,   97,  452,   -1,  100,   -1,   -1,
			  457,  458,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			  467,  468,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,  484,  485,   11,

			   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,
			   22,   23,   24,   25,   26,   27,   28,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,  511,   -1,   -1,   -1,   40,   -1,
			   -1,   -1,  519,  520,  521,    9,   10,  524,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,  533,   -1,   -1,   -1,
			   -1,   -1,   -1,  540,   -1,   29,   30,   31,   32,   33,
			   34,   35,   36,   37,   38,   39,   -1,   41,   42,   43,
			   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,
			   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,
			   64,   -1,   -1,   -1,   -1,   29,   30,   31,   32,   33,

			   34,   35,   36,   37,   38,   39,  593,   41,   42,   43,
			   44,   45,   46,   47,   48,   49,   50,   51,   -1,  606,
			  607,   -1,   96,   -1,   -1,   -1,   -1,  614,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  645,   -1,
			   -1,   -1,   -1,   -1,   -1,  652,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,  661,  662,   -1,   -1,   -1,   -1,
			   -1,   -1,  669,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,  679,    8,    9,   10,   11,   12,   13,   14,

			   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,
			   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,
			   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,
			   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,
			   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,
			   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,
			   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,
			   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,
			   95,   96,   97,   98,   99,  100,  101,  102,  103,    8,
			    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,

			   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,
			   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,
			   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,
			   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,
			   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,
			   69,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   89,   -1,   91,   -1,   93,   -1,   95,   -1,   -1,   -1,
			   99,   -1,   -1,  102,  103,    8,    9,   10,   11,   12,
			   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,

			   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,
			   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,
			   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,
			   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,
			   63,   64,   65,   66,   67,   68,   69,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   89,   -1,   91,   -1,
			   93,   -1,   95,   -1,   -1,   -1,   99,   -1,  101,   -1,
			  103,    8,    9,   10,   11,   12,   13,   14,   15,   16,
			   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,

			   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,
			   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,
			   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,
			   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,
			   67,   68,   69,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   89,   -1,   91,   -1,   93,   -1,   95,   -1,
			   -1,   -1,   99,   -1,   -1,   -1,  103,    8,    9,   10,
			   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,
			   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,

			   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,
			   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,
			   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,
			   61,   62,   63,   64,   65,   66,   67,   68,   69,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,    9,   10,   -1,   -1,   -1,   89,   -1,
			   91,   -1,   93,   -1,   95,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,  103,   29,   30,   31,   32,   33,   34,   35,
			   36,   37,   38,   39,   -1,   41,   42,   43,   44,   45,
			   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,

			   56,   57,   58,   59,   60,   61,   62,   63,   64,   -1,
			   -1,   -1,   -1,   -1,   70,   71,   72,   73,   74,   75,
			   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,
			   86,   87,   88,   89,   -1,   91,   -1,   93,   -1,   95,
			   -1,   97,   98,    9,   10,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   29,   30,   31,   32,   33,   34,   35,
			   36,   37,   38,   39,   -1,   41,   42,   43,   44,   45,
			   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,
			   56,   57,   58,   59,   60,   61,   62,   63,   64,   -1,

			   -1,   -1,   -1,   -1,   70,   71,   72,   73,   74,   75,
			   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,
			   86,   87,   88,   89,   90,   91,   -1,   93,   -1,   95,
			   -1,   97,    9,   10,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   29,   30,   31,   32,   33,   34,   35,   36,
			   37,   38,   39,   -1,   41,   42,   43,   44,   45,   46,
			   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,
			   57,   58,   59,   60,   61,   62,   63,   64,   -1,   -1,
			   -1,   -1,   -1,   70,   71,   72,   73,   74,   75,   76,

			   77,   78,   79,   80,   81,   82,   83,   84,   85,   86,
			   87,   88,   89,   -1,   91,   92,   93,   -1,   95,   -1,
			   97,    9,   10,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   29,   30,   31,   32,   33,   34,   35,   36,   37,
			   38,   39,   -1,   41,   42,   43,   44,   45,   46,   47,
			   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,
			   58,   59,   60,   61,   62,   63,   64,   -1,   -1,   -1,
			   -1,   -1,   70,   71,   72,   73,   74,   75,   76,   77,
			   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,

			   88,   89,   -1,   91,   -1,   93,   -1,   95,   -1,   97,
			    9,   10,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,
			   39,   -1,   41,   42,   43,   44,   45,   46,   47,   48,
			   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,
			   59,   60,   61,   62,   63,   64,   -1,   -1,   -1,   -1,
			   -1,   70,   71,   72,   73,   74,   75,   76,   77,   78,
			   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,
			    9,   10,   -1,   -1,   -1,   -1,   -1,   96,   -1,   -1,

			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,
			   39,   -1,   41,   42,   43,   44,   45,   46,   47,   48,
			   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,
			   59,   60,   61,   62,   63,   64,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,    9,   10,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   89,   90,   91,   -1,   93,   -1,   95,   29,   30,   31,
			   32,   33,   34,   35,   36,   37,   38,   39,   -1,   41,
			   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,

			   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,
			   62,   63,   64,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			    9,   -1,   -1,   -1,    9,   10,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   89,   -1,   91,
			   92,   93,   -1,   95,   29,   30,   31,   32,   33,   34,
			   35,   36,   37,   38,   39,   -1,   41,   42,   43,   44,
			   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,
			   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,
			   -1,   70,   71,   72,   73,   74,   75,   76,   77,   78,
			   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,

			    9,   10,   -1,   -1,   89,   94,   91,   -1,   93,   -1,
			   95,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,
			   39,   -1,   41,   42,   43,   44,   45,   46,   47,   48,
			   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,
			   59,   60,   61,   62,   63,   64,   -1,   -1,   -1,   -1,
			   -1,   70,   71,   72,   73,   74,   75,   76,   77,   78,
			   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,
			    9,   10,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,

			   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,
			   39,   -1,   41,   42,   43,   44,   45,   46,   47,   48,
			   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,
			   59,   60,   61,   62,   63,   64, yyDummy>>)
		end

feature {NONE} -- Semantic value stacks

	yyvs1: SPECIAL [ANY]
			-- Stack for semantic values of type ANY

	yyvsc1: INTEGER
			-- Capacity of semantic value stack `yyvs1'

	yyvsp1: INTEGER
			-- Top of semantic value stack `yyvs1'

	yyspecial_routines1: KL_SPECIAL_ROUTINES [ANY]
			-- Routines that ought to be in SPECIAL [ANY]

	yyvs2: SPECIAL [INTEGER]
			-- Stack for semantic values of type INTEGER

	yyvsc2: INTEGER
			-- Capacity of semantic value stack `yyvs2'

	yyvsp2: INTEGER
			-- Top of semantic value stack `yyvs2'

	yyspecial_routines2: KL_SPECIAL_ROUTINES [INTEGER]
			-- Routines that ought to be in SPECIAL [INTEGER]

	yyvs3: SPECIAL [DOUBLE]
			-- Stack for semantic values of type DOUBLE

	yyvsc3: INTEGER
			-- Capacity of semantic value stack `yyvs3'

	yyvsp3: INTEGER
			-- Top of semantic value stack `yyvs3'

	yyspecial_routines3: KL_SPECIAL_ROUTINES [DOUBLE]
			-- Routines that ought to be in SPECIAL [DOUBLE]

	yyvs4: SPECIAL [STRING]
			-- Stack for semantic values of type STRING

	yyvsc4: INTEGER
			-- Capacity of semantic value stack `yyvs4'

	yyvsp4: INTEGER
			-- Top of semantic value stack `yyvs4'

	yyspecial_routines4: KL_SPECIAL_ROUTINES [STRING]
			-- Routines that ought to be in SPECIAL [STRING]

	yyvs5: SPECIAL [DS_ARRAYED_LIST [STRING]]
			-- Stack for semantic values of type DS_ARRAYED_LIST [STRING]

	yyvsc5: INTEGER
			-- Capacity of semantic value stack `yyvs5'

	yyvsp5: INTEGER
			-- Top of semantic value stack `yyvs5'

	yyspecial_routines5: KL_SPECIAL_ROUTINES [DS_ARRAYED_LIST [STRING]]
			-- Routines that ought to be in SPECIAL [DS_ARRAYED_LIST [STRING]]

	yyvs6: SPECIAL [DOUBLE_ARRAYED_LIST]
			-- Stack for semantic values of type DOUBLE_ARRAYED_LIST

	yyvsc6: INTEGER
			-- Capacity of semantic value stack `yyvs6'

	yyvsp6: INTEGER
			-- Top of semantic value stack `yyvs6'

	yyspecial_routines6: KL_SPECIAL_ROUTINES [DOUBLE_ARRAYED_LIST]
			-- Routines that ought to be in SPECIAL [DOUBLE_ARRAYED_LIST]

	yyvs7: SPECIAL [PARAMETER_LIST]
			-- Stack for semantic values of type PARAMETER_LIST

	yyvsc7: INTEGER
			-- Capacity of semantic value stack `yyvs7'

	yyvsp7: INTEGER
			-- Top of semantic value stack `yyvs7'

	yyspecial_routines7: KL_SPECIAL_ROUTINES [PARAMETER_LIST]
			-- Routines that ought to be in SPECIAL [PARAMETER_LIST]

feature {NONE} -- Constants

	yyFinal: INTEGER is 685
			-- Termination state id

	yyFlag: INTEGER is -32768
			-- Most negative INTEGER

	yyNtbase: INTEGER is 104
			-- Number of tokens

	yyLast: INTEGER is 2335
			-- Upper bound of `yytable' and `yycheck'

	yyMax_token: INTEGER is 358
			-- Maximum token id
			-- (upper bound of `yytranslate'.)

	yyNsyms: INTEGER is 324
			-- Number of symbols
			-- (terminal and nonterminal)

feature -- User-defined features


feature {NONE} -- Initialization
	
	make is
			-- Create a new RenderMan parser.
		do
			make_rib_scanner
			make_parser_skeleton
			ri_begin
			
			create strings.make (1)
			create values.make (1)
			
			create filter_factory.make
			create light_mapping.make (1, 10)
			create light_mapping_for_strings.make (10)
			create tmp_transform.make
		end
	
feature -- Error handling

	report_error (a_message: STRING) is
			-- Print error message.
		local
			f_buffer: YY_FILE_BUFFER
		do
			f_buffer ?= input_buffer
			if f_buffer /= Void then
				std.error.put_string (f_buffer.file.name)
				std.error.put_string (", line ")
			else
				std.error.put_string ("line ")
			end
			std.error.put_integer (eif_lineno)
			std.error.put_string (": ")
			std.error.put_string (a_message)
			std.error.put_character ('%N')
		end

	rib_syntax_error (routine, message, found, resolution: STRING) is
			-- 
		require 
			not_void_routine: routine /= Void
			not_void_message: message /= Void
			not_void_resolution: resolution /= Void
		local
			error_message: STRING
		do
			create error_message.make_from_string ("(")
			error_message.append (routine)
			error_message.append (", line ")
			error_message.append_string (line.out)
			error_message.append ("): ")
			error_message.append (message)
		
			if found /= Void then
				error_message.append (" found ")
				error_message.append (found)
			end
			
			error_message.append (" at column ")
			error_message.append_string (column.out)
			
			error_message.append (" ")
			error_message.append (resolution)
			error_message.append ("%N")
	
			io.put_string (error_message)
		end
	
	rib_error (routine, message: STRING) is
			-- 
		require 
			not_void_routine: routine /= Void
			not_void_message: message /= Void
		local
			error_message: STRING
		do
			create error_message.make_from_string ("(")
			error_message.append (routine)
			error_message.append (", line ")
			error_message.append_string (line.out)
			error_message.append ("): ")
			error_message.append (message)
		
			error_message.append ("%N")
	
			io.put_string (error_message)
		end
	
feature {NONE} -- Implementation

	filter_factory: FILTER_FACTORY
  
	str1, str2, str3: STRING
			-- Temporary strings for mid-action parsing
  
	tmp1: DOUBLE
			-- Temporary double
  
	tmp_array, tmp_array1, tmp_array2: DOUBLE_ARRAYED_LIST
			-- Temporary arrays for mid-action parsing
  
	int_array, int_array1, int_array2: INTEGER_ARRAYED_LIST
	int_array_64, int_array1_64, int_array2_64: INTEGER_64_ARRAYED_LIST
			-- Temporary arrays for mid-action parsing
  
	tmp_vector: VECTOR
	tmp_transform: TRANSFORM
	tmp_color: RGBA_COLOR
	tmp_opacity: RGB_COLOR
	tmp_index: INTEGER
	light_mapping: ARRAY [INTEGER]
			-- Mapping between requested handle and the actual one
	light_mapping_for_strings: HASH_TABLE [INTEGER, STRING]
	
	pt1, pt2: POINT3
	box: AXIS_ALIGNED_BOX
			-- Used for creating `bounds'
	
	verbose: BOOLEAN
			-- Set through an Option call
	
	strings: DS_ARRAYED_LIST [STRING]
	
	parameters: PARAMETER_LIST
	values: DOUBLE_ARRAYED_LIST
			-- Storage for arrays of numbers
	
	reset_variables is
			-- reset the temporary variables
		do
			create parameters.make
			create strings.make (1)
			create values.make (1)
		end
	
	print_values (vals: DOUBLE_ARRAYED_LIST; 
				  print_brackets: BOOLEAN) is
			-- Print out the values from `vals'
		require
			vals_not_void: vals /= Void
		do
			if print_brackets then
				io.put_string ("[")
			end
			
			from
				vals.start
			variant
				vals.count - vals.index + 1
			until
				vals.after
			loop
				io.put_double (vals.item_for_iteration)
				vals.forth
				
				if not vals.after then
					io.put_string (" ")
				end
			end
			
			if print_brackets then
				io.put_string ("]")
			end
		end
	
end -- class RIB_PARSER
